/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/state/electron-main/state","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/common/profiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/userDataSync/electron-main/userDataSyncProfilesStorageIpc","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(z){for(var e=[],w=0,t=z.length;w<t;w++)e[w]=te[z[w]];return e};define(te[119],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(D){return D?D.replace(/\$\((.*?)\)/g,(E,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=w;class t{constructor(E,u,m){this.id=E,this.definition=u,this.description=m,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,E){const u=["codicon","codicon-"+D];return E&&u.push("codicon-modifier-"+E),u}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function u(v){if(v instanceof t)return["codicon","codicon-"+v.id];const b=E.exec(v.id);if(!b)return u(t.error);const[,d,h]=b,y=["codicon","codicon-"+d];return h&&y.push("codicon-modifier-"+h.substr(1)),y}D.asClassNameArray=u;function m(v){return u(v).join(" ")}D.asClassName=m;function I(v){return"."+u(v).join(".")}D.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(te[120],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function w(E,u){const m=Math.pow(10,u);return Math.round(E*m)/m}class t{constructor(u,m,I,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=w(Math.max(Math.min(1,v),0),3)}static equals(u,m){return u.r===m.r&&u.g===m.g&&u.b===m.b&&u.a===m.a}}e.RGBA=t;class k{constructor(u,m,I,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.l=w(Math.max(Math.min(1,I),0),3),this.a=w(Math.max(Math.min(1,v),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.l===m.l&&u.a===m.a}static fromRGBA(u){const m=u.r/255,I=u.g/255,v=u.b/255,b=u.a,d=Math.max(m,I,v),h=Math.min(m,I,v);let y=0,C=0;const p=(h+d)/2,S=d-h;if(S>0){switch(C=Math.min(p<=.5?S/(2*p):S/(2-2*p),1),d){case m:y=(I-v)/S+(I<v?6:0);break;case I:y=(v-m)/S+2;break;case v:y=(m-I)/S+4;break}y*=60,y=Math.round(y)}return new k(y,C,p,b)}static _hue2rgb(u,m,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?u+(m-u)*6*I:I<1/2?m:I<2/3?u+(m-u)*(2/3-I)*6:u}static toRGBA(u){const m=u.h/360,{s:I,l:v,a:b}=u;let d,h,y;if(I===0)d=h=y=v;else{const C=v<.5?v*(1+I):v+I-v*I,p=2*v-C;d=k._hue2rgb(p,C,m+1/3),h=k._hue2rgb(p,C,m),y=k._hue2rgb(p,C,m-1/3)}return new t(Math.round(d*255),Math.round(h*255),Math.round(y*255),b)}}e.HSLA=k;class R{constructor(u,m,I,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=w(Math.max(Math.min(1,m),0),3),this.v=w(Math.max(Math.min(1,I),0),3),this.a=w(Math.max(Math.min(1,v),0),3)}static equals(u,m){return u.h===m.h&&u.s===m.s&&u.v===m.v&&u.a===m.a}static fromRGBA(u){const m=u.r/255,I=u.g/255,v=u.b/255,b=Math.max(m,I,v),d=Math.min(m,I,v),h=b-d,y=b===0?0:h/b;let C;return h===0?C=0:b===m?C=((I-v)/h%6+6)%6:b===I?C=(v-m)/h+2:C=(m-I)/h+4,new R(Math.round(C*60),y,b,u.a)}static toRGBA(u){const{h:m,s:I,v,a:b}=u,d=v*I,h=d*(1-Math.abs(m/60%2-1)),y=v-d;let[C,p,S]=[0,0,0];return m<60?(C=d,p=h):m<120?(C=h,p=d):m<180?(p=d,S=h):m<240?(p=h,S=d):m<300?(C=h,S=d):m<=360&&(C=d,S=h),C=Math.round((C+y)*255),p=Math.round((p+y)*255),S=Math.round((S+y)*255),new t(C,p,S,b)}}e.HSVA=R;class D{static fromHex(u){return D.Format.CSS.parseHex(u)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof t)this.rgba=u;else if(u instanceof k)this._hsla=u,this.rgba=k.toRGBA(u);else if(u instanceof R)this._hsva=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&t.equals(this.rgba,u.rgba)&&k.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=D._relativeLuminanceForComponent(this.rgba.r),m=D._relativeLuminanceForComponent(this.rgba.g),I=D._relativeLuminanceForComponent(this.rgba.b),v=.2126*u+.7152*m+.0722*I;return w(v,4)}static _relativeLuminanceForComponent(u){const m=u/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(u){const m=this.getRelativeLuminance(),I=u.getRelativeLuminance();return m>I?(m+.05)/(I+.05):(I+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const m=this.getRelativeLuminance(),I=u.getRelativeLuminance();return m>I}isDarkerThan(u){const m=this.getRelativeLuminance(),I=u.getRelativeLuminance();return m<I}lighten(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:m,g:I,b:v,a:b}=this.rgba;return new D(new t(m,I,v,b*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const m=u.rgba,I=this.rgba.a,v=m.a,b=I+v*(1-I);if(b<1e-6)return D.transparent;const d=this.rgba.r*I/b+m.r*v*(1-I)/b,h=this.rgba.g*I/b+m.g*v*(1-I)/b,y=this.rgba.b*I/b+m.b*v*(1-I)/b;return new D(new t(d,h,y,b))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:m,g:I,b:v,a:b}=this.rgba;return new D(new t(u.rgba.r-b*(u.rgba.r-m),u.rgba.g-b*(u.rgba.g-I),u.rgba.b-b*(u.rgba.b-v),1))}flatten(...u){const m=u.reduceRight((I,v)=>D._flatten(v,I));return D._flatten(this,m)}static _flatten(u,m){const I=1-u.rgba.a;return new D(new t(I*m.rgba.r+u.rgba.a*u.rgba.r,I*m.rgba.g+u.rgba.a*u.rgba.g,I*m.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(u,m,I){if(u.isLighterThan(m))return u;I=I||.5;const v=u.getRelativeLuminance(),b=m.getRelativeLuminance();return I=I*(b-v)/b,u.lighten(I)}static getDarkerColor(u,m,I){if(u.isDarkerThan(m))return u;I=I||.5;const v=u.getRelativeLuminance(),b=m.getRelativeLuminance();return I=I*(v-b)/v,u.darken(I)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(E){let u;(function(m){let I;(function(v){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:E.Format.CSS.formatRGBA(i)}v.formatRGB=b;function d(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}v.formatRGBA=d;function h(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(i)}v.formatHSL=h;function y(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}v.formatHSLA=y;function C(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function p(i){return`#${C(i.rgba.r)}${C(i.rgba.g)}${C(i.rgba.b)}`}v.formatHex=p;function S(i,o=!1){return o&&i.rgba.a===1?E.Format.CSS.formatHex(i):`#${C(i.rgba.r)}${C(i.rgba.g)}${C(i.rgba.b)}${C(Math.round(i.rgba.a*255))}`}v.formatHexA=S;function f(i){return i.isOpaque()?E.Format.CSS.formatHex(i):E.Format.CSS.formatRGBA(i)}v.format=f;function g(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const n=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),r=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),s=16*a(i.charCodeAt(5))+a(i.charCodeAt(6));return new E(new t(n,r,s,1))}if(o===9){const n=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),r=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),s=16*a(i.charCodeAt(5))+a(i.charCodeAt(6)),c=16*a(i.charCodeAt(7))+a(i.charCodeAt(8));return new E(new t(n,r,s,c/255))}if(o===4){const n=a(i.charCodeAt(1)),r=a(i.charCodeAt(2)),s=a(i.charCodeAt(3));return new E(new t(16*n+n,16*r+r,16*s+s))}if(o===5){const n=a(i.charCodeAt(1)),r=a(i.charCodeAt(2)),s=a(i.charCodeAt(3)),c=a(i.charCodeAt(4));return new E(new t(16*n+n,16*r+r,16*s+s,(16*c+c)/255))}return null}v.parseHex=g;function a(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=m.CSS||(m.CSS={}))})(u=E.Format||(E.Format={}))}(D=e.Color||(e.Color={}))}),define(te[53],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(D){return(E,u,m)=>{let I=null,v=null;if(typeof m.value=="function"?(I="value",v=m.value):typeof m.get=="function"&&(I="get",v=m.get),!v)throw new Error("not supported");m[I]=D(v,u)}}e.createDecorator=w;function t(D,E,u){let m=null,I=null;if(typeof u.value=="function"?(m="value",I=u.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(m="get",I=u.get),!I)throw new Error("not supported");const v=`$memoize$${E}`;u[m]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,b)}),this[v]}}e.memoize=t;function k(D,E,u){return w((m,I)=>{const v=`$debounce$${I}`,b=`$debounce$result$${I}`;return function(...d){this[b]||(this[b]=u?u():void 0),clearTimeout(this[v]),E&&(this[b]=E(this[b],...d),d=[this[b]]),this[v]=setTimeout(()=>{m.apply(this,d),this[b]=u?u():void 0},D)}})}e.debounce=k;function R(D,E,u){return w((m,I)=>{const v=`$throttle$timer$${I}`,b=`$throttle$result$${I}`,d=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...y){if(this[b]||(this[b]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),E&&(this[b]=E(this[b],...y)),this[h])return;const C=this[d]+D;C<=Date.now()?(this[d]=Date.now(),m.apply(this,[this[b]]),this[b]=u?u():void 0):(this[h]=!0,this[v]=setTimeout(()=>{this[h]=!1,this[d]=Date.now(),m.apply(this,[this[b]]),this[b]=u?u():void 0},C-Date.now()))}})}e.throttle=R}),define(te[17],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?f.isErrorNoTelemetry(i)?new f(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=w,e.errorHandler=new w;function t(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=t;function k(a){u(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=k;function R(a){u(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=R;function D(a){if(a instanceof Error){const{name:i,message:o}=a,n=a.stacktrace||a.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:f.isErrorNoTelemetry(a)}}return a}e.transformErrorForSerialization=D;const E="Canceled";function u(a){return a instanceof m?!0:a instanceof Error&&a.name===E&&a.message===E}e.isCancellationError=u;class m extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=m;function I(){const a=new Error(E);return a.name=a.message,a}e.canceled=I;function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=v;function b(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=b;function d(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function h(a){const i=new Error(`${a} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=y;class C extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=C;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class f extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof f)return i;const o=new f;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class g extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(te[24],ie([0,1,17]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(q,re=0){return q[q.length-(1+re)]}e.tail=t;function k(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=k;function R(q,re,ne=(ce,ge)=>ce===ge){if(q===re)return!0;if(!q||!re||q.length!==re.length)return!1;for(let ce=0,ge=q.length;ce<ge;ce++)if(!ne(q[ce],re[ce]))return!1;return!0}e.equals=R;function D(q,re){const ne=q.length-1;re<ne&&(q[re]=q[ne]),q.pop()}e.removeFastWithoutKeepingOrder=D;function E(q,re,ne){return u(q.length,ce=>ne(q[ce],re))}e.binarySearch=E;function u(q,re){let ne=0,ce=q-1;for(;ne<=ce;){const ge=(ne+ce)/2|0,De=re(ge);if(De<0)ne=ge+1;else if(De>0)ce=ge-1;else return ge}return-(ne+1)}e.binarySearch2=u;function m(q,re){let ne=0,ce=q.length;if(ce===0)return 0;for(;ne<ce;){const ge=Math.floor((ne+ce)/2);re(q[ge])?ce=ge:ne=ge+1}return ne}e.findFirstInSorted=m;function I(q,re,ne){if(q=q|0,q>=re.length)throw new TypeError("invalid index");const ce=re[Math.floor(re.length*Math.random())],ge=[],De=[],Ae=[];for(const ke of re){const Le=ne(ke,ce);Le<0?ge.push(ke):Le>0?De.push(ke):Ae.push(ke)}return q<ge.length?I(q,ge,ne):q<ge.length+Ae.length?Ae[0]:I(q-(ge.length+Ae.length),De,ne)}e.quickSelect=I;function v(q,re){const ne=[];let ce;for(const ge of q.slice(0).sort(re))!ce||re(ce[0],ge)!==0?(ce=[ge],ne.push(ce)):ce.push(ge);return ne}e.groupBy=v;function b(q,re,ne){const ce=[];function ge(ke,Le,qe){if(Le===0&&qe.length===0)return;const me=ce[ce.length-1];me&&me.start+me.deleteCount===ke?(me.deleteCount+=Le,me.toInsert.push(...qe)):ce.push({start:ke,deleteCount:Le,toInsert:qe})}let De=0,Ae=0;for(;;){if(De===q.length){ge(De,0,re.slice(Ae));break}if(Ae===re.length){ge(De,q.length-De,[]);break}const ke=q[De],Le=re[Ae],qe=ne(ke,Le);qe===0?(De+=1,Ae+=1):qe<0?(ge(De,1,[]),De+=1):qe>0&&(ge(De,0,[Le]),Ae+=1)}return ce}e.sortedDiff=b;function d(q,re,ne){const ce=b(q,re,ne),ge=[],De=[];for(const Ae of ce)ge.push(...q.slice(Ae.start,Ae.start+Ae.deleteCount)),De.push(...Ae.toInsert);return{removed:ge,added:De}}e.delta=d;function h(q,re,ne){if(ne===0)return[];const ce=q.slice(0,ne).sort(re);return C(q,re,ce,ne,q.length),ce}e.top=h;function y(q,re,ne,ce,ge){return ne===0?Promise.resolve([]):new Promise((De,Ae)=>{(async()=>{const ke=q.length,Le=q.slice(0,ne).sort(re);for(let qe=ne,me=Math.min(ne+ce,ke);qe<ke;qe=me,me=Math.min(me+ce,ke)){if(qe>ne&&await new Promise(we=>setTimeout(we)),ge&&ge.isCancellationRequested)throw new w.CancellationError;C(q,re,Le,qe,me)}return Le})().then(De,Ae)})}e.topAsync=y;function C(q,re,ne,ce,ge){for(const De=ne.length;ce<ge;ce++){const Ae=q[ce];if(re(Ae,ne[De-1])<0){ne.pop();const ke=m(ne,Le=>re(Ae,Le)<0);ne.splice(ke,0,Ae)}}}function p(q){return q.filter(re=>!!re)}e.coalesce=p;function S(q){let re=0;for(let ne=0;ne<q.length;ne++)q[ne]&&(q[re]=q[ne],re+=1);q.length=re}e.coalesceInPlace=S;function f(q,re,ne){q.splice(ne,0,q.splice(re,1)[0])}e.move=f;function g(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=g;function a(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=a;function i(q,re=ne=>ne){const ne=new Set;return q.filter(ce=>{const ge=re(ce);return ne.has(ge)?!1:(ne.add(ge),!0)})}e.distinct=i;function o(q){const re=new Set;return ne=>{const ce=q(ne);return re.has(ce)?!1:(re.add(ce),!0)}}e.uniqueFilter=o;function n(q,re){const ne=r(q,re);if(ne!==-1)return q[ne]}e.findLast=n;function r(q,re){for(let ne=q.length-1;ne>=0;ne--){const ce=q[ne];if(re(ce))return ne}return-1}e.lastIndex=r;function s(q,re){return q.length>0?q[0]:re}e.firstOrDefault=s;function c(q,re){return q.length>0?q[q.length-1]:re}e.lastOrDefault=c;function l(q,re,ne=(ce,ge)=>ce===ge){let ce=0;for(let ge=0,De=Math.min(q.length,re.length);ge<De&&ne(q[ge],re[ge]);ge++)ce++;return ce}e.commonPrefixLength=l;function P(q){return[].concat(...q)}e.flatten=P;function M(q,re){let ne=typeof re=="number"?q:0;typeof re=="number"?ne=q:(ne=0,re=q);const ce=[];if(ne<=re)for(let ge=ne;ge<re;ge++)ce.push(ge);else for(let ge=ne;ge>re;ge--)ce.push(ge);return ce}e.range=M;function T(q,re,ne){return q.reduce((ce,ge)=>(ce[re(ge)]=ne?ne(ge):ge,ce),Object.create(null))}e.index=T;function N(q,re){return q.push(re),()=>X(q,re)}e.insert=N;function X(q,re){const ne=q.indexOf(re);if(ne>-1)return q.splice(ne,1),re}e.remove=X;function ae(q,re,ne){const ce=q.slice(0,re),ge=q.slice(re);return ce.concat(ne,ge)}e.arrayInsert=ae;function Q(q,re){let ne;if(typeof re=="number"){let ce=re;ne=()=>{const ge=Math.sin(ce++)*179426549;return ge-Math.floor(ge)}}else ne=Math.random;for(let ce=q.length-1;ce>0;ce-=1){const ge=Math.floor(ne()*(ce+1)),De=q[ce];q[ce]=q[ge],q[ge]=De}}e.shuffle=Q;function G(q,re){const ne=q.indexOf(re);ne>-1&&(q.splice(ne,1),q.unshift(re))}e.pushToStart=G;function Z(q,re){const ne=q.indexOf(re);ne>-1&&(q.splice(ne,1),q.push(re))}e.pushToEnd=Z;function se(q,re){for(const ne of re)q.push(ne)}e.pushMany=se;function he(q,re){return Array.isArray(q)?q.map(re):re(q)}e.mapArrayOrNot=he;function V(q){return Array.isArray(q)?q:[q]}e.asArray=V;function H(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=H;function W(q,re){for(const ne of q){const ce=re(ne);if(ce!==void 0)return ce}}e.mapFind=W;function A(q,re,ne){const ce=U(q,re),ge=q.length,De=ne.length;q.length=ge+De;for(let Ae=ge-1;Ae>=ce;Ae--)q[Ae+De]=q[Ae];for(let Ae=0;Ae<De;Ae++)q[Ae+ce]=ne[Ae]}e.insertInto=A;function F(q,re,ne,ce){const ge=U(q,re),De=q.splice(ge,ne);return A(q,ge,ce),De}e.splice=F;function U(q,re){return re<0?Math.max(re+q.length,0):Math.min(re,q.length)}var J;(function(q){function re(ge){return ge<0}q.isLessThan=re;function ne(ge){return ge>0}q.isGreaterThan=ne;function ce(ge){return ge===0}q.isNeitherLessOrGreaterThan=ce,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function B(q,re){return(ne,ce)=>re(q(ne),q(ce))}e.compareBy=B;function $(...q){return(re,ne)=>{for(const ce of q){const ge=ce(re,ne);if(!J.isNeitherLessOrGreaterThan(ge))return ge}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=$;const L=(q,re)=>q-re;e.numberComparator=L;function O(q,re){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const ge=q[ce];re(ge,ne)>0&&(ne=ge)}return ne}e.findMaxBy=O;function _(q,re){if(q.length===0)return;let ne=q[0];for(let ce=1;ce<q.length;ce++){const ge=q[ce];re(ge,ne)>=0&&(ne=ge)}return ne}e.findLastMaxBy=_;function j(q,re){return O(q,(ne,ce)=>-re(ne,ce))}e.findMinBy=j;class Y{constructor(re){this.items=re,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(re){let ne=this.firstIdx;for(;ne<this.items.length&&re(this.items[ne]);)ne++;const ce=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ce}takeFromEndWhile(re){let ne=this.lastIdx;for(;ne>=0&&re(this.items[ne]);)ne--;const ce=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const re=this.items[this.firstIdx];return this.firstIdx++,re}removeLast(){const re=this.items[this.lastIdx];return this.lastIdx--,re}takeCount(re){const ne=this.items.slice(this.firstIdx,this.firstIdx+re);return this.firstIdx+=re,ne}}e.ArrayQueue=Y;class oe{constructor(re){this.iterate=re}forEach(re){this.iterate(ne=>(re(ne),!0))}toArray(){const re=[];return this.iterate(ne=>(re.push(ne),!0)),re}filter(re){return new oe(ne=>this.iterate(ce=>re(ce)?ne(ce):!0))}map(re){return new oe(ne=>this.iterate(ce=>ne(re(ce))))}some(re){let ne=!1;return this.iterate(ce=>(ne=re(ce),!ne)),ne}findFirst(re){let ne;return this.iterate(ce=>re(ce)?(ne=ce,!1):!0),ne}findLast(re){let ne;return this.iterate(ce=>(re(ce)&&(ne=ce),!0)),ne}findLastMaxBy(re){let ne,ce=!0;return this.iterate(ge=>((ce||J.isGreaterThan(re(ge,ne)))&&(ce=!1,ne=ge),!0)),ne}}e.CallbackIterable=oe,oe.empty=new oe(q=>{})}),define(te[121],ie([0,1,17]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(u,m){if(!u)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function k(u,m="Unreachable"){throw new Error(m)}e.assertNever=k;function R(u){if(!u)throw new w.BugIndicatingError("Assertion Failed")}e.assert=R;function D(u){if(!u()){debugger;u(),(0,w.onUnexpectedError)(new w.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function E(u,m){let I=0;for(;I<u.length-1;){const v=u[I],b=u[I+1];if(!m(v,b))return!1;I++}return!0}e.checkAdjacentItems=E}),define(te[49],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=w}),define(te[57],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*E(o){yield o}t.single=E;function u(o){return o||R}t.from=u;function m(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=m;function I(o){return o[Symbol.iterator]().next().value}t.first=I;function v(o,n){for(const r of o)if(n(r))return!0;return!1}t.some=v;function b(o,n){for(const r of o)if(n(r))return r}t.find=b;function*d(o,n){for(const r of o)n(r)&&(yield r)}t.filter=d;function*h(o,n){let r=0;for(const s of o)yield n(s,r++)}t.map=h;function*y(...o){for(const n of o)for(const r of n)yield r}t.concat=y;function*C(o){for(const n of o)for(const r of n)yield r}t.concatNested=C;function p(o,n,r){let s=r;for(const c of o)s=n(s,c);return s}t.reduce=p;function S(o,n){let r=0;for(const s of o)n(s,r++)}t.forEach=S;function*f(o,n,r=o.length){for(n<0&&(n+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);n<r;n++)yield o[n]}t.slice=f;function g(o,n=Number.POSITIVE_INFINITY){const r=[];if(n===0)return[r,o];const s=o[Symbol.iterator]();for(let c=0;c<n;c++){const l=s.next();if(l.done)return[r,t.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=g;function a(o){return g(o)[0]}t.collect=a;function i(o,n,r=(s,c)=>s===c){const s=o[Symbol.iterator](),c=n[Symbol.iterator]();for(;;){const l=s.next(),P=c.next();if(l.done!==P.done)return!1;if(l.done)return!0;if(!r(l.value,P.value))return!1}}t.equals=i})(w=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(i,o=!1){let n=0;const r=i.length;let s="",c=0,l=16,P=0;function M(Z){let se=0,he=0;for(;se<Z;){const V=i.charCodeAt(n);if(V>=48&&V<=57)he=he*16+V-48;else if(V>=65&&V<=70)he=he*16+V-65+10;else if(V>=97&&V<=102)he=he*16+V-97+10;else break;n++,se++}return se<Z&&(he=-1),he}function T(Z){n=Z,s="",c=0,l=16,P=0}function N(){const Z=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return P=3,i.substring(Z,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;se=n}else P=3;return i.substring(Z,se)}function X(){let Z="",se=n;for(;;){if(n>=r){Z+=i.substring(se,n),P=2;break}const he=i.charCodeAt(n);if(he===34){Z+=i.substring(se,n),n++;break}if(he===92){if(Z+=i.substring(se,n),n++,n>=r){P=2;break}switch(i.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:{const H=M(4);H>=0?Z+=String.fromCharCode(H):P=4;break}default:P=5}se=n;continue}if(he>=0&&he<=31)if(u(he)){Z+=i.substring(se,n),P=2;break}else P=6;n++}return Z}function ae(){if(s="",P=0,c=n,n>=r)return c=r,l=17;let Z=i.charCodeAt(n);if(E(Z)){do n++,s+=String.fromCharCode(Z),Z=i.charCodeAt(n);while(E(Z));return l=15}if(u(Z))return n++,s+=String.fromCharCode(Z),Z===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),l=14;switch(Z){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,s=X(),l=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<r&&!u(i.charCodeAt(n));)n++;return s=i.substring(se,n),l=12}if(i.charCodeAt(n+1)===42){n+=2;const he=r-1;let V=!1;for(;n<he;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,V=!0;break}n++}return V||(n++,P=1),s=i.substring(se,n),l=13}return s+=String.fromCharCode(Z),n++,l=16}case 45:if(s+=String.fromCharCode(Z),n++,n===r||!m(i.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),l=11;default:for(;n<r&&Q(Z);)n++,Z=i.charCodeAt(n);if(c!==n){switch(s=i.substring(c,n),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(Z),n++,l=16}}function Q(Z){if(E(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let Z;do Z=ae();while(Z>=12&&Z<=15);return Z}return{setPosition:T,getPosition:()=>n,scan:o?G:ae,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>P}}e.createScanner=D;function E(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function v(i,o){const n=[],r=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(M,T,N,X){c.value=M,c.offset=T,c.length=N,c.type=X,c.colonOffset=void 0,s=c}try{f(i,{onObjectBegin:(M,T)=>{if(o<=M)throw r;s=void 0,l=o>M,n.push("")},onObjectProperty:(M,T,N)=>{if(o<T||(P(M,T,N,"property"),n[n.length-1]=M,o<=T+N))throw r},onObjectEnd:(M,T)=>{if(o<=M)throw r;s=void 0,n.pop()},onArrayBegin:(M,T)=>{if(o<=M)throw r;s=void 0,n.push(0)},onArrayEnd:(M,T)=>{if(o<=M)throw r;s=void 0,n.pop()},onLiteralValue:(M,T,N)=>{if(o<T||(P(M,T,N,a(M)),o<=T+N))throw r},onSeparator:(M,T,N)=>{if(o<=T)throw r;if(M===":"&&s&&s.type==="property")s.colonOffset=T,l=!1,s=void 0;else if(M===","){const X=n[n.length-1];typeof X=="number"?n[n.length-1]=X+1:(l=!0,n[n.length-1]=""),s=void 0}}})}catch(M){if(M!==r)throw M}return{path:n,previousNode:s,isAtPropertyKey:l,matches:M=>{let T=0;for(let N=0;T<M.length&&N<n.length;N++)if(M[T]===n[N]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=v;function b(i,o=[],n=R.DEFAULT){let r=null,s=[];const c=[];function l(M){Array.isArray(s)?s.push(M):r!==null&&(s[r]=M)}return f(i,{onObjectBegin:()=>{const M={};l(M),c.push(s),s=M,r=null},onObjectProperty:M=>{r=M},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const M=[];l(M),c.push(s),s=M,r=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:l,onError:(M,T,N)=>{o.push({error:M,offset:T,length:N})}},n),s[0]}e.parse=b;function d(i,o=[],n=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(M){r.type==="property"&&(r.length=M-r.offset,r=r.parent)}function c(M){return r.children.push(M),M}f(i,{onObjectBegin:M=>{r=c({type:"object",offset:M,length:-1,parent:r,children:[]})},onObjectProperty:(M,T,N)=>{r=c({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:M,offset:T,length:N,parent:r})},onObjectEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onArrayBegin:(M,T)=>{r=c({type:"array",offset:M,length:-1,parent:r,children:[]})},onArrayEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onLiteralValue:(M,T,N)=>{c({type:a(M),offset:T,length:N,parent:r,value:M}),s(T+N)},onSeparator:(M,T,N)=>{r.type==="property"&&(M===":"?r.colonOffset=T:M===","&&s(T))},onError:(M,T,N)=>{o.push({error:M,offset:T,length:N})}},n);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=d;function h(i,o){if(!i)return;let n=i;for(const r of o)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===r){n=c.children[1],s=!0;break}if(!s)return}else{const s=r;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function y(i){if(!i.parent||!i.parent.children)return[];const o=y(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.getNodePath=y;function C(i){switch(i.type){case"array":return i.children.map(C);case"object":{const o=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(o[n.children[0].value]=C(r))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=C;function p(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.contains=p;function S(i,o,n=!1){if(p(i,o,n)){const r=i.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const c=S(r[s],o,n);if(c)return c}return i}}e.findNodeAtOffset=S;function f(i,o,n=R.DEFAULT){const r=D(i,!1);function s(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(B){return B?$=>B($,r.getTokenOffset(),r.getTokenLength()):()=>!0}const l=s(o.onObjectBegin),P=c(o.onObjectProperty),M=s(o.onObjectEnd),T=s(o.onArrayBegin),N=s(o.onArrayEnd),X=c(o.onLiteralValue),ae=c(o.onSeparator),Q=s(o.onComment),G=c(o.onError),Z=n&&n.disallowComments,se=n&&n.allowTrailingComma;function he(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:Z||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(B){case 12:case 13:Z?V(10):Q();break;case 16:V(1);break;case 15:case 14:break;default:return B}}}function V(B,$=[],L=[]){if(G(B),$.length+L.length>0){let O=r.getToken();for(;O!==17;){if($.indexOf(O)!==-1){he();break}else if(L.indexOf(O)!==-1)break;O=he()}}}function H(B){const $=r.getTokenValue();return B?X($):P($),he(),!0}function W(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(V(2),B=0)}catch{V(2)}X(B);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return he(),!0}function A(){return r.getToken()!==10?(V(3,[],[2,5]),!1):(H(!1),r.getToken()===6?(ae(":"),he(),J()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function F(){l(),he();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||V(4,[],[]),ae(","),he(),r.getToken()===2&&se)break}else B&&V(6,[],[]);A()||V(4,[],[2,5]),B=!0}return M(),r.getToken()!==2?V(7,[2],[]):he(),!0}function U(){T(),he();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||V(4,[],[]),ae(","),he(),r.getToken()===4&&se)break}else B&&V(6,[],[]);J()||V(4,[],[4,5]),B=!0}return N(),r.getToken()!==4?V(8,[4],[]):he(),!0}function J(){switch(r.getToken()){case 3:return U();case 1:return F();case 10:return H(!0);default:return W()}}return he(),r.getToken()===17?n.allowEmptyContent?!0:(V(4,[],[]),!1):J()?(r.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=f;function g(i,o){const n=D(i),r=[];let s,c=0,l;do switch(l=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:c!==l&&r.push(i.substring(c,l)),o!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,o)),c=n.getPosition();break}while(s!==17);return r.join("")}e.stripComments=g;function a(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(te[122],ie([0,1,43]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,I,v){let b,d,h,y,C;if(I){for(y=I.offset,C=y+I.length,h=y;h>0&&!u(m,h-1);)h--;let l=C;for(;l<m.length&&!u(m,l);)l++;d=m.substring(h,l),b=D(d,v)}else d=m,b=0,h=0,y=0,C=m.length;const p=E(v,m);let S=!1,f=0,g;v.insertSpaces?g=R(" ",v.tabSize||4):g="	";const a=(0,w.createScanner)(d,!1);let i=!1;function o(){return p+R(g,b+f)}function n(){let l=a.scan();for(S=!1;l===15||l===14;)S=S||l===14,l=a.scan();return i=l===16||a.getTokenError()!==0,l}const r=[];function s(l,P,M){!i&&P<C&&M>y&&m.substring(P,M)!==l&&r.push({offset:P,length:M-P,content:l})}let c=n();if(c!==17){const l=a.getTokenOffset()+h,P=R(g,b);s(P,h,l)}for(;c!==17;){let l=a.getTokenOffset()+a.getTokenLength()+h,P=n(),M="";for(;!S&&(P===12||P===13);){const N=a.getTokenOffset()+h;s(" ",l,N),l=a.getTokenOffset()+a.getTokenLength()+h,M=P===12?o():"",P=n()}if(P===2)c!==1&&(f--,M=o());else if(P===4)c!==3&&(f--,M=o());else{switch(c){case 3:case 1:f++,M=o();break;case 5:case 12:M=o();break;case 13:S?M=o():M=" ";break;case 6:M=" ";break;case 10:if(P===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?M=" ":P!==5&&P!==17&&(i=!0);break;case 16:i=!0;break}S&&(P===12||P===13)&&(M=o())}const T=a.getTokenOffset()+h;s(M,l,T),c=P}return r}e.format=t;function k(m,I){const v=JSON.stringify(m,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?v.replace(/\r\n|\r|\n/g,I.eol):v}e.toFormattedString=k;function R(m,I){let v="";for(let b=0;b<I;b++)v+=m;return v}function D(m,I){let v=0,b=0;const d=I.tabSize||4;for(;v<m.length;){const h=m.charAt(v);if(h===" ")b++;else if(h==="	")b+=d;else break;v++}return Math.floor(b/d)}function E(m,I){for(let v=0;v<I.length;v++){const b=I.charAt(v);if(b==="\r")return v+1<I.length&&I.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=E;function u(m,I){return`\r
`.indexOf(m.charAt(I))!==-1}e.isEOL=u}),define(te[123],ie([0,1,43,122]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,I,v){return R(m,I,void 0,v)}e.removeProperty=k;function R(m,I,v,b,d){const h=I.slice(),y=[],C=(0,w.parseTree)(m,y);let p,S;for(;h.length>0&&(S=h.pop(),p=(0,w.findNodeAtLocation)(C,h),p===void 0&&v!==void 0);)typeof S=="string"?v={[S]:v}:v=[v];if(p)if(p.type==="object"&&typeof S=="string"&&Array.isArray(p.children)){const f=(0,w.findNodeAtLocation)(p,[S]);if(f!==void 0)if(v===void 0){if(!f.parent)throw new Error("Malformed AST");const g=p.children.indexOf(f.parent);let a,i=f.parent.offset+f.parent.length;if(g>0){const o=p.children[g-1];a=o.offset+o.length}else a=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return D(m,{offset:a,length:i-a,content:""},b)}else return D(m,{offset:f.offset,length:f.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const g=`${JSON.stringify(S)}: ${JSON.stringify(v)}`,a=d?d(p.children.map(o=>o.children[0].value)):p.children.length;let i;if(a>0){const o=p.children[a-1];i={offset:o.offset+o.length,length:0,content:","+g}}else p.children.length===0?i={offset:p.offset+1,length:0,content:g}:i={offset:p.offset+1,length:0,content:g+","};return D(m,i,b)}}else if(p.type==="array"&&typeof S=="number"&&Array.isArray(p.children))if(v!==void 0){const f=`${JSON.stringify(v)}`;let g;if(p.children.length===0||S===0)g={offset:p.offset+1,length:0,content:p.children.length===0?f:f+","};else{const a=S===-1||S>p.children.length?p.children.length:S,i=p.children[a-1];g={offset:i.offset+i.length,length:0,content:","+f}}return D(m,g,b)}else{const f=S,g=p.children[f];let a;if(p.children.length===1)a={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===f){const i=p.children[f-1],o=i.offset+i.length,n=p.offset+p.length;a={offset:o,length:n-2-o,content:""}}else a={offset:g.offset,length:p.children[f+1].offset-g.offset,content:""};return D(m,a,b)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${p.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(m,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(v)},b)}}e.setProperty=R;function D(m,I,v){let b=E(m,I),d=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;d>0&&!(0,t.isEOL)(b,d-1);)d--;for(;h<b.length&&!(0,t.isEOL)(b,h);)h++}const y=(0,t.format)(b,{offset:d,length:h-d},v);for(let p=y.length-1;p>=0;p--){const S=y[p];b=E(b,S),d=Math.min(d,S.offset),h=Math.max(h,S.offset+S.length),h+=S.content.length-S.length}const C=m.length-(b.length-h)-d;return[{offset:d,length:C,content:b.substring(d,h)}]}e.withFormatting=D;function E(m,I){return m.substring(0,I.offset)+I.content+m.substring(I.offset+I.length)}e.applyEdit=E;function u(m,I){const v=I.slice(0).sort((d,h)=>{const y=d.offset-h.offset;return y===0?d.length-h.length:y});let b=m.length;for(let d=v.length-1;d>=0;d--){const h=v[d];if(h.offset+h.length<=b)m=E(m,h);else throw new Error("Overlapping edit");b=h.offset}return m}e.applyEdits=u}),define(te[124],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new w(()=>k(this.getValue()))}}e.Lazy=w}),define(te[2],ie([0,1,49,57]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(s){R=s}if(e.setDisposableTracker=D,k){const s="__is_disposable_tracked__";D(new class{trackDisposable(c){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[s]||console.log(l)},3e3)}setParent(c,l){if(c&&c!==S.None)try{c[s]=!0}catch{}}markAsDisposed(c){if(c&&c!==S.None)try{c[s]=!0}catch{}}markAsSingleton(c){}})}function E(s){return R?.trackDisposable(s),s}function u(s){R?.markAsDisposed(s)}function m(s,c){R?.setParent(s,c)}function I(s,c){if(!!R)for(const l of s)R.setParent(l,c)}function v(s){return R?.markAsSingleton(s),s}e.markAsSingleton=v;function b(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=b;function d(s){if(t.Iterable.is(s)){const c=[];for(const l of s)if(l)try{l.dispose()}catch(P){c.push(P)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=d;function h(s){for(const c of s)b(c)&&c.dispose();return[]}e.disposeIfDisposable=h;function y(...s){const c=C(()=>d(s));return I(s,c),c}e.combinedDisposable=y;function C(s){const c=E({dispose:(0,w.once)(()=>{u(c),s()})});return c}e.toDisposable=C;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return m(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new p,E(this),m(this._store,this)}dispose(){u(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&m(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&m(c,null),c}}e.MutableDisposable=f;class g{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(c){let l=c;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,u(this))},this}}e.SafeDisposable=a;class i{constructor(){this.references=new Map}acquire(c,...l){let P=this.references.get(c);P||(P={counter:0,object:this.createReferencedObject(c,...l)},this.references.set(c,P));const{object:M}=P,T=(0,w.once)(()=>{--P.counter===0&&(this.destroyReferencedObject(c,P.object),this.references.delete(c))});return P.counter++,{object:M,dispose:T}}}e.ReferenceCollection=i;class o{constructor(c){this.referenceCollection=c}async acquire(c,...l){const P=this.referenceCollection.acquire(c,...l);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(M){throw P.dispose(),M}}}e.AsyncReferenceCollection=o;class n{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=n;function r(s){const c=new p;try{s(c)}finally{c.dispose()}}e.disposeOnReturn=r}),define(te[125],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(R){this.element=R,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class t{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let R=this._first;for(;R!==w.Undefined;){const D=R.next;R.prev=w.Undefined,R.next=w.Undefined,R=D}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const E=new w(R);if(this._first===w.Undefined)this._first=E,this._last=E;else if(D){const m=this._last;this._last=E,E.prev=m,m.next=E}else{const m=this._first;this._first=E,E.next=m,m.prev=E}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(E))}}shift(){if(this._first!==w.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==w.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==w.Undefined&&R.next!==w.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===w.Undefined&&R.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):R.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):R.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==w.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function z(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(u){R.push(u,Date.now())}function E(){const u=[];for(let m=0;m<R.length;m+=2)u.push({name:R[m],startTime:R[m+1]});return u}return{mark:D,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=w(t))}(),function(z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var t in w)(typeof exports=="object"?exports:z)[t]=w[t]}}(typeof self<"u"?self:this,function(){return function(z){var e={};function w(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return z[t].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=z,w.c=e,w.d=function(t,k,R){w.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},w.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},w.t=function(t,k){if(1&k&&(t=w(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(w.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)w.d(R,D,function(E){return t[E]}.bind(null,D));return R},w.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return w.d(k,"a",k),k},w.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},w.p="",w(w.s=0)}([function(z,e,w){(function(t){var k;e=z.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],m=0,I=m++;u[I]="0|[1-9]\\d*";var v=m++;u[v]="[0-9]+";var b=m++;u[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=m++;u[d]="("+u[I]+")\\.("+u[I]+")\\.("+u[I]+")";var h=m++;u[h]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var y=m++;u[y]="(?:"+u[I]+"|"+u[b]+")";var C=m++;u[C]="(?:"+u[v]+"|"+u[b]+")";var p=m++;u[p]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var S=m++;u[S]="(?:-?("+u[C]+"(?:\\."+u[C]+")*))";var f=m++;u[f]="[0-9A-Za-z-]+";var g=m++;u[g]="(?:\\+("+u[f]+"(?:\\."+u[f]+")*))";var a=m++,i="v?"+u[d]+u[p]+"?"+u[g]+"?";u[a]="^"+i+"$";var o="[v=\\s]*"+u[h]+u[S]+"?"+u[g]+"?",n=m++;u[n]="^"+o+"$";var r=m++;u[r]="((?:<|>)?=?)";var s=m++;u[s]=u[v]+"|x|X|\\*";var c=m++;u[c]=u[I]+"|x|X|\\*";var l=m++;u[l]="[v=\\s]*("+u[c]+")(?:\\.("+u[c]+")(?:\\.("+u[c]+")(?:"+u[p]+")?"+u[g]+"?)?)?";var P=m++;u[P]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[S]+")?"+u[g]+"?)?)?";var M=m++;u[M]="^"+u[r]+"\\s*"+u[l]+"$";var T=m++;u[T]="^"+u[r]+"\\s*"+u[P]+"$";var N=m++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=m++;u[X]="(?:~>?)";var ae=m++;u[ae]="(\\s*)"+u[X]+"\\s+",E[ae]=new RegExp(u[ae],"g");var Q=m++;u[Q]="^"+u[X]+u[l]+"$";var G=m++;u[G]="^"+u[X]+u[P]+"$";var Z=m++;u[Z]="(?:\\^)";var se=m++;u[se]="(\\s*)"+u[Z]+"\\s+",E[se]=new RegExp(u[se],"g");var he=m++;u[he]="^"+u[Z]+u[l]+"$";var V=m++;u[V]="^"+u[Z]+u[P]+"$";var H=m++;u[H]="^"+u[r]+"\\s*("+o+")$|^$";var W=m++;u[W]="^"+u[r]+"\\s*("+i+")$|^$";var A=m++;u[A]="(\\s*)"+u[r]+"\\s*("+o+"|"+u[l]+")",E[A]=new RegExp(u[A],"g");var F=m++;u[F]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var U=m++;u[U]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var J=m++;u[J]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,u[B]),E[B]||(E[B]=new RegExp(u[B]));function $(x,le){if(x instanceof L)return x;if(typeof x!="string"||x.length>R||!(le?E[n]:E[a]).test(x))return null;try{return new L(x,le)}catch{return null}}function L(x,le){if(x instanceof L){if(x.loose===le)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(x,le);k("SemVer",x,le),this.loose=le;var fe=x.trim().match(le?E[n]:E[a]);if(!fe)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ie=+Se;if(Ie>=0&&Ie<D)return Ie}return Se}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=$,e.valid=function(x,le){var fe=$(x,le);return fe?fe.version:null},e.clean=function(x,le){var fe=$(x.trim().replace(/^[=v]+/,""),le);return fe?fe.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof L||(x=new L(x,this.loose)),this.compareMain(x)||this.comparePre(x)},L.prototype.compareMain=function(x){return x instanceof L||(x=new L(x,this.loose)),_(this.major,x.major)||_(this.minor,x.minor)||_(this.patch,x.patch)},L.prototype.comparePre=function(x){if(x instanceof L||(x=new L(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var le=0;do{var fe=this.prerelease[le],Se=x.prerelease[le];if(k("prerelease compare",le,fe,Se),fe===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(fe===void 0)return-1;if(fe!==Se)return _(fe,Se)}while(++le)},L.prototype.inc=function(x,le){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,le,fe,Se){typeof fe=="string"&&(Se=fe,fe=void 0);try{return new L(x,fe).inc(le,Se).version}catch{return null}},e.diff=function(x,le){if(q(x,le))return null;var fe=$(x),Se=$(le);if(fe.prerelease.length||Se.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Se[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Se[Ie])return Ie},e.compareIdentifiers=_;var O=/^[0-9]+$/;function _(x,le){var fe=O.test(x),Se=O.test(le);return fe&&Se&&(x=+x,le=+le),fe&&!Se?-1:Se&&!fe?1:x<le?-1:x>le?1:0}function j(x,le,fe){return new L(x,fe).compare(new L(le,fe))}function Y(x,le,fe){return j(x,le,fe)>0}function oe(x,le,fe){return j(x,le,fe)<0}function q(x,le,fe){return j(x,le,fe)===0}function re(x,le,fe){return j(x,le,fe)!==0}function ne(x,le,fe){return j(x,le,fe)>=0}function ce(x,le,fe){return j(x,le,fe)<=0}function ge(x,le,fe,Se){var Ie;switch(le){case"===":typeof x=="object"&&(x=x.version),typeof fe=="object"&&(fe=fe.version),Ie=x===fe;break;case"!==":typeof x=="object"&&(x=x.version),typeof fe=="object"&&(fe=fe.version),Ie=x!==fe;break;case"":case"=":case"==":Ie=q(x,fe,Se);break;case"!=":Ie=re(x,fe,Se);break;case">":Ie=Y(x,fe,Se);break;case">=":Ie=ne(x,fe,Se);break;case"<":Ie=oe(x,fe,Se);break;case"<=":Ie=ce(x,fe,Se);break;default:throw new TypeError("Invalid operator: "+le)}return Ie}function De(x,le){if(x instanceof De){if(x.loose===le)return x;x=x.value}if(!(this instanceof De))return new De(x,le);k("comparator",x,le),this.loose=le,this.parse(x),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,le){return _(le,x)},e.major=function(x,le){return new L(x,le).major},e.minor=function(x,le){return new L(x,le).minor},e.patch=function(x,le){return new L(x,le).patch},e.compare=j,e.compareLoose=function(x,le){return j(x,le,!0)},e.rcompare=function(x,le,fe){return j(le,x,fe)},e.sort=function(x,le){return x.sort(function(fe,Se){return e.compare(fe,Se,le)})},e.rsort=function(x,le){return x.sort(function(fe,Se){return e.rcompare(fe,Se,le)})},e.gt=Y,e.lt=oe,e.eq=q,e.neq=re,e.gte=ne,e.lte=ce,e.cmp=ge,e.Comparator=De;var Ae={};function ke(x,le){if(x instanceof ke)return x.loose===le?x:new ke(x.raw,le);if(x instanceof De)return new ke(x.value,le);if(!(this instanceof ke))return new ke(x,le);if(this.loose=le,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Le(x){return!x||x.toLowerCase()==="x"||x==="*"}function qe(x,le,fe,Se,Ie,Te,Oe,Ne,Be,ze,Ke,Ue,Ge){return((le=Le(fe)?"":Le(Se)?">="+fe+".0.0":Le(Ie)?">="+fe+"."+Se+".0":">="+le)+" "+(Ne=Le(Be)?"":Le(ze)?"<"+(+Be+1)+".0.0":Le(Ke)?"<"+Be+"."+(+ze+1)+".0":Ue?"<="+Be+"."+ze+"."+Ke+"-"+Ue:"<="+Ne)).trim()}function me(x,le){for(var fe=0;fe<x.length;fe++)if(!x[fe].test(le))return!1;if(le.prerelease.length){for(fe=0;fe<x.length;fe++)if(k(x[fe].semver),x[fe].semver!==Ae&&x[fe].semver.prerelease.length>0){var Se=x[fe].semver;if(Se.major===le.major&&Se.minor===le.minor&&Se.patch===le.patch)return!0}return!1}return!0}function we(x,le,fe){try{le=new ke(le,fe)}catch{return!1}return le.test(x)}function Ee(x,le,fe,Se){var Ie,Te,Oe,Ne,Be;switch(x=new L(x,Se),le=new ke(le,Se),fe){case">":Ie=Y,Te=ce,Oe=oe,Ne=">",Be=">=";break;case"<":Ie=oe,Te=ne,Oe=Y,Ne="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(x,le,Se))return!1;for(var ze=0;ze<le.set.length;++ze){var Ke=le.set[ze],Ue=null,Ge=null;if(Ke.forEach(function(K){K.semver===Ae&&(K=new De(">=0.0.0")),Ue=Ue||K,Ge=Ge||K,Ie(K.semver,Ue.semver,Se)?Ue=K:Oe(K.semver,Ge.semver,Se)&&(Ge=K)}),Ue.operator===Ne||Ue.operator===Be||(!Ge.operator||Ge.operator===Ne)&&Te(x,Ge.semver)||Ge.operator===Be&&Oe(x,Ge.semver))return!1}return!0}De.prototype.parse=function(x){var le=this.loose?E[H]:E[W],fe=x.match(le);if(!fe)throw new TypeError("Invalid comparator: "+x);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new L(fe[2],this.loose):this.semver=Ae},De.prototype.toString=function(){return this.value},De.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===Ae||(typeof x=="string"&&(x=new L(x,this.loose)),ge(x,this.operator,this.semver,this.loose))},De.prototype.intersects=function(x,le){if(!(x instanceof De))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new ke(x.value,le),we(this.value,fe,le);if(x.operator==="")return fe=new ke(this.value,le),we(x.semver,fe,le);var Se=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Te=this.semver.version===x.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Ne=ge(this.semver,"<",x.semver,le)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Be=ge(this.semver,">",x.semver,le)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return Se||Ie||Te&&Oe||Ne||Be},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(x){var le=this.loose;x=x.trim(),k("range",x,le);var fe=le?E[U]:E[F];x=x.replace(fe,qe),k("hyphen replace",x),x=x.replace(E[A],"$1$2$3"),k("comparator trim",x,E[A]),x=(x=(x=x.replace(E[ae],"$1~")).replace(E[se],"$1^")).split(/\s+/).join(" ");var Se=le?E[H]:E[W],Ie=x.split(" ").map(function(Te){return function(Oe,Ne){return k("comp",Oe),Oe=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ke){return function(Ue,Ge){k("caret",Ue,Ge);var K=Ge?E[V]:E[he];return Ue.replace(K,function(ue,de,pe,ye,Re){var _e;return k("caret",Ue,ue,de,pe,ye,Re),Le(de)?_e="":Le(pe)?_e=">="+de+".0.0 <"+(+de+1)+".0.0":Le(ye)?_e=de==="0"?">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+".0 <"+(+de+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=de==="0"?pe==="0"?">="+de+"."+pe+"."+ye+Re+" <"+de+"."+pe+"."+(+ye+1):">="+de+"."+pe+"."+ye+Re+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+ye+Re+" <"+(+de+1)+".0.0"):(k("no pr"),_e=de==="0"?pe==="0"?">="+de+"."+pe+"."+ye+" <"+de+"."+pe+"."+(+ye+1):">="+de+"."+pe+"."+ye+" <"+de+"."+(+pe+1)+".0":">="+de+"."+pe+"."+ye+" <"+(+de+1)+".0.0"),k("caret return",_e),_e})}(Ke,ze)}).join(" ")}(Oe,Ne),k("caret",Oe),Oe=function(Be,ze){return Be.trim().split(/\s+/).map(function(Ke){return function(Ue,Ge){var K=Ge?E[G]:E[Q];return Ue.replace(K,function(ue,de,pe,ye,Re){var _e;return k("tilde",Ue,ue,de,pe,ye,Re),Le(de)?_e="":Le(pe)?_e=">="+de+".0.0 <"+(+de+1)+".0.0":Le(ye)?_e=">="+de+"."+pe+".0 <"+de+"."+(+pe+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),_e=">="+de+"."+pe+"."+ye+Re+" <"+de+"."+(+pe+1)+".0"):_e=">="+de+"."+pe+"."+ye+" <"+de+"."+(+pe+1)+".0",k("tilde return",_e),_e})}(Ke,ze)}).join(" ")}(Oe,Ne),k("tildes",Oe),Oe=function(Be,ze){return k("replaceXRanges",Be,ze),Be.split(/\s+/).map(function(Ke){return function(Ue,Ge){Ue=Ue.trim();var K=Ge?E[T]:E[M];return Ue.replace(K,function(ue,de,pe,ye,Re,_e){k("xRange",Ue,ue,de,pe,ye,Re,_e);var it=Le(pe),xe=it||Le(ye),je=xe||Le(Re);return de==="="&&je&&(de=""),it?ue=de===">"||de==="<"?"<0.0.0":"*":de&&je?(xe&&(ye=0),je&&(Re=0),de===">"?(de=">=",xe?(pe=+pe+1,ye=0,Re=0):je&&(ye=+ye+1,Re=0)):de==="<="&&(de="<",xe?pe=+pe+1:ye=+ye+1),ue=de+pe+"."+ye+"."+Re):xe?ue=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(ue=">="+pe+"."+ye+".0 <"+pe+"."+(+ye+1)+".0"),k("xRange return",ue),ue})}(Ke,ze)}).join(" ")}(Oe,Ne),k("xrange",Oe),Oe=function(Be,ze){return k("replaceStars",Be,ze),Be.trim().replace(E[J],"")}(Oe,Ne),k("stars",Oe),Oe}(Te,le)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Te){return!!Te.match(Se)})),Ie=Ie.map(function(Te){return new De(Te,le)})},ke.prototype.intersects=function(x,le){if(!(x instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Se){return x.set.some(function(Ie){return Ie.every(function(Te){return Se.intersects(Te,le)})})})})},e.toComparators=function(x,le){return new ke(x,le).set.map(function(fe){return fe.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new L(x,this.loose));for(var le=0;le<this.set.length;le++)if(me(this.set[le],x))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(x,le,fe){var Se=null,Ie=null;try{var Te=new ke(le,fe)}catch{return null}return x.forEach(function(Oe){Te.test(Oe)&&(Se&&Ie.compare(Oe)!==-1||(Ie=new L(Se=Oe,fe)))}),Se},e.minSatisfying=function(x,le,fe){var Se=null,Ie=null;try{var Te=new ke(le,fe)}catch{return null}return x.forEach(function(Oe){Te.test(Oe)&&(Se&&Ie.compare(Oe)!==1||(Ie=new L(Se=Oe,fe)))}),Se},e.validRange=function(x,le){try{return new ke(x,le).range||"*"}catch{return null}},e.ltr=function(x,le,fe){return Ee(x,le,"<",fe)},e.gtr=function(x,le,fe){return Ee(x,le,">",fe)},e.outside=Ee,e.prerelease=function(x,le){var fe=$(x,le);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(x,le,fe){return x=new ke(x,fe),le=new ke(le,fe),x.intersects(le)},e.coerce=function(x){if(x instanceof L)return x;if(typeof x!="string")return null;var le=x.match(E[N]);return le==null?null:$((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,w(1))},function(z,e){var w,t,k=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function E(C){if(w===setTimeout)return setTimeout(C,0);if((w===R||!w)&&setTimeout)return w=setTimeout,setTimeout(C,0);try{return w(C,0)}catch{try{return w.call(null,C,0)}catch{return w.call(this,C,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:R}catch{w=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var u,m=[],I=!1,v=-1;function b(){I&&u&&(I=!1,u.length?m=u.concat(m):v=-1,m.length&&d())}function d(){if(!I){var C=E(b);I=!0;for(var p=m.length;p;){for(u=m,m=[];++v<p;)u&&u[v].run();v=-1,p=m.length}u=null,I=!1,function(S){if(t===clearTimeout)return clearTimeout(S);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(S);try{t(S)}catch{try{return t.call(null,S)}catch{return t.call(this,S)}}}(C)}}function h(C,p){this.fun=C,this.array=p}function y(){}k.nextTick=function(C){var p=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)p[S-1]=arguments[S];m.push(new h(C,p)),m.length!==1||I||E(d)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[126],ie([0,1]),function(z,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(E,u,m){this.level=E,this.key=u,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(E,u=2**16){this.comparator=E,this[w]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(E){return Boolean(R._search(this,E,this.comparator))}get(E){return R._search(this,E,this.comparator)?.value}set(E,u){return R._insert(this,E,u,this.comparator)&&(this._size+=1),this}delete(E){const u=R._delete(this,E,this.comparator);return u&&(this._size-=1),u}forEach(E,u){let m=this._header.forward[0];for(;m;)E.call(u,m.value,m.key,this),m=m.forward[0]}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this._header.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static _search(E,u,m){let I=E._header;for(let v=E._level-1;v>=0;v--)for(;I.forward[v]&&m(I.forward[v].key,u)<0;)I=I.forward[v];if(I=I.forward[0],I&&m(I.key,u)===0)return I}static _insert(E,u,m,I){const v=[];let b=E._header;for(let d=E._level-1;d>=0;d--){for(;b.forward[d]&&I(b.forward[d].key,u)<0;)b=b.forward[d];v[d]=b}if(b=b.forward[0],b&&I(b.key,u)===0)return b.value=m,!1;{const d=R._randomLevel(E);if(d>E._level){for(let h=E._level;h<d;h++)v[h]=E._header;E._level=d}b=new t(d,u,m);for(let h=0;h<d;h++)b.forward[h]=v[h].forward[h],v[h].forward[h]=b;return!0}}static _randomLevel(E,u=.5){let m=1;for(;Math.random()<u&&m<E._maxLevel;)m+=1;return m}static _delete(E,u,m){const I=[];let v=E._header;for(let b=E._level-1;b>=0;b--){for(;v.forward[b]&&m(v.forward[b].key,u)<0;)v=v.forward[b];I[b]=v}if(v=v.forward[0],!v||m(v.key,u)!==0)return!1;for(let b=0;b<E._level&&I[b].forward[b]===v;b++)I[b].forward[b]=v.forward[b];for(;E._level>0&&E._header.forward[E._level-1]===k;)E._level-=1;return!0}}e.SkipList=R}),define(te[58],ie([0,1,17,2]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(g){const a=g;return a?typeof a.read=="function":!1}e.isReadable=k;function R(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function D(g){const a=g;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=D;function E(g,a){return new u(g,a)}e.newWriteableStream=E;class u{constructor(a,i){this.reducer=a,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(i=>i(a))}emitError(a){this.listeners.error.length===0?(0,w.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(i=>i(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,i){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(a,i){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(g,a){const i=[];let o;for(;(o=g.read())!==null;)i.push(o);return a(i)}e.consumeReadable=m;function I(g,a,i){const o=[];let n;for(;(n=g.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const r=n;return n=void 0,r}return g.read()}}}e.peekReadable=I;function v(g,a){return new Promise((i,o)=>{const n=[];b(g,{onData:r=>{a&&n.push(r)},onError:r=>{a?o(r):i(void 0)},onEnd:()=>{i(a?a(n):void 0)}})})}e.consumeStream=v;function b(g,a){let i=!1;return g.on("error",o=>{i||a.onError(o)}),g.on("end",()=>{i||a.onEnd()}),g.on("data",o=>{i||a.onData(o)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=b;function d(g,a){return new Promise((i,o)=>{const n=new t.DisposableStore,r=[],s=P=>{if(r.push(P),r.length>a)return n.dispose(),g.pause(),i({stream:g,buffer:r,ended:!1})},c=P=>o(P),l=()=>i({stream:g,buffer:r,ended:!0});n.add((0,t.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),n.add((0,t.toDisposable)(()=>g.removeListener("end",l))),g.on("end",l),n.add((0,t.toDisposable)(()=>g.removeListener("data",s))),g.on("data",s)})}e.peekStream=d;function h(g,a){const i=E(a);return i.end(g),i}e.toStream=h;function y(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=y;function C(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.toReadable=C;function p(g,a,i){const o=E(i);return b(g,{onData:n=>o.write(a.data(n)),onError:n=>o.error(a.error?a.error(n):n),onEnd:()=>o.end()}),o}e.transform=p;function S(g,a,i){let o=!1;return{read:()=>{const n=a.read();return o?n:(o=!0,n!==null?i([g,n]):g)}}}e.prefixedReadable=S;function f(g,a,i){let o=!1;const n=E(i);return b(a,{onData:r=>o?n.write(r):(o=!0,n.write(i([g,r]))),onError:r=>n.error(r),onEnd:()=>{o||(o=!0,n.write(g)),n.end()}}),n}e.prefixedStream=f}),define(te[18],ie([0,1,58]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{static alloc(P){return t?new D(Buffer.allocUnsafe(P)):new D(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new D(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(P)):(k||(k=new TextEncoder),new D(k.encode(P)))}static fromByteArray(P){const M=D.alloc(P.length);for(let T=0,N=P.length;T<N;T++)M.buffer[T]=P[T];return M}static concat(P,M){if(typeof M>"u"){M=0;for(let X=0,ae=P.length;X<ae;X++)M+=P[X].byteLength}const T=D.alloc(M);let N=0;for(let X=0,ae=P.length;X<ae;X++){const Q=P[X];T.set(Q,N),N+=Q.byteLength}return T}constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}clone(){const P=D.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,M){return new D(this.buffer.subarray(P,M))}set(P,M){if(P instanceof D)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return m(this.buffer,P)}writeUInt32BE(P,M){I(this.buffer,P,M)}readUInt32LE(P){return v(this.buffer,P)}writeUInt32LE(P,M){b(this.buffer,P,M)}readUInt8(P){return d(this.buffer,P)}writeUInt8(P,M){h(this.buffer,P,M)}}e.VSBuffer=D;function E(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0}e.readUInt16LE=E;function u(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255}e.writeUInt16LE=u;function m(l,P){return l[P]*2**24+l[P+1]*2**16+l[P+2]*2**8+l[P+3]}e.readUInt32BE=m;function I(l,P,M){l[M+3]=P,P=P>>>8,l[M+2]=P,P=P>>>8,l[M+1]=P,P=P>>>8,l[M]=P}e.writeUInt32BE=I;function v(l,P){return l[P+0]<<0>>>0|l[P+1]<<8>>>0|l[P+2]<<16>>>0|l[P+3]<<24>>>0}e.readUInt32LE=v;function b(l,P,M){l[M+0]=P&255,P=P>>>8,l[M+1]=P&255,P=P>>>8,l[M+2]=P&255,P=P>>>8,l[M+3]=P&255}e.writeUInt32LE=b;function d(l,P){return l[P]}e.readUInt8=d;function h(l,P,M){l[M]=P}e.writeUInt8=h;function y(l){return w.consumeReadable(l,P=>D.concat(P))}e.readableToBuffer=y;function C(l){return w.toReadable(l)}e.bufferToReadable=C;function p(l){return w.consumeStream(l,P=>D.concat(P))}e.streamToBuffer=p;async function S(l){return l.ended?D.concat(l.buffer):D.concat([...l.buffer,await p(l.stream)])}e.bufferedStreamToBuffer=S;function f(l){return w.toStream(l,P=>D.concat(P))}e.bufferToStream=f;function g(l){return w.transform(l,{data:P=>typeof P=="string"?D.fromString(P):D.wrap(P)},P=>D.concat(P))}e.streamToBufferReadableStream=g;function a(l){return w.newWriteableStream(P=>D.concat(P),l)}e.newWriteableBufferStream=a;function i(l,P){return w.prefixedReadable(l,P,M=>D.concat(M))}e.prefixedBufferReadable=i;function o(l,P){return w.prefixedStream(l,P,M=>D.concat(M))}e.prefixedBufferStream=o;function n(l){let P=0,M=0,T=0;const N=new Uint8Array(Math.floor(l.length/4*3)),X=Q=>{switch(M){case 3:N[T++]=P|Q,M=0;break;case 2:N[T++]=P|Q>>>2,P=Q<<6,M=3;break;case 1:N[T++]=P|Q>>>4,P=Q<<4,M=2;break;default:P=Q<<2,M=1}};for(let Q=0;Q<l.length;Q++){const G=l.charCodeAt(Q);if(G>=65&&G<=90)X(G-65);else if(G>=97&&G<=122)X(G-97+26);else if(G>=48&&G<=57)X(G-48+52);else if(G===43||G===45)X(62);else if(G===47||G===95)X(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${l[Q]}`)}}const ae=T;for(;M>0;)X(0);return D.wrap(N).slice(0,ae)}e.decodeBase64=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:l},P=!0,M=!1){const T=M?s:r;let N="";const X=l.byteLength%3;let ae=0;for(;ae<l.byteLength-X;ae+=3){const Q=l[ae+0],G=l[ae+1],Z=l[ae+2];N+=T[Q>>>2],N+=T[(Q<<4|G>>>4)&63],N+=T[(G<<2|Z>>>6)&63],N+=T[Z&63]}if(X===1){const Q=l[ae+0];N+=T[Q>>>2],N+=T[Q<<4&63],P&&(N+="==")}else if(X===2){const Q=l[ae+0],G=l[ae+1];N+=T[Q>>>2],N+=T[(Q<<4|G>>>4)&63],N+=T[G<<2&63],P&&(N+="=")}return N}e.encodeBase64=c}),define(te[12],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function w(o){return typeof o=="string"}e.isString=w;function t(o){return Array.isArray(o)&&o.every(n=>w(n))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.isTypedArray=R;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function E(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=E;function u(o){return o===!0||o===!1}e.isBoolean=u;function m(o){return typeof o>"u"}e.isUndefined=m;function I(o){return!v(o)}e.isDefined=I;function v(o){return m(o)||o===null}e.isUndefinedOrNull=v;function b(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=b;function d(o){if(v(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=d;function h(...o){const n=[];for(let r=0;r<o.length;r++){const s=o[r];if(v(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);n.push(s)}return n}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function C(o){if(!k(o))return!1;for(const n in o)if(y.call(o,n))return!1;return!0}e.isEmptyObject=C;function p(o){return typeof o=="function"}e.isFunction=p;function S(...o){return o.length>0&&o.every(p)}e.areFunctions=S;function f(o,n){const r=Math.min(o.length,n.length);for(let s=0;s<r;s++)g(o[s],n[s])}e.validateConstraints=f;function g(o,n){if(w(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(p(n)){try{if(o instanceof n)return}catch{}if(!v(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(te[50],ie([0,1,12]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const S=Array.isArray(p)?[]:{};return Object.keys(p).forEach(f=>{p[f]&&typeof p[f]=="object"?S[f]=t(p[f]):S[f]=p[f]}),S}e.deepClone=t;function k(p){if(!p||typeof p!="object")return p;const S=[p];for(;S.length>0;){const f=S.shift();Object.freeze(f);for(const g in f)if(R.call(f,g)){const a=f[g];typeof a=="object"&&!Object.isFrozen(a)&&!(0,w.isTypedArray)(a)&&S.push(a)}}return p}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(p,S){return E(p,S,new Set)}e.cloneAndChange=D;function E(p,S,f){if((0,w.isUndefinedOrNull)(p))return p;const g=S(p);if(typeof g<"u")return g;if(Array.isArray(p)){const a=[];for(const i of p)a.push(E(i,S,f));return a}if((0,w.isObject)(p)){if(f.has(p))throw new Error("Cannot clone recursive data-structure");f.add(p);const a={};for(const i in p)R.call(p,i)&&(a[i]=E(p[i],S,f));return f.delete(p),a}return p}function u(p,S,f=!0){return(0,w.isObject)(p)?((0,w.isObject)(S)&&Object.keys(S).forEach(g=>{g in p?f&&((0,w.isObject)(p[g])&&(0,w.isObject)(S[g])?u(p[g],S[g],f):p[g]=S[g]):p[g]=S[g]}),p):S}e.mixin=u;function m(p,S){if(p===S)return!0;if(p==null||S===null||S===void 0||typeof p!=typeof S||typeof p!="object"||Array.isArray(p)!==Array.isArray(S))return!1;let f,g;if(Array.isArray(p)){if(p.length!==S.length)return!1;for(f=0;f<p.length;f++)if(!m(p[f],S[f]))return!1}else{const a=[];for(g in p)a.push(g);a.sort();const i=[];for(g in S)i.push(g);if(i.sort(),!m(a,i))return!1;for(f=0;f<a.length;f++)if(!m(p[a[f]],S[a[f]]))return!1}return!0}e.equals=m;function I(p){const S=new Set;return JSON.stringify(p,(f,g)=>{if((0,w.isObject)(g)||Array.isArray(g)){if(S.has(g))return"[Circular]";S.add(g)}return g})}e.safeStringify=I;function v(p,S){const f=Object.create(null);return!p||!S||Object.keys(S).forEach(a=>{const i=p[a],o=S[a];m(i,o)||(f[a]=o)}),f}e.distinct=v;function b(p,S){const f=S.toLowerCase(),g=Object.keys(p).find(a=>a.toLowerCase()===f);return g?p[g]:p[S]}e.getCaseInsensitive=b;function d(p,S){const f=Object.create(null);for(const[g,a]of Object.entries(p))S(g,a)&&(f[g]=a);return f}e.filter=d;function h(p){let S=[],f=Object.getPrototypeOf(p);for(;Object.prototype!==f;)S=S.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return S}e.getAllPropertyNames=h;function y(p){const S=[];for(const f of h(p))typeof p[f]=="function"&&S.push(f);return S}e.getAllMethodNames=y;function C(p,S){const f=a=>function(){const i=Array.prototype.slice.call(arguments,0);return S(a,i)},g={};for(const a of p)g[a]=f(a);return g}e.createProxyObject=C}),define(te[29],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return w.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),D=[];for(let E=0;E<256;E++)D.push(E.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,m="";return m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+="-",m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m+=D[R[u++]],m}}()}),define(te[127],ie([0,1,76,40,49]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,E){if(await new Promise((I,v)=>{const b=t.createReadStream(D),d=w.createHash("sha1");b.pipe(d);const h=(0,k.once)((y,C)=>{b.removeAllListeners(),d.removeAllListeners(),y?v(y):I(C)});b.once("error",h),b.once("end",h),d.once("error",h),d.once("data",y=>h(void 0,y.toString("hex")))})!==E)throw new Error("Hash mismatch")}e.checksum=R}),define(te[128],ie([0,1,27]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const E=D.replace(/\-/g,":").toLowerCase();return!t.has(E)}function R(){const D=(0,w.networkInterfaces)();for(const E in D){const u=D[E];if(u){for(const{mac:m}of u)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[94],ie([0,1,77]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(E,u,m,I=1){let v=!1;return new Promise(b=>{const d=setTimeout(()=>{if(!v)return v=!0,b(0)},m);k(E,u,I,h=>{if(!v)return v=!0,clearTimeout(d),b(h)})})}e.findFreePort=t;function k(E,u,m,I){if(u===0)return I(0);const v=new w.Socket;v.once("connect",()=>(D(v),k(E+m,u-1,m,I))),v.once("data",()=>{}),v.once("error",b=>(D(v),b.code!=="ECONNREFUSED"?k(E+m,u-1,m,I):I(E))),v.connect(E,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,u,m){let I=!1,v,b=1;const d=w.createServer({pauseOnConnect:!0});function h(y,C){I||(I=!0,d.removeAllListeners(),d.close(),v&&clearTimeout(v),C(y))}return new Promise(y=>{v=setTimeout(()=>{h(0,y)},m),d.on("listening",()=>{h(E,y)}),d.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&b<u?(E++,b++,d.listen(E,"127.0.0.1")):h(0,y)}),d.on("close",()=>{h(0,y)}),d.listen(E,"127.0.0.1")})}e.findFreePortFaster=R;function D(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(u){console.error(u)}}}),define(te[129],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[130],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(te[41],ie([0,1,15,17]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,E){const u=(m,...I)=>{this.validateEvent(D,m)&&E(m,...I)};return this.mapListenerToWrapper.set(E,u),w.ipcMain.on(D,u),this}once(D,E){return w.ipcMain.once(D,(u,...m)=>{this.validateEvent(D,u)&&E(u,...m)}),this}handle(D,E){return w.ipcMain.handle(D,(u,...m)=>this.validateEvent(D,u)?E(u,...m):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return w.ipcMain.removeHandler(D),this}removeListener(D,E){const u=this.mapListenerToWrapper.get(E);return u&&(w.ipcMain.removeListener(D,u),this.mapListenerToWrapper.delete(E)),this}validateEvent(D,E){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const u=E.senderFrame,m=u.url;if(!m)return!0;let I="unknown";try{I=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${m}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${I}'.`),!1):u.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(te[131],ie([0,1,15,41,12,129]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(u,m,I,v,b)=>{const d=E(u,v,I);d.popup({window:(0,k.withNullAsUndefined)(w.BrowserWindow.fromWebContents(u.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{d&&u.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=D;function E(u,m,I){const v=new w.Menu;return I.forEach(b=>{let d;b.type==="separator"?d=new w.MenuItem({type:b.type}):Array.isArray(b.submenu)?d=new w.MenuItem({submenu:E(u,m,b.submenu),label:b.label}):d=new w.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(h,y,C)=>u.sender.send(m,b.id,C)}),v.append(d)}),v}}),define(te[132],ie([11,10]),function(z,e){return z.create("vs/base/common/date",e)}),define(te[133],ie([0,1,132]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,E=R*30,u=R*365;function m(v,b,d){typeof v!="number"&&(v=v.getTime());const h=Math.round((new Date().getTime()-v)/1e3);if(h<-30)return(0,w.localize)(0,null,m(new Date().getTime()+h*1e3,!1));if(h<30)return(0,w.localize)(1,null);let y;return h<t?(y=h,b?y===1?d?(0,w.localize)(2,null,y):(0,w.localize)(3,null,y):d?(0,w.localize)(4,null,y):(0,w.localize)(5,null,y):y===1?d?(0,w.localize)(6,null,y):(0,w.localize)(7,null,y):d?(0,w.localize)(8,null,y):(0,w.localize)(9,null,y)):h<k?(y=Math.floor(h/t),b?y===1?d?(0,w.localize)(10,null,y):(0,w.localize)(11,null,y):d?(0,w.localize)(12,null,y):(0,w.localize)(13,null,y):y===1?d?(0,w.localize)(14,null,y):(0,w.localize)(15,null,y):d?(0,w.localize)(16,null,y):(0,w.localize)(17,null,y)):h<R?(y=Math.floor(h/k),b?y===1?d?(0,w.localize)(18,null,y):(0,w.localize)(19,null,y):d?(0,w.localize)(20,null,y):(0,w.localize)(21,null,y):y===1?d?(0,w.localize)(22,null,y):(0,w.localize)(23,null,y):d?(0,w.localize)(24,null,y):(0,w.localize)(25,null,y)):h<D?(y=Math.floor(h/R),b?y===1?(0,w.localize)(26,null,y):(0,w.localize)(27,null,y):y===1?(0,w.localize)(28,null,y):(0,w.localize)(29,null,y)):h<E?(y=Math.floor(h/D),b?y===1?d?(0,w.localize)(30,null,y):(0,w.localize)(31,null,y):d?(0,w.localize)(32,null,y):(0,w.localize)(33,null,y):y===1?d?(0,w.localize)(34,null,y):(0,w.localize)(35,null,y):d?(0,w.localize)(36,null,y):(0,w.localize)(37,null,y)):h<u?(y=Math.floor(h/E),b?y===1?d?(0,w.localize)(38,null,y):(0,w.localize)(39,null,y):d?(0,w.localize)(40,null,y):(0,w.localize)(41,null,y):y===1?d?(0,w.localize)(42,null,y):(0,w.localize)(43,null,y):d?(0,w.localize)(44,null,y):(0,w.localize)(45,null,y)):(y=Math.floor(h/u),b?y===1?d?(0,w.localize)(46,null,y):(0,w.localize)(47,null,y):d?(0,w.localize)(48,null,y):(0,w.localize)(49,null,y):y===1?d?(0,w.localize)(50,null,y):(0,w.localize)(51,null,y):d?(0,w.localize)(52,null,y):(0,w.localize)(53,null,y))}e.fromNow=m;function I(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[134],ie([11,10]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(te[44],ie([0,1,24,12,134]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(v,b){return b&&(v.stack||v.stacktrace)?k.localize(0,null,E(v),D(v.stack)||D(v.stacktrace)):E(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function E(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function u(v=null,b=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const d=w.coalesce(v),h=u(d[0],b);return d.length>1?k.localize(4,null,h,d.length):h}if(t.isString(v))return v;if(v.detail){const d=v.detail;if(d.error)return R(d.error,b);if(d.exception)return R(d.exception,b)}return v.stack?R(v,b):v.message?v.message:k.localize(5,null)}e.toErrorMessage=u;function m(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=m;function I(v,b){let d;return typeof v=="string"?d=new Error(v):d=v,d.actions=b,d}e.createErrorWithActions=I}),define(te[135],ie([11,10]),function(z,e){return z.create("vs/base/common/jsonErrorMessages",e)}),define(te[136],ie([0,1,135]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,w.localize)(0,null);case 2:return(0,w.localize)(1,null);case 3:return(0,w.localize)(2,null);case 4:return(0,w.localize)(3,null);case 5:return(0,w.localize)(4,null);case 6:return(0,w.localize)(5,null);case 7:return(0,w.localize)(6,null);case 8:return(0,w.localize)(7,null);case 9:return(0,w.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(te[137],ie([11,10]),function(z,e){return z.create("vs/base/common/platform",e)}),define(te[5],ie([0,1,137]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,D=!1,E=!1,u=!1,m=!1,I=!1,v=!1,b=!1,d,h=e.LANGUAGE_DEFAULT,y,C;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?p=e.globals.vscode.process:typeof process<"u"&&(p=process);const S=typeof p?.versions?.electron=="string",f=S&&p?.type==="renderer";if(typeof navigator=="object"&&!f)C=navigator.userAgent,t=C.indexOf("Windows")>=0,k=C.indexOf("Macintosh")>=0,I=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=C.indexOf("Linux")>=0,b=C?.indexOf("Mobi")>=0,u=!0,d=w.getConfiguredDefaultLocale(w.localize(0,null))||e.LANGUAGE_DEFAULT,h=d;else if(typeof p=="object"){t=p.platform==="win32",k=p.platform==="darwin",R=p.platform==="linux",D=R&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,m=S,v=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const l=p.env.VSCODE_NLS_CONFIG;if(l)try{const P=JSON.parse(l),M=P.availableLanguages["*"];d=P.locale,h=M||e.LANGUAGE_DEFAULT,y=P._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var g;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function a(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let i=0;k?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=D,e.isNative=E,e.isElectron=m,e.isWeb=u,e.isWebWorker=u&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=b,e.isCI=v,e.platform=i,e.userAgent=C,e.language=h;var o;(function(l){function P(){return e.language}l.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=M;function T(){return e.language==="en"}l.isDefault=T})(o=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,N=l.length;T<N;T++){const X=l[T];if(X.id===M.data.vscodeScheduleAsyncWork){l.splice(T,1),X.callback();return}}});let P=0;return M=>{const T=++P;l.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return l=>setTimeout(l)})();var n;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||I?2:t?1:3;let r=!0,s=!1;function c(){if(!s){s=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,r=new Uint16Array(l.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[34],ie([0,1,5]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof w.globals.vscode<"u"&&typeof w.globals.vscode.process<"u"){const k=w.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[9],ie([0,1,34]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,E=46,u=47,m=92,I=58,v=63;class b extends Error{constructor(g,a,i){let o;typeof a=="string"&&a.indexOf("not ")===0?(o="must not be",a=a.replace(/^not /,"")):o="must be";const n=g.indexOf(".")!==-1?"property":"argument";let r=`The "${g}" ${n} ${o} of type ${a}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function d(f,g){if(typeof f!="string")throw new b(g,"string",f)}function h(f){return f===u||f===m}function y(f){return f===u}function C(f){return f>=t&&f<=R||f>=k&&f<=D}function p(f,g,a,i){let o="",n=0,r=-1,s=0,c=0;for(let l=0;l<=f.length;++l){if(l<f.length)c=f.charCodeAt(l);else{if(i(c))break;c=u}if(i(c)){if(!(r===l-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const P=o.lastIndexOf(a);P===-1?(o="",n=0):(o=o.slice(0,P),n=o.length-1-o.lastIndexOf(a)),r=l,s=0;continue}else if(o.length!==0){o="",n=0,r=l,s=0;continue}}g&&(o+=o.length>0?`${a}..`:"..",n=2)}else o.length>0?o+=`${a}${f.slice(r+1,l)}`:o=f.slice(r+1,l),n=l-r-1;r=l,s=0}else c===E&&s!==-1?++s:s=-1}return o}function S(f,g){if(g===null||typeof g!="object")throw new b("pathObject","Object",g);const a=g.dir||g.root,i=g.base||`${g.name||""}${g.ext||""}`;return a?a===g.root?`${a}${i}`:`${a}${f}${i}`:i}e.win32={resolve(...f){let g="",a="",i=!1;for(let o=f.length-1;o>=-1;o--){let n;if(o>=0){if(n=f[o],d(n,"path"),n.length===0)continue}else g.length===0?n=w.cwd():(n=w.env[`=${g}`]||w.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==g.toLowerCase()&&n.charCodeAt(2)===m)&&(n=`${g}\\`));const r=n.length;let s=0,c="",l=!1;const P=n.charCodeAt(0);if(r===1)h(P)&&(s=1,l=!0);else if(h(P))if(l=!0,h(n.charCodeAt(1))){let M=2,T=M;for(;M<r&&!h(n.charCodeAt(M));)M++;if(M<r&&M!==T){const N=n.slice(T,M);for(T=M;M<r&&h(n.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&!h(n.charCodeAt(M));)M++;(M===r||M!==T)&&(c=`\\\\${N}\\${n.slice(T,M)}`,s=M)}}}else s=1;else C(P)&&n.charCodeAt(1)===I&&(c=n.slice(0,2),s=2,r>2&&h(n.charCodeAt(2))&&(l=!0,s=3));if(c.length>0)if(g.length>0){if(c.toLowerCase()!==g.toLowerCase())continue}else g=c;if(i){if(g.length>0)break}else if(a=`${n.slice(s)}\\${a}`,i=l,l&&g.length>0)break}return a=p(a,!i,"\\",h),i?`${g}\\${a}`:`${g}${a}`||"."},normalize(f){d(f,"path");const g=f.length;if(g===0)return".";let a=0,i,o=!1;const n=f.charCodeAt(0);if(g===1)return y(n)?"\\":f;if(h(n))if(o=!0,h(f.charCodeAt(1))){let s=2,c=s;for(;s<g&&!h(f.charCodeAt(s));)s++;if(s<g&&s!==c){const l=f.slice(c,s);for(c=s;s<g&&h(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!h(f.charCodeAt(s));)s++;if(s===g)return`\\\\${l}\\${f.slice(c)}\\`;s!==c&&(i=`\\\\${l}\\${f.slice(c,s)}`,a=s)}}}else a=1;else C(n)&&f.charCodeAt(1)===I&&(i=f.slice(0,2),a=2,g>2&&h(f.charCodeAt(2))&&(o=!0,a=3));let r=a<g?p(f.slice(a),!o,"\\",h):"";return r.length===0&&!o&&(r="."),r.length>0&&h(f.charCodeAt(g-1))&&(r+="\\"),i===void 0?o?`\\${r}`:r:o?`${i}\\${r}`:`${i}${r}`},isAbsolute(f){d(f,"path");const g=f.length;if(g===0)return!1;const a=f.charCodeAt(0);return h(a)||g>2&&C(a)&&f.charCodeAt(1)===I&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let g,a;for(let n=0;n<f.length;++n){const r=f[n];d(r,"path"),r.length>0&&(g===void 0?g=a=r:g+=`\\${r}`)}if(g===void 0)return".";let i=!0,o=0;if(typeof a=="string"&&h(a.charCodeAt(0))){++o;const n=a.length;n>1&&h(a.charCodeAt(1))&&(++o,n>2&&(h(a.charCodeAt(2))?++o:i=!1))}if(i){for(;o<g.length&&h(g.charCodeAt(o));)o++;o>=2&&(g=`\\${g.slice(o)}`)}return e.win32.normalize(g)},relative(f,g){if(d(f,"from"),d(g,"to"),f===g)return"";const a=e.win32.resolve(f),i=e.win32.resolve(g);if(a===i||(f=a.toLowerCase(),g=i.toLowerCase(),f===g))return"";let o=0;for(;o<f.length&&f.charCodeAt(o)===m;)o++;let n=f.length;for(;n-1>o&&f.charCodeAt(n-1)===m;)n--;const r=n-o;let s=0;for(;s<g.length&&g.charCodeAt(s)===m;)s++;let c=g.length;for(;c-1>s&&g.charCodeAt(c-1)===m;)c--;const l=c-s,P=r<l?r:l;let M=-1,T=0;for(;T<P;T++){const X=f.charCodeAt(o+T);if(X!==g.charCodeAt(s+T))break;X===m&&(M=T)}if(T!==P){if(M===-1)return i}else{if(l>P){if(g.charCodeAt(s+T)===m)return i.slice(s+T+1);if(T===2)return i.slice(s+T)}r>P&&(f.charCodeAt(o+T)===m?M=T:T===2&&(M=3)),M===-1&&(M=0)}let N="";for(T=o+M+1;T<=n;++T)(T===n||f.charCodeAt(T)===m)&&(N+=N.length===0?"..":"\\..");return s+=M,N.length>0?`${N}${i.slice(s,c)}`:(i.charCodeAt(s)===m&&++s,i.slice(s,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const g=e.win32.resolve(f);if(g.length<=2)return f;if(g.charCodeAt(0)===m){if(g.charCodeAt(1)===m){const a=g.charCodeAt(2);if(a!==v&&a!==E)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(C(g.charCodeAt(0))&&g.charCodeAt(1)===I&&g.charCodeAt(2)===m)return`\\\\?\\${g}`;return f},dirname(f){d(f,"path");const g=f.length;if(g===0)return".";let a=-1,i=0;const o=f.charCodeAt(0);if(g===1)return h(o)?f:".";if(h(o)){if(a=i=1,h(f.charCodeAt(1))){let s=2,c=s;for(;s<g&&!h(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&h(f.charCodeAt(s));)s++;if(s<g&&s!==c){for(c=s;s<g&&!h(f.charCodeAt(s));)s++;if(s===g)return f;s!==c&&(a=i=s+1)}}}}else C(o)&&f.charCodeAt(1)===I&&(a=g>2&&h(f.charCodeAt(2))?3:2,i=a);let n=-1,r=!0;for(let s=g-1;s>=i;--s)if(h(f.charCodeAt(s))){if(!r){n=s;break}}else r=!1;if(n===-1){if(a===-1)return".";n=a}return f.slice(0,n)},basename(f,g){g!==void 0&&d(g,"ext"),d(f,"path");let a=0,i=-1,o=!0,n;if(f.length>=2&&C(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(a=2),g!==void 0&&g.length>0&&g.length<=f.length){if(g===f)return"";let r=g.length-1,s=-1;for(n=f.length-1;n>=a;--n){const c=f.charCodeAt(n);if(h(c)){if(!o){a=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(c===g.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return a===i?i=s:i===-1&&(i=f.length),f.slice(a,i)}for(n=f.length-1;n>=a;--n)if(h(f.charCodeAt(n))){if(!o){a=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":f.slice(a,i)},extname(f){d(f,"path");let g=0,a=-1,i=0,o=-1,n=!0,r=0;f.length>=2&&f.charCodeAt(1)===I&&C(f.charCodeAt(0))&&(g=i=2);for(let s=f.length-1;s>=g;--s){const c=f.charCodeAt(s);if(h(c)){if(!n){i=s+1;break}continue}o===-1&&(n=!1,o=s+1),c===E?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||o===-1||r===0||r===1&&a===o-1&&a===i+1?"":f.slice(a,o)},format:S.bind(null,"\\"),parse(f){d(f,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return g;const a=f.length;let i=0,o=f.charCodeAt(0);if(a===1)return h(o)?(g.root=g.dir=f,g):(g.base=g.name=f,g);if(h(o)){if(i=1,h(f.charCodeAt(1))){let M=2,T=M;for(;M<a&&!h(f.charCodeAt(M));)M++;if(M<a&&M!==T){for(T=M;M<a&&h(f.charCodeAt(M));)M++;if(M<a&&M!==T){for(T=M;M<a&&!h(f.charCodeAt(M));)M++;M===a?i=M:M!==T&&(i=M+1)}}}}else if(C(o)&&f.charCodeAt(1)===I){if(a<=2)return g.root=g.dir=f,g;if(i=2,h(f.charCodeAt(2))){if(a===3)return g.root=g.dir=f,g;i=3}}i>0&&(g.root=f.slice(0,i));let n=-1,r=i,s=-1,c=!0,l=f.length-1,P=0;for(;l>=i;--l){if(o=f.charCodeAt(l),h(o)){if(!c){r=l+1;break}continue}s===-1&&(c=!1,s=l+1),o===E?n===-1?n=l:P!==1&&(P=1):n!==-1&&(P=-1)}return s!==-1&&(n===-1||P===0||P===1&&n===s-1&&n===r+1?g.base=g.name=f.slice(r,s):(g.name=f.slice(r,n),g.base=f.slice(r,s),g.ext=f.slice(n,s))),r>0&&r!==i?g.dir=f.slice(0,r-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let g="",a=!1;for(let i=f.length-1;i>=-1&&!a;i--){const o=i>=0?f[i]:w.cwd();d(o,"path"),o.length!==0&&(g=`${o}/${g}`,a=o.charCodeAt(0)===u)}return g=p(g,!a,"/",y),a?`/${g}`:g.length>0?g:"."},normalize(f){if(d(f,"path"),f.length===0)return".";const g=f.charCodeAt(0)===u,a=f.charCodeAt(f.length-1)===u;return f=p(f,!g,"/",y),f.length===0?g?"/":a?"./":".":(a&&(f+="/"),g?`/${f}`:f)},isAbsolute(f){return d(f,"path"),f.length>0&&f.charCodeAt(0)===u},join(...f){if(f.length===0)return".";let g;for(let a=0;a<f.length;++a){const i=f[a];d(i,"path"),i.length>0&&(g===void 0?g=i:g+=`/${i}`)}return g===void 0?".":e.posix.normalize(g)},relative(f,g){if(d(f,"from"),d(g,"to"),f===g||(f=e.posix.resolve(f),g=e.posix.resolve(g),f===g))return"";const a=1,i=f.length,o=i-a,n=1,r=g.length-n,s=o<r?o:r;let c=-1,l=0;for(;l<s;l++){const M=f.charCodeAt(a+l);if(M!==g.charCodeAt(n+l))break;M===u&&(c=l)}if(l===s)if(r>s){if(g.charCodeAt(n+l)===u)return g.slice(n+l+1);if(l===0)return g.slice(n+l)}else o>s&&(f.charCodeAt(a+l)===u?c=l:l===0&&(c=0));let P="";for(l=a+c+1;l<=i;++l)(l===i||f.charCodeAt(l)===u)&&(P+=P.length===0?"..":"/..");return`${P}${g.slice(n+c)}`},toNamespacedPath(f){return f},dirname(f){if(d(f,"path"),f.length===0)return".";const g=f.charCodeAt(0)===u;let a=-1,i=!0;for(let o=f.length-1;o>=1;--o)if(f.charCodeAt(o)===u){if(!i){a=o;break}}else i=!1;return a===-1?g?"/":".":g&&a===1?"//":f.slice(0,a)},basename(f,g){g!==void 0&&d(g,"ext"),d(f,"path");let a=0,i=-1,o=!0,n;if(g!==void 0&&g.length>0&&g.length<=f.length){if(g===f)return"";let r=g.length-1,s=-1;for(n=f.length-1;n>=0;--n){const c=f.charCodeAt(n);if(c===u){if(!o){a=n+1;break}}else s===-1&&(o=!1,s=n+1),r>=0&&(c===g.charCodeAt(r)?--r===-1&&(i=n):(r=-1,i=s))}return a===i?i=s:i===-1&&(i=f.length),f.slice(a,i)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===u){if(!o){a=n+1;break}}else i===-1&&(o=!1,i=n+1);return i===-1?"":f.slice(a,i)},extname(f){d(f,"path");let g=-1,a=0,i=-1,o=!0,n=0;for(let r=f.length-1;r>=0;--r){const s=f.charCodeAt(r);if(s===u){if(!o){a=r+1;break}continue}i===-1&&(o=!1,i=r+1),s===E?g===-1?g=r:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||i===-1||n===0||n===1&&g===i-1&&g===a+1?"":f.slice(g,i)},format:S.bind(null,"/"),parse(f){d(f,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return g;const a=f.charCodeAt(0)===u;let i;a?(g.root="/",i=1):i=0;let o=-1,n=0,r=-1,s=!0,c=f.length-1,l=0;for(;c>=i;--c){const P=f.charCodeAt(c);if(P===u){if(!s){n=c+1;break}continue}r===-1&&(s=!1,r=c+1),P===E?o===-1?o=c:l!==1&&(l=1):o!==-1&&(l=-1)}if(r!==-1){const P=n===0&&a?1:n;o===-1||l===0||l===1&&o===r-1&&o===n+1?g.base=g.name=f.slice(P,r):(g.name=f.slice(P,o),g.base=f.slice(P,r),g.ext=f.slice(o,r))}return n>0?g.dir=f.slice(0,n-1):a&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[78],ie([0,1,5]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(E,...u){const m=u.reduce((b,d)=>(b[d]=!0,b),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(b=>!m[b]).forEach(b=>{for(let d=0;d<I.length;d++)if(b.search(I[d])!==-1){delete E[b];break}})}e.sanitizeProcessEnvironment=R;function D(E){!E||(delete E.DEBUG,w.isMacintosh&&delete E.DYLD_LIBRARY_PATH,w.isLinux&&delete E.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(te[79],ie([0,1,5]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=w.globals.performance&&typeof w.globals.performance.now=="function";class k{static create(D=!0){return new k(D)}constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ie([0,1,17,49,2,125,79]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const E=!1,u=!1;var m;(function(c){c.None=()=>k.Disposable.None;function l(O){if(u){const{onListenerDidAdd:_}=O,j=h.create();let Y=0;O.onListenerDidAdd=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),_?.()}}}function P(O){return(_,j=null,Y)=>{let oe=!1,q;return q=O(re=>{if(!oe)return q?q.dispose():oe=!0,_.call(j,re)},null,Y),oe&&q.dispose(),q}}c.once=P;function M(O,_,j){return G((Y,oe=null,q)=>O(re=>Y.call(oe,_(re)),null,q),j)}c.map=M;function T(O,_,j){return G((Y,oe=null,q)=>O(re=>{_(re),Y.call(oe,re)},null,q),j)}c.forEach=T;function N(O,_,j){return G((Y,oe=null,q)=>O(re=>_(re)&&Y.call(oe,re),null,q),j)}c.filter=N;function X(O){return O}c.signal=X;function ae(...O){return(_,j=null,Y)=>(0,k.combinedDisposable)(...O.map(oe=>oe(q=>_.call(j,q),null,Y)))}c.any=ae;function Q(O,_,j,Y){let oe=j;return M(O,q=>(oe=_(oe,q),oe),Y)}c.reduce=Q;function G(O,_){let j;const Y={onFirstListenerAdd(){j=O(oe.fire,oe)},onLastListenerRemove(){j?.dispose()}};_||l(Y);const oe=new C(Y);return _?.add(oe),oe.event}function Z(O,_,j=100,Y=!1,oe,q){let re,ne,ce,ge=0;const De={leakWarningThreshold:oe,onFirstListenerAdd(){re=O(ke=>{ge++,ne=_(ne,ke),Y&&!ce&&(Ae.fire(ne),ne=void 0),clearTimeout(ce),ce=setTimeout(()=>{const Le=ne;ne=void 0,ce=void 0,(!Y||ge>1)&&Ae.fire(Le),ge=0},j)})},onLastListenerRemove(){re.dispose()}};q||l(De);const Ae=new C(De);return q?.add(Ae),Ae.event}c.debounce=Z;function se(O,_=(Y,oe)=>Y===oe,j){let Y=!0,oe;return N(O,q=>{const re=Y||!_(q,oe);return Y=!1,oe=q,re},j)}c.latch=se;function he(O,_,j){return[c.filter(O,_,j),c.filter(O,Y=>!_(Y),j)]}c.split=he;function V(O,_=!1,j=[]){let Y=j.slice(),oe=O(ne=>{Y?Y.push(ne):re.fire(ne)});const q=()=>{Y?.forEach(ne=>re.fire(ne)),Y=null},re=new C({onFirstListenerAdd(){oe||(oe=O(ne=>re.fire(ne)))},onFirstListenerDidAdd(){Y&&(_?setTimeout(q):q())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return re.event}c.buffer=V;class H{constructor(_){this.event=_,this.disposables=new k.DisposableStore}map(_){return new H(M(this.event,_,this.disposables))}forEach(_){return new H(T(this.event,_,this.disposables))}filter(_){return new H(N(this.event,_,this.disposables))}reduce(_,j){return new H(Q(this.event,_,j,this.disposables))}latch(){return new H(se(this.event,void 0,this.disposables))}debounce(_,j=100,Y=!1,oe){return new H(Z(this.event,_,j,Y,oe,this.disposables))}on(_,j,Y){return this.event(_,j,Y)}once(_,j,Y){return P(this.event)(_,j,Y)}dispose(){this.disposables.dispose()}}function W(O){return new H(O)}c.chain=W;function A(O,_,j=Y=>Y){const Y=(...ne)=>re.fire(j(...ne)),oe=()=>O.on(_,Y),q=()=>O.removeListener(_,Y),re=new C({onFirstListenerAdd:oe,onLastListenerRemove:q});return re.event}c.fromNodeEventEmitter=A;function F(O,_,j=Y=>Y){const Y=(...ne)=>re.fire(j(...ne)),oe=()=>O.addEventListener(_,Y),q=()=>O.removeEventListener(_,Y),re=new C({onFirstListenerAdd:oe,onLastListenerRemove:q});return re.event}c.fromDOMEventEmitter=F;function U(O){return new Promise(_=>P(O)(_))}c.toPromise=U;function J(O,_){return _(void 0),O(j=>_(j))}c.runAndSubscribe=J;function B(O,_){let j=null;function Y(q){j?.dispose(),j=new k.DisposableStore,_(q,j)}Y(void 0);const oe=O(q=>Y(q));return(0,k.toDisposable)(()=>{oe.dispose(),j?.dispose()})}c.runAndSubscribeWithStore=B;class ${constructor(_,j){this.obs=_,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{_.addObserver(this)},onLastListenerRemove:()=>{_.removeObserver(this)}};j||l(Y),this.emitter=new C(Y),j&&j.add(this.emitter)}beginUpdate(_){this._counter++}handleChange(_,j){this._hasChanged=!0}endUpdate(_){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,_){return new $(O,_).emitter.event}c.fromObservable=L})(m=e.Event||(e.Event={}));class I{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${I._idPool++}`,I.all.add(this)}start(l){this._stopWatch=new D.StopWatch(!0),this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I,I.all=new Set,I._idPool=0;let v=-1;function b(c){const l=v;return v=c,{dispose(){v=l}}}e.setGlobalLeakWarningThreshold=b;class d{constructor(l,P=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,P){let M=v;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||P<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let N,X=0;for(const[ae,Q]of this._stacks)(!N||X<Q)&&(N=ae,X=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${X}):`),console.warn(N)}return()=>{const N=this._stacks.get(l.value)||0;this._stacks.set(l.value,N-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(l,P,M){this.callback=l,this.callbackThis=P,this.stack=M,this.subscription=new k.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class C{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=v>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(E){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const P of l)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,P,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let N,X;this._leakageMon&&this._listeners.size>=30&&(X=h.create(),N=this._leakageMon.check(X,this._listeners.size+1)),E&&(X=X??h.create());const ae=new y(l,P,X),Q=this._listeners.push(ae);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,P);const G=ae.subscription.set(()=>{N?.(),this._disposed||(Q(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(G):Array.isArray(M)&&M.push(G),G}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(const P of this._listeners)this._deliveryQueue.push(this,P,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class p{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(l,P,M){this._queue.push(new f(l,P,M))}clear(l){const P=new R.LinkedList;for(const M of this._queue)M.emitter!==l&&P.push(M);this._queue=P}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(P){(0,w.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=p;class S extends p{clear(l){this._queue.clear()}}class f{constructor(l,P,M){this.emitter=l,this.listener=P,this.event=M}}class g extends C{async fireAsync(l,P,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,l]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,N]=this._asyncDeliveryQueue.shift(),X=[],ae={...N,token:P,waitUntil:Q=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");M&&(Q=M(Q,T.callback)),X.push(Q)}};try{T.invoke(ae)}catch(Q){(0,w.onUnexpectedError)(Q);continue}Object.freeze(X),await Promise.allSettled(X).then(Q=>{for(const G of Q)G.status==="rejected"&&(0,w.onUnexpectedError)(G.reason)})}}}}e.AsyncEmitter=g;class a extends C{constructor(l){super(l),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=a;class i extends a{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=i;class o extends C{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){!this.hasListeners()||(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const P={event:l,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(P=>this.emitter.fire(P))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class r{constructor(){this.buffers=[]}wrapEvent(l){return(P,M,T)=>l(N=>{const X=this.buffers[this.buffers.length-1];X?X.push(()=>P.call(M,N)):P.call(M,N)},void 0,T)}bufferEvents(l){const P=[];this.buffers.push(P);const M=l();return this.buffers.pop(),P.forEach(T=>T()),M}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=m.None,this.inputEventListener=k.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(te[23],ie([0,1,3]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(E,u){const m=setTimeout(E.bind(u),0);return{dispose(){clearTimeout(m)}}});var k;(function(E){function u(m){return m===E.None||m===E.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}E.isCancellationToken=u,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(te[138],ie([0,1,23]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(E){this.task=E,this.result=null}get(){if(this.result)return this.result;const E=new w.CancellationTokenSource,u=this.task(E.token);return this.result={promise:u,dispose:()=>{this.result=null,E.cancel(),E.dispose()}},this.result}}e.Cache=t;class k{constructor(E){this.fn=E,this.lastCache=void 0,this.lastArgKey=void 0}get(E){const u=JSON.stringify(E);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(E)),this.lastCache}}e.LRUCachedFunction=k;class R{get cachedValues(){return this._map}constructor(E){this.fn=E,this._map=new Map}get(E){if(this._map.has(E))return this._map.get(E);const u=this.fn(E);return this._map.set(E,u),u}}e.CachedFunction=R}),define(te[95],ie([0,1,3,2]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:w.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{get value(){return this._value}set value(E){E!==this._value&&(this._value=E,this.changeEmitter.fire(E))}constructor(E){super(),this._value=E,this.changeEmitter=this._register(new w.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=R}),define(te[25],ie([0,1,138,124]),function(z,e,w,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function E(K,...ue){return ue.length===0?K:K.replace(D,function(de,pe){const ye=parseInt(pe,10);return isNaN(ye)||ye<0||ye>=ue.length?de:ue[ye]})}e.format=E;const u=/{([^}]+)}/g;function m(K,ue){return K.replace(u,(de,pe)=>ue[pe]??de)}e.format2=m;function I(K){return K.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=I;function v(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function b(K,ue){let de=0;const pe=ue.charCodeAt(0);for(let ye=K.length-1;ye>=0;ye--)K.charCodeAt(ye)===pe&&de++;return de}e.count=b;function d(K,ue,de="\u2026"){return K.length<=ue?K:`${K.substr(0,ue)}${de}`}e.truncate=d;function h(K,ue=" "){const de=y(K,ue);return C(de,ue)}e.trim=h;function y(K,ue){if(!K||!ue)return K;const de=ue.length;if(de===0||K.length===0)return K;let pe=0;for(;K.indexOf(ue,pe)===pe;)pe=pe+de;return K.substring(pe)}e.ltrim=y;function C(K,ue){if(!K||!ue)return K;const de=ue.length,pe=K.length;if(de===0||pe===0)return K;let ye=pe,Re=-1;for(;Re=K.lastIndexOf(ue,ye-1),!(Re===-1||Re+de!==ye);){if(Re===0)return"";ye=Re}return K.substring(0,ye)}e.rtrim=C;function p(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function S(K){return K.replace(/\*/g,"")}e.stripWildcards=S;function f(K,ue,de={}){if(!K)throw new Error("Cannot create regex from empty string");ue||(K=v(K)),de.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let pe="";return de.global&&(pe+="g"),de.matchCase||(pe+="i"),de.multiline&&(pe+="m"),de.unicode&&(pe+="u"),new RegExp(K,pe)}e.createRegExp=f;function g(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function a(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=a;function i(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=i;function o(K){return K.split(/\r\n|\r|\n/)}e.splitLines=o;function n(K){for(let ue=0,de=K.length;ue<de;ue++){const pe=K.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.firstNonWhitespaceIndex=n;function r(K,ue=0,de=K.length){for(let pe=ue;pe<de;pe++){const ye=K.charCodeAt(pe);if(ye!==32&&ye!==9)return K.substring(ue,pe)}return K.substring(ue,de)}e.getLeadingWhitespace=r;function s(K,ue=K.length-1){for(let de=ue;de>=0;de--){const pe=K.charCodeAt(de);if(pe!==32&&pe!==9)return de}return-1}e.lastNonWhitespaceIndex=s;function c(K,ue,de){const pe=[];let ye=0;for(const Re of K.matchAll(ue)){if(pe.push(K.slice(ye,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ye=Re.index+Re[0].length,pe.push(de(Re[0],...Re.slice(1),Re.index,K,Re.groups))}return pe.push(K.slice(ye)),Promise.all(pe).then(Re=>Re.join(""))}e.replaceAsync=c;function l(K,ue){return K<ue?-1:K>ue?1:0}e.compare=l;function P(K,ue,de=0,pe=K.length,ye=0,Re=ue.length){for(;de<pe&&ye<Re;de++,ye++){const xe=K.charCodeAt(de),je=ue.charCodeAt(ye);if(xe<je)return-1;if(xe>je)return 1}const _e=pe-de,it=Re-ye;return _e<it?-1:_e>it?1:0}e.compareSubstring=P;function M(K,ue){return T(K,ue,0,K.length,0,ue.length)}e.compareIgnoreCase=M;function T(K,ue,de=0,pe=K.length,ye=0,Re=ue.length){for(;de<pe&&ye<Re;de++,ye++){let xe=K.charCodeAt(de),je=ue.charCodeAt(ye);if(xe===je)continue;if(xe>=128||je>=128)return P(K.toLowerCase(),ue.toLowerCase(),de,pe,ye,Re);X(xe)&&(xe-=32),X(je)&&(je-=32);const et=xe-je;if(et!==0)return et}const _e=pe-de,it=Re-ye;return _e<it?-1:_e>it?1:0}e.compareSubstringIgnoreCase=T;function N(K){return K>=48&&K<=57}e.isAsciiDigit=N;function X(K){return K>=97&&K<=122}e.isLowerAsciiLetter=X;function ae(K){return K>=65&&K<=90}e.isUpperAsciiLetter=ae;function Q(K,ue){return K.length===ue.length&&T(K,ue)===0}e.equalsIgnoreCase=Q;function G(K,ue){const de=ue.length;return ue.length>K.length?!1:T(K,ue,0,de)===0}e.startsWithIgnoreCase=G;function Z(K,ue){const de=Math.min(K.length,ue.length);let pe;for(pe=0;pe<de;pe++)if(K.charCodeAt(pe)!==ue.charCodeAt(pe))return pe;return de}e.commonPrefixLength=Z;function se(K,ue){const de=Math.min(K.length,ue.length);let pe;const ye=K.length-1,Re=ue.length-1;for(pe=0;pe<de;pe++)if(K.charCodeAt(ye-pe)!==ue.charCodeAt(Re-pe))return pe;return de}e.commonSuffixLength=se;function he(K){return 55296<=K&&K<=56319}e.isHighSurrogate=he;function V(K){return 56320<=K&&K<=57343}e.isLowSurrogate=V;function H(K,ue){return(K-55296<<10)+(ue-56320)+65536}e.computeCodePoint=H;function W(K,ue,de){const pe=K.charCodeAt(de);if(he(pe)&&de+1<ue){const ye=K.charCodeAt(de+1);if(V(ye))return H(pe,ye)}return pe}e.getNextCodePoint=W;function A(K,ue){const de=K.charCodeAt(ue-1);if(V(de)&&ue>1){const pe=K.charCodeAt(ue-2);if(he(pe))return H(pe,de)}return de}class F{get offset(){return this._offset}constructor(ue,de=0){this._str=ue,this._len=ue.length,this._offset=de}setOffset(ue){this._offset=ue}prevCodePoint(){const ue=A(this._str,this._offset);return this._offset-=ue>=65536?2:1,ue}nextCodePoint(){const ue=W(this._str,this._len,this._offset);return this._offset+=ue>=65536?2:1,ue}eol(){return this._offset>=this._len}}e.CodePointIterator=F;class U{get offset(){return this._iterator.offset}constructor(ue,de=0){this._iterator=new F(ue,de)}nextGraphemeLength(){const ue=Te.getInstance(),de=this._iterator,pe=de.offset;let ye=ue.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Re=de.offset,_e=ue.getGraphemeBreakType(de.nextCodePoint());if(Se(ye,_e)){de.setOffset(Re);break}ye=_e}return de.offset-pe}prevGraphemeLength(){const ue=Te.getInstance(),de=this._iterator,pe=de.offset;let ye=ue.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Re=de.offset,_e=ue.getGraphemeBreakType(de.prevCodePoint());if(Se(_e,ye)){de.setOffset(Re);break}ye=_e}return pe-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=U;function J(K,ue){return new U(K,ue).nextGraphemeLength()}e.nextCharLength=J;function B(K,ue){return new U(K,ue).prevGraphemeLength()}e.prevCharLength=B;function $(K,ue){ue>0&&V(K.charCodeAt(ue))&&ue--;const de=ue+J(K,ue);return[de-B(K,de),de]}e.getCharContainingOffset=$;function L(K){const ue=new U(K);let de=0;for(;!ue.eol();)de++,ue.nextGraphemeLength();return de}e.charCount=L;let O;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(K){return O||(O=_()),O.test(K)}e.containsRTL=j;const Y=/^[\t\n\r\x20-\x7E]*$/;function oe(K){return Y.test(K)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=q;function re(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=re;function ne(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ne;function ce(K,ue){if(K.length<ue)return K;const de=/\b/g;let pe=0;for(;de.test(K)&&!(K.length-de.lastIndex<ue);)pe=de.lastIndex,de.lastIndex+=1;return K.substring(pe).replace(/^\s/,"")}e.lcut=ce;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Ae=/\x1b\[0?m/g;function ke(K){return K&&(K=K.replace(ge,""),K=K.replace(De,""),K=K.replace(Ae,"")),K}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function qe(K){return Le(K)?K.substr(1):K}e.stripUTF8BOM=qe;function me(K,ue){if(!K||!ue||K.length<ue.length)return!1;const de=ue.length,pe=K.toLowerCase();let ye=0,Re=-1;for(;ye<de;){const _e=pe.indexOf(ue[ye],Re+1);if(_e<0)return!1;Re=_e,ye++}return!0}e.fuzzyContains=me;function we(K,ue=!1){return K?(ue&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=we;function Ee(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ee;function x(K,ue=1){if(ue===0)return"";let de=-1;do de=K.indexOf(`
`,de+1),ue--;while(ue>0&&de>=0);return de===-1?K:(K[de-1]==="\r"&&de--,K.substr(0,de))}e.getNLines=x;function le(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}e.singleLetterHash=le;function fe(K){return Te.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=fe;function Se(K,ue){return K===0?ue!==5&&ue!==7:K===2&&ue===3?!1:K===4||K===2||K===3||ue===4||ue===2||ue===3?!0:!(K===8&&(ue===8||ue===9||ue===11||ue===12)||(K===11||K===9)&&(ue===9||ue===10)||(K===12||K===10)&&ue===10||ue===5||ue===13||ue===7||K===1||K===13&&ue===14||K===6&&ue===6)}var Ie;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=Oe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const de=this._data,pe=de.length/3;let ye=1;for(;ye<=pe;)if(ue<de[3*ye])ye=2*ye;else if(ue>de[3*ye+1])ye=2*ye+1;else return de[3*ye+2];return 0}}Te._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(K,ue){if(K===0)return 0;const de=Be(K,ue);if(de!==void 0)return de;const pe=new F(ue,K);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=Ne;function Be(K,ue){const de=new F(ue,K);let pe=de.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(de.offset===0)return;pe=de.prevCodePoint()}if(!ne(pe))return;let ye=de.offset;return ye>0&&de.prevCodePoint()===8205&&(ye=de.offset),ye}function ze(K){return 127995<=K&&K<=127999}var Ke;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ke||(Ke={})),e.noBreakWhitespace="\xA0";class Ue{static getInstance(ue){return Ue.cache.get(Array.from(ue))}static getLocales(){return Ue._locales.getValue()}constructor(ue){this.confusableDictionary=ue}isAmbiguous(ue){return this.confusableDictionary.has(ue)}getPrimaryConfusable(ue){return this.confusableDictionary.get(ue)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue,k=Ue,Ue.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.cache=new w.LRUCachedFunction(K=>{function ue(je){const et=new Map;for(let nt=0;nt<je.length;nt+=2)et.set(je[nt],je[nt+1]);return et}function de(je,et){const nt=new Map(je);for(const[lt,gt]of et)nt.set(lt,gt);return nt}function pe(je,et){if(!je)return et;const nt=new Map;for(const[lt,gt]of je)et.has(lt)&&nt.set(lt,gt);return nt}const ye=k.ambiguousCharacterData.getValue();let Re=K.filter(je=>!je.startsWith("_")&&je in ye);Re.length===0&&(Re=["_default"]);let _e;for(const je of Re){const et=ue(ye[je]);_e=pe(_e,et)}const it=ue(ye._common),xe=de(it,_e);return new Ue(xe)}),Ue._locales=new t.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Ge{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ge.getRawData())),this._data}static isInvisibleCharacter(ue){return Ge.getData().has(ue)}static get codePoints(){return Ge.getData()}}e.InvisibleCharacters=Ge,Ge._data=void 0}),define(te[30],ie([0,1,9,5,25,12]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function E(s){return s.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=E;function u(s){return s.indexOf("/")===-1&&(s=E(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=u;function m(s,c=w.posix.sep){if(!s)return"";const l=s.length,P=s.charCodeAt(0);if(D(P)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const N=T;for(;T<l&&!D(s.charCodeAt(T));T++);if(N!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<l;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,c)}}return c}else if(p(P)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let M=s.indexOf("://");if(M!==-1){for(M+=3;M<l;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1)}return""}e.getRoot=m;function I(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let l=2;const P=l;for(;l<s.length&&(c=s.charCodeAt(l),c!==92);l++);return!(P===l||(c=s.charCodeAt(l+1),isNaN(c)||c===92))}e.isUNC=I;const v=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,c=t.isWindows){const l=c?v:b;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||c&&d.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function y(s,c,l){const P=s===c;return!l||P?P:!s||!c?!1:(0,k.equalsIgnoreCase)(s,c)}e.isEqual=y;function C(s,c,l,P=w.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let T=c.length;return c.charAt(c.length-1)===P&&T--,s.charAt(T)===P}return c.charAt(c.length-1)!==P&&(c+=P),s.indexOf(c)===0}e.isEqualOrParent=C;function p(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=p;function S(s,c){return t.isWindows&&s.endsWith(":")&&(s+=w.sep),(0,w.isAbsolute)(s)||(s=(0,w.join)(c,s)),s=(0,w.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,w.sep),s.endsWith(":")&&(s+=w.sep)):(s=(0,k.rtrim)(s,w.sep),s||(s=w.sep)),s}e.sanitizeFilePath=S;function f(s){const c=(0,w.normalize)(s);return t.isWindows?s.length>3?!1:g(c)&&(s.length===2||c.charCodeAt(2)===92):c===w.posix.sep}e.isRootOrDriveLetter=f;function g(s,c=t.isWindows){return c?p(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function a(s){return g(s)?s[0]:void 0}e.getDriveLetter=a;function i(s,c,l){return c.length>s.length?-1:s===c?0:(l&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=i;function o(s){const c=s.split(":");let l,P,M;for(const T of c){const N=Number(T);(0,R.isNumber)(N)?P===void 0?P=N:M===void 0&&(M=N):l=l?[l,T].join(":"):T}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:P!==void 0?P:void 0,column:M!==void 0?M:P!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,c,l=8){let P="";for(let T=0;T<l;T++)P+=n.charAt(Math.floor(Math.random()*n.length));let M;return c?M=`${c}-${P}`:M=P,s?(0,w.join)(s,M):M}e.randomPath=r}),define(te[66],ie([0,1,25]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return k(p,0)}e.hash=t;function k(p,S){switch(typeof p){case"object":return p===null?R(349,S):Array.isArray(p)?u(p,S):m(p,S);case"string":return E(p,S);case"boolean":return D(p,S);case"number":return R(p,S);case"undefined":return R(937,S);default:return R(617,S)}}e.doHash=k;function R(p,S){return(S<<5)-S+p|0}e.numberHash=R;function D(p,S){return R(p?433:863,S)}function E(p,S){S=R(149417,S);for(let f=0,g=p.length;f<g;f++)S=R(p.charCodeAt(f),S);return S}e.stringHash=E;function u(p,S){return S=R(104579,S),p.reduce((f,g)=>k(g,f),S)}function m(p,S){return S=R(181387,S),Object.keys(p).sort().reduce((f,g)=>(f=E(g,f),k(p[g],f)),S)}class I{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=I;var v;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(p,S,f=32){const g=f-S,a=~((1<<g)-1);return(p<<S|(a&p)>>>g)>>>0}function d(p,S=0,f=p.byteLength,g=0){for(let a=0;a<f;a++)p[S+a]=g}function h(p,S,f="0"){for(;p.length<S;)p=f+p;return p}function y(p,S=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(f=>f.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),S/4)}e.toHexString=y;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const f=S.length;if(f===0)return;const g=this._buff;let a=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=S.charCodeAt(0),n=0);;){let r=o;if(w.isHighSurrogate(o))if(n+1<f){const s=S.charCodeAt(n+1);w.isLowSurrogate(s)?(n++,r=w.computeCodePoint(o,s)):r=65533}else{i=o;break}else w.isLowSurrogate(o)&&(r=65533);if(a=this._push(g,a,r),n++,n<f)o=S.charCodeAt(n);else break}this._buffLen=a,this._leftoverHighSurrogate=i}_push(S,f,g){return g<128?S[f++]=g:g<2048?(S[f++]=192|(g&1984)>>>6,S[f++]=128|(g&63)>>>0):g<65536?(S[f++]=224|(g&61440)>>>12,S[f++]=128|(g&4032)>>>6,S[f++]=128|(g&63)>>>0):(S[f++]=240|(g&1835008)>>>18,S[f++]=128|(g&258048)>>>12,S[f++]=128|(g&4032)>>>6,S[f++]=128|(g&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=C._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)S.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)S.setUint32(l,b(S.getUint32(l-12,!1)^S.getUint32(l-32,!1)^S.getUint32(l-56,!1)^S.getUint32(l-64,!1),1),!1);let g=this._h0,a=this._h1,i=this._h2,o=this._h3,n=this._h4,r,s,c;for(let l=0;l<80;l++)l<20?(r=a&i|~a&o,s=1518500249):l<40?(r=a^i^o,s=1859775393):l<60?(r=a&i|a&o|i&o,s=2400959708):(r=a^i^o,s=3395469782),c=b(g,5)+r+n+s+S.getUint32(l*4,!1)&4294967295,n=o,o=i,i=b(a,30),a=g,g=c;this._h0=this._h0+g&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(te[31],ie([0,1,24,25]),function(z,e,w,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(n,r,s){let c=n.get(r);return c===void 0&&(c=s,n.set(r,c)),c}e.getOrSet=E;function u(n){const r=[];return n.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.mapToString=u;function m(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}e.setToString=m;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=I;class v{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class b{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const c=this._value.charCodeAt(s);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var d;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(d||(d={}));class h{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(C||(C={}));class p{static forUris(r=()=>!1,s=()=>!1){return new p(new h(r,s))}static forPaths(r=!1){return new p(new b(void 0,!r))}static forStrings(){return new p(new I)}static forConfigKeys(){return new p(new v)}constructor(r){this._iter=r}clear(){this._root=void 0}fill(r,s){if(s){const c=s.slice(0);(0,w.shuffle)(c);for(const l of c)this.set(l,r)}else{const c=r.slice(0);(0,w.shuffle)(c);for(const l of c)this.set(l[0],l[1])}}set(r,s){const c=this._iter.reset(r);let l;this._root||(this._root=new y,this._root.segment=c.value());const P=[];for(l=this._root;;){const T=c.cmp(l.segment);if(T>0)l.left||(l.left=new y,l.left.segment=c.value()),P.push([-1,l]),l=l.left;else if(T<0)l.right||(l.right=new y,l.right.segment=c.value()),P.push([1,l]),l=l.right;else if(c.hasNext())c.next(),l.mid||(l.mid=new y,l.mid.segment=c.value()),P.push([0,l]),l=l.mid;else break}const M=l.value;l.value=s,l.key=r;for(let T=P.length-1;T>=0;T--){const N=P[T][1];N.updateHeight();const X=N.balanceFactor();if(X<-1||X>1){const ae=P[T][0],Q=P[T+1][0];if(ae===1&&Q===1)P[T][1]=N.rotateLeft();else if(ae===-1&&Q===-1)P[T][1]=N.rotateRight();else if(ae===1&&Q===-1)N.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=N.rotateLeft();else if(ae===-1&&Q===1)N.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=N.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return M}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const c=this._iter.reset(r),l=[];let P=this._root;for(;P;){const M=c.cmp(P.segment);if(M>0)l.push([-1,P]),P=P.left;else if(M<0)l.push([1,P]),P=P.right;else if(c.hasNext())c.next(),l.push([0,P]),P=P.mid;else break}if(!!P){if(s?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const M=this._min(P.right);if(M.key){const{key:T,value:N,segment:X}=M;this._delete(M.key,!1),P.key=T,P.value=N,P.segment=X}}else{const M=P.left??P.right;if(l.length>0){const[T,N]=l[l.length-1];switch(T){case-1:N.left=M;break;case 0:N.mid=M;break;case 1:N.right=M;break}}else this._root=M}for(let M=l.length-1;M>=0;M--){const T=l[M][1];T.updateHeight();const N=T.balanceFactor();if(N>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),l[M][1]=T.rotateLeft()):N<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),l[M][1]=T.rotateRight()),M>0)switch(l[M-1][0]){case-1:l[M-1][1].left=l[M][1];break;case 1:l[M-1][1].right=l[M][1];break;case 0:l[M-1][1].mid=l[M][1];break}else this._root=l[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let c=this._root,l;for(;c;){const P=s.cmp(c.segment);if(P>0)c=c.left;else if(P<0)c=c.right;else if(s.hasNext())s.next(),l=c.value||l,c=c.mid;else break}return c&&c.value||l}findSuperstr(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(r){for(const[s,c]of this)r(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=p;class S{constructor(r,s){this.uri=r,this.value=s}}class f{constructor(r,s){this[k]="ResourceMap",r instanceof f?(this.map=new Map(r.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=r??f.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new S(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[c,l]of this.map)r(l.value,l.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=f,f.defaultToKey=n=>n.toString();class g{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this._map=new f(r):(this._map=new f(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((c,l)=>r.call(s,l,l,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=g;var a;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class i{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const c=this._map.get(r);if(!!c)return s!==0&&this.touch(c,s),c.value}set(r,s,c=0){let l=this._map.get(r);if(l)l.value=s,c!==0&&this.touch(l,c);else{switch(l={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const c=this._state;let l=this._head;for(;l;){if(s?r.bind(s)(l.value,l.key,this):r(l.value,l.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:c.key,done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return l}values(){const r=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:c.value,done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return l}entries(){const r=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const P={value:[c.key,c.value],done:!1};return c=c.next,P}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>r;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const c=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(c.previous=l,l.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const c=r.next,l=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=l,l.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.LinkedMap=i;class o extends i{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(te[80],ie([0,1,31]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new w.LRUCache(1e4);function k(m){return u(m,"NFC",t)}e.normalizeNFC=k;const R=new w.LRUCache(1e4);function D(m){return u(m,"NFD",R)}e.normalizeNFD=D;const E=/[^\u0000-\u0080]/;function u(m,I,v){if(!m)return m;const b=v.get(m);if(b)return b;let d;return E.test(m)?d=m.normalize(I):d=m,v.set(m,d),d}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(I){return D(I).replace(m,"")}}()}),define(te[96],ie([0,1,25]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",E="warn",u="info",m="ignore";function I(b){return b?w.equalsIgnoreCase(R,b)?k.Error:w.equalsIgnoreCase(D,b)||w.equalsIgnoreCase(E,b)?k.Warning:w.equalsIgnoreCase(u,b)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function v(b){switch(b){case k.Error:return R;case k.Warning:return D;case k.Info:return u;default:return m}}k.toString=v}(t||(t={})),e.default=t}),define(te[7],ie([0,1,9,5]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function E(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(n,r){return!n&&!r?"file":n}function m(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==v&&(r=v+r):r=v;break}return r}const I="",v="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(r){return r instanceof d?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,s,c,l,P,M=!1){typeof r=="object"?(this.scheme=r.scheme||I,this.authority=r.authority||I,this.path=r.path||I,this.query=r.query||I,this.fragment=r.fragment||I):(this.scheme=u(r,M),this.authority=s||I,this.path=m(this.scheme,c||I),this.query=l||I,this.fragment=P||I,E(this,M))}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:c,path:l,query:P,fragment:M}=r;return s===void 0?s=this.scheme:s===null&&(s=I),c===void 0?c=this.authority:c===null&&(c=I),l===void 0?l=this.path:l===null&&(l=I),P===void 0?P=this.query:P===null&&(P=I),M===void 0?M=this.fragment:M===null&&(M=I),s===this.scheme&&c===this.authority&&l===this.path&&P===this.query&&M===this.fragment?this:new y(s,c,l,P,M)}static parse(r,s=!1){const c=b.exec(r);return c?new y(c[2]||I,o(c[4]||I),o(c[5]||I),o(c[7]||I),o(c[9]||I),s):new y(I,I,I,I,I)}static file(r){let s=I;if(t.isWindows&&(r=r.replace(/\\/g,v)),r[0]===v&&r[1]===v){const c=r.indexOf(v,2);c===-1?(s=r.substring(2),r=v):(s=r.substring(2,c),r=r.substring(c)||v)}return new y("file",s,r,I,I)}static from(r){const s=new y(r.scheme,r.authority,r.path,r.query,r.fragment);return E(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&r.scheme==="file"?c=d.file(w.win32.join(f(r,!0),...s)).path:c=w.posix.join(r.path,...s),r.with({path:c})}toString(r=!1){return g(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof d)return r;{const s=new y(r);return s._formatted=r.external,s._fsPath=r._sep===h?r.fsPath:null,s}}else return r}}e.URI=d;const h=t.isWindows?1:void 0;class y extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(n,r){let s,c=-1;for(let l=0;l<n.length;l++){const P=n.charCodeAt(l);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)c!==-1&&(s+=encodeURIComponent(n.substring(c,l)),c=-1),s!==void 0&&(s+=n.charAt(l));else{s===void 0&&(s=n.substr(0,l));const M=C[P];M!==void 0?(c!==-1&&(s+=encodeURIComponent(n.substring(c,l)),c=-1),s+=M):c===-1&&(c=l)}}return c!==-1&&(s+=encodeURIComponent(n.substring(c))),s!==void 0?s:n}function S(n){let r;for(let s=0;s<n.length;s++){const c=n.charCodeAt(s);c===35||c===63?(r===void 0&&(r=n.substr(0,s)),r+=C[c]):r!==void 0&&(r+=n[s])}return r!==void 0?r:n}function f(n,r){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function g(n,r){const s=r?S:p;let c="",{scheme:l,authority:P,path:M,query:T,fragment:N}=n;if(l&&(c+=l,c+=":"),(P||l==="file")&&(c+=v,c+=v),P){let X=P.indexOf("@");if(X!==-1){const ae=P.substr(0,X);P=P.substr(X+1),X=ae.indexOf(":"),X===-1?c+=s(ae,!1):(c+=s(ae.substr(0,X),!1),c+=":",c+=s(ae.substr(X+1),!1)),c+="@"}P=P.toLowerCase(),X=P.indexOf(":"),X===-1?c+=s(P,!1):(c+=s(P.substr(0,X),!1),c+=P.substr(X))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const X=M.charCodeAt(1);X>=65&&X<=90&&(M=`/${String.fromCharCode(X+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const X=M.charCodeAt(0);X>=65&&X<=90&&(M=`${String.fromCharCode(X+32)}:${M.substr(2)}`)}c+=s(M,!0)}return T&&(c+="?",c+=s(T,!1)),N&&(c+="#",c+=r?N:p(N,!1)),c}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(i)?n.replace(i,r=>a(r)):n}}),define(te[139],ie([0,1,7]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const I=m;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const I=[];let v;try{const b=JSON.parse(m.arguments),d=b[b.length-1];d&&d.__$stack&&(b.pop(),v=d.__$stack),I.push(...b)}catch{I.push("Unable to log remote console arguments",m.arguments)}return{args:I,stack:v}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const I=m;if(I){const v=D(I),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:w.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=R;function D(m){if(!m)return m;const I=m.indexOf(`
`);return I===-1?m:m.substring(0,I)}function E(m,I){const{args:v,stack:b}=k(m),d=typeof v[0]=="string"&&v.length===1;let h=D(b);h&&(h=`(${h.trim()})`);let y=[];if(typeof v[0]=="string"?h&&d?y=[`%c[${I}] %c${v[0]} %c${h}`,u("blue"),u(""),u("grey")]:y=[`%c[${I}] %c${v[0]}`,u("blue"),u(""),...v.slice(1)]:y=[`%c[${I}]%`,u("blue"),...v],h&&!d&&y.push(h),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,y)}e.log=E;function u(m){return`color: ${m}`}}),define(te[67],ie([0,1,18,25,7]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,E)}e.stringify=R;function D(m){let I=JSON.parse(m);return I=u(I),I}e.parse=D;function E(m,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function u(m,I=0){if(!m||I>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 14:return new Date(m.source)}if(m instanceof w.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let v=0;v<m.length;++v)m[v]=u(m[v],I+1);else for(const v in m)Object.hasOwnProperty.call(m,v)&&(m[v]=u(m[v],I+1))}return m}e.revive=u}),define(te[13],ie([0,1,5,7]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebook="vscode-notebook",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${k.vscodeRemoteResource}`}set(m,I,v){this._hosts[m]=I,this._ports[m]=v}setConnectionToken(m,I){this._connectionTokens[m]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const I=m.authority;let v=this._hosts[I];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const b=this._ports[I],d=this._connectionTokens[I];let h=`path=${encodeURIComponent(m.path)}`;return typeof d=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),t.URI.from({scheme:w.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${v}:${b}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new R;class D{asBrowserUri(m,I){const v=this.toUri(m,I);return v.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(v):v.scheme===k.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?v.with({scheme:k.vscodeFileResource,authority:v.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):v}asFileUri(m,I){const v=this.toUri(m,I);return v.scheme===k.vscodeFileResource?v.with({scheme:k.file,authority:v.authority!==D.FALLBACK_AUTHORITY?v.authority:null,query:null,fragment:null}):v}toUri(m,I){return t.URI.isUri(m)?m:t.URI.parse(I.toUrl(m))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var E;(function(u){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(m.get("3"));const I="vscode-coi";function v(d){let h;typeof d=="string"?h=new URL(d).searchParams:d instanceof URL?h=d.searchParams:t.URI.isUri(d)&&(h=new URL(d.toString(!0)).searchParams);const y=h?.get(I);if(!!y)return m.get(y)}u.getHeadersFromQuery=v;function b(d,h,y){if(!globalThis.crossOriginIsolated)return;const C=h&&y?"3":y?"2":"1";d instanceof URLSearchParams?d.set(I,C):d[I]=C}u.addSearchParam=b})(E=e.COI||(e.COI={}))}),define(te[16],ie([0,1,30,13,9,5,25,7]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function u(d){return(0,E.uriToFsPath)(d,!0)}e.originalFSPath=u;class m{constructor(h){this._ignorePathCasing=h}compare(h,y,C=!1){return h===y?0:(0,D.compare)(this.getComparisonKey(h,C),this.getComparisonKey(y,C))}isEqual(h,y,C=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,C)===this.getComparisonKey(y,C)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,C=!1){if(h.scheme===y.scheme){if(h.scheme===t.Schemas.file)return w.isEqualOrParent(u(h),u(y),this._ignorePathCasing(h))&&h.query===y.query&&(C||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return w.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(C||h.fragment===y.fragment)}return!1}joinPath(h,...y){return E.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===t.Schemas.file?y=E.URI.file(k.dirname(u(h))).path:(y=k.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===t.Schemas.file?y=E.URI.file(k.normalize(u(h))).path:y=k.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===t.Schemas.file){const S=k.relative(u(h),u(y));return R.isWindows?w.toSlashes(S):S}let C=h.path||"/";const p=y.path||"/";if(this._ignorePathCasing(h)){let S=0;for(const f=Math.min(C.length,p.length);S<f&&!(C.charCodeAt(S)!==p.charCodeAt(S)&&C.charAt(S).toLowerCase()!==p.charAt(S).toLowerCase());S++);C=p.substr(0,S)+C.substr(S)}return k.posix.relative(C,p)}resolvePath(h,y){if(h.scheme===t.Schemas.file){const C=E.URI.file(k.resolve(u(h),y));return h.with({authority:C.authority,path:C.path})}return y=w.toPosixPath(y),h.with({path:k.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,D.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=k.sep){if(h.scheme===t.Schemas.file){const C=u(h);return C.length>w.getRoot(C).length&&C[C.length-1]===y}else{const C=h.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=k.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=k.sep){let C=!1;if(h.scheme===t.Schemas.file){const p=u(h);C=p!==void 0&&p.length===w.getRoot(p).length&&p[p.length-1]===y}else{y="/";const p=h.path;C=p.length===1&&p.charCodeAt(p.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(d=>d.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(d,h){const y=[];for(let C=0;C<d.length;C++){const p=h(d[C]);d.some((S,f)=>f===C?!1:(0,e.isEqualOrParent)(p,h(S)))||y.push(d[C])}return y}e.distinctParents=I;var v;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function h(y){const C=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(f=>{const[g,a]=f.split(":");g&&a&&C.set(g,a)});const S=y.path.substring(0,y.path.indexOf(";"));return S&&C.set(d.META_DATA_MIME,S),C}d.parseMetaData=h})(v=e.DataUri||(e.DataUri={}));function b(d,h,y){if(h){let C=d.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),d.with({scheme:y,authority:h,path:C})}return d.with({scheme:y})}e.toLocalResource=b}),define(te[8],ie([0,1,23,17,3,2,16,5]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function u($){return!!$&&typeof $.then=="function"}e.isThenable=u;function m($){const L=new w.CancellationTokenSource,O=$(L.token),_=new Promise((j,Y)=>{const oe=L.token.onCancellationRequested(()=>{oe.dispose(),L.dispose(),Y(new t.CancellationError)});Promise.resolve(O).then(q=>{oe.dispose(),L.dispose(),j(q)},q=>{oe.dispose(),L.dispose(),Y(q)})});return new class{cancel(){L.cancel()}then(j,Y){return _.then(j,Y)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=m;function I($,L,O){return new Promise((_,j)=>{const Y=L.onCancellationRequested(()=>{Y.dispose(),_(O)});$.then(_,j).finally(()=>Y.dispose())})}e.raceCancellation=I;function v($,L){return new Promise((O,_)=>{const j=L.onCancellationRequested(()=>{j.dispose(),_(new t.CancellationError)});$.then(O,_).finally(()=>j.dispose())})}e.raceCancellationError=v;async function b($){let L=-1;const O=$.map((j,Y)=>j.then(oe=>(L=Y,oe))),_=await Promise.race(O);return $.forEach((j,Y)=>{Y!==L&&j.cancel()}),_}e.raceCancellablePromises=b;function d($,L,O){let _;const j=setTimeout(()=>{_?.(void 0),O?.()},L);return Promise.race([$.finally(()=>clearTimeout(j)),new Promise(Y=>_=Y)])}e.raceTimeout=d;function h($){return new Promise((L,O)=>{const _=$();u(_)?_.then(L,O):L(_)})}e.asPromise=h;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=L(),new Promise((O,_)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=y;class C{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=C;class p{constructor(){this.promiseMap=new Map}queue(L,O){const j=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===j&&this.promiseMap.delete(L)});return this.promiseMap.set(L,j),j}}e.SequencerByKey=p;const S=($,L)=>{let O=!0;const _=setTimeout(()=>{O=!1,L()},$);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},f=$=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,$())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Y)=>{this.doResolve=j,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?f(_):S(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class a{constructor(L){this.delayer=new g(L),this.throttler=new y}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class i{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function n($,L){return L?new Promise((O,_)=>{const j=setTimeout(()=>{Y.dispose(),O()},$),Y=L.onCancellationRequested(()=>{clearTimeout(j),Y.dispose(),_(new t.CancellationError)})}):m(O=>n($,O))}e.timeout=n;function r($,L=0){const O=setTimeout($,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s($){const L=[];let O=0;const _=$.length;function j(){return O<_?$[O++]():null}function Y(oe){oe!=null&&L.push(oe);const q=j();return q?q.then(Y):Promise.resolve(L)}return Promise.resolve(null).then(Y)}e.sequence=s;function c($,L=_=>!!_,O=null){let _=0;const j=$.length,Y=()=>{if(_>=j)return Promise.resolve(O);const oe=$[_++];return Promise.resolve(oe()).then(re=>L(re)?Promise.resolve(re):Y())};return Y()}e.first=c;function l($,L=_=>!!_,O=null){if($.length===0)return Promise.resolve(O);let _=$.length;const j=()=>{_=-1;for(const Y of $)Y.cancel?.()};return new Promise((Y,oe)=>{for(const q of $)q.then(re=>{--_>=0&&L(re)?(j(),Y(re)):_===0&&Y(O)}).catch(re=>{--_>=0&&(j(),oe(re))})})}e.firstParallel=l;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:L,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new W;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const _=O.getComparisonKey(L);let j=this.queues.get(_);return j||(j=new M,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(_),this.onDidQueueDrain()}),this.queues.set(_,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=N;class X{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=X;class ae{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ae;class Q{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=Q;class G extends ae{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=G;class Z extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ae(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{(0,E.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=($,L)=>{const O=requestIdleCallback($,typeof L=="number"?{timeout:L}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function he($,L,O){let _;for(let j=0;j<O;j++)try{return await $()}catch(Y){_=Y,await n(L)}throw _}e.retry=he;class V{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,_){return this._pending={taskId:L,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,_;const j=new Promise((Y,oe)=>{O=Y,_=oe});this._next={run:L,promise:j,promiseResolve:O,promiseReject:_}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=V;class H{constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=W;var A;(function($){async function L(_){let j;const Y=await Promise.all(_.map(oe=>oe.then(q=>q,q=>{j||(j=q)})));if(typeof j<"u")throw j;return Y}$.settled=L;function O(_){return new Promise(async(j,Y)=>{try{await _(j,Y)}catch(oe){Y(oe)}})}$.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var F;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(F||(F={}));class U{static fromArray(L){return new U(O=>{O.emitMany(L)})}static fromPromise(L){return new U(async O=>{O.emitMany(await L)})}static fromPromises(L){return new U(async O=>{await Promise.all(L.map(async _=>O.emitOne(await _)))})}static merge(L){return new U(async O=>{await Promise.all(L.map(async _=>{for await(const j of _)O.emitOne(j)}))})}constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(L(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new U(async _=>{for await(const j of L)_.emitOne(O(j))})}map(L){return U.map(this,L)}static filter(L,O){return new U(async _=>{for await(const j of L)O(j)&&_.emitOne(j)})}filter(L){return U.filter(this,L)}static coalesce(L){return U.filter(L,O=>!!O)}coalesce(){return U.coalesce(this)}static async toPromise(L){const O=[];for await(const _ of L)O.push(_);return O}toPromise(){return U.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=U,U.EMPTY=U.fromArray([]);class J extends U{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function B($){const L=new w.CancellationTokenSource,O=$(L.token);return new J(L,async _=>{const j=L.token.onCancellationRequested(()=>{j.dispose(),L.dispose(),_.reject(new t.CancellationError)});try{for await(const Y of O){if(L.token.isCancellationRequested)return;_.emitOne(Y)}j.dispose(),L.dispose()}catch(Y){j.dispose(),L.dispose(),_.reject(Y)}})}e.createCancelableAsyncIterable=B}),define(te[97],ie([0,1,24,8,30,31,9,5,25]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",v="[^/\\\\]",b=/\//g;function d(W,A){switch(W){case 0:return"";case 1:return`${v}*?`;default:return`(?:${I}|${v}+${I}${A?`|${I}${v}+`:""})*?`}}function h(W,A){if(!W)return[];const F=[];let U=!1,J=!1,B="";for(const $ of W){switch($){case A:if(!U&&!J){F.push(B),B="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":J=!0;break;case"]":J=!1;break}B+=$}return B&&F.push(B),F}e.splitGlobAware=h;function y(W){if(!W)return"";let A="";const F=h(W,e.GLOB_SPLIT);if(F.every(U=>U===e.GLOBSTAR))A=".*";else{let U=!1;F.forEach((J,B)=>{if(J===e.GLOBSTAR){if(U)return;A+=d(2,B===F.length-1)}else{let $=!1,L="",O=!1,_="";for(const j of J){if(j!=="}"&&$){L+=j;continue}if(O&&(j!=="]"||!_)){let Y;j==="-"?Y=j:(j==="^"||j==="!")&&!_?Y="^":j===e.GLOB_SPLIT?Y="":Y=(0,u.escapeRegExpCharacters)(j),_+=Y;continue}switch(j){case"{":$=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${h(L,",").map(q=>y(q)).join("|")})`,$=!1,L="";break}case"]":{A+="["+_+"]",O=!1,_="";break}case"?":A+=v;continue;case"*":A+=d(1);continue;default:A+=(0,u.escapeRegExpCharacters)(j)}}B<F.length-1&&(F[B+1]!==e.GLOBSTAR||B+2<F.length)&&(A+=I)}U=J===e.GLOBSTAR})}return A}const C=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},n=function(){return null};function r(W,A){if(!W)return n;let F;typeof W!="string"?F=W.pattern:F=W,F=F.trim();const U=`${F}_${!!A.trimForExclusions}`;let J=i.get(U);if(J)return s(J,W);let B;return C.test(F)?J=l(F.substr(4),F):(B=p.exec(c(F,A)))?J=P(B[1],F):(A.trimForExclusions?f:S).test(F)?J=M(F,A):(B=g.exec(c(F,A)))?J=T(B[1].substr(1),F,!0):(B=a.exec(c(F,A)))?J=T(B[1],F,!1):J=N(F),i.set(U,J),s(J,W)}function s(W,A){if(typeof A=="string")return W;const F=function(U,J){return(0,k.isEqualOrParent)(U,A.base,!E.isLinux)?W(U.substr(A.base.length+1),J):null};return F.allBasenames=W.allBasenames,F.allPaths=W.allPaths,F.basenames=W.basenames,F.patterns=W.patterns,F}function c(W,A){return A.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function l(W,A){return function(F,U){return typeof F=="string"&&F.endsWith(W)?A:null}}function P(W,A){const F=`/${W}`,U=`\\${W}`,J=function($,L){return typeof $!="string"?null:L?L===W?A:null:$===W||$.endsWith(F)||$.endsWith(U)?A:null},B=[W];return J.basenames=B,J.patterns=[A],J.allBasenames=B,J}function M(W,A){const F=V(W.slice(1,-1).split(",").map(L=>r(L,A)).filter(L=>L!==n),W),U=F.length;if(!U)return n;if(U===1)return F[0];const J=function(L,O){for(let _=0,j=F.length;_<j;_++)if(F[_](L,O))return W;return null},B=F.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function T(W,A,F){const U=D.sep===D.posix.sep,J=U?W:W.replace(b,D.sep),B=D.sep+J,$=D.posix.sep+W;let L;return F?L=function(O,_){return typeof O=="string"&&(O===J||O.endsWith(B)||!U&&(O===W||O.endsWith($)))?A:null}:L=function(O,_){return typeof O=="string"&&(O===J||!U&&O===W)?A:null},L.allPaths=[(F?"*/":"./")+W],L}function N(W){try{const A=new RegExp(`^${y(W)}$`);return function(F){return A.lastIndex=0,typeof F=="string"&&A.test(F)?W:null}}catch{return n}}function X(W,A,F){return!W||typeof A!="string"?!1:ae(W)(A,void 0,F)}e.match=X;function ae(W,A={}){if(!W)return o;if(typeof W=="string"||Q(W)){const F=r(W,A);if(F===n)return o;const U=function(J,B){return!!F(J,B)};return F.allBasenames&&(U.allBasenames=F.allBasenames),F.allPaths&&(U.allPaths=F.allPaths),U}return se(W,A)}e.parse=ae;function Q(W){const A=W;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=Q;function G(W){return W.allBasenames||[]}e.getBasenameTerms=G;function Z(W){return W.allPaths||[]}e.getPathTerms=Z;function se(W,A){const F=V(Object.getOwnPropertyNames(W).map(L=>he(L,W[L],A)).filter(L=>L!==n)),U=F.length;if(!U)return n;if(!F.some(L=>!!L.requiresSiblings)){if(U===1)return F[0];const L=function(j,Y){let oe;for(let q=0,re=F.length;q<re;q++){const ne=F[q](j,Y);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(oe||(oe=[]),oe.push(ne))}return oe?(async()=>{for(const q of oe){const re=await q;if(typeof re=="string")return re}return null})():null},O=F.find(j=>!!j.allBasenames);O&&(L.allBasenames=O.allBasenames);const _=F.reduce((j,Y)=>Y.allPaths?j.concat(Y.allPaths):j,[]);return _.length&&(L.allPaths=_),L}const J=function(L,O,_){let j,Y;for(let oe=0,q=F.length;oe<q;oe++){const re=F[oe];re.requiresSiblings&&_&&(O||(O=(0,D.basename)(L)),j||(j=O.substr(0,O.length-(0,D.extname)(L).length)));const ne=re(L,O,j,_);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(Y||(Y=[]),Y.push(ne))}return Y?(async()=>{for(const oe of Y){const q=await oe;if(typeof q=="string")return q}return null})():null},B=F.find(L=>!!L.allBasenames);B&&(J.allBasenames=B.allBasenames);const $=F.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return $.length&&(J.allPaths=$),J}function he(W,A,F){if(A===!1)return n;const U=r(W,F);if(U===n)return n;if(typeof A=="boolean")return U;if(A){const J=A.when;if(typeof J=="string"){const B=($,L,O,_)=>{if(!_||!U($,L))return null;const j=J.replace("$(basename)",O),Y=_(j);return(0,t.isThenable)(Y)?Y.then(oe=>oe?W:null):Y?W:null};return B.requiresSiblings=!0,B}}return U}function V(W,A){const F=W.filter(L=>!!L.basenames);if(F.length<2)return W;const U=F.reduce((L,O)=>{const _=O.basenames;return _?L.concat(_):L},[]);let J;if(A){J=[];for(let L=0,O=U.length;L<O;L++)J.push(A)}else J=F.reduce((L,O)=>{const _=O.patterns;return _?L.concat(_):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let j;for(j=L.length;j>0;j--){const Y=L.charCodeAt(j-1);if(Y===47||Y===92)break}O=L.substr(j)}const _=U.indexOf(O);return _!==-1?J[_]:null};B.basenames=U,B.patterns=J,B.allBasenames=U;const $=W.filter(L=>!L.basenames);return $.push(B),$}function H(W,A){return(0,w.equals)(W,A,(F,U)=>typeof F=="string"&&typeof U=="string"?F===U:typeof F!="string"&&typeof U!="string"?F.base===U.base&&F.pattern===U.pattern:!1)}e.patternsEquals=H}),define(te[35],ie([0,1,24,30,9,5,16,25]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function u(n,r){const{os:s,tildify:c,relative:l}=r;if(l){const T=m(n,l,s);if(typeof T=="string")return T}let P=n.fsPath;if(s===1&&!R.isWindows?P=P.replace(/\//g,"\\"):s!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),s!==1&&c?.userHome){const T=c.userHome.fsPath;let N;n.scheme!==c.userHome.scheme&&n.path.startsWith(k.posix.sep)?N=c.userHome.with({path:n.path}).fsPath:N=n.fsPath,P=b(N,T,s)}return(s===1?k.win32:k.posix).normalize(I(P,s===1))}e.getPathLabel=u;function m(n,r,s){const c=s===1?k.win32:k.posix,l=s===3?D.extUri:D.extUriIgnorePathCase,P=r.getWorkspace(),M=(0,w.firstOrDefault)(P.folders);if(!M)return;n.scheme!==M.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=M.uri.with({path:n.path}));const T=r.getWorkspaceFolder(n);if(!T)return;let N;if(l.isEqual(T.uri,n)?N="":N=l.relativePath(T.uri,n)??"",N&&(N=c.normalize(N)),P.folders.length>1&&!r.noPrefix){const X=T.name?T.name:l.basenameOrAuthority(T.uri);N=N?`${X} \u2022 ${N}`:X}return N}function I(n,r=R.isWindows){return(0,t.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let v=Object.create(null);function b(n,r,s=R.OS){if(s===1||!n||!r)return n;let c=v.original===r?v.normalized:void 0;c||(c=r,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,E.rtrim)(c,k.posix.sep)}${k.posix.sep}`,v={original:r,normalized:c});let l=n;return R.isWindows&&(l=(0,t.toSlashes)(l)),(s===3?l.startsWith(c):(0,E.startsWithIgnoreCase)(l,c))?`~/${l.substr(c.length)}`:n}e.tildify=b;function d(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=d;const h="\u2026",y="\\\\",C="~";function p(n,r=k.sep){const s=new Array(n.length);let c=!1;for(let l=0;l<n.length;l++){const P=n[l];if(P===""){s[l]=`.${r}`;continue}if(!P){s[l]=P;continue}c=!0;let M="",T=P;T.indexOf(y)===0?(M=T.substr(0,T.indexOf(y)+y.length),T=T.substr(T.indexOf(y)+y.length)):T.indexOf(r)===0?(M=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(C)===0&&(M=T.substr(0,T.indexOf(C)+C.length),T=T.substr(T.indexOf(C)+C.length));const N=T.split(r);for(let X=1;c&&X<=N.length;X++)for(let ae=N.length-X;c&&ae>=0;ae--){c=!1;let Q=N.slice(ae,ae+X).join(r);for(let G=0;!c&&G<n.length;G++)if(G!==l&&n[G]&&n[G].indexOf(Q)>-1){const Z=ae+X===N.length,se=ae>0&&n[G].indexOf(r)>-1?r+Q:Q,he=n[G].endsWith(se);c=!Z||he}if(!c){let G="";(N[0].endsWith(":")||M!=="")&&(ae===1&&(ae=0,X++,Q=N[0]+r+Q),ae>0&&(G=N[0]+r),G=M+G),ae>0&&(G=G+h+r),G=G+Q,ae+X<N.length&&(G=G+r+h),s[l]=G}}c&&(s[l]=P)}return s}e.shorten=p;var S;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function f(n,r=Object.create(null)){const s=[];let c=!1,l="";for(const P of n)if(P==="$"||c&&P==="{")l&&s.push({value:l,type:S.TEXT}),l="",c=!0;else if(P==="}"&&c){const M=r[l];if(typeof M=="string")M.length&&s.push({value:M,type:S.VARIABLE});else if(M){const T=s[s.length-1];(!T||T.type!==S.SEPARATOR)&&s.push({value:M.label,type:S.SEPARATOR})}l="",c=!1}else l+=P;return l&&!c&&s.push({value:l,type:S.TEXT}),s.filter((P,M)=>{if(P.type===S.SEPARATOR){const T=s[M-1],N=s[M+1];return[T,N].every(X=>X&&(X.type===S.VARIABLE||X.type===S.TEXT)&&X.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=f;function g(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function a(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(n){const r=n.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(n),c=r.dirname(n);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=o}),define(te[140],ie([0,1,7]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(v){this._uriTransformer=v}transformIncoming(v){const b=this._uriTransformer.transformIncoming(v);return b===v?v:t(w.URI.from(b))}transformOutgoing(v){const b=this._uriTransformer.transformOutgoing(v);return b===v?v:t(w.URI.from(b))}transformOutgoingURI(v){const b=this._uriTransformer.transformOutgoing(v);return b===v?v:w.URI.from(b)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,v,b){if(!I||b>200)return null;if(typeof I=="object"){if(I instanceof w.URI)return v.transformOutgoing(I);for(const d in I)if(Object.hasOwnProperty.call(I,d)){const h=R(I[d],v,b+1);h!==null&&(I[d]=h)}}return null}function D(I,v){const b=R(I,v,0);return b===null?I:b}e.transformOutgoingURIs=D;function E(I,v,b,d){if(!I||d>200)return null;if(typeof I=="object"){if(I.$mid===1)return b?w.URI.revive(v.transformIncoming(I)):v.transformIncoming(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const y=E(I[h],v,b,d+1);y!==null&&(I[h]=y)}}return null}function u(I,v){const b=E(I,v,!1,0);return b===null?I:b}e.transformIncomingURIs=u;function m(I,v){const b=E(I,v,!0,0);return b===null?I:b}e.transformAndReviveIncomingURIs=m}),define(te[81],ie([0,1,27,17,31,29,128]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,v=0;const b=(0,w.networkInterfaces)();for(const d in b){const h=b[d];if(h)for(const{mac:y,internal:C}of h)C||(v+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(I+=1))}this._value=v>0?I/v:0}return this._value}};let E;async function u(){return E||(E=(async()=>await m()||R.generateUuid())()),E}e.getMachineId=u;async function m(){try{const I=await new Promise((b,d)=>{z(["crypto"],b,d)}),v=(0,D.getMac)();return I.createHash("sha256").update(v,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(te[21],ie([0,1,40,27,141,8,30,80,9,5,16,7]),function(z,e,w,t,k,R,D,E,u,m,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function d(se,he=b.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return he===b.UNLINK?y(se):h(se)}async function h(se){try{const he=(0,D.randomPath)((0,t.tmpdir)());try{await w.promises.rename(se,he)}catch(V){return V.code==="ENOENT"?void 0:y(se)}y(he).catch(V=>{})}catch(he){if(he.code!=="ENOENT")throw he}}async function y(se){return(0,k.promisify)(w.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function C(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function p(se,he){return g(await(he?S(se):(0,k.promisify)(w.readdir)(se)))}async function S(se){try{return await(0,k.promisify)(w.readdir)(se,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const he=[],V=await p(se);for(const H of V){let W=!1,A=!1,F=!1;try{const U=await e.Promises.lstat((0,u.join)(se,H));W=U.isFile(),A=U.isDirectory(),F=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}he.push({name:H,isFile:()=>W,isDirectory:()=>A,isSymbolicLink:()=>F})}return he}function f(se){return g(w.readdirSync(se))}e.readdirSync=f;function g(se){return se.map(he=>typeof he=="string"?m.isMacintosh?(0,E.normalizeNFC)(he):he:(he.name=m.isMacintosh?(0,E.normalizeNFC)(he.name):he.name,he))}async function a(se){const he=await p(se),V=[];for(const H of he)await o.existsDirectory((0,u.join)(se,H))&&V.push(H);return V}function i(se,he=1e3){return new Promise(V=>{let H=!1;const W=setInterval(()=>{H||(H=!0,w.access(se,A=>{H=!1,A&&(clearInterval(W),V(void 0))}))},he)})}e.whenDeleted=i;var o;(function(se){async function he(W){let A;try{if(A=await e.Promises.lstat(W),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(m.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw U}throw F}}se.stat=he;async function V(W){try{const{stat:A,symbolicLink:F}=await se.stat(W);return A.isFile()&&F?.dangling!==!0}catch{}return!1}se.existsFile=V;async function H(W){try{const{stat:A,symbolicLink:F}=await se.stat(W);return A.isDirectory()&&F?.dangling!==!0}catch{}return!1}se.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function r(se,he,V){return n.queueFor(v.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const H=M(V);return new Promise((W,A)=>l(se,he,H,F=>F?A(F):W()))})}let s=!0;function c(se){s=se}e.configureFlushOnWrite=c;function l(se,he,V,H){if(!s)return w.writeFile(se,he,{mode:V.mode,flag:V.flag},H);w.open(se,V.flag,V.mode,(W,A)=>{if(W)return H(W);w.writeFile(A,he,F=>{if(F)return w.close(A,()=>H(F));w.fdatasync(A,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),c(!1)),w.close(A,J=>H(J))))})})}function P(se,he,V){const H=M(V);if(!s)return w.writeFileSync(se,he,{mode:H.mode,flag:H.flag});const W=w.openSync(se,H.flag,H.mode);try{w.writeFileSync(W,he);try{w.fdatasyncSync(W)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c(!1)}}finally{w.closeSync(W)}}e.writeFileSync=P;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,he){if(se!==he)try{await e.Promises.rename(se,he)}catch(V){if(se.toLowerCase()!==he.toLowerCase()&&V.code==="EXDEV"||se.endsWith("."))await N(se,he,{preserveSymlinks:!1}),await d(se,b.MOVE);else throw V}}async function N(se,he,V){return ae(se,he,{root:{source:se,target:he},options:V,handledSourcePaths:new Set})}const X=511;async function ae(se,he,V){if(V.handledSourcePaths.has(se))return;V.handledSourcePaths.add(se);const{stat:H,symbolicLink:W}=await o.stat(se);if(W){if(V.options.preserveSymlinks)try{return await Z(se,he,V)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(W.dangling)return}return H.isDirectory()?Q(se,he,H.mode&X,V):G(se,he,H.mode&X)}async function Q(se,he,V,H){await e.Promises.mkdir(he,{recursive:!0,mode:V});const W=await p(se);for(const A of W)await ae((0,u.join)(se,A),(0,u.join)(he,A),H)}async function G(se,he,V){await e.Promises.copyFile(se,he),await e.Promises.chmod(he,V)}async function Z(se,he,V){let H=await e.Promises.readlink(se);(0,D.isEqualOrParent)(H,V.root.source,!m.isLinux)&&(H=(0,u.join)(V.root.target,H.substr(V.root.source.length+1))),await e.Promises.symlink(H,he)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(se,he,V,H,W)=>new Promise((A,F)=>{w.read(se,he,V,H,W,(U,J,B)=>U?F(U):A({bytesRead:J,buffer:B}))})}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(se,he,V,H,W)=>new Promise((A,F)=>{w.write(se,he,V,H,W,(U,J,B)=>U?F(U):A({bytesWritten:J,buffer:B}))})}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get rename(){return(0,k.promisify)(w.rename)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return a}get writeFile(){return r}get rm(){return d}get move(){return T}get copy(){return N}}}),define(te[98],ie([0,1,40,9,5,25,21]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function E(b){if(k.isLinux)return b;const d=(0,t.dirname)(b);if(b===d)return b;const h=((0,t.basename)(b)||b).toLowerCase();try{const C=(0,D.readdirSync)(d).filter(p=>p.toLowerCase()===h);if(C.length===1){const p=E(d);if(p)return(0,t.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(h);if(p>=0){const S=E(d);if(S)return(0,t.join)(S,C[p])}}}catch{}return null}e.realcaseSync=E;async function u(b){if(k.isLinux)return b;const d=(0,t.dirname)(b);if(b===d)return b;const h=((0,t.basename)(b)||b).toLowerCase();try{const C=(await D.Promises.readdir(d)).filter(p=>p.toLowerCase()===h);if(C.length===1){const p=await u(d);if(p)return(0,t.join)(p,C[0])}else if(C.length>1){const p=C.indexOf(h);if(p>=0){const S=await u(d);if(S)return(0,t.join)(S,C[p])}}}catch{}return null}e.realcase=u;async function m(b){try{return await D.Promises.realpath(b)}catch{const h=v(b);return await D.Promises.access(h,w.constants.R_OK),h}}e.realpath=m;function I(b){try{return w.realpathSync(b)}catch{const h=v(b);return w.accessSync(h,w.constants.R_OK),h}}e.realpathSync=I;function v(b){return(0,R.rtrim)((0,t.normalize)(b),t.sep)}}),define(te[142],ie([0,1,27,9,21]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(u||(u={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class v{constructor(a,i,o){this.exePath=a,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:g=!1}={}){return g?m===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:g=!1,findPreview:a=!1}={}){const i=b({useAlternateBitness:g});if(!i)return null;const o=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let n=-1,r=null;for(const l of await k.Promises.readdir(o)){let P=-1;if(a){const T=l.indexOf("-");if(T<0)continue;const N=l.substring(0,T);if(!R.test(N)||l.substring(T+1)!=="preview")continue;P=parseInt(N,10)}else{if(!R.test(l))continue;P=parseInt(l,10)}if(P<=n)continue;const M=t.join(o,l,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(r=M,n=P)}if(!r)return null;const s=i.includes("x86")?" (x86)":"",c=a?" Preview":"";return new v(r,`PowerShell${c}${s}`,!0)}async function h({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const a=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(a))if(i.test(n)){const r=t.join(a,n,"pwsh.exe");return new v(r,o)}return null}function y(){const g=t.join(w.homedir(),".dotnet","tools","pwsh.exe");return new v(g,".NET Core PowerShell Global Tool")}function C(){const g=t.join(process.env.windir,m===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(g,"Windows PowerShell",!0)}async function*p(){let g=await d();g&&(yield g),g=await d({useAlternateBitness:!0}),g&&(yield g),g=await h(),g&&(yield g),g=y(),g&&(yield g),g=await d({findPreview:!0}),g&&(yield g),g=await h({findPreview:!0}),g&&(yield g),g=await d({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=C(),g&&(yield g)}async function*S(){for await(const g of p())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=S;async function f(){for await(const g of S())return g;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[82],ie([0,1,9,5,34,78,12,21]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(v=k.env){return v.comspec||"cmd.exe"}e.getWindowsShell=u;function m(v){let b=[],d=!1;const h=function(y){if(d){b.push(y);return}(!v.send(y,p=>{if(p&&console.error(p),d=!1,b.length>0){const S=b.slice(0);b=[],S.forEach(f=>h(f))}})||t.isWindows)&&(d=!0)};return{send:h}}e.createQueuedSender=m;var I;(function(v){async function b(d,h,y){if(w.isAbsolute(d))return d;if(h===void 0&&(h=k.cwd()),w.dirname(d)!=="."||(y===void 0&&D.isString(k.env.PATH)&&(y=k.env.PATH.split(w.delimiter)),y===void 0||y.length===0))return w.join(h,d);async function p(S){if(await E.Promises.exists(S)){let f;try{f=await E.Promises.stat(S)}catch(g){g.message.startsWith("EACCES")&&(f=await E.Promises.lstat(S))}return f?!f.isDirectory():!1}return!1}for(const S of y){let f;if(w.isAbsolute(S)?f=w.join(S,d):f=w.join(h,S,d),await p(f))return f;let g=f+".com";if(await p(g)||(g=f+".exe",await p(g)))return g}return w.join(h,d)}v.findExecutable=b})(I=e.win32||(e.win32={}))}),define(te[99],ie([0,1,45,13]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((E,u)=>{let m;const I=new Map;function v(d,h,y,C,p){const S=I.get(h);if(d===D||S){const f={name:b(y),cmd:y,pid:d,ppid:h,load:C,mem:p};I.set(d,f),d===D&&(m=f),S&&(S.children||(S.children=[]),S.children.push(f),S.children.length>1&&(S.children=S.children.sort((g,a)=>g.pid-a.pid)))}}function b(d){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,S=/--utility-sub-type=node.mojom.NodeService/,f=/--crashes-directory/,g=/\\pipe\\winpty-control/,a=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(f.exec(d))return"electron-crash-reporter";if(g.exec(d))return"winpty-process";if(a.exec(d))return"console-window-host (Windows internal process)";let o=i.exec(d);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(d)?"shared-process":y.exec(d)?"issue-reporter":C.exec(d)?"process-explorer":"window";if(o[1]==="utility"){if(p.exec(d))return"utility-network-service";if(S.exec(d))return"extension-host"}return o[1]}const n=/[a-zA-Z-]+\.js/g;let r="";do o=n.exec(d),o&&(r+=o+" ");while(o);return r&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${r}`:d}if(process.platform==="win32"){const d=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{z(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(D,y=>{if(!y){u(new Error(`Root process ${D} not found`));return}h.getProcessCpuUsage(y,C=>{const p=new Map;C.forEach(S=>{const f=d(S.commandLine||"");p.set(S.pid,{name:b(f),cmd:f,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),m=p.get(D),m?(p.forEach(S=>{const f=p.get(S.ppid);f&&(f.children||(f.children=[]),f.children.push(S))}),p.forEach(S=>{S.children&&(S.children=S.children.sort((f,g)=>f.pid-g.pid))}),E(m)):u(new Error(`Root process ${D} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let d=function(){let h=[m];const y=[];for(;h.length;){const p=h.shift();p&&(y.push(p.pid),p.children&&(h=h.concat(p.children)))}let C=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);C+=" "+y.join(" "),(0,w.exec)(C,{},(p,S,f)=>{if(p||f)u(p||new Error(f.toString()));else{const g=S.toString().split(`
`);for(let a=0;a<y.length;a++){const i=I.get(y[a]);i.load=parseFloat(g[a])}if(!m){u(new Error(`Root process ${D} not found`));return}E(m)}})};(0,w.exec)("which ps",{},(h,y,C)=>{if(h||C)if(process.platform!=="linux")u(h||new Error(C.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);(0,w.exec)(p,{},(S,f,g)=>{S||g?u(S||new Error(g.toString())):(R(f,v),d())})}else{const p=y.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${p} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,g,a)=>{f||a&&!a.includes("screen size is bogus")?u(f||new Error(a.toString())):(R(g,v),process.platform==="linux"?d():m?E(m):u(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,E){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=D.toString().split(`
`);for(const I of m){const v=u.exec(I.trim());v&&v.length===6&&E(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(te[143],ie([0,1,27,5,142,82]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(d,h){return d===1?t.isWindows?v():R.getWindowsShell(h):m(d,h)}e.getSystemShell=D;function E(d,h){return d===1?t.isWindows?b(h):R.getWindowsShell(h):m(d,h)}e.getSystemShellSync=E;let u=null;function m(d,h){if(t.isLinux&&d===2||t.isMacintosh&&d===3)return"/bin/bash";if(!u){let y;if(t.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,w.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}u=y}return u}let I=null;async function v(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function b(d){if(I)return I;const h=t.isWindows&&parseFloat((0,w.release)())>=10,y=d.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${d.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?C:R.getWindowsShell(d)}});var ve=this&&this.__decorate||function(z,e,w,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,w):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,e,w,t);else for(var E=z.length-1;E>=0;E--)(D=z[E])&&(R=(k<3?D(R):k>3?D(e,w,R):D(e,w))||R);return k>3&&R&&Object.defineProperty(e,w,R),R};define(te[46],ie([0,1,24,8,18,23,53,17,3,2,67,25,12]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var d;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(d=e.RequestType||(e.RequestType={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function C(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(p||(p={}));class S{constructor(A){this.buffer=A,this.pos=0}read(A){const F=this.buffer.slice(this.pos,this.pos+A);return this.pos+=F.byteLength,F}}class f{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var g;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(g||(g={}));function a(W){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(W,0),A}function i(W){return W.read(4).readUInt32BE(0)}function o(W){const A=k.VSBuffer.alloc(1);return A.writeUInt8(W,0),A}const n={Undefined:o(g.Undefined),String:o(g.String),Buffer:o(g.Buffer),VSBuffer:o(g.VSBuffer),Array:o(g.Array),Object:o(g.Object)},r=typeof Buffer<"u";function s(W,A){if(typeof A>"u")W.write(n.Undefined);else if(typeof A=="string"){const F=k.VSBuffer.fromString(A);W.write(n.String),W.write(a(F.byteLength)),W.write(F)}else if(r&&Buffer.isBuffer(A)){const F=k.VSBuffer.wrap(A);W.write(n.Buffer),W.write(a(F.byteLength)),W.write(F)}else if(A instanceof k.VSBuffer)W.write(n.VSBuffer),W.write(a(A.byteLength)),W.write(A);else if(Array.isArray(A)){W.write(n.Array),W.write(a(A.length));for(const F of A)s(W,F)}else{const F=k.VSBuffer.fromString(JSON.stringify(A));W.write(n.Object),W.write(a(F.byteLength)),W.write(F)}}function c(W){switch(W.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return W.read(i(W)).toString();case g.Buffer:return W.read(i(W)).buffer;case g.VSBuffer:return W.read(i(W));case g.Array:{const F=i(W),U=[];for(let J=0;J<F;J++)U.push(c(W));return U}case g.Object:return JSON.parse(W.read(i(W)).toString())}}class l{constructor(A,F,U=null,J=1e3){this.protocol=A,this.ctx=F,this.logger=U,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,F){this.channels.set(A,F),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const F=this.send([A.type]);this.logger?.logOutgoing(F,0,1,C(A.type));return}case 201:case 202:case 204:case 203:{const F=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(F,A.id,1,C(A.type),A.data);return}}}send(A,F=void 0){const U=new f;return s(U,A),s(U,F),this.sendBuffer(U.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const F=new S(A),U=c(F),J=c(F),B=U[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,U[1],1,`${h(B)}: ${U[2]}.${U[3]}`,J),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:J});case 102:return this.logger?.logIncoming(A.byteLength,U[1],1,`${h(B)}: ${U[2]}.${U[3]}`,J),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:J});case 101:return this.logger?.logIncoming(A.byteLength,U[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger?.logIncoming(A.byteLength,U[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const U=new R.CancellationTokenSource;let J;try{J=F.call(this.ctx,A.name,A.arg,U.token)}catch(L){J=Promise.reject(L)}const B=A.id;J.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const $=(0,m.toDisposable)(()=>U.cancel());this.activeRequests.set(A.id,$)}onEventListen(A){const F=this.channels.get(A.channelName);if(!F){this.collectPendingRequest(A);return}const U=A.id,B=F.listen(this.ctx,A.name,A.arg)($=>this.sendResponse({id:U,data:$,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const F=this.activeRequests.get(A.id);F&&(F.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let F=this.pendingRequests.get(A.channelName);F||(F=[],this.pendingRequests.set(A.channelName,F));const U=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:A,timeoutTimer:U})}flushPendingRequests(A){const F=this.pendingRequests.get(A);if(F){for(const U of F)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var P;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,F=null){this.protocol=A,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=F}getChannel(A){const F=this;return{call(U,J,B){return F.isDisposed?Promise.reject(new E.CancellationError):F.requestPromise(A,U,J,B)},listen(U,J){return F.isDisposed?u.Event.None:F.requestEvent(A,U,J)}}}requestPromise(A,F,U,J=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:F,arg:U};if(J.isCancellationRequested)return Promise.reject(new E.CancellationError);let O;return new Promise((j,Y)=>{if(J.isCancellationRequested)return Y(new E.CancellationError);const oe=()=>{const ce=ge=>{switch(ge.type){case 201:this.handlers.delete(B),j(ge.data);break;case 202:{this.handlers.delete(B);const De=new Error(ge.data.message);De.stack=ge.data.stack,De.name=ge.data.name,Y(De);break}case 203:this.handlers.delete(B),Y(ge.data);break}};this.handlers.set(B,ce),this.sendRequest(L)};let q=null;this.state===p.Idle?oe():(q=(0,t.createCancelablePromise)(ce=>this.whenInitialized()),q.then(()=>{q=null,oe()}));const re=()=>{q?(q.cancel(),q=null):this.sendRequest({id:B,type:101}),Y(new E.CancellationError)},ne=J.onCancellationRequested(re);O=(0,m.combinedDisposable)((0,m.toDisposable)(re),ne),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,F,U){const J=this.lastRequestId++,$={id:J,type:102,channelName:A,name:F,arg:U};let L=null;const O=new u.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(j=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest($)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:J,type:103}))}}),_=j=>O.fire(j.data);return this.handlers.set(J,_),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const F=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(F,A.id,0,`${h(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const F=this.send([A.type,A.id]);this.logger?.logOutgoing(F,A.id,0,h(A.type));return}}}send(A,F=void 0){const U=new f;return s(U,A),s(U,F),this.sendBuffer(U.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const F=new S(A),U=c(F),J=c(F),B=U[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,C(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,U[1],0,C(B),J),this.onResponse({type:U[0],id:U[1],data:J})}}onResponse(A){if(A.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,m.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const A=[];return this._connections.forEach(F=>A.push(F)),A}constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:F,onDidClientDisconnect:U})=>{u.Event.once(F.onMessage)(B=>{const $=new S(B),L=c($),O=new l(F,L),_=new M(F);this.channels.forEach((Y,oe)=>O.registerChannel(oe,Y));const j={channelServer:O,channelClient:_,ctx:L};this._connections.add(j),this._onDidAddConnection.fire(j),U(()=>{O.dispose(),_.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}getChannel(A,F){const U=this;return{call(J,B,$){let L;if((0,b.isFunction)(F)){const _=(0,w.getRandomElement)(U.connections.filter(F));L=_?Promise.resolve(_):u.Event.toPromise(u.Event.filter(U.onDidAddConnection,F))}else L=F.routeCall(U,J,B);const O=L.then(_=>_.channelClient.getChannel(A));return X(O).call(J,B,$)},listen(J,B){if((0,b.isFunction)(F))return U.getMulticastEvent(A,F,J,B);const $=F.routeEvent(U,J,B).then(L=>L.channelClient.getChannel(A));return X($).listen(J,B)}}}getMulticastEvent(A,F,U,J){const B=this;let $=new m.DisposableStore;const L=new u.Emitter({onFirstListenerAdd:()=>{$=new m.DisposableStore;const O=new u.EventMultiplexer,_=new Map,j=oe=>{const re=oe.channelClient.getChannel(A).listen(U,J),ne=O.add(re);_.set(oe,ne)},Y=oe=>{const q=_.get(oe);!q||(q.dispose(),_.delete(oe))};B.connections.filter(F).forEach(j),u.Event.filter(B.onDidAddConnection,F)(j,void 0,$),B.onDidRemoveConnection(Y,void 0,$),O.event(L.fire,L,$),$.add(O)},onLastListenerRemove:()=>{$.dispose()}});return L.event}registerChannel(A,F){this.channels.set(A,F),this._connections.forEach(U=>{U.channelServer.registerChannel(A,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class N{constructor(A,F,U=null){const J=new f;s(J,F),A.send(J.buffer),this.channelClient=new M(A,U),this.channelServer=new l(A,F,U)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,F){this.channelServer.registerChannel(A,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=N;function X(W){return{call(A,F,U){return W.then(J=>J.call(A,F,U))},listen(A,F){const U=new u.Relay;return W.then(J=>U.input=J.listen(A,F)),U.event}}}e.getDelayedChannel=X;function ae(W){let A=!1;return{call(F,U,J){return A?W.call(F,U,J):(0,t.timeout)(0).then(()=>A=!0).then(()=>W.call(F,U,J))},listen(F,U){if(A)return W.listen(F,U);const J=new u.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>J.input=W.listen(F,U)),J.event}}}e.getNextTickChannel=ae;class Q{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const F of A.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await u.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=Q;var G;(function(W){function A(B,$){const L=B,O=$&&$.disableMarshalling,_=new Map;for(const j in L)U(j)&&_.set(j,u.Event.buffer(L[j],!0));return new class{listen(j,Y,oe){const q=_.get(Y);if(q)return q;if(J(Y)){const re=L[Y];if(typeof re=="function")return re.call(L,oe)}throw new Error(`Event not found: ${Y}`)}call(j,Y,oe){const q=L[Y];if(typeof q=="function"){if(!O&&Array.isArray(oe))for(let re=0;re<oe.length;re++)oe[re]=(0,I.revive)(oe[re]);return q.apply(L,oe)}throw new Error(`Method not found: ${Y}`)}}}W.fromService=A;function F(B,$){const L=$&&$.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return $?.properties?.has(_)?$.properties.get(_):J(_)?function(j){return B.listen(_,j)}:U(_)?B.listen(_):async function(...j){let Y;$&&!(0,b.isUndefinedOrNull)($.context)?Y=[$.context,...j]:Y=j;const oe=await B.call(_,Y);return L?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(_)}`)}})}W.toService=F;function U(B){return B[0]==="o"&&B[1]==="n"&&v.isUpperAsciiLetter(B.charCodeAt(2))}function J(B){return/^onDynamic/.test(B)&&v.isUpperAsciiLetter(B.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const A=W.toString();if(A!=="[object Object]")return A}return W}function he(W){return Array.isArray(W)?W.map(se):se(W)}function V(W,A,F,U,J,B,$){$=he($);const L=Z[J],O=L[U%L.length];let _=[`%c[${W}]%c[${String(A).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(_=_.concat($),_.push(")")):_.push($),console.log.apply(console,_)}e.logWithColors=V;class H{constructor(A,F){this._outgoingPrefix=A,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,F,U,J,B){this._totalOutgoing+=A,V(this._outgoingPrefix,this._totalOutgoing,A,F,U,J,B)}logIncoming(A,F,U,J,B){this._totalIncoming+=A,V(this._incomingPrefix,this._totalIncoming,A,F,U,J,B)}}e.IPCLogger=H}),define(te[144],ie([0,1,18,3,46]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(u){this.port=u,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",m=>w.VSBuffer.wrap(m.data)),u.start()}send(u){this.port.postMessage(u.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(u,m){const I=new R(u);super(I,m),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=D}),define(te[100],ie([0,1,18,3,2,46]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let c=0;function l(M,T){if(!s.has(M)){const N=String(++c);s.set(M,N)}return s.get(M)}function P(M,T,N,X){if(!r.enableDiagnostics)return;const ae=l(M,T);if(X instanceof w.VSBuffer||X instanceof Uint8Array||X instanceof ArrayBuffer||ArrayBuffer.isView(X)){const Q=w.VSBuffer.alloc(X.byteLength);Q.set(X),r.records.push({timestamp:Date.now(),id:ae,label:T,type:N,buff:Q})}else r.records.push({timestamp:Date.now(),id:ae,label:T,type:N,data:X})}r.traceSocketEvent=P})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var u;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function I(){return m||(m=w.VSBuffer.alloc(0)),m}class v{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const l=w.VSBuffer.alloc(s);let P=0,M=0;for(;s>0;){const T=this._chunks[M];if(T.byteLength>s){const N=T.slice(0,s);l.set(N,P),P+=s,c&&(this._chunks[M]=T.slice(s),this._totalLength-=s),s-=s}else l.set(T,P),P+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,s-=T.byteLength}return l}}e.ChunkStream=v;var b;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(b||(b={}));function d(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,c,l,P){this.type=s,this.id=c,this.ack=l,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new v,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:d(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,P=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new y(l,P,M,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=w.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:d(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(c,s.data)}_bufferAdd(s,c){const l=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,l}_bufferTake(){const s=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class S extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=S;class f extends R.IPCClient{static fromSocket(s,c){return new f(new S(s),c)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,c,l=null){super(s,c,l),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=f;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class a{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,c=this._first;for(;c;)c=c.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let c=0,l=this._first;for(;l;)s[c++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new a(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<o._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=o._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),c=(1+o._HISTORY_LENGTH)*1e3;let l=0;for(let P=0;P<o._HISTORY_LENGTH;P++)s-this.lastRuns[P]<=c&&l++;return 1-l/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,c=null,l=o.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new y(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new y(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s);const c=this._outgoingUnackMsg.toArray();for(let l=0,P=c.length;l<P;l++)this._socketWriter.write(c[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new y(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let l=0,P=c.length;l<P;l++)this._socketWriter.write(c[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new y(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const c=new y(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&l>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:l});return}const M=Math.max(2e4-c,2e4-l,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new y(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(te[145],ie([0,1,41,18,3,2,46,130]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function u(I,v){const b=k.Event.fromNodeEventEmitter(w.validatedIpcMain,v,(h,y)=>({event:h,message:y})),d=k.Event.filter(b,({event:h})=>h.sender.id===I);return k.Event.map(d,({message:h})=>h&&t.VSBuffer.wrap(h))}class m extends D.IPCServer{static getOnDidClientConnect(){const v=k.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(v,b=>{const d=b.id;m.Clients.get(d)?.dispose();const y=new k.Emitter;m.Clients.set(d,(0,R.toDisposable)(()=>y.fire()));const C=u(d,"vscode:message"),p=k.Event.any(k.Event.signal(u(d,"vscode:disconnect")),y.event);return{protocol:new E.Protocol(b,C),onDidClientDisconnect:p}})}constructor(){super(m.getOnDidClientConnect())}}e.Server=m,m.Clients=new Map}),define(te[101],ie([0,1,41,3,29,144]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(m,I){super({addEventListener:(v,b)=>m.addListener(v,b),removeEventListener:(v,b)=>m.removeListener(v,b),postMessage:v=>m.postMessage(v),start:()=>m.start(),close:()=>m.close()},I)}}e.Client=D;async function E(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();u.webContents.send("vscode:createMessageChannel",m);const I=t.Event.fromNodeEventEmitter(w.validatedIpcMain,"vscode:createMessageChannelResult",(b,d)=>({nonce:d,port:b.ports[0]})),{port:v}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,b=>b.nonce===m)));return v}e.connect=E}),define(te[146],ie([0,1,45,8,18,23,139,17,3,2,50,82,78,46]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends d.ChannelServer{constructor(p){super({send:S=>{try{process.send?.(S.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",S=>k.VSBuffer.wrap(Buffer.from(S,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(p,S){this.modulePath=p,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new t.Delayer(f),this.child=null,this._client=null}getChannel(p){const S=this;return{call(f,g,a){return S.requestPromise(p,f,g,a)},listen(f,g){return S.requestEvent(p,f,g)}}}requestPromise(p,S,f,g=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(p),i=(0,t.createCancelablePromise)(r=>a.call(S,f,r)),o=g.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,S,f){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let g;const a=new u.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(p).listen(S,f)(a.fire,a),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,b.removeDangerousEnvVariables)(S.env),this.child=(0,w.fork)(this.modulePath,p,S);const f=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}f.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const a=this.options.useQueue?(0,v.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&a.send(s.buffer.toString("base64")),o=f.event,n={send:i,onMessage:o};this._client=new d.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(l=>(0,m.dispose)(l)),this.activeRequests.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:c})})}return this._client}getCachedChannel(p){let S=this.channels.get(p);return S||(S=this.client.getChannel(p),this.channels.set(p,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(te[83],ie([0,1,18,17,3,2,9,5,29,46,100]),function(z,e,w,t,k,R,D,E,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:z.__$__nodeRequire("crypto"),zlib:z.__$__nodeRequire("zlib"),net:z.__$__nodeRequire("net"),os:z.__$__nodeRequire("os")}}class b{traceSocketEvent(l,P){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,P)}constructor(l,P=""){this._canWrite=!0,this.debugLabel=P,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener),this._closeListener=M=>{this.traceSocketEvent("close",{hadError:M}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(l){const P=M=>{this.traceSocketEvent("read",M),l(w.VSBuffer.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(l){const P=M=>{l({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(l){const P=()=>{l()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(l){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=b;var d;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class y extends R.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,P){this.socket.traceSocketEvent(l,P)}constructor(l,P,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new C(this,P,M,T,this._onData,(N,X)=>this._write(N,X))),this._register(this._flowManager.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(N=>this._onClose.fire(N)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let M=2;l.byteLength<126?M+=0:l.byteLength<2**16?M+=2:M+=8;const T=w.VSBuffer.alloc(M);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let N=1;T.writeUInt8(l.byteLength>>>8&255,++N),T.writeUInt8(l.byteLength>>>0&255,++N)}else{T.writeUInt8(127,1);let N=1;T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(l.byteLength>>>24&255,++N),T.writeUInt8(l.byteLength>>>16&255,++N),T.writeUInt8(l.byteLength>>>8&255,++N),T.writeUInt8(l.byteLength>>>0&255,++N)}this.socket.write(w.VSBuffer.concat([T,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),M=P.readUInt8(0),T=(M&128)>>>7,N=(M&64)>>>6,X=P.readUInt8(1),ae=(X&128)>>>7,Q=X&127;this._state.state=2,this._state.readLen=2+(ae?4:0)+(Q===126?2:0)+(Q===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(N)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),M=P.readUInt8(1),T=(M&128)>>>7;let N=M&127,X=1;N===126?N=P.readUInt8(++X)*2**8+P.readUInt8(++X):N===127&&(N=P.readUInt8(++X)*0+P.readUInt8(++X)*0+P.readUInt8(++X)*0+P.readUInt8(++X)*0+P.readUInt8(++X)*2**24+P.readUInt8(++X)*2**16+P.readUInt8(++X)*2**8+P.readUInt8(++X));let ae=0;T&&(ae=P.readUInt8(++X)*2**24+P.readUInt8(++X)*2**16+P.readUInt8(++X)*2**8+P.readUInt8(++X)),this._state.state=3,this._state.readLen=N,this._state.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),f(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class C extends R.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:w.VSBuffer.alloc(0)}constructor(l,P,M,T,N,X){super(),this._tracer=l,this._onData=N,this._writeFn=X,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new p(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(ae=>this._onError.fire(ae))),this._register(this._zlibDeflateStream.onError(ae=>this._onError.fire(ae)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(P,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,P){return new Promise((M,T)=>{l.write(P),l.flush(N=>M(N))})}acceptFrame(l,P,M){this._readQueue.push({data:l,isCompressed:P,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,P,M){return new Promise((T,N)=>{l.write(P),M&&l.write(w.VSBuffer.fromByteArray([0,0,255,255])),l.flush(X=>T(X))})}}class p extends R.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?w.VSBuffer.concat(this._recordedInflateBytes):w.VSBuffer.alloc(0)}constructor(l,P,M,T){super(),this._tracer=l,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=v().zlib.createInflateRaw(T),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(w.VSBuffer.wrap(N))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=w.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(P)})}}class S extends R.Disposable{constructor(l,P){super(),this._tracer=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=v().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(w.VSBuffer.wrap(M))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=w.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),l(P)})}}function f(c,l){if(l===0)return;const P=c.byteLength>>>2;for(let Q=0;Q<P;Q++){const G=c.readUInt32BE(Q*4);c.writeUInt32BE(G^l,Q*4)}const M=P*4,T=c.byteLength-M,N=l>>>24&255,X=l>>>16&255,ae=l>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(M)^N,M),T>=2&&c.writeUInt8(c.readUInt8(M+1)^X,M+1),T>=3&&c.writeUInt8(c.readUInt8(M+2)^ae,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const g={[2]:107,[1]:103};function a(){const c=(0,u.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):l=(0,D.join)(v().os.tmpdir(),`vscode-ipc-${c}.sock`),o(l),l}e.createRandomIPCHandle=a;function i(c,l,P){const M=v().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${l}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${P}-${l}.sock`):T=(0,D.join)(c,`${P}-${l}.sock`),o(T),T}e.createStaticIPCHandle=i;function o(c){const l=g[E.platform];typeof l=="number"&&c.length>=l&&console.warn(`WARNING: IPC handle "${c}" is longer than ${l} chars, try a shorter --user-data-dir`)}class n extends m.IPCServer{static toClientConnectionEvent(l){const P=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(P,M=>({protocol:new I.Protocol(new b(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}constructor(l){super(n.toClientConnectionEvent(l)),this.server=l}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function r(c){return new Promise((l,P)=>{const M=v().net.createServer();M.on("error",P),M.listen(c,()=>{M.removeListener("error",P),l(new n(M))})})}e.serve=r;function s(c,l){return new Promise((P,M)=>{const T=v().net.createConnection(c,()=>{T.removeListener("error",M),P(I.Client.fromSocket(new b(T,`ipc-client${l}`),l))});T.once("error",M)})}e.connect=s}),define(te[102],ie([0,1,8,3,2,12]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function E(v){const b=v;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=E;var u;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(u=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(b,d=Object.create(null)){super(),this.database=b,this.options=d,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((d,h)=>this.accept(h,d)),b.deleted?.forEach(d=>this.accept(d,void 0))}accept(b,d){if(this.state===u.Closed)return;let h=!1;(0,R.isUndefinedOrNull)(d)?h=this.cache.delete(b):this.cache.get(b)!==d&&(this.cache.set(b,d),h=!0),h&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,d){const h=this.cache.get(b);return(0,R.isUndefinedOrNull)(h)?d:h}getBoolean(b,d){const h=this.get(b);return(0,R.isUndefinedOrNull)(h)?d:h==="true"}getNumber(b,d){const h=this.get(b);return(0,R.isUndefinedOrNull)(h)?d:parseInt(h,10)}async set(b,d){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(d))return this.delete(b);const h=String(d);if(this.cache.get(b)!==h)return this.cache.set(b,h),this.pendingInserts.set(b,h),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async delete(b){if(!(this.state===u.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(b){if(!!this.hasPending)return this.doFlush(b)}async doFlush(b){return this.flushDelayer.trigger(()=>this.flushPending(),b)}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert?.forEach((d,h)=>this.items.set(h,d)),b.delete?.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[147],ie([0,1,8,3,31,9,21]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class E{get onDidChangeItemsExternal(){return t.Event.None}constructor(I,v=Object.create(null)){this.path=I,this.options=v,this.name=(0,R.basename)(this.path),this.logger=new u(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const I=await this.whenConnected,v=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(d=>v.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${v.size} rows`),v}async updateItems(I){const v=await this.whenConnected;return this.doUpdateItems(v,I)}doUpdateItems(I,v){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${v.insert?(0,k.mapToString)(v.insert):"0"}), delete(${v.delete?(0,k.setToString)(v.delete):"0"})`),this.transaction(I,()=>{const b=v.insert,d=v.delete;if(b&&b.size>0){const h=[];h.push([]);let y=0;b.forEach((C,p)=>{let S=h[y];S.length>E.MAX_HOST_PARAMETERS&&(y++,S=[],h.push(S)),S.push(p,C)}),h.forEach(C=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(C.length/2).fill("(?,?)").join(",")}`,p=>p.run(C),()=>{const p=[];let S=0;return b.forEach((f,g)=>{p.push(g),S+=f.length}),`Keys: ${p.join(", ")} Length: ${S}`})})}if(d&&d.size){const h=[];h.push([]);let y=0;d.forEach(C=>{let p=h[y];p.length>E.MAX_HOST_PARAMETERS&&(y++,p=[],h.push(p)),p.push(C)}),h.forEach(C=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(C.length).fill("?").join(",")})`,p=>p.run(C),()=>{const p=[];return d.forEach(S=>{p.push(S)}),`Keys: ${p.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const v=await this.whenConnected;return this.doClose(v,I)}doClose(I,v){return new Promise((b,d)=>{I.db.close(h=>(h&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${h}`),this.path===E.IN_MEMORY_PATH?b():!I.isErroneous&&!I.isInMemory?this.backup().then(b,y=>(this.logger.error(`[storage ${this.name}] backup(): ${y}`),b())):typeof v=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(y=>{const C=()=>this.doClose(y,void 0);return this.doUpdateItems(y,{insert:v()}).then(()=>C(),p=>(C(),Promise.reject(p)))})).then(b,d):d(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return D.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const v=await this.whenConnected,b=await this.get(v,I?"PRAGMA integrity_check":"PRAGMA quick_check"),d=I?b.integrity_check:b.quick_check;return v.isErroneous?`${d} (last error: ${v.lastError})`:v.isInMemory?`${d} (in-memory!)`:d}async connect(I,v=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${v})`);try{return await this.doConnect(I)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&v)return await(0,w.timeout)(E.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await D.Promises.unlink(I);try{await D.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(E.IN_MEMORY_PATH)}}}handleSQLiteError(I,v){I.isErroneous=!0,I.lastError=v,this.logger.error(v)}doConnect(I){return new Promise((v,b)=>{new Promise((d,h)=>{z(["@vscode/sqlite3"],d,h)}).then(d=>{const h={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(I,y=>y?h.db&&y.code!=="SQLITE_CANTOPEN"?h.db.close(()=>b(y)):b(y):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(h),C=>h.db.close(()=>b(C)))),isInMemory:I===E.IN_MEMORY_PATH};h.db.on("error",y=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${y}`)),this.logger.isTracing&&h.db.on("trace",y=>this.logger.trace(`[storage ${this.name}] Trace (event): ${y}`))},b)})}exec(I,v){return new Promise((b,d)=>{I.db.exec(v,h=>h?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${h}`),d(h)):b())})}get(I,v){return new Promise((b,d)=>{I.db.get(v,(h,y)=>h?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${h}`),d(h)):b(y))})}all(I,v){return new Promise((b,d)=>{I.db.all(v,(h,y)=>h?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${h}`),d(h)):b(y))})}transaction(I,v){return new Promise((b,d)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),v(),I.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${h}`),d(h)):b())})})}prepare(I,v,b,d){const h=I.db.prepare(v),y=C=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${C} (${v}). Details: ${d()}`)};h.on("error",y),b(h),h.finalize(C=>{C&&y(C),h.removeListener("error",y)})}}e.SQLiteStorageDatabase=E,E.IN_MEMORY_PATH=":memory:",E.BUSY_OPEN_TIMEOUT=2e3,E.MAX_HOST_PARAMETERS=256;class u{constructor(I){I&&typeof I.logTrace=="function"&&process.env[u.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}u.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[148],ie([11,10]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(te[149],ie([11,10]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[150],ie([11,10]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[151],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(te[152],ie([11,10]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(te[153],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[154],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[155],ie([11,10]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[156],ie([11,10]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[157],ie([11,10]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[158],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(te[159],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(te[160],ie([11,10]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(te[161],ie([11,10]),function(z,e){return z.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[162],ie([11,10]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[163],ie([11,10]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[164],ie([11,10]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[165],ie([11,10]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[166],ie([11,10]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(te[167],ie([11,10]),function(z,e){return z.create("vs/platform/shell/node/shellEnv",e)}),define(te[168],ie([11,10]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[169],ie([11,10]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(te[170],ie([11,10]),function(z,e){return z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[171],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[172],ie([11,10]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[173],ie([11,10]),function(z,e){return z.create("vs/platform/workspace/common/workspace",e)}),define(te[174],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[175],ie([11,10]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[176],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(te[177],ie([0,1,7]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let E=[];try{Array.isArray(D.workspaces)&&(E=D.workspaces.map(u=>({workspace:{id:u.id,configPath:w.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return E}e.deserializeWorkspaceInfos=k;function R(D){let E=[];try{Array.isArray(D.folders)&&(E=D.folders.map(u=>({folderUri:w.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return E}e.deserializeFolderInfos=R}),define(te[178],ie([0,1,3,2]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(E,u,m){switch(u){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(E,u,m){switch(u){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(E){super(),this.channel=E}reload(E){this.channel.call("reload",[E])}get onReload(){return this.channel.listen("reload")}close(E){this.channel.call("close",[E])}get onClose(){return this.channel.listen("close")}attachSession(E,u,m){this.channel.call("attach",[E,u,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(E,u){this.channel.call("terminate",[E,u])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(E,u){return this.channel.call("openExtensionDevelopmentHostWindow",[E,u])}}e.ExtensionHostDebugChannelClient=R}),define(te[179],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>z(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=w}),define(te[180],ie([0,1,133,53,13,9,34,16,7]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",z).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,E.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return u.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=D.env.VSCODE_PORTABLE;return y?u.URI.file((0,R.join)(y,"argv.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,R.resolve)(y):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,R.resolve)(y):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,R.resolve)(y);const C=D.env.VSCODE_EXTENSIONS;if(C)return C;const p=D.env.VSCODE_PORTABLE;return p?(0,R.join)(p,"extensions"):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(C=>/^[^:/?#]+?:\/\//.test(C)?u.URI.parse(C):u.URI.file((0,R.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?u.URI.parse(y):u.URI.file((0,R.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,E.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=D.env.VSCODE_PORTABLE;return y?u.URI.file((0,R.join)(y,"policy.json")):(0,E.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this._args}constructor(y,C,p){this._args=y,this.paths=C,this.productService=p,this.editSessionId=this.args.editSessionId}}ve([t.memoize],m.prototype,"appRoot",null),ve([t.memoize],m.prototype,"userHome",null),ve([t.memoize],m.prototype,"userDataPath",null),ve([t.memoize],m.prototype,"appSettingsHome",null),ve([t.memoize],m.prototype,"tmpDir",null),ve([t.memoize],m.prototype,"cacheHome",null),ve([t.memoize],m.prototype,"stateResource",null),ve([t.memoize],m.prototype,"userRoamingDataHome",null),ve([t.memoize],m.prototype,"userDataSyncHome",null),ve([t.memoize],m.prototype,"userDataSyncLogResource",null),ve([t.memoize],m.prototype,"editSessionsLogResource",null),ve([t.memoize],m.prototype,"sync",null),ve([t.memoize],m.prototype,"machineSettingsResource",null),ve([t.memoize],m.prototype,"workspaceStorageHome",null),ve([t.memoize],m.prototype,"localHistoryHome",null),ve([t.memoize],m.prototype,"keyboardLayoutResource",null),ve([t.memoize],m.prototype,"argvResource",null),ve([t.memoize],m.prototype,"isExtensionDevelopment",null),ve([t.memoize],m.prototype,"untitledWorkspacesHome",null),ve([t.memoize],m.prototype,"installSourcePath",null),ve([t.memoize],m.prototype,"builtinExtensionsPath",null),ve([t.memoize],m.prototype,"extensionsPath",null),ve([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],m.prototype,"extensionDevelopmentKind",null),ve([t.memoize],m.prototype,"extensionTestsLocationURI",null),ve([t.memoize],m.prototype,"debugExtensionHost",null),ve([t.memoize],m.prototype,"serviceMachineIdResource",null),ve([t.memoize],m.prototype,"telemetryLogResource",null),ve([t.memoize],m.prototype,"disableWorkspaceTrust",null),ve([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function I(h,y){return d(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function v(h,y){return d(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=v;function b(h,y){return d(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=b;function d(h,y,C,p,S,f){const a=Number(y||h)||(p?null:C),i=a?Boolean(!!y):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:a,break:i,debugId:S,env:o}}}),define(te[103],ie([0,1,277,5,151]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(h,y,C=D){const p={},S=["_"],f=[];for(const o in y){const n=y[o];n.alias&&(p[o]=n.alias),n.type==="string"||n.type==="string[]"?(S.push(o),n.deprecates&&S.push(...n.deprecates)):n.type==="boolean"&&(f.push(o),n.deprecates&&f.push(...n.deprecates))}const g=w(h,{string:S,boolean:f,alias:p}),a={},i=g;a._=g._.map(o=>String(o)).filter(o=>o.length>0),delete i._;for(const o in y){const n=y[o];n.alias&&delete i[n.alias];let r=i[o];if(n.deprecates)for(const s of n.deprecates)i.hasOwnProperty(s)&&(r||(r=i[s],r&&C.onDeprecatedOption(s,n.deprecationMessage||(0,k.localize)(35,null,o))),delete i[s]);if(typeof r<"u"){if(n.type==="string[]"){if(Array.isArray(r)||(r=[r]),!n.allowEmptyValue){const s=r.filter(c=>c.length>0);s.length!==r.length&&(C.onEmptyValue(o),r=s.length>0?s:void 0)}}else n.type==="string"&&(Array.isArray(r)?(r=r.pop(),C.onMultipleValues(o,r)):!r&&!n.allowEmptyValue&&(C.onEmptyValue(o),r=void 0));a[o]=r,n.deprecationMessage&&C.onDeprecatedOption(o,n.deprecationMessage)}delete i[o]}for(const o in i)C.onUnknownOption(o);return a}e.parseArgs=E;function u(h,y){let C="";return y.args&&(Array.isArray(y.args)?C=` <${y.args.join("> <")}>`:C=` <${y.args}>`),y.alias?`-${y.alias} --${h}${C}`:`--${h}${C}`}function m(h,y){let C=0;const p=[];for(const a in h){const i=h[a],o=u(a,i);C=Math.max(C,o.length),p.push([o,i.description])}const S=C+2+1;if(y-S<25)return p.reduce((a,i)=>a.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const f=y-S-1,g=[];for(const a of p){const i=a[0],o=v(a[1],f),n=I(S-i.length-2);g.push("  "+i+n+o[0]);for(let r=1;r<o.length;r++)g.push(I(S)+o[r])}return g}e.formatOptions=m;function I(h){return" ".repeat(h)}function v(h,y){const C=[];for(;h.length;){const p=h.length<y?h.length:h.lastIndexOf(" ",y),S=h.slice(0,p).trim();h=h.slice(p),C.push(S)}return C}function b(h,y,C,p,S){const f=process.stdout.isTTY&&process.stdout.columns||80,g=S?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",a=[`${h} ${C}`];a.push(""),a.push(`${(0,k.localize)(37,null)}: ${y} [${(0,k.localize)(38,null)}]${g}`),a.push(""),S?.noPipe!==!0&&(t.isWindows?a.push((0,k.localize)(39,null,y)):a.push((0,k.localize)(40,null,y)),a.push(""));const i={};for(const o in p){const n=p[o];if(n.description&&n.cat){let r=i[n.cat];r||(i[n.cat]=r={}),r[o]=n}}for(const o in i){const n=o,r=i[n];r&&(a.push(R[n]),a.push(...m(r,f)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=b;function d(h,y){return`${h||(0,k.localize)(41,null)}
${y||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=d}),define(te[181],ie([0,1,77,178,103]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(E,u){super(),this.windowsMainService=E,this.userDataProfilesMainService=u}call(E,u,m){return u==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(E,u,m)}async openExtensionDevelopmentHostWindow(E,u){const m=(0,k.parseArgs)(E,k.OPTIONS);m.debugRenderer=u;const I=m.extensionDevelopmentPath;if(!I)return{success:!1};const[v]=await this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:m,profile:await this.userDataProfilesMainService.checkAndCreateProfileFromCli(m)});if(!u)return{success:!0};const b=v.win;if(!b)return{success:!0};const d=b.webContents.debugger;let h=d.isAttached()?1/0:0;const y=(0,w.createServer)(C=>{h++===0&&d.attach();let p=!1;const S=a=>{p||C.write(JSON.stringify(a)+"\0")},f=(a,i,o,n)=>S({method:i,params:o,sessionId:n});b.on("close",()=>{d.removeListener("message",f),C.end(),p=!0}),d.addListener("message",f);let g=Buffer.alloc(0);C.on("data",a=>{g=Buffer.concat([g,a]);for(let i=g.indexOf(0);i!==-1;i=g.indexOf(0)){let o;try{const n=g.slice(0,i).toString("utf8");g=g.slice(i+1),o=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}d.sendCommand(o.method,o.params,o.sessionId).then(n=>S({id:o.id,sessionId:o.sessionId,result:n})).catch(n=>S({id:o.id,sessionId:o.sessionId,error:{code:0,message:n.message}}))}}),C.on("error",a=>{console.error("error on cdp pipe:",a)}),C.on("close",()=>{p=!0,--h===0&&d.detach()})});return await new Promise(C=>y.listen(0,C)),b.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(te[59],ie([0,1,278,152,103]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(b,d){const h={onUnknownOption:C=>{console.warn((0,t.localize)(0,null,C))},onMultipleValues:(C,p)=>{console.warn((0,t.localize)(1,null,C,p))},onEmptyValue:C=>{console.warn((0,t.localize)(2,null,C))},onDeprecatedOption:(C,p)=>{console.warn((0,t.localize)(3,null,C,p))}},y=(0,k.parseArgs)(b,k.OPTIONS,d?h:void 0);return y.goto&&y._.forEach(C=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,t.localize)(4,null))),y["max-memory"]&&w(parseInt(y["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),y}function E(b){const d=b.findIndex(h=>!/^-/.test(h));if(d>-1)return[...b.slice(0,d),...b.slice(d+1)]}function u(b){let[,...d]=b;process.env.VSCODE_DEV&&(d=E(d)||[]);const h=!v(process.env);return D(d,h)}e.parseMainProcessArgv=u;function m(b){const[,,...d]=b;return D(d,!0)}e.parseCLIProcessArgv=m;function I(b,...d){const h=b.indexOf("--");return h===-1?b.push(...d):b.splice(h,0,...d),b}e.addArg=I;function v(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function z(e,w,t){function k(D,E){const u=R(D,E),m=[u];return e.isAbsolute(u)||m.unshift(t),e.resolve(...m)}function R(D,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,E);const I=D["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(v,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,E)}return{getUserDataPath:k}}if(typeof define=="function")define(te[182],ie([183,27,34]),function(e,w,t){return z(e,w,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=z(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[184],ie([0,1,27,180,182]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(E,u){super(E,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(E,u.nameShort)},u)}}e.NativeEnvironmentService=R}),define(te[185],ie([0,1,40,27,30]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const E=(0,k.randomPath)((0,t.tmpdir)());try{return(0,w.writeFileSync)(E,""),D&&console.log(`Marker file for --wait created: ${E}`),E}catch(u){D&&console.error(`Failed to create marker file for --wait: ${u}`);return}}e.createWaitMarkerFileSync=R}),define(te[186],ie([0,1,12,154]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,E,u){try{R(D,E,u)}catch{}return D}e.localizeManifest=k;function R(D,E,u){const m=(I,v,b)=>{const d=I[v];if((0,w.isString)(d)){const h=d,y=h.length;if(y>1&&h[0]==="%"&&h[y-1]==="%"){const C=h.substr(1,y-2);let p=E[C];p===void 0&&u&&(p=u[C]);const S=typeof p=="string"?p:p.message;if(S!==void 0){const f=u?.[C],g=typeof f=="string"?f:f?.message;if(b&&(v==="title"||v==="category")&&g&&g!==S){const a={value:S,original:g};I[v]=a}else I[v]=S}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,C)}`)}}else if((0,w.isObject)(d))for(const h in d)d.hasOwnProperty(h)&&(h==="commands"?m(d,h,!0):m(d,h,b));else if(Array.isArray(d))for(let h=0;h<d.length;h++)m(d,h,b)};for(const I in D)D.hasOwnProperty(I)&&m(D,I)}}),define(te[187],ie([0,1,16,96,156,188]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(p){return p=p.trim(),p==="*"||D.test(p)}e.isValidVersionStr=u;function m(p){if(!u(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const S=p.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=m;function I(p){if(!p)return null;const S=p.majorBase,f=p.majorMustEqual,g=p.minorBase;let a=p.minorMustEqual;const i=p.patchBase;let o=p.patchMustEqual;p.hasCaret&&(S===0||(a=!1),o=!1);let n=0;if(p.preRelease){const r=E.exec(p.preRelease);if(r){const[,s,c,l]=r;n=Date.UTC(Number(s),Number(c)-1,Number(l))}}return{majorBase:S,majorMustEqual:f,minorBase:g,minorMustEqual:a,patchBase:i,patchMustEqual:o,isMinimum:p.hasGreaterEquals,notBefore:n}}e.normalizeVersion=I;function v(p,S,f){let g;typeof p=="string"?g=I(m(p)):g=p;let a;S instanceof Date?a=S.getTime():typeof S=="string"&&(a=new Date(S).getTime());let i;if(typeof f=="string"?i=I(m(f)):i=f,!g||!i)return!1;const o=g.majorBase,n=g.minorBase,r=g.patchBase;let s=i.majorBase,c=i.minorBase,l=i.patchBase;const P=i.notBefore;let M=i.majorMustEqual,T=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:n>c?!0:n<c||a&&a<P?!1:r>=l:(o===1&&s===0&&(!M||!T||!N)&&(s=1,c=0,l=0,M=!0,T=!1,N=!1),o<s?!1:o>s?!M:n<c?!1:n>c?!T:r<l?!1:r>l?!N:!(a&&a<P))}e.isValidVersion=v;function b(p,S,f,g,a){const i=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof g.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof g.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!g.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof g.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof g.extensionDependencies<"u"&&!C(g.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof g.activationEvents<"u"){if(!C(g.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof g.main>"u"&&typeof g.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const r=(0,w.joinPath)(f,g.main);(0,w.isEqualOrParent)(r,f)||i.push([t.default.Warning,k.localize(10,null,r.path,f.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof g.browser<"u"){if(typeof g.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,w.joinPath)(f,g.browser);(0,w.isEqualOrParent)(r,f)||i.push([t.default.Warning,k.localize(13,null,r.path,f.path)])}if(typeof g.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(g.version))return i.push([t.default.Error,k.localize(15,null)]),i;const o=[];if(!d(p,S,g,a,o))for(const r of o)i.push([t.default.Error,r]);return i}e.validateExtensionManifest=b;function d(p,S,f,g,a){return g||typeof f.main>"u"&&typeof f.browser>"u"?!0:y(p,S,f.engines.vscode,a)}e.isValidExtensionVersion=d;function h(p,S,f){return p==="*"||y(S,f,p)}e.isEngineValid=h;function y(p,S,f,g=[]){const a=I(m(f));if(!a)return g.push(k.localize(16,null,f)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(k.localize(17,null,f)),!1}else if(!a.majorMustEqual)return g.push(k.localize(18,null,f)),!1;return v(p,S,a)?!0:(g.push(k.localize(19,null,p,f)),!1)}function C(p){if(!Array.isArray(p))return!1;for(let S=0,f=p.length;S<f;S++)if(typeof p[S]!="string")return!1;return!0}}),define(te[189],ie([0,1,18,29]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const I=(await D.readFile(R.serviceMachineIdResource)).value.toString();u=(0,t.isUUID)(I)?I:null}catch{u=null}if(!u){u=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,w.VSBuffer.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}e.getServiceMachineId=k}),define(te[68],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=w}),define(te[190],ie([0,1,68]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(E,u,m){u instanceof w.SyncDescriptor||(u=new w.SyncDescriptor(u,[],Boolean(m))),t.push([E,u])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(te[191],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=w;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const E=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(D);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const E of this._nodes.values())E.outgoing.delete(D),E.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let E=this._nodes.get(D);return E||(E=new w(D,R),this._nodes.set(D,E)),E}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,E]of this._nodes)R.push(`${D}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const E=new Set([R]),u=this._findCycle(D,E);if(u)return u}}_findCycle(R,D){for(const[E,u]of R.outgoing){if(D.has(E))return[...D,E].join(" -> ");D.add(E);const m=this._findCycle(u,D);if(m)return m;D.delete(E)}}}e.Graph=t}),define(te[4],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function E(u){return u[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=E})(w=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,E,u){E[w.DI_TARGET]===E?E[w.DI_DEPENDENCIES].push({id:D,index:u}):(E[w.DI_DEPENDENCIES]=[{id:D,index:u}],E[w.DI_TARGET]=E)}function k(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const E=function(u,m,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(E,u,I)};return E.toString=()=>D,w.serviceIds.set(D,E),E}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(te[60],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(te[19],ie([0,1,12,7,4]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var E;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function u(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=u;function m(p,S){const f=Object.create(null);for(const g in p)I(f,g,p[g],S);return f}e.toValuesTree=m;function I(p,S,f,g){const a=S.split("."),i=a.pop();let o=p;for(let n=0;n<a.length;n++){const r=a[n];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:g(`Ignoring ${S} as ${a.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=f}catch{g(`Ignoring ${S} as ${a.join(".")} is ${JSON.stringify(o)}`)}else g(`Ignoring ${S} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function v(p,S){const f=S.split(".");b(p,f)}e.removeFromValueTree=v;function b(p,S){const f=S.shift();if(S.length===0){delete p[f];return}if(Object.keys(p).indexOf(f)!==-1){const g=p[f];typeof g=="object"&&!Array.isArray(g)&&(b(g,S),Object.keys(g).length===0&&delete p[f])}}function d(p,S,f){function g(o,n){let r=o;for(const s of n){if(typeof r!="object"||r===null)return;r=r[s]}return r}const a=S.split("."),i=g(p,a);return typeof i>"u"?f:i}e.getConfigurationValue=d;function h(p,S,f){Object.keys(S).forEach(g=>{g!=="__proto__"&&(g in p?w.isObject(p[g])&&w.isObject(S[g])?h(p[g],S[g],f):f&&(p[g]=S[g]):p[g]=S[g])})}e.merge=h;function y(p,S,f){const g=p.inspect(S),a=p.inspect(f);return typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:g.defaultValue}e.getMigratedSettingValue=y;function C(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(te[69],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,E){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=E}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const E of Object.keys(this.secretVault[R]||{}))D.push({account:E,password:this.secretVault[R][E]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(te[84],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,E){return{}}async getSystemInfo(D,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,E){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(te[104],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(te[36],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(te[26],ie([0,1,53,9,83,36,184,4]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,E.refineServiceDecorator)(R.IEnvironmentService);class u extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([w.memoize],u.prototype,"cachedLanguagesPath",null),ve([w.memoize],u.prototype,"backupHome",null),ve([w.memoize],u.prototype,"mainIPCHandle",null),ve([w.memoize],u.prototype,"mainLockfile",null),ve([w.memoize],u.prototype,"disableUpdates",null),ve([w.memoize],u.prototype,"disableKeytar",null),ve([w.memoize],u.prototype,"crossOriginIsolated",null),ve([w.memoize],u.prototype,"codeCachePath",null),ve([w.memoize],u.prototype,"useCodeCache",null),e.EnvironmentMainService=u}),define(te[192],ie([0,1,153,4]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(p,S){switch(p){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function E(p,S){return S==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function u(p,S,f){return E(S,f)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===f?!0:m(f).includes(p)}e.isTargetPlatformCompatible=u;function m(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=I;var v;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var b;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var d;(function(p){p.Install="install",p.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var h;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var y;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(S,f){super(S),this.code=f,this.name=f}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,w.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,w.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[193],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(te[194],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[105],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(te[195],ie([0,1,45,13,9,5,78,21,82,157,105]),function(z,e,w,t,k,R,D,E,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=m.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends b{openTerminal(g,a){return this.spawnTerminal(w,g,u.getWindowsShell(),a)}spawnTerminal(g,a,i,o){const n=a.windowsExec||d.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=k.basename(n).toLowerCase();if(r==="cmder"||r==="cmder.exe")return g.spawn(n,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return n.indexOf(" ")>=0&&s.push('""'),s.push(n),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((c,l)=>{const P=C(process),M=g.spawn(i,s,{cwd:o,env:P});M.on("error",l),M.on("exit",()=>c())})}runInTerminal(g,a,i,o,n){const r="windowsExec"in n&&n.windowsExec?n.windowsExec:d.getDefaultTerminalWindows();return new Promise((s,c)=>{const l=`"${a} - ${v}"`,P=`""${i.join('" "')}" & pause"`,M=["/c","start",l,"/wait",r,"/c",P],T=Object.assign({},C(process),o);Object.keys(T).filter(ae=>T[ae]===null).forEach(ae=>delete T[ae]);const N={cwd:a,env:T,windowsVerbatimArguments:!0};w.spawn(d.CMD,M,N).on("error",ae=>{c(p(ae))}),s(void 0)})}static getDefaultTerminalWindows(){if(!d._DEFAULT_TERMINAL_WINDOWS){const g=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${g?"Sysnative":"System32"}\\cmd.exe`}return d._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=d,d.CMD="cmd.exe";class h extends b{openTerminal(g,a){return this.spawnTerminal(w,g,a)}runInTerminal(g,a,i,o,n){const r=n.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(r===I.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const l=r===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,z).fsPath,"-t",g||v,"-w",a];for(const X of i)M.push("-a"),M.push(X);if(o){const X=Object.assign({},C(process),o);for(const ae in X){const Q=X[ae];Q===null?(M.push("-u"),M.push(ae)):(M.push("-e"),M.push(`${ae}=${Q}`))}}let T="";const N=w.spawn(h.OSASCRIPT,M);N.on("error",X=>{c(p(X))}),N.stderr.on("data",X=>{T+=X.toString()}),N.on("exit",X=>{if(X===0)s(void 0);else if(T){const ae=T.split(`
`,1);c(new Error(ae[0]))}else c(new Error(m.localize(1,null,l,X)))})}else c(new Error(m.localize(2,null,r)))})}spawnTerminal(g,a,i){const o=a.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((n,r)=>{const s=["-a",o];i&&s.push(i);const c=C(process),l=g.spawn("/usr/bin/open",s,{cwd:i,env:c});l.on("error",r),l.on("exit",()=>n())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class y extends b{openTerminal(g,a){return this.spawnTerminal(w,g,a)}runInTerminal(g,a,i,o,n){const r=n.linuxExec?Promise.resolve(n.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const l=[];r.then(P=>{P.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const M=`${S(i)}; echo; read -p "${y.WAIT_MESSAGE}" -n1;`;l.push(`''${M}''`);const T=Object.assign({},C(process),o);Object.keys(T).filter(Q=>T[Q]===null).forEach(Q=>delete T[Q]);const N={cwd:a,env:T};let X="";const ae=w.spawn(P,l,N);ae.on("error",Q=>{c(p(Q))}),ae.stderr.on("data",Q=>{X+=Q.toString()}),ae.on("exit",Q=>{if(Q===0)s(void 0);else if(X){const G=X.split(`
`,1);c(new Error(G[0]))}else c(new Error(m.localize(4,null,P,Q)))})})})}static async getDefaultTerminalLinuxReady(){if(!y._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)y._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const g=await E.Promises.exists("/etc/debian_version");y._DEFAULT_TERMINAL_LINUX_READY=new Promise(a=>{g?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return y._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(g,a,i){const o=a.linuxExec?Promise.resolve(a.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{o.then(s=>{const c=C(process),l=g.spawn(s,[],{cwd:i,env:c});l.on("error",r),l.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=y,y.WAIT_MESSAGE=m.localize(3,null);function C(f){const g={...f.env};return(0,D.sanitizeProcessEnvironment)(g),g}function p(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(m.localize(5,null,f.path)):f}function S(f){let g="";for(const a of f)a.indexOf(" ")>=0?g+='"'+a+'"':g+=a,g+=" ";return g}}),define(te[14],ie([0,1,31,9,25,12,7,159,4]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,u.createDecorator)("fileService");function m(V){return V.create===!0}e.isFileOpenForWriteOptions=m;var I;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var v;(function(V){V[V.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var b;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function h(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=y;function C(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function S(V){return d(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var f;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(H,W){super(H),this.code=W}}e.FileSystemProviderError=g;function a(V,H){const W=new g(V.toString(),H);return o(W,H),W}e.createFileSystemProviderError=a;function i(V){return V||a((0,E.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=i;function o(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=o;function n(V){if(!V)return f.Unknown;if(V instanceof g)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return f.Unknown;switch(H[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=n;function r(V){if(V instanceof T)return V.fileOperationResult;switch(n(V)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(H,W,A){this.resource=H,this.operation=W,this.target=A}isOperation(H){return this.operation===H}}e.FileOperationEvent=c;var l;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class P{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const A=new Map;for(const F of H){const U=A.get(F.type);switch(U?U.push([F.resource,F]):A.set(F.type,[[F.resource,F]]),F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}}for(const[F,U]of A)switch(F){case 1:this.added=w.TernarySearchTree.forUris(()=>W),this.added.fill(U);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>W),this.updated.fill(U);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>W),this.deleted.fill(U);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...A){if(!H)return!1;const F=A.length>0;return!!((!F||A.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!F||A.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!F||A.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function M(V,H,W){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==t.sep&&(H+=t.sep),W?(0,k.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=M;class T extends Error{constructor(H,W,A){super(H),this.fileOperationResult=W,this.options=A}}e.FileOperationError=T;class N extends T{constructor(H,W,A){super(H,2,A),this.stat=W}}e.NotModifiedSinceFileOperationError=N;var X;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(X=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=Q;async function G(V,H){if(!H.hasProvider(D.URI.from({scheme:V.scheme})))return new Promise(W=>{const A=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(A.dispose(),W())})})}e.whenProviderRegistered=G,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Z{static formatSize(H){return(0,R.isNumber)(H)||(H=0),H<Z.KB?(0,E.localize)(1,null,H.toFixed(0)):H<Z.MB?(0,E.localize)(2,null,(H/Z.KB).toFixed(2)):H<Z.GB?(0,E.localize)(3,null,(H/Z.MB).toFixed(2)):H<Z.TB?(0,E.localize)(4,null,(H/Z.GB).toFixed(2)):(0,E.localize)(5,null,(H/Z.TB).toFixed(2))}}e.ByteSize=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;var se;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*Z.MB:16*Z.GB,maxHeapSize:V===0?700*Z.MB:2*700*Z.MB}}e.getPlatformLimits=he}),define(te[196],ie([0,1,18,44,17,3,2,58,7,29,14]),function(z,e,w,t,k,R,D,E,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends D.Disposable{constructor(d,h){super(),this.channel=d,this.extraCapabilities=h,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(d){return this.channel.call("stat",[d])}readdir(d){return this.channel.call("readdir",[d])}async readFile(d,h){const{buffer:y}=await this.channel.call("readFile",[d,h]);return y}readFileStream(d,h,y){const C=(0,E.newWriteableStream)(S=>w.VSBuffer.concat(S.map(f=>w.VSBuffer.wrap(f))).buffer),p=this.channel.listen("readFileStream",[d,h])(S=>{if(S instanceof w.VSBuffer)C.write(S.buffer);else{if(S==="end")C.end();else{let f=S;f instanceof Error||(f=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(f),I.FileSystemProviderErrorCode.Unknown)),C.error(f),C.end()}p.dispose()}});return y.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),p.dispose()}),C}writeFile(d,h,y){return this.channel.call("writeFile",[d,w.VSBuffer.wrap(h),y])}open(d,h){return this.channel.call("open",[d,h])}close(d){return this.channel.call("close",[d])}async read(d,h,y,C,p){const[S,f]=await this.channel.call("read",[d,h,p]);return y.set(S.buffer.slice(0,f),C),f}write(d,h,y,C,p){return this.channel.call("write",[d,h,w.VSBuffer.wrap(y),C,p])}mkdir(d){return this.channel.call("mkdir",[d])}delete(d,h){return this.channel.call("delete",[d,h])}rename(d,h,y){return this.channel.call("rename",[d,h,y])}copy(d,h,y){return this.channel.call("copy",[d,h,y])}cloneFile(d,h){return this.channel.call("cloneFile",[d,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(d=>{if(Array.isArray(d)){const h=d;this._onDidChange.fire(h.map(y=>({resource:u.URI.revive(y.resource),type:y.type})))}else{const h=d;this._onDidWatchError.fire(h)}}))}watch(d,h){const y=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,y,d,h]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=v}),define(te[106],ie([0,1,18,17,160,14]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,v,b,d,h,y){let C;try{await E(I,v,b,d,h,y)}catch(p){C=p}finally{C&&h.errorTransformer&&(C=h.errorTransformer(C)),typeof C<"u"&&b.error(C),b.end()}}e.readFileIntoStream=D;async function E(I,v,b,d,h,y){u(y);const C=await I.open(v,{create:!1});try{u(y);let p=0,S=0,f=h&&typeof h.length=="number"?h.length:void 0,g=w.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),a=h&&typeof h.position=="number"?h.position:0,i=0;do S=await I.read(C,a,g.buffer,i,g.byteLength-i),a+=S,i+=S,p+=S,typeof f=="number"&&(f-=S),i===g.byteLength&&(await b.write(d(g)),g=w.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),i=0);while(S>0&&(typeof f!="number"||f>0)&&u(y)&&m(p,h));if(i>0){let o=i;typeof f=="number"&&(o=Math.min(i,f)),b.write(d(g.slice(0,o)))}}catch(p){throw(0,R.ensureFileSystemProviderError)(p)}finally{await I.close(C)}}function u(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function m(I,v){if(v?.limits){if(typeof v.limits.memory=="number"&&I>v.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&I>v.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[70],ie([0,1,97,2,9,5,7,14]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function u(p){return p.recursive===!0}e.isRecursiveWatchRequest=u;class m extends t.Disposable{constructor(S,f,g,a){super(),this.onFileChanges=S,this.onLogMessage=f,this.verboseLogging=g,this.options=a,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new t.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),S.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),S.add(this.watcher.onDidError(f=>this.onError(f)))}onError(S){this.options.restartOnError?this.restartCounter<m.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.MAX_RESTARTS=5;class I extends m{constructor(S,f,g){super(S,f,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class v extends m{constructor(S,f,g){super(S,f,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function b(p){return p.map(S=>({type:S.type,resource:D.URI.file(S.path)}))}e.toFileChanges=b;function d(p){const S=new C;for(const f of p)S.processEvent(f);return S.coalesce()}e.coalesceEvents=d;function h(p,S){return typeof S=="string"&&!S.startsWith(w.GLOBSTAR)&&!(0,k.isAbsolute)(S)?{base:p,pattern:S}:S}e.normalizeWatcherPattern=h;function y(p,S){const f=[];for(const g of S)f.push((0,w.parse)(h(p,g)));return f}e.parseWatcherPatterns=y;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return R.isLinux?S.path:S.path.toLowerCase()}processEvent(S){const f=this.mapPathToChange.get(this.toKey(S));let g=!1;if(f){const a=f.type,i=S.type;f.path!==S.path&&(S.type===2||S.type===1)?g=!0:a===1&&i===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(f)):a===2&&i===1?f.type=0:a===1&&i===0||(f.type=i)}else g=!0;g&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],f=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(S.push(g),!1):!0).sort((g,a)=>g.path.length-a.path.length).filter(g=>f.some(a=>(0,E.isParent)(g.path,a,!R.isLinux))?!1:(f.push(g.path),!0)).concat(S)}}}),define(te[197],ie([0,1,40,8,23,30,2,80,9,5,98,21,70]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends D.Disposable{constructor(C,p,S,f){super(),this.request=C,this.onDidFilesChange=p,this.onLogMessage=S,this.verboseLogging=f,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,b.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,b.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await v.Promises.stat(C);this._register(await this.doWatch(C,p.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let p=C.path;try{p=await v.Promises.realpath(C.path),C.path===p&&(p=await(0,I.realcase)(C.path)??C.path),C.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${p})`)}catch{}return p}async doWatch(C,p){if(m.isMacintosh&&(0,R.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const S=new k.CancellationTokenSource(this.cts.token),f=new D.DisposableStore;try{const g=(0,u.basename)(C),a=(0,w.watch)(C);f.add((0,D.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${C}'`);const i=new Set;if(p)try{for(const n of await v.Promises.readdir(C))i.add(n)}catch(n){this.error(n)}const o=new Map;f.add((0,D.toDisposable)(()=>{for(const[,n]of o)n.dispose();o.clear()})),a.on("error",(n,r)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${n}, ${r})`),this.dispose()}),a.on("change",(n,r)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${r}`);let s="";if(r&&(s=r.toString(),m.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(p)if(n==="rename"){o.get(s)?.dispose();const c=setTimeout(async()=>{if(o.delete(s),s===g&&!await v.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,u.join)(C,s));if(S.token.isCancellationRequested)return;let P;l?i.has(s)?P=0:(P=1,i.add(s)):(i.delete(s),P=2),this.onFileChange({path:(0,u.join)(this.request.path,s),type:P})},d.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,D.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(s)?c=0:(c=1,i.add(s)),this.onFileChange({path:(0,u.join)(this.request.path,s),type:c})}else if(n==="rename"||s!==g){const c=setTimeout(async()=>{const l=await v.Promises.exists(C);S.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),f.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);f.clear(),f.add((0,D.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await v.Promises.exists(C)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${g.toString()})`)}return(0,D.toDisposable)(()=>{S.dispose(!0),f.dispose()})}async onFileChange(C,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!p&&this.excludes.some(S=>S(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const f=(0,b.coalesceEvents)(S);if(f.length>0){if(this.verboseLogging)for(const a of f)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(f)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(m.isLinux)return v.Promises.exists(C);try{const p=(0,u.basename)(C);return(await v.Promises.readdir((0,u.dirname)(C))).some(f=>f===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function h(y,C,p,S,f=512){const g=await v.Promises.open(y,"r"),a=Buffer.allocUnsafe(f),i=new k.CancellationTokenSource(S);let o,n=!1;const r={path:y,excludes:[],recursive:!1},s=new d(r,c=>{(async()=>{for(const{type:l}of c)if(l===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:P}=await v.Promises.read(g,a,0,f,null);if(!P||i.token.isCancellationRequested)break;C(a.slice(0,P))}}catch(P){o=new Error(P),i.dispose(!0)}finally{n=!1}}})()});return await s.ready,p(),new Promise((c,l)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await v.Promises.close(g)}catch(P){o=new Error(P)}o?l(o):c()})})}e.watchFileContents=h}),define(te[198],ie([0,1,3,97,2,5,197]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class E extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new w.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new w.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=w.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(m){const I=this.normalizeRequests(m),v=I.filter(d=>{const h=this.watchers.get(d.path);return h?!(0,t.patternsEquals)(h.request.excludes,d.excludes)||!(0,t.patternsEquals)(h.request.includes,d.includes):!0}),b=Array.from(this.watchers.values()).filter(({request:d})=>!I.find(h=>h.path===d.path&&(0,t.patternsEquals)(h.excludes,d.excludes)&&(0,t.patternsEquals)(h.includes,d.includes))).map(({request:d})=>d.path);v.length&&this.trace(`Request to start watching: ${v.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),b.length&&this.trace(`Request to stop watching: ${b.join(",")}`);for(const d of b)this.stopWatching(d);for(const d of v)this.startWatching(d)}startWatching(m){const I=new D.NodeJSFileWatcherLibrary(m,b=>this._onDidChangeFile.fire(b),b=>this._onDidLogMessage.fire(b),this.verboseLogging),v={request:m,instance:I};this.watchers.set(m.path,v)}async stop(){for(const[m]of this.watchers)this.stopWatching(m);this.watchers.clear()}stopWatching(m){const I=this.watchers.get(m);I&&(this.watchers.delete(m),I.instance.dispose())}normalizeRequests(m){const I=new Map;for(const v of m){const b=R.isLinux?v.path:v.path.toLowerCase();I.set(b,v)}return Array.from(I.values())}async setVerboseLogging(m){this.verboseLogging=m;for(const[,I]of this.watchers)I.instance.setVerboseLogging(m)}trace(m){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(m)})}toMessage(m,I){return I?`[File Watcher (node.js)] ${m} (path: ${I.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=E}),define(te[199],ie([0,1,70,198]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends w.AbstractNonRecursiveWatcherClient{constructor(D,E,u){super(D,E,u),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[200],ie([0,1,13,46,146,70]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(u,m,I){super(u,m,I),this.init()}createWatcher(u){const m=u.add(new k.Client(w.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(m.onDidProcessExit(({code:I,signal:v})=>this.onError(`terminated by itself with code ${I}, signal: ${v}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(te[85],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(te[201],ie([0,1,8,17,68,191,4,85]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const u=!1;class m extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new E.ServiceCollection,y=!1,C,p=u){this._services=h,this._strict=y,this._parent=C,this._enableTracing=p,this._activeInstantiations=new Set,this._services.set(D.IInstantiationService,this),this._globalGraph=p?C?._globalGraph??new R.Graph(S=>S):void 0}createChild(h){return new I(h,this._strict,this,this._enableTracing)}invokeFunction(h,...y){const C=b.traceInvocation(this._enableTracing,h);let p=!1;try{return h({get:f=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(f,C);if(!g)throw new Error(`[invokeFunction] unknown service '${f}'`);return g}},...y)}finally{p=!0,C.stop()}}createInstance(h,...y){let C,p;return h instanceof k.SyncDescriptor?(C=b.traceCreation(this._enableTracing,h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(y),C)):(C=b.traceCreation(this._enableTracing,h),p=this._createInstance(h,y,C)),C.stop(),p}_createInstance(h,y=[],C){const p=D._util.getServiceDependencies(h).sort((g,a)=>g.index-a.index),S=[];for(const g of p){const a=this._getOrCreateServiceInstance(g.id,C);a||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${g.id}.`,!1),S.push(a)}const f=p.length>0?p[0].index:y.length;if(y.length!==f){console.trace(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${y.length} static arguments`);const g=f-y.length;g>0?y=y.concat(new Array(g)):y=y.slice(0,f)}return new h(...y,...S)}_setServiceInstance(h,y){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const C=this._getServiceInstanceOrDescriptor(h);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,C,y.branch(h,!0)):(y.branch(h,!1),C)}_safeCreateAndCacheServiceInstance(h,y,C){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,C)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,C){const p=new R.Graph(g=>g.id.toString());let S=0;const f=[{id:h,desc:y,_trace:C}];for(;f.length;){const g=f.pop();if(p.lookupOrInsertNode(g),S++>1e3)throw new m(p);for(const a of D._util.getServiceDependencies(g.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(a.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(g.id),String(a.id)),i instanceof k.SyncDescriptor){const o={id:a.id,desc:i,_trace:g._trace.branch(a.id,!0)};p.insertEdge(g,o),f.push(o)}}}for(;;){const g=p.roots();if(g.length===0){if(!p.isEmpty())throw new m(p);break}for(const{data:a}of g){if(this._getServiceInstanceOrDescriptor(a.id)instanceof k.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,C=[],p,S){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(h,y,C,p,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,C,p,S);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y,C=[],p,S){if(p){const f=new I(void 0,this._strict,this,this._enableTracing);f._globalGraphImplicitDependency=String(h);const g=new w.IdleValue(()=>f._createInstance(y,C,S));return new Proxy(Object.create(null),{get(a,i){if(i in a)return a[i];const o=g.value;let n=o[i];return typeof n!="function"||(n=n.bind(o),a[i]=n),n},set(a,i,o){return g.value[i]=o,!0}})}else return this._createInstance(y,C,S)}_throwIfStrict(h,y){if(y&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=I;var v;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(v||(v={}));class b{static traceInvocation(h,y){return h?new b(1,y.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b._None}static traceCreation(h,y){return h?new b(0,y.name):b._None}constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}branch(h,y){const C=new b(2,h.toString());return this._dep.push([h,y,C]),C}stop(){const h=Date.now()-this._start;b._totals+=h;let y=!1;function C(S,f){const g=[],a=new Array(S+1).join("	");for(const[i,o,n]of f._dep)if(o&&n){y=!0,g.push(`${a}CREATES -> ${i}`);const r=C(S+1,n);r&&g.push(r)}else g.push(`${a}uses -> ${i}`);return g.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(h>2||y)&&b.all.add(p.join(`
`))}}e.Trace=b,b.all=new Set,b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(te[6],ie([0,1,44,3,2,5,4]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function E(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=u.Info;function m(o,n,r){switch(n){case u.Trace:o.trace(r);break;case u.Debug:o.debug(r);break;case u.Info:o.info(r);break;case u.Warning:o.warn(r);break;case u.Error:o.error(r);break;case u.Critical:o.critical(r);break;default:throw new Error("Invalid log level")}}e.log=m;function I(o){let n="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(r>0?" ":"")+s}return n}e.format=I;class v extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class b extends v{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(u.Trace)&&this.log(u.Trace,I([n,...r]))}debug(n,...r){this.checkLogLevel(u.Debug)&&this.log(u.Debug,I([n,...r]))}info(n,...r){this.checkLogLevel(u.Info)&&this.log(u.Info,I([n,...r]))}warn(n,...r){this.checkLogLevel(u.Warning)&&this.log(u.Warning,I([n,...r]))}error(n,...r){if(this.checkLogLevel(u.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(u.Error,I(s))}else this.log(u.Error,I([n,...r]))}critical(n,...r){this.checkLogLevel(u.Critical)&&this.log(u.Critical,I([n,...r]))}flush(){}}e.AbstractMessageLogger=b;class d extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!R.isWindows}trace(n,...r){this.getLevel()<=u.Trace&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.log(`[main ${E()}]`,n,...r))}debug(n,...r){this.getLevel()<=u.Debug&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.log(`[main ${E()}]`,n,...r))}info(n,...r){this.getLevel()<=u.Info&&(this.useColors?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.log(`[main ${E()}]`,n,...r))}warn(n,...r){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,n,...r):console.warn(`[main ${E()}]`,n,...r))}error(n,...r){this.getLevel()<=u.Error&&(this.useColors?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,n,...r):console.error(`[main ${E()}]`,n,...r))}critical(n,...r){this.getLevel()<=u.Critical&&(this.useColors?console.error(`\x1B[90m[main ${E()}]\x1B[0m`,n,...r):console.error(`[main ${E()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class h extends v{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends v{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,w.toErrorMessage)(n,this.getLevel()<=u.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class C extends v{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const s of this.logServices)s.trace(n,...r)}debug(n,...r){for(const s of this.logServices)s.debug(n,...r)}info(n,...r){for(const s of this.logServices)s.info(n,...r)}warn(n,...r){for(const s of this.logServices)s.warn(n,...r)}error(n,...r){for(const s of this.logServices)s.error(n,...r)}critical(n,...r){for(const s of this.logServices)s.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=C;class p extends k.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}e.LogService=p;class S extends k.Disposable{constructor(n,r){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,r?.always?u.Trace:this.logLevel,r),this.loggers.set(n.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return u.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogService=f;function g(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const n=a(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function a(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}e.parseLogLevel=a;function i(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}e.LogLevelToString=i});var ee=this&&this.__param||function(z,e){return function(w,t){e(w,t,z)}};define(te[202],ie([0,1,69,3,2,6,5,8]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let u=class Et extends k.Disposable{constructor(I){super(),this.logService=I,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(I,v){this.logService.trace("Getting password from keytar:",I,v);let b;try{b=await this.withKeytar()}catch{return null}const d=await(0,E.retry)(()=>b.getPassword(I,v),50,3);if(!d)return this.logService.trace("Did not get a password from keytar for account:",v),d;let h,y;try{const C=JSON.parse(d);h=C.content,y=C.hasNextChunk}catch{}if(!h||!y)return this.logService.trace("Got password from keytar for account:",v),d;try{let C=1;for(;y;){const p=await(0,E.retry)(()=>b.getPassword(I,`${v}-${C}`),50,3),S=JSON.parse(p);h+=S.content,y=S.hasNextChunk,C++}return this.logService.trace(`Got ${C}-chunked password from keytar for account:`,v),h}catch(C){return this.logService.error(C),d}}async setPassword(I,v,b){this.logService.trace("Setting password using keytar:",I,v);let d;try{d=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}if(D.isWindows&&b.length>Et.MAX_PASSWORD_LENGTH){let h=0,y=0,C=!0;for(;C;){const p=b.substring(h,h+Et.PASSWORD_CHUNK_SIZE);h+=Et.PASSWORD_CHUNK_SIZE,C=b.length-h>0;const S={content:p,hasNextChunk:C};await(0,E.retry)(()=>d.setPassword(I,y?`${v}-${y}`:v,JSON.stringify(S)),50,3),y++}this.logService.trace(`Got${y?` ${y}-chunked`:""} password from keytar for account:`,v)}else await(0,E.retry)(()=>d.setPassword(I,v,b),50,3),this.logService.trace("Got password from keytar for account:",v);this._onDidChangePassword.fire({service:I,account:v})}async deletePassword(I,v){this.logService.trace("Deleting password using keytar:",I,v);let b;try{b=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}const d=await b.getPassword(I,v);if(!d)return this.logService.trace("Did not get a password to delete from keytar for account:",v),!1;let h,y;try{const p=JSON.parse(d);h=p.content,y=p.hasNextChunk}catch{}let C=0;if(h&&y)try{for(C++;y;){const p=`${v}-${C}`,S=await b.getPassword(I,p);await b.deletePassword(I,p),y=JSON.parse(S).hasNextChunk,C++}}catch(p){this.logService.error(p)}return await b.deletePassword(I,v)?(this._onDidChangePassword.fire({service:I,account:v}),this.logService.trace(`Deleted${C?` ${C}-chunked`:""} password from keytar for account:`,v),!0):(this.logService.trace(`Keytar failed to delete${C?` ${C}-chunked`:""} password for account:`,v),!1)}async findPassword(I){let v;try{v=await this.withKeytar()}catch{return null}return await v.findPassword(I)}async findCredentials(I){let v;try{v=await this.withKeytar()}catch{return[]}return await v.findCredentials(I)}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};u.MAX_PASSWORD_LENGTH=2500,u.PASSWORD_CHUNK_SIZE=u.MAX_PASSWORD_LENGTH-100,u=ve([ee(0,R.ILogService)],u),e.BaseCredentialsMainService=u}),define(te[203],ie([0,1,24,8,17,3,2,9,70,6]),function(z,e,w,t,k,R,D,E,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(b,d){super(),this.logService=b,this.options=d,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(b,d){return d.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(b,d):this.watchNonRecursive(b,d)}watchUniversal(b,d){const h={path:this.toFilePath(b),excludes:d.excludes,includes:d.includes,recursive:d.recursive},y=(0,w.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(b=>(0,k.onUnexpectedError)(b))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(d=>this._onDidChangeFile.fire((0,u.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})));const b=this.options?.watcher?.recursive?.usePolling;if(b===!0)for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const d of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(d)&&b.includes(d.path)&&(d.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(b,d){const h={path:this.toFilePath(b),excludes:d.excludes,includes:d.includes,recursive:!1},y=(0,w.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(b=>(0,k.onUnexpectedError)(b))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(b=>this._onDidChangeFile.fire((0,u.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(b){b.type==="error"&&this._onDidWatchError.fire(b.message),this.logService[b.type](b.message)}toFilePath(b){return(0,E.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[204],ie([0,1,24,8,18,23,3,66,57,2,31,13,71,16,58,158,14,106,6]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let f=class extends m.Disposable{constructor(a){super(),this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(a,i){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`);const o=new m.DisposableStore;return this.provider.set(a,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:i}),o.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new C.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&o.add(i.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),o.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:a}))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:i}),this.provider.delete(a),(0,m.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){i.push(o)}}),!this.provider.has(a)&&await t.Promises.settled(i)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,i){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&i)}listCapabilities(){return u.Iterable.map(this.provider,([a,i])=>({scheme:a,capabilities:i.capabilities}))}async withProvider(a){if(!(0,d.isAbsolutePath)(a))throw new C.FileOperationError((0,y.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const i=this.provider.get(a.scheme);if(!i){const o=new Error;throw o.name="ENOPRO",o.message=(0,y.localize)(1,null,a.toString()),o}return i}async withReadProvider(a){const i=await this.withProvider(a);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i)||(0,C.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const i=await this.withProvider(a);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,i){try{return await this.doResolveFile(a,i)}catch(o){throw(0,C.toFileSystemProviderErrorCode)(o)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,y.localize)(2,null,this.resourceForError(a)),1):(0,C.ensureFileSystemProviderError)(o)}}async doResolveFile(a,i){const o=await this.withProvider(a),n=this.isPathCaseSensitive(o),r=i?.resolveTo,s=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,l=await o.stat(a);let P;return this.toFileStat(o,a,l,void 0,!!c,(M,T)=>(P||(P=I.TernarySearchTree.forUris(()=>!n),P.set(a,!0),r&&P.fill(!0,r)),P.get(M.resource)||P.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?T===1:!1))}async toFileStat(a,i,o,n,r,s){const{providerExtUri:c}=this.getExtUri(a),l={resource:i,name:c.basename(i),isFile:(o.type&C.FileType.File)!==0,isDirectory:(o.type&C.FileType.Directory)!==0,isSymbolicLink:(o.type&C.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&C.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,C.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(l.isDirectory&&s(l,n)){try{const P=await a.readdir(i),M=await t.Promises.settled(P.map(async([T,N])=>{try{const X=c.joinPath(i,T),ae=r?await a.stat(X):{type:N};return await this.toFileStat(a,X,ae,P.length,r,s)}catch(X){return this.logService.trace(X),null}}));l.children=(0,w.coalesce)(M)}catch(P){this.logService.trace(P),l.children=[]}return l}return l}async resolveAll(a){return t.Promises.settled(a.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(a){const i=await this.withProvider(a),o=await i.stat(a);return this.toFileStat(i,a,o,void 0,!0,()=>!1)}async exists(a){const i=await this.withProvider(a);try{return!!await i.stat(a)}catch{return!1}}async canCreateFile(a,i){try{await this.doValidateCreateFile(a,i)}catch(o){return o}return!0}async doValidateCreateFile(a,i){if(!i?.overwrite&&await this.exists(a))throw new C.FileOperationError((0,y.localize)(3,null,this.resourceForError(a)),3,i)}async createFile(a,i=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const n=await this.writeFile(a,i);return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,n)),n}async writeFile(a,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,a,o)||await this.mkdirp(n,r.dirname(a));let c;if((0,C.hasReadWriteCapability)(n)&&!(i instanceof k.VSBuffer))if((0,h.isReadableStream)(i)){const l=await(0,h.peekStream)(i,3);l.ended?c=k.VSBuffer.concat(l.buffer):c=l}else c=(0,h.peekReadable)(i,l=>k.VSBuffer.concat(l),3);else c=i;!(0,C.hasOpenReadWriteCloseCapability)(n)||(0,C.hasReadWriteCapability)(n)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(n,a,o,c):await this.doWriteBuffered(n,a,o,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new C.FileOperationEvent(a,4))}catch(s){throw new C.FileOperationError((0,y.localize)(4,null,this.resourceForError(a),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,i,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(i)));let r;try{r=await a.stat(i)}catch{return}if((r.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,y.localize)(6,null,this.resourceForError(i)),0,o);if(this.throwIfFileIsReadonly(i,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==C.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,C.etag)({mtime:o.mtime,size:r.size}))throw new C.FileOperationError((0,y.localize)(7,null),3,o);return r}async readFile(a,i,o){const n=await this.withReadProvider(a);return i?.atomic?this.doReadFileAtomic(n,a,i,o):this.doReadFile(n,a,i,o)}async doReadFileAtomic(a,i,o,n){return new Promise((r,s)=>{this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(a,i,o,n);r(c)}catch(c){s(c)}})})}async doReadFile(a,i,o,n){const r=await this.doReadFileStream(a,i,{...o,preferUnbuffered:!0},n);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(a,i,o){const n=await this.withReadProvider(a);return this.doReadFileStream(n,a,i,o)}async doReadFileStream(a,i,o,n){const r=new R.CancellationTokenSource(n),s=this.validateReadFile(i,o).then(l=>l,l=>{throw r.cancel(),l});let c;try{return typeof o?.etag=="string"&&o.etag!==C.ETAG_DISABLED&&await s,o?.atomic&&(0,C.hasFileAtomicReadCapability)(a)||!((0,C.hasOpenReadWriteCloseCapability)(a)||(0,C.hasFileReadStreamCapability)(a))||(0,C.hasReadWriteCapability)(a)&&o?.preferUnbuffered?c=this.readFileUnbuffered(a,i,o):(0,C.hasFileReadStreamCapability)(a)?c=this.readFileStreamed(a,i,r.token,o):c=this.readFileBuffered(a,i,r.token,o),{...await s,value:c}}catch(l){c&&await(0,h.consumeStream)(c);const P=(0,y.localize)(8,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(l).toString());throw l instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(P,l.stat,o):new C.FileOperationError(P,(0,C.toFileOperationResult)(l),o)}}readFileStreamed(a,i,o,n=Object.create(null)){const r=a.readFileStream(i,n,o);return(0,h.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new C.FileOperationError((0,y.localize)(9,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),n)},s=>k.VSBuffer.concat(s))}readFileBuffered(a,i,o,n=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(a,i,r,s=>s,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new C.FileOperationError((0,y.localize)(10,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),n)},o),r}readFileUnbuffered(a,i,o){const n=(0,h.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,C.hasFileAtomicReadCapability)(a)?r=await a.readFile(i,{atomic:!0}):r=await a.readFile(i),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(i,r.byteLength,o),n.end(k.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(a,i){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new C.FileOperationError((0,y.localize)(11,null,this.resourceForError(a)),0,i);if(typeof i?.etag=="string"&&i.etag!==C.ETAG_DISABLED&&i.etag===o.etag)throw new C.NotModifiedSinceFileOperationError((0,y.localize)(12,null),o,i);return this.validateReadFileLimits(a,o.size,i),o}validateReadFileLimits(a,i,o){if(o?.limits){let n;if(typeof o.limits.memory=="number"&&i>o.limits.memory&&(n=9),typeof o.limits.size=="number"&&i>o.limits.size&&(n=7),typeof n=="number")throw new C.FileOperationError((0,y.localize)(13,null,this.resourceForError(a)),n)}}async canMove(a,i,o){return this.doCanMoveCopy(a,i,"move",o)}async canCopy(a,i,o){return this.doCanMoveCopy(a,i,"copy",o)}async doCanMoveCopy(a,i,o,n){if(a.toString()!==i.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,a,s,i,o,n)}catch(r){return r}return!0}async move(a,i,o){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,a,r,i,"move",!!o),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="move"?2:3,c)),c}async copy(a,i,o){const n=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(n,a,r,i,"copy",!!o),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,s==="copy"?3:2,c)),c}async doMoveCopy(a,i,o,n,r,s){if(i.toString()===n.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(a,i,o,n,r,s);if(c&&!l&&s&&await this.del(n,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(n)),r==="copy"){if(a===o&&(0,C.hasFileFolderCopyCapability)(a))await a.copy(i,n,{overwrite:s});else{const P=await this.resolve(i);P.isDirectory?await this.doCopyFolder(a,P,o,n):await this.doCopyFile(a,i,o,n)}return r}else return a===o?(await a.rename(i,n,{overwrite:s}),r):(await this.doMoveCopy(a,i,o,n,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(a,i,o,n){if((0,C.hasOpenReadWriteCloseCapability)(a)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,i,o,n);if((0,C.hasOpenReadWriteCloseCapability)(a)&&(0,C.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,i,o,n);if((0,C.hasReadWriteCapability)(a)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,i,o,n);if((0,C.hasReadWriteCapability)(a)&&(0,C.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,i,o,n)}async doCopyFolder(a,i,o,n){await o.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),o,s):this.doCopyFile(a,r.resource,o,s)}))}async doValidateMoveCopy(a,i,o,n,r,s){let c=!1;if(a===o){const{providerExtUri:P,isPathCaseSensitive:M}=this.getExtUri(a);if(M||(c=P.isEqual(i,n)),c&&r==="copy")throw new Error((0,y.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!c&&P.isEqualOrParent(n,i))throw new Error((0,y.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!c){if(!s)throw new C.FileOperationError((0,y.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(a===o){const{providerExtUri:P}=this.getExtUri(a);if(P.isEqualOrParent(i,n))throw new Error((0,y.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(a){const i=this.isPathCaseSensitive(a);return{providerExtUri:i?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(i,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(a,0,o)),o}async mkdirp(a,i){const o=[],{providerExtUri:n}=this.getExtUri(a);for(;!n.isEqual(i,n.dirname(i));)try{if(((await a.stat(i)).type&C.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(n.basename(i)),i=n.dirname(i)}for(let r=o.length-1;r>=0;r--){i=n.joinPath(i,o[r]);try{await a.mkdir(i)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,i){try{await this.doValidateDelete(a,i)}catch(o){return o}return!0}async doValidateDelete(a,i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!i?.useTrash&&!(o.capabilities&4096))throw new Error((0,y.localize)(19,null,this.resourceForError(a)));let r;try{r=await o.stat(a)}catch{}if(r)this.throwIfFileIsReadonly(a,r);else throw new C.FileOperationError((0,y.localize)(20,null,this.resourceForError(a)),1);if(!!!i?.recursive){const c=await this.resolve(a);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,y.localize)(21,null,this.resourceForError(a)))}return o}async del(a,i){const o=await this.doValidateDelete(a,i),n=!!i?.useTrash,r=!!i?.recursive;await o.delete(a,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new C.FileOperationEvent(a,1))}async cloneFile(a,i){const o=await this.withProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(o===n&&this.getExtUri(o).providerExtUri.isEqual(a,i))return;if(o===n&&(0,C.hasFileCloneCapability)(o))return o.cloneFile(a,i);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri);return o===n&&(0,C.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(a,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,a,n,i))}watch(a,i={recursive:!1,excludes:[]}){const o=new m.DisposableStore;let n=!1,r=()=>{n=!0};return o.add((0,m.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(a,i);n?(0,m.dispose)(s):r=()=>(0,m.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(a,i){const o=await this.withProvider(a),n=(0,E.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(a),i]);let r=this.activeWatchers.get(n);return r||(r={count:0,disposable:o.watch(a,i)},this.activeWatchers.set(n,r)),r.count+=1,(0,m.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,m.dispose)(r.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,m.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(i,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(n)||(0,h.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(a,r,n):await this.doWriteReadableBufferedQueued(a,r,n)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,i,o){let n=0,r;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,i,s,s.byteLength,n,0),n+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,c)=>{(0,h.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(a,i,l,l.byteLength,n,0)}catch(P){return c(P)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>c(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,i,o){let n=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(a,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(a,i,o,n,r,s){let c=0;for(;c<n;)c+=await a.write(i,r+c,o.buffer,s+c,n-c)}async doWriteUnbuffered(a,i,o,n){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,i,o,n))}async doWriteUnbufferedQueued(a,i,o,n){let r;n instanceof k.VSBuffer?r=n:(0,h.isReadableStream)(n)?r=await(0,k.streamToBuffer)(n):(0,h.isReadableBufferedStream)(n)?r=await(0,k.bufferedStreamToBuffer)(n):r=(0,k.readableToBuffer)(n),await a.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,i,o,n))}async doPipeBufferedQueued(a,i,o,n){let r,s;try{r=await a.open(i,{create:!1}),s=await o.open(n,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,P=0,M=0;do M=await a.read(r,l,c.buffer,P,c.byteLength-P),await this.doWriteBuffer(o,s,c,M,l,P),l+=M,P+=M,P===c.byteLength&&(P=0);while(M>0)}catch(c){throw(0,C.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,i,o,n))}async doPipeUnbufferedQueued(a,i,o,n){return o.writeFile(n,await a.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,i,o,n){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,i,o,n))}async doPipeUnbufferedToBufferedQueued(a,i,o,n){const r=await o.open(n,{create:!0,unlock:!1});try{const s=await a.readFile(i);await this.doWriteBuffer(o,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(a,i,o,n){const r=await(0,k.streamToBuffer)(this.readFileBuffered(a,i,R.CancellationToken.None));await this.doWriteUnbuffered(o,n,void 0,r)}throwIfFileSystemIsReadonly(a,i){if(a.capabilities&2048)throw new C.FileOperationError((0,y.localize)(22,null,this.resourceForError(i)),6);return a}throwIfFileIsReadonly(a,i){if((i.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,y.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===v.Schemas.file?a.fsPath:a.toString(!0)}};f=ve([ee(0,S.ILogService)],f),e.FileService=f}),define(te[86],ie([0,1,40,279,8,31,18,3,30,2,9,5,16,58,21,162,14,106,203,44,200,199]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(w)}catch(o){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(o)}`)}})();class i extends S.AbstractDiskFileSystemProvider{constructor(n,r){super(n,r),this.onDidChangeCapabilities=E.Event.None,this.resourceLocks=new R.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,v.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat((0,b.joinPath)(n,c.name))).type:l=this.toType(c),s.push([c.name,l])}catch(l){this.logService.trace(l)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let s;return r?.dangling?s=C.FileType.Unknown:n.isFile()?s=C.FileType.File:n.isDirectory()?s=C.FileType.Directory:s=C.FileType.Unknown,r&&(s|=C.FileType.SymbolicLink),s}async createResourceLock(n){const r=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const c=new k.Barrier;return this.resourceLocks.set(n,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,m.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(n)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(n,r){let s;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const c=this.toFilePath(n);return await h.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{s?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,r,s){const c=(0,d.newWriteableStream)(l=>D.VSBuffer.concat(l.map(P=>D.VSBuffer.wrap(P))).buffer);return(0,p.readFileIntoStream)(this,n,c,l=>l.buffer,{...r,bufferSize:256*1024},s),c}async writeFile(n,r,s){let c;try{const l=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(l)){if(!s.overwrite)throw(0,C.createFileSystemProviderError)((0,y.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,C.createFileSystemProviderError)((0,y.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(n,l)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.canFlush=n}async open(n,r){const s=this.toFilePath(n);let c;(0,C.isFileOpenForWriteOptions)(r)&&(c=await this.createResourceLock(n));let l;try{if((0,C.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:M}=await h.SymlinkSupport.stat(s);M.mode&128||await h.Promises.chmod(s,M.mode|128)}catch(M){this.logService.trace(M)}let P;if((0,C.isFileOpenForWriteOptions)(r)){if(v.isWindows)try{await h.Promises.truncate(s,0),P="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}P||(P="w")}else P="r";l=await h.Promises.open(s,P)}catch(P){throw c?.dispose(),(0,C.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(l,0),(0,C.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(l,n),c){const P=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,c),P&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),P.dispose())}return l}async close(n){const r=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await h.Promises.fdatasync(n)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),r.dispose())}}async read(n,r,s,c,l){const P=this.normalizePos(n,r);let M=null;try{M=(await h.Promises.read(n,s,c,l,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(n,P,M)}return M}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,s){const c=this.mapHandleToPos.get(n);typeof c=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,c+s):this.mapHandleToPos.delete(n)))}async write(n,r,s,c,l){return(0,k.retry)(()=>this.doWrite(n,r,s,c,l),100,3)}async doWrite(n,r,s,c,l){const P=this.normalizePos(n,r);let M=null;try{M=(await h.Promises.write(n,s,c,l,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),T)}finally{this.updatePos(n,P,M)}return M}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const s=this.toFilePath(n);r.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,r,s){const c=this.toFilePath(n),l=this.toFilePath(r);if(c!==l)try{await this.validateTargetDeleted(n,r,"move",s.overwrite),await h.Promises.move(c,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(n,r,s){const c=this.toFilePath(n),l=this.toFilePath(r);if(c!==l)try{await this.validateTargetDeleted(n,r,"copy",s.overwrite),await h.Promises.copy(c,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,I.basename)(c),(0,I.basename)((0,I.dirname)(l)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(n,r,s,c){const l=this.toFilePath(n),P=this.toFilePath(r);let M=!1;if(!!(this.capabilities&1024)||(M=(0,u.isEqual)(l,P,!0)),M&&s==="copy")throw(0,C.createFileSystemProviderError)((0,y.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!M&&await h.Promises.exists(P)){if(!c)throw(0,C.createFileSystemProviderError)((0,y.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(n,r){return this.doCloneFile(n,r,!1)}async doCloneFile(n,r,s){const c=this.toFilePath(n),l=this.toFilePath(r),P=!!(this.capabilities&1024);if((0,u.isEqual)(c,l,!P))return;const M=new m.DisposableStore;try{const[T,N]=await Promise.all([this.createResourceLock(n),this.createResourceLock(r)]);M.add(T),M.add(N),s&&await h.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await h.Promises.copyFile(c,l)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(n,r,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(n,r,s){return new g.UniversalWatcherClient(c=>n(c),c=>r(c),s)}createNonRecursiveWatcher(n,r,s){return new a.NodeJSWatcherClient(c=>n(c),c=>r(c),s)}toFileSystemProviderError(n){if(n instanceof C.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=C.FileSystemProviderErrorCode.NoPermissions;break;default:r=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let s=this.toFileSystemProviderError(r);if(n&&s.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.toFilePath(n));c.mode&128||(s=(0,C.createFileSystemProviderError)(r,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return s}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(te[205],ie([0,1,3,86,2,18,58,23]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class u extends k.Disposable{constructor(v,b){super(),this.provider=v,this.logService=b,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(v,b,d){const h=this.getUriTransformer(v);switch(b){case"stat":return this.stat(h,d[0]);case"readdir":return this.readdir(h,d[0]);case"open":return this.open(h,d[0],d[1]);case"close":return this.close(d[0]);case"read":return this.read(d[0],d[1],d[2]);case"readFile":return this.readFile(h,d[0],d[1]);case"write":return this.write(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.writeFile(h,d[0],d[1],d[2]);case"rename":return this.rename(h,d[0],d[1],d[2]);case"copy":return this.copy(h,d[0],d[1],d[2]);case"cloneFile":return this.cloneFile(h,d[0],d[1]);case"mkdir":return this.mkdir(h,d[0]);case"delete":return this.delete(h,d[0],d[1]);case"watch":return this.watch(h,d[0],d[1],d[2],d[3]);case"unwatch":return this.unwatch(d[0],d[1])}throw new Error(`IPC Command ${b} not found`)}listen(v,b,d){const h=this.getUriTransformer(v);switch(b){case"fileChange":return this.onFileChange(h,d[0]);case"readFileStream":return this.onReadFileStream(h,d[0],d[1])}throw new Error(`Unknown event ${b}`)}stat(v,b){const d=this.transformIncoming(v,b,!0);return this.provider.stat(d)}readdir(v,b){const d=this.transformIncoming(v,b);return this.provider.readdir(d)}async readFile(v,b,d){const h=this.transformIncoming(v,b,!0),y=await this.provider.readFile(h,d);return R.VSBuffer.wrap(y)}onReadFileStream(v,b,d){const h=this.transformIncoming(v,b,!0),y=new E.CancellationTokenSource,C=new w.Emitter({onLastListenerRemove:()=>{y.cancel()}}),p=this.provider.readFileStream(h,d,y.token);return(0,D.listenStream)(p,{onData:S=>C.fire(R.VSBuffer.wrap(S)),onError:S=>C.fire(S),onEnd:()=>{C.fire("end"),C.dispose(),y.dispose()}}),C.event}writeFile(v,b,d,h){const y=this.transformIncoming(v,b);return this.provider.writeFile(y,d.buffer,h)}open(v,b,d){const h=this.transformIncoming(v,b,!0);return this.provider.open(h,d)}close(v){return this.provider.close(v)}async read(v,b,d){const h=R.VSBuffer.alloc(d),y=0,C=await this.provider.read(v,b,h.buffer,y,d);return[h,C]}write(v,b,d,h,y){return this.provider.write(v,b,d.buffer,h,y)}mkdir(v,b){const d=this.transformIncoming(v,b);return this.provider.mkdir(d)}delete(v,b,d){const h=this.transformIncoming(v,b);return this.provider.delete(h,d)}rename(v,b,d,h){const y=this.transformIncoming(v,b),C=this.transformIncoming(v,d);return this.provider.rename(y,C,h)}copy(v,b,d,h){const y=this.transformIncoming(v,b),C=this.transformIncoming(v,d);return this.provider.copy(y,C,h)}cloneFile(v,b,d){const h=this.transformIncoming(v,b),y=this.transformIncoming(v,d);return this.provider.cloneFile(h,y)}onFileChange(v,b){const d=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(b,this.createSessionFileWatcher(v,d))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(b)),this.sessionToWatcher.delete(b)}});return d.event}async watch(v,b,d,h,y){const C=this.sessionToWatcher.get(b);if(C){const p=this.transformIncoming(v,h),S=C.watch(d,p,y);this.watchRequests.set(b+d,S)}}async unwatch(v,b){const d=v+b,h=this.watchRequests.get(d);h&&((0,k.dispose)(h),this.watchRequests.delete(d))}dispose(){super.dispose();for(const[,v]of this.watchRequests)v.dispose();this.watchRequests.clear();for(const[,v]of this.sessionToWatcher)v.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=u;class m extends k.Disposable{constructor(v,b,d,h){super(),this.uriTransformer=v,this.logService=d,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(b)}registerListeners(v){const b=this._register(new w.Emitter);this._register(b.event(d=>{v.fire(d.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type})))})),this._register(this.fileWatcher.onDidChangeFile(d=>b.fire(d))),this._register(this.fileWatcher.onDidWatchError(d=>v.fire(d)))}getRecursiveWatcherOptions(v){}getExtraExcludes(v){}watch(v,b,d){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(d.excludes=[...d.excludes,...h]),this.watcherRequests.set(v,this.fileWatcher.watch(b,d)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(v)),this.watcherRequests.delete(v)})}dispose(){super.dispose();for(const[,v]of this.watcherRequests)v.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=m}),define(te[206],ie([0,1,15,161,5,7,14,9,205,140]),function(z,e,w,t,k,R,D,E,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends u.AbstractDiskFileSystemProviderChannel{constructor(d,h,y){super(d,h),this.environmentService=y}getUriTransformer(d){return m.DefaultURITransformer}transformIncoming(d,h){return R.URI.revive(h)}async delete(d,h,y){if(!y.useTrash)return super.delete(d,h,y);const C=this.transformIncoming(d,h),p=(0,E.normalize)(C.fsPath);try{await w.shell.trashItem(p)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,E.basename)(p)):(0,t.localize)(1,null,(0,E.basename)(p)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(d,h){return new v(d,h,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class v extends u.AbstractSessionFileWatcher{watch(d,h,y){if(y.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(d,h,y)}}}),define(te[107],ie([0,1,6]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case w.LogLevel.Trace:return R.trace;case w.LogLevel.Debug:return R.debug;case w.LogLevel.Info:return R.info;case w.LogLevel.Warning:return R.warn;case w.LogLevel.Error:return R.error;case w.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends w.AbstractLogger{constructor(D=w.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(E=>{this._logger?.setLevel(E)}))}set logger(D){this._logger=D;for(const{level:E,args:u}of this.buffer)t(D,E).apply(D,u);this.buffer=[]}_log(D,...E){this._logger?t(this._logger,D).apply(this._logger,E):this.getLevel()<=D&&this.buffer.push({level:D,args:E})}trace(D,...E){this._log(w.LogLevel.Trace,D,...E)}debug(D,...E){this._log(w.LogLevel.Debug,D,...E)}info(D,...E){this._log(w.LogLevel.Info,D,...E)}warn(D,...E){this._log(w.LogLevel.Warning,D,...E)}error(D,...E){this._log(w.LogLevel.Error,D,...E)}critical(D,...E){this._log(w.LogLevel.Critical,D,...E)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(te[207],ie([0,1,8,18,16,14,4,107,6]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*R.ByteSize.MB;let I=class extends u.AbstractLogger{constructor(d,h,y,C,p){super(),this.name=d,this.resource=h,this.donotUseFormatters=C,this.fileService=p,this.backupIndex=1,this.setLevel(y),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=u.LogLevel.Trace&&this._log(u.LogLevel.Trace,(0,u.format)(arguments))}debug(){this.getLevel()<=u.LogLevel.Debug&&this._log(u.LogLevel.Debug,(0,u.format)(arguments))}info(){this.getLevel()<=u.LogLevel.Info&&this._log(u.LogLevel.Info,(0,u.format)(arguments))}warn(){this.getLevel()<=u.LogLevel.Warning&&this._log(u.LogLevel.Warning,(0,u.format)(arguments))}error(){if(this.getLevel()<=u.LogLevel.Error){const d=arguments[0];if(d instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=d.stack,this._log(u.LogLevel.Error,(0,u.format)(h))}else this._log(u.LogLevel.Error,(0,u.format)(arguments))}}critical(){this.getLevel()<=u.LogLevel.Critical&&this._log(u.LogLevel.Critical,(0,u.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(d){if(d.fileOperationResult!==3)throw d}}_log(d,h){this.queue.queue(async()=>{await this.initializePromise;let y=await this.loadContent();y.length>m&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(y)),y=""),this.donotUseFormatters?y+=h:y+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(d)}] ${h}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(y))})}getCurrentTimestamp(){const d=C=>C<10?`0${C}`:C,h=C=>C<10?`00${C}`:C<100?`0${C}`:C,y=new Date;return`${y.getFullYear()}-${d(y.getMonth()+1)}-${d(y.getDate())} ${d(y.getHours())}:${d(y.getMinutes())}:${d(y.getSeconds())}.${h(y.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(d){switch(d){case u.LogLevel.Critical:return"critical";case u.LogLevel.Debug:return"debug";case u.LogLevel.Error:return"error";case u.LogLevel.Info:return"info";case u.LogLevel.Trace:return"trace";case u.LogLevel.Warning:return"warning"}return""}};I=ve([ee(4,R.IFileService)],I),e.FileLogger=I;let v=class extends u.AbstractLoggerService{constructor(d,h,y){super(d.getLevel(),d.onDidChangeLogLevel),this.instantiationService=h,this.fileService=y}doCreateLogger(d,h,y){const C=new E.BufferLogService(h);return(0,R.whenProviderRegistered)(d,this.fileService).then(()=>C.logger=this.instantiationService.createInstance(I,y?.name||(0,k.basename)(d),d,C.getLevel(),!!y?.donotUseFormatters)),C}};v=ve([ee(0,u.ILogService),ee(1,D.IInstantiationService),ee(2,R.IFileService)],v),e.FileLoggerService=v}),define(te[208],ie([0,1,3,7,6]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(b){this.service=b,this.onDidChangeLogLevel=w.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,d){switch(d){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${d}`)}async call(b,d,h){switch(d){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${d}`)}}e.LogLevelChannel=R;class D{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){D.setLevel(this.channel,b)}static setLevel(b,d){return b.call("setLevel",d)}}e.LogLevelChannelClient=D;class E{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,d){throw new Error(`Event not found: ${d}`)}async call(b,d,h){switch(d){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${d}`)}createLogger(b,d){this.loggers.set(b.toString(),this.loggerService.createLogger(b,d))}consoleLog(b,d){let h=console.log;switch(b){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...d)}log(b,d){const h=this.loggers.get(b.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,C]of d)(0,k.log)(h,y,C)}}e.LoggerChannel=E;class u extends k.AbstractLoggerService{constructor(b,d,h){super(b,d),this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(b,d)=>{this.channel.call("consoleLog",[b,d])}})}doCreateLogger(b,d,h){return new m(this.channel,b,d,h)}}e.LoggerChannelClient=u;class m extends k.AbstractMessageLogger{constructor(b,d,h,y){super(y?.always),this.channel=b,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[d,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,d){const h=[[b,d]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(b){this.channel.call("log",[this.file,b])}}class I extends k.LogService{constructor(b,d){super(d),this.parent=b,this._register(b.onDidChangeLogLevel(h=>d.setLevel(h)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=I}),define(te[108],ie([0,1,14,6]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(E,u,m,I,v){try{const b=await new Promise((h,y)=>{z(["spdlog"],h,y)});b.setFlushOn(t.LogLevel.Trace);const d=await b.createAsyncRotatingLogger(E,u,m,I);return v&&d.clearFormatters(),d}catch(b){console.error(b)}return null}function R(E,u,m){switch(u){case t.LogLevel.Trace:E.trace(m);break;case t.LogLevel.Debug:E.debug(m);break;case t.LogLevel.Info:E.info(m);break;case t.LogLevel.Warning:E.warn(m);break;case t.LogLevel.Error:E.error(m);break;case t.LogLevel.Critical:E.critical(m);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(u,m,I,v,b){super(),this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(u,m,I,v),this._register(this.onDidChangeLogLevel(d=>{this._logger?.setLevel(d)}))}async _createSpdLogLogger(u,m,I,v){const b=I?6:1,d=30/b*w.ByteSize.MB,h=await k(u,m,d,b,v);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:y,message:C}of this.buffer)R(this._logger,y,C);this.buffer=[]}}log(u,m){this._logger?R(this._logger,u,m):this.getLevel()<=u&&this.buffer.push({level:u,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(te[209],ie([0,1,13,16,29,14,207,6,108]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends E.AbstractLoggerService{constructor(v,b){super(v.getLevel(),v.onDidChangeLogLevel),this.fileService=b}doCreateLogger(v,b,d){return v.scheme===w.Schemas.file?new u.SpdLogLogger(d?.name||(0,k.generateUuid)(),v.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,b):new D.FileLogger(d?.name??(0,t.basename)(v),v,b,!!d?.donotUseFormatters,this.fileService)}};m=ve([ee(0,E.ILogService),ee(1,R.IFileService)],m),e.LoggerService=m}),define(te[210],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!w(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(te[37],ie([0,1,3,57,2,4]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(m){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...m,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(m),t.Iterable.reduce(this.policies.entries(),(v,[b,d])=>({...v,[b]:d}),{})}getPolicyValue(m){return this.policies.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(m,[I,v])=>({...m,[I]:{definition:v,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=D;class E{constructor(){this.onDidChange=w.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=E}),define(te[211],ie([0,1,8,3,57,12,14,6,37]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(v,b){const d=[];for(const h of k.Iterable.concat(v.keys(),b.keys()))v.get(h)!==b.get(h)&&d.push(h);return d}let I=class extends u.AbstractPolicyService{constructor(b,d,h){super(),this.file=b,this.fileService=d,this.logService=h,this.throttledDelayer=this._register(new w.ThrottledDelayer(500));const y=t.Event.filter(d.onDidFilesChange,C=>C.affects(b));this._register(d.watch(b)),this._register(y(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(b){await this.refresh()}async read(){const b=new Map;try{const d=await this.fileService.readFile(this.file),h=JSON.parse(d.value.toString());if(!(0,R.isObject)(h))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(h))this.policyDefinitions[y]&&b.set(y,h[y])}catch(d){d.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",d)}return b}async refresh(){const b=await this.read(),d=m(this.policies,b);this.policies=b,d.length>0&&this._onDidChange.fire(d)}};I=ve([ee(1,D.IFileService),ee(2,E.ILogService)],I),e.FilePolicyService=I}),define(te[212],ie([0,1,3,2,37]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(u){this.service=u,this.disposables=new t.DisposableStore}listen(u,m){switch(m){case"onDidChange":return w.Event.map(this.service.onDidChange,I=>I.reduce((v,b)=>({...v,[b]:this.service.getPolicyValue(b)??null}),{}),this.disposables)}throw new Error(`Event not found: ${m}`)}call(u,m,I){switch(m){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${m}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(u,m){super(),this.channel=m;for(const I in u){const{definition:v,value:b}=u[I];this.policyDefinitions[I]=v,b!==void 0&&this.policies.set(I,b)}this.channel.listen("onDidChange")(I=>{for(const v in I){const b=I[v];b===null?this.policies.delete(v):this.policies.set(v,b)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(u){const m=await this.channel.call("registerPolicyDefinitions",u);for(const I in m)this.policies.set(I,m[I])}}e.PolicyChannelClient=D}),define(te[54],ie([0,1,13,5,34,16]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const E=t.globals.vscode.context.configuration();if(E)D=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof z?.__$__nodeRequire=="function"){const E=(0,R.dirname)(w.FileAccess.asFileUri("",z));if(D=z.__$__nodeRequire((0,R.joinPath)(E,"product.json").fsPath),k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const u=z.__$__nodeRequire((0,R.joinPath)(E,"package.json").fsPath);Object.assign(D,{version:u.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(te[20],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[213],ie([0,1,76,6,20]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(E,u){this.productService=E,this.logService=u,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(E,u){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(u);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",u),!1;const[,I,v]=m;let b=this.trustedExtensionUrlPublicKeys.get(E);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[E],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",E),!1;this.trustedExtensionUrlPublicKeys.set(E,[...b])}const d=Buffer.from(decodeURIComponent(v),"base64");if(d.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",u),!1;const h=d.slice(0,6),y=d.readUIntBE(0,6),C=Date.now()-y;if(C<0||C>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",u),!1;const p=d.slice(6),S=w.createVerify("SHA256");S.write(h),S.write(Buffer.from(I)),S.end();for(let f=0;f<b.length;f++){let g=b[f];if(g!==null){if(typeof g=="string")try{g=w.createPublicKey({key:Buffer.from(g,"base64"),format:"der",type:"spki"}),b[f]=g}catch(a){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${f+1} for ${E}:`,a),b[f]=null;continue}if(S.verify(g,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",u),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",u),!1}};R=ve([ee(0,k.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(te[214],ie([0,1,9,4]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var k;(function(R){function D(E,u="noAbsolutePaths"){for(const m of E.nodes)m.callFrame&&m.callFrame.url&&((0,w.isAbsolute)(m.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(m.callFrame.url))&&(m.callFrame.url=(0,w.join)(u,(0,w.basename)(m.callFrame.url)));return E}R.rewriteAbsolutePaths=D})(k=e.Utils||(e.Utils={}))}),define(te[61],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(te[47],ie([0,1,121,12]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,E){w.ok(t.isString(D)),w.ok(t.isObject(E)),w.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,E)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(te[215],ie([0,1,3,47]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,m){this.schemasById[k(u)]=m,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(te[62],ie([0,1,24,3,12,149,19,215,47]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=u.Registry.as(E.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=this.doRegisterConfigurations(i,o);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=this.doDeregisterConfigurations(i);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=[];n.push(...this.doDeregisterConfigurations(o)),n.push(...this.doRegisterConfigurations(i,!1)),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(n)})}registerDefaultConfigurations(i){const o=[],n=[];for(const{overrides:r,source:s}of i)for(const c in r)if(o.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const l=this.configurationDefaultsOverrides.get(c),P=l?.valuesSources??new Map;if(s)for(const X of Object.keys(r[c]))P.set(X,s);const M={...l?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:s,value:M,valuesSources:P});const T=(0,D.getLanguageTagSettingPlainKey)(c),N={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(s)?void 0:s,defaultValueSource:s};n.push(...y(c)),this.configurationProperties[c]=N,this.defaultLanguageConfigurationOverridesNode.properties[c]=N}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:s});const l=this.configurationProperties[c];l&&(this.updatePropertyDefaultValue(c,l),this.updateSchema(c,l))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:n,source:r}of i)for(const s in n){const c=this.configurationDefaultsOverrides.get(s),l=k.isString(r)?r:r?.id,P=k.isString(c?.source)?c?.source:c?.source?.id;if(l===P)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const M=this.configurationProperties[s];M&&(this.updatePropertyDefaultValue(s,M),this.updateSchema(s,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o){const n=[];return i.forEach(r=>{n.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),n}doDeregisterConfigurations(i){const o=[],n=r=>{if(r.properties)for(const s in r.properties){o.push(s);const c=this.configurationProperties[s];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>n(s))};for(const r of i){n(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(i,o=!0,n,r,s=3){s=k.isUndefinedOrNull(i.scope)?s:i.scope;const c=[],l=i.properties;if(l)for(const M in l){const T=l[M];if(o&&f(M,T)){delete l[M];continue}if(T.source=n,T.defaultDefaultValue=l[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!r?.includes(M):T.restricted),l[M].hasOwnProperty("included")&&!l[M].included){this.excludedConfigurationProperties[M]=l[M],delete l[M];continue}else this.configurationProperties[M]=l[M],l[M].policy?.name&&this.policyConfigurations.set(l[M].policy.name,M);!l[M].deprecationMessage&&l[M].markdownDeprecationMessage&&(l[M].deprecationMessage=l[M].markdownDeprecationMessage),c.push(M)}const P=i.allOf;if(P)for(const M of P)c.push(...this.validateAndRegisterProperties(M,o,n,r,s));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const r=n.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let r=n?.value,s=n?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=p(o.type)),o.default=r,o.defaultValueSource=s}}const d="\\[([^\\]]+)\\]",h=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(a){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=h.exec(a);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=h.exec(a)}}return(0,w.distinct)(i)}e.overrideIdentifiersFromKey=y;function C(a){return a.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=C;function p(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const S=new b;u.Registry.add(e.Extensions.Configuration,S);function f(a,i){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?R.localize(7,null,a):S.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):i.policy?.name&&S.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,a,i.policy?.name,S.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=f;function g(){const a=[],i=S.getConfigurationProperties();for(const o of Object.keys(i))a.push([o,i[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=g}),define(te[109],ie([0,1,24,3,43,2,31,50,12,7,19,62,47]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class d{constructor(i={},o=[],n=[],r){this._contents=i,this._keys=o,this._overrides=n,this.raw=r,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof d)return o;const n=new h("");return n.parseRaw(o),n.configurationModel});this._rawConfiguration=i.reduce((o,n)=>n===o?n:o.merge(n),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}inspect(i,o){const n=this.rawConfiguration.getValue(i),r=o?this.rawConfiguration.getOverrideValue(i,o):void 0,s=o?this.rawConfiguration.override(o).getValue(i):n;return{value:n,override:r,merged:s}}getOverrideValue(i,o){const n=this.getContentsForOverrideIdentifer(o);return n?i?(0,I.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const n of this.overrides)n.identifiers.includes(i)&&o.push(...n.keys);return w.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return w.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=E.deepClone(this.contents),n=E.deepClone(this.overrides),r=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const c of i)if(s.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.mergeContents(o,c.contents);for(const l of c.overrides){const[P]=n.filter(M=>w.equals(M.identifiers,l.identifiers));P?(this.mergeContents(P.contents,l.contents),P.keys.push(...l.keys),P.keys=w.distinct(P.keys)):n.push(E.deepClone(l))}for(const l of c.keys)r.indexOf(l)===-1&&r.push(l)}return new d(o,r,n,s.every(c=>c instanceof d)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new d(E.deepClone(this.contents),[...this.keys],E.deepClone(this.overrides))}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const n={};for(const r of w.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r];const c=o[r];c&&(typeof s=="object"&&typeof c=="object"?(s=E.deepClone(s),this.mergeContents(s,c)):s=c),n[r]=s}return new d(n,this.keys,this.overrides)}mergeContents(i,o){for(const n of Object.keys(o)){if(n in i&&u.isObject(i[n])&&u.isObject(o[n])){this.mergeContents(i[n],o[n]);continue}i[n]=E.deepClone(o[n])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?E.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,n=null;const r=s=>{s&&(n?this.mergeContents(n,s):n=E.deepClone(s))};for(const s of this.overrides)w.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&r(s.contents);return r(o),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,I.addToValueTree)(this.contents,i,o,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let n=0;n<o;n++)i.indexOf(this.keys[n])===0&&(o=n);this.keys.splice(o,1,i)}removeKey(i){const o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=d;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!u.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:n,keys:r,overrides:s,restricted:c,hasExcludedProperties:l}=this.doParseRaw(i,o);this._configurationModel=new d(n,r,s,l?[i]:void 0),this._restrictedConfigurations=c||[]}doParseContent(i){let o={},n=null,r=[];const s=[],c=[];function l(M){Array.isArray(r)?r.push(M):n!==null&&(r[n]=M)}const P={onObjectBegin:()=>{const M={};l(M),s.push(r),r=M,n=null},onObjectProperty:M=>{n=M},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const M=[];l(M),s.push(r),r=M,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:l,onError:(M,T,N)=>{c.push({error:M,offset:T,length:N})}};if(i)try{k.visit(i,P),o=r[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return o}doParseRaw(i,o){const n=b.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,n,!0,o);i=r.raw;const s=(0,I.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),c=Object.keys(i),l=this.toOverrides(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:s,keys:c,overrides:l,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(i,o,n,r){let s=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const c={},l=[];for(const P in i)if(v.OVERRIDE_PROPERTY_REGEX.test(P)&&n){const M=this.filter(i[P],o,!1,r);c[P]=M.raw,s=s||M.hasExcludedProperties,l.push(...M.restricted)}else{const M=o[P],T=M?typeof M.scope<"u"?M.scope:3:void 0;M?.restricted&&l.push(P),(T===void 0||r.scopes===void 0||r.scopes.includes(T))&&!(r.skipRestricted&&M?.restricted)?c[P]=i[P]:s=!0}return{raw:c,restricted:l,hasExcludedProperties:s}}toOverrides(i,o){const n=[];for(const r of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const c in i[r])s[c]=i[r][c];n.push({identifiers:(0,v.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return n}}e.ConfigurationModelParser=h;class y extends R.Disposable{constructor(i,o,n,r){super(),this.userSettingsResource=i,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class C{constructor(i,o,n,r,s=new d,c=new d,l=new D.ResourceMap,P=new d,M=new D.ResourceMap,T=!0){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=n,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=l,this._memoryConfiguration=P,this._memoryConfigurationByResource=M,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,o,n){return this.getConsolidatedConfigurationModel(i,o,n).getValue(i)}updateValue(i,o,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new d,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(i):r.setValue(i,o),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,n){const r=this.getConsolidatedConfigurationModel(i,o,n),s=this.getFolderConfigurationModelForResource(o.resource,n),c=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,l=this._defaultConfiguration.inspect(i,o.overrideIdentifier),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(i),M=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(i),T=this.userConfiguration.freeze().inspect(i,o.overrideIdentifier),N=this.localUserConfiguration.freeze().inspect(i,o.overrideIdentifier),X=this.remoteUserConfiguration.freeze().inspect(i,o.overrideIdentifier),ae=n?this._workspaceConfiguration.freeze().inspect(i,o.overrideIdentifier):void 0,Q=s?s.freeze().inspect(i,o.overrideIdentifier):void 0,G=c.inspect(i,o.overrideIdentifier),Z=r.getValue(i),se=w.distinct(r.overrides.map(he=>he.identifiers).flat()).filter(he=>r.getOverrideValue(i,he)!==void 0);return{defaultValue:l?l.merged:void 0,policyValue:P?P.merged:void 0,applicationValue:M?M.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:N?N.merged:void 0,userRemoteValue:X?X.merged:void 0,workspaceValue:ae?ae.merged:void 0,workspaceFolderValue:Q?Q.merged:void 0,memoryValue:G?G.merged:void 0,value:Z,default:l.value!==void 0||l.override!==void 0?{value:l.value,override:l.override}:void 0,policy:P?.value!==void 0?{value:P.value}:void 0,application:M?.value!==void 0||M?.override!==void 0?{value:M.value,override:M.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:N.value!==void 0||N.override!==void 0?{value:N.value,override:N.override}:void 0,userRemote:X.value!==void 0||X.override!==void 0?{value:X.value,override:X.override}:void 0,workspace:ae?.value!==void 0||ae?.override!==void 0?{value:ae.value,override:ae.override}:void 0,workspaceFolder:Q?.value!==void 0||Q?.override!==void 0?{value:Q.value,override:Q.override}:void 0,memory:G.value!==void 0||G.override!==void 0?{value:G.value,override:G.override}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const n=[];if(!o){const{added:r,updated:s,removed:c}=f(this._defaultConfiguration,i);o=[...r,...s,...c]}for(const r of o)for(const s of(0,v.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=i.getKeysForOverrideIdentifier(s),P=[...l.filter(M=>c.indexOf(M)===-1),...c.filter(M=>l.indexOf(M)===-1),...c.filter(M=>!E.equals(this._defaultConfiguration.override(s).getValue(M),i.override(s).getValue(M)))];n.push([s,P])}return this.updateDefaultConfiguration(i),{keys:o,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:n,removed:r}=f(this._policyConfiguration,i),s=[...o,...n,...r];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.applicationConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.localUserConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.remoteUserConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:n,removed:r,overrides:s}=f(this.workspaceConfiguration,i),c=[...o,...n,...r];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const n=this.folderConfigurations.get(i),{added:r,updated:s,removed:c,overrides:l}=f(n,o),P=[...r,...s,...c];return(P.length||!n)&&this.updateFolderConfiguration(i,o),{keys:P,overrides:l}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:s,overrides:c}=f(o,void 0);return{keys:[...n,...r,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,n){let r=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier&&(r=r.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},o){let n=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const r=o.getFolder(i);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const s=this._memoryConfigurationByResource.get(i);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(o=n.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=n}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const n=o.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:n,overrides:r,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:n,overrides:r,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),c=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((P,M)=>(P.set(m.URI.revive(M[0]),this.parseConfigurationModel(M[1])),P),new D.ResourceMap);return new C(o,n,r,s,new d,c,l,new d,new D.ResourceMap,!1)}static parseConfigurationModel(i){return new d(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function p(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,o=new Map;for(const r of a)r.keys.forEach(s=>i.add(s)),r.overrides.forEach(([s,c])=>{const l=(0,D.getOrSet)(o,s,new Set);c.forEach(P=>l.add(P))});const n=[];return o.forEach((r,s)=>n.push([s,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=p;class S{constructor(i,o,n,r){this.change=i,this.previous=o,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(l=>s.add(l)),i.overrides.forEach(([,l])=>l.forEach(P=>s.add(P))),this.affectedKeys=[...s.values()];const c=new d;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!E.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let n=(0,I.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(i=i[r],!i)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=S;function f(a,i){const{added:o,removed:n,updated:r}=g(i,a),s=[],c=a?.getAllOverrideIdentifiers()||[],l=i?.getAllOverrideIdentifiers()||[];if(i){const P=l.filter(M=>!c.includes(M));for(const M of P)s.push([M,i.getKeysForOverrideIdentifier(M)])}if(a){const P=c.filter(M=>!l.includes(M));for(const M of P)s.push([M,a.getKeysForOverrideIdentifier(M)])}if(i&&a){for(const P of c)if(l.includes(P)){const M=g({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)});s.push([P,[...M.added,...M.removed,...M.updated]])}}return{added:o,removed:n,updated:r,overrides:s}}function g(a,i){const o=a?i?a.keys.filter(s=>i.keys.indexOf(s)===-1):[...a.keys]:[],n=i?a?i.keys.filter(s=>a.keys.indexOf(s)===-1):[...i.keys]:[],r=[];if(a&&i){for(const s of i.keys)if(a.keys.indexOf(s)!==-1){const c=(0,I.getConfigurationValue)(i.contents,s),l=(0,I.getConfigurationValue)(a.contents,s);E.equals(c,l)||r.push(s)}}return{added:o,removed:n,updated:r}}}),define(te[216],ie([0,1,24,3,2,50,12,19,109,62,6,37,47]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class d extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(b.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:f})=>this.onDidUpdateConfiguration(S,f))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,f){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=d;class h extends u.ConfigurationModel{constructor(S={}){const f=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(f),a=Object.create(null),i=[];for(const o in f){const n=S[o],r=n!==void 0?n:f[o].default;(0,E.addToValueTree)(a,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(a))m.OVERRIDE_PROPERTY_REGEX.test(o)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(o),keys:Object.keys(a[o]),contents:(0,E.toValuesTree)(a[o],n=>console.error(`Conflict in default settings file: ${n}`))});super(a,g,i)}}e.DefaultConfigurationModel=h;class y{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new u.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let C=class extends k.Disposable{get configurationModel(){return this._configurationModel}constructor(S,f,g){super(),this.defaultConfiguration=S,this.policyService=f,this.logService=g,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new u.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const f={},g=[],a=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of S){const o=a[i];if(!o){g.push(i);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}g.push(i),f[o.policy.name]={type:o.type}}}return(0,D.isEmptyObject)(f)||await this.policyService.registerPolicyDefinitions(f),g}onDidChangePolicies(S){const f=b.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),g=(0,w.coalesce)(S.map(a=>f.get(a)));this.update(g,!0)}update(S,f){const g=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),a=[],i=this._configurationModel.isEmpty();for(const o of S){const n=g[o]?.policy?.name;if(n){const r=this.policyService.getPolicyValue(n);(i?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),r))&&a.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&a.push([o,void 0])}if(a.length){const o=this._configurationModel;this._configurationModel=new u.ConfigurationModel;for(const n of o.keys)this._configurationModel.setValue(n,o.getValue(n));for(const[n,r]of a)r===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,r);f&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=ve([ee(1,v.IPolicyService),ee(2,I.ILogService)],C),e.PolicyConfiguration=C}),define(te[217],ie([0,1,8,3,2,16,19,109,216,37]),function(z,e,w,t,k,R,D,E,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(b,d,h,y){super(),this.settingsResource=b,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new u.DefaultConfiguration),this.policyConfiguration=h instanceof m.NullPolicyService?new u.NullPolicyConfiguration:this._register(new u.PolicyConfiguration(this.defaultConfiguration,h,y)),this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,d)),this.configuration=new E.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new E.ConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:p})=>this.onDidDefaultConfigurationChange(C,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[b,d,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new E.Configuration(b,d,new E.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(b,d){const h=typeof b=="string"?b:void 0,y=(0,D.isConfigurationOverrides)(b)?b:(0,D.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(h,y,void 0)}updateValue(b,d,h,y){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const d=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(h,d,2)}onDidDefaultConfigurationChange(b,d){const h=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(b,d);this.trigger(y,h,7)}onDidPolicyConfigurationChange(b){const d=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(b);this.trigger(h,d,7)}trigger(b,d,h){const y=new E.ConfigurationChangeEvent(b,{data:d},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(b){switch(b){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[218],ie([0,1,17,4]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends w.ErrorNoTelemetry{static isTemporarilyNotAvailable(E){return E instanceof R&&E._code===k.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof R&&E._code===k.NoResolverFound}static isHandled(E){return E instanceof R&&E.isHandled}constructor(E,u=k.Unknown,m){super(E),this._message=E,this._code=u,this._detail=m,this.isHandled=u===k.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(te[63],ie([0,1,13]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const I=m.indexOf("+");return I<0?m:m.substr(0,I)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(m){const{host:I,port:v}=u(m);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:v}}e.parseAuthorityWithPort=D;function E(m,I){let{host:v,port:b}=u(m);return typeof b>"u"&&(b=I),{host:v,port:b}}e.parseAuthorityWithOptionalPort=E;function u(m){const I=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const v=m.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const b=m.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:m,port:void 0}}}),define(te[110],ie([0,1,25,4,63]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=R;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var u;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(u=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,C){if(typeof y>"u"||y===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof y=="string"||typeof C=="string"){const p=typeof y=="string"?y:y.value,S=typeof C=="string"?C:C.value;return w.equalsIgnoreCase(p,S)}return y._lower===C._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=m;function I(h){return v(h)}e.isApplicationScopedExtension=I;function v(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function b(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function d(h,y){if(y){const C=`onResolveRemoteAuthority:${(0,k.getRemoteName)(y)}`;return h.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[111],ie([0,1,25,192,110,5,7,17,34]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(o,n){return o.uuid&&n.uuid?o.uuid===n.uuid:o.id===n.id?!0:(0,w.compareIgnoreCase)(o.id,n.id)===0}e.areSameExtensions=m;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new v(n.identifier,r,s)}static parse(n){const r=I.exec(n);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof v?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=v;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(o){const n=b.exec(o);return n&&n[1]?[y(n[1]),n[2]]:[y(o),void 0]}e.getIdAndVersion=d;function h(o,n){return`${o}.${n}`}e.getExtensionId=h;function y(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function C(o,n){return y(h(o,n))}e.getGalleryExtensionId=C;function p(o,n){const r=[],s=c=>{for(const l of r)if(l.some(P=>m(n(P),n(c))))return l;return null};for(const c of o){const l=s(c);l?l.push(c):r.push([c])}return r}e.groupByExtension=p;function S(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function f(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function g(o,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&r.every(l=>!m(l.identifier,{id:c}))){const l=o.filter(P=>m(P.identifier,{id:c}));l.length===1&&(r.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=g;async function a(o,n){if(!R.isLinux)return!1;let r;try{r=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,E.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=a;async function i(o,n){const r=await a(o,n),s=(0,t.getTargetPlatform)(r?"alpine":R.platform,u.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(te[72],ie([0,1,8,18,2,31,7,111,14,4,6]),function(z,e,w,t,k,R,D,E,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let v=class extends k.Disposable{constructor(d,h){super(),this.fileService=d,this.logService=h,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(d){return this.withProfileExtensions(d)}addExtensionsToProfile(d,h){return this.withProfileExtensions(h,y=>(y=y.filter(C=>d.some(([p])=>!(0,E.areSameExtensions)(C.identifier,p.identifier))),y.push(...d.map(([C,p])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:p}))),y))}removeExtensionFromProfile(d,h){return this.withProfileExtensions(h,y=>y.filter(C=>!(0,E.areSameExtensions)(C.identifier,d)))}async withProfileExtensions(d,h){return this.getResourceAccessQueue(d).queue(async()=>{let y=[];try{const C=await this.fileService.readFile(d),p=JSON.parse(C.value.toString());for(const S of p){if(!S.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",S);continue}if(!S.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",S);continue}if(!S.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",S);continue}y.push({identifier:S.identifier,location:D.URI.revive(S.location),version:S.version,metadata:S.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(h){y=h(y);const C=y.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(d,t.VSBuffer.fromString(JSON.stringify(C)))}return y})}getResourceAccessQueue(d){let h=this.resourcesAccessQueueMap.get(d);return h||(h=new w.Queue,this.resourcesAccessQueueMap.set(d,h)),h}};v=ve([ee(0,u.IFileService),ee(1,I.ILogService)],v),e.ExtensionsProfileScannerService=v}),define(te[219],ie([0,1,8,18,23,17,3,2,29,100,218,63]),function(z,e,w,t,k,R,D,E,u,m,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var d;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function h(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(B){const $=new k.CancellationTokenSource;return setTimeout(()=>$.cancel(),B),$.token}function C(B,$){if(B.isCancellationRequested||$.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),$.onCancellationRequested(()=>L.cancel()),L.token}class p{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new E.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function S(B,$){const L=new p($);return L.registerDisposable(B.onControlMessage(O=>{const _=JSON.parse(O.toString()),j=W(_);j?L.reject(j):L.resolve(_)})),L.promise}function f(B,$,L,O,_,j,Y,oe){const q=new p(oe);return $.connect(L,O,_,j,Y,(re,ne)=>{q.didTimeout?(re&&B.error(re),ne?.dispose()):re||!ne?q.reject(re):q.resolve(ne)}),q.promise}function g(B,$){const L=new p($);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function a(B,$,L,O){const _=U(B,$);B.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let j;try{j=await f(B.logService,B.socketFactory,B.host,B.port,(0,v.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${h($)}-${B.reconnectionToken}`,O)}catch(ne){throw B.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ne),ne}B.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let Y,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(j,null),Y=B.reconnectionProtocol,oe=!1):(Y=new m.PersistentProtocol(j,null),oe=!0),B.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const q=await g(B.signService.createNewMessage((0,u.generateUuid)()),O),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:q.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(re)));try{const ne=await S(Y,C(O,y(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(B.logService.trace(`${_} 4/6. received SignRequest control message.`),!await g(B.signService.validate(q,ne.signedData),O)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const ge=await g(B.signService.sign(ne.data),O),De={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:$};return L&&(De.args=L),B.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:Y,ownsProtocol:oe}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(B.logService.error(`${_} the handshake timed out. Error:`),B.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${_} received error control message when negotiating connection. Error:`),B.logService.error(ne)),oe&&H(Y),ne}}async function i(B,$,L,O){const _=Date.now(),j=U(B,$),{protocol:Y,ownsProtocol:oe}=await a(B,$,L,O),q=new p(O);return q.registerDisposable(Y.onControlMessage(re=>{const ne=JSON.parse(re.toString()),ce=W(ne);ce?(B.logService.error(`${j} received error control message when negotiating connection. Error:`),B.logService.error(ce),oe&&H(Y),q.reject(ce)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${J(_)}!`),q.resolve({protocol:Y,firstMessage:ne}))})),q.promise}async function o(B,$){const{protocol:L}=await i(B,1,void 0,$);return{protocol:L}}async function n(B,$,L){const{protocol:O,firstMessage:_}=await i(B,2,$,L),j=_&&_.debugPort;return{protocol:O,debugPort:j}}async function r(B,$,L){const O=Date.now(),_=U(B,3),{protocol:j}=await a(B,3,$,L);return B.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${J(O)}!`),j}async function s(B,$,L){const{host:O,port:_,connectionToken:j}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:_,connectionToken:j,reconnectionToken:$,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function c(B,$,L){return P(B,async O=>{const{protocol:_}=await o(O,k.CancellationToken.None);return new he(B,$,L,O.reconnectionToken,_)})}e.connectRemoteAgentManagement=c;async function l(B,$){return P(B,async L=>{const{protocol:O,debugPort:_}=await n(L,$,k.CancellationToken.None);return new V(B,$,L.reconnectionToken,O,_)})}e.connectRemoteAgentExtensionHost=l;async function P(B,$){for(let O=1;;O++)try{const _=(0,u.generateUuid)(),j=await s(B,_,null);return await $(j)}catch(_){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(_);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(_),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(_)),_}}async function M(B,$,L){const O=await s(B,(0,u.generateUuid)(),null);return await r(O,{host:$,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(B){return(0,w.createCancelablePromise)($=>new Promise((L,O)=>{const _=setTimeout(L,B*1e3);$.onCancellationRequested(()=>{clearTimeout(_),L()})}))}var N;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class X{constructor($,L){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=X;class ae{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=ae;class Q{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=Q;class G{constructor($,L,O){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=G;class Z{constructor($,L,O,_){this.reconnectionToken=$,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=Z;class se extends E.Disposable{static triggerPermanentFailure($,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}constructor($,L,O,_,j){super(),this._connectionType=$,this._options=L,this.reconnectionToken=O,this.protocol=_,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new G(this.reconnectionToken,0,0)),this._register(_.onSocketClose(Y=>{const oe=F(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(Y=>{const oe=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,E.toDisposable)(()=>{const Y=se._instances.indexOf(this);Y>=0&&se._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const $=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const _=O<L.length?L[O]:L[L.length-1];try{if(_>0){const Y=T(_);this._onDidStateChange.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,Y)),this._options.logService.info(`${$} waiting for ${_} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${$} resolving connection...`);const j=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,y(b)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,R.isCancellationError)(j)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,I.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure($,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure($,L,O):this._gotoPermanentFailure($,L,O)}_gotoPermanentFailure($,L,O){this._onDidStateChange.fire(new Z(this.reconnectionToken,$,L,O)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class he extends se{constructor($,L,O,_,j){super(1,$,_,j,!0),this.client=this._register(new m.Client(j,{remoteAuthority:L,clientId:O},$.ipcLogger))}async _reconnect($,L){await o($,L)}}e.ManagementPersistentConnection=he;class V extends se{constructor($,L,O,_,j){super(2,$,O,_,!1),this._startArguments=L,this.debugPort=j}async _reconnect($,L){await n($,this._startArguments,L)}}e.ExtensionHostPersistentConnection=V;function H(B){try{B.acceptDisconnect();const $=B.getSocket();B.dispose(),$.dispose()}catch($){(0,R.onUnexpectedError)($)}}function W(B){if(B&&B.type==="error"){const $=new Error(`Connection error: ${B.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function A(B,$){for(;B.length<$;)B+=" ";return B}function F(B,$,L){return`[remote-connection][${A(h(B),13)}][${$.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function U(B,$){return`${F($,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function J(B){return`${Date.now()-B} ms`}}),define(te[220],ie([0,1,77,83]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,E,u,m){const I=b=>m(b,void 0),v=w.createConnection({host:k,port:R},()=>{v.removeListener("error",I);const b=Buffer.alloc(16);for(let C=0;C<16;C++)b[C]=Math.round(Math.random()*256);const d=b.toString("base64"),h=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];v.write(h.join(`\r
`)+`\r
\r
`);const y=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",y),m(void 0,new t.NodeSocket(v,u)))};v.on("data",y)});v.setNoDelay(!0),v.once("error",I)}}}),define(te[221],ie([0,1,27,45,40,183]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function E(d=!1){return(D===void 0||d)&&(D=u()),D}e.hasWSLFeatureInstalled=E;async function u(){const d=m();if(d===void 0)return!1;if(d>=22e3){const h=v();if(h)return new Promise(y=>{t.execFile(h,["--status"],C=>y(!C))})}else{const h=b();if(h)try{if((await k.promises.stat(h)).isFile())return!0}catch{}}return!1}function m(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());if(d)return parseInt(d[3])}function I(d){const h=process.env.SystemRoot;if(h){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(h,y?"Sysnative":"System32",d)}}function v(){return I("wsl.exe")}function b(){return I("lxss\\LxssManager.dll")}}),define(te[55],ie([0,1,18,166,62,4,47]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function E(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=E;function u(y){return y.res.statusCode===204}async function m(y){return u(y)?null:(await(0,w.streamToBuffer)(y.stream)).toString()}e.asText=m;async function I(y){if(!E(y))throw new Error("Server returned "+y.res.statusCode);return m(y)}e.asTextOrError=I;async function v(y){if(!E(y))throw new Error("Server returned "+y.res.statusCode);if(u(y))return null;const p=(await(0,w.streamToBuffer)(y.stream)).toString();try{return JSON.parse(p)}catch(S){throw S.message+=`:
`+p,S}}e.asJson=v;function b(y){h(y)}e.updateProxyConfigurationsScope=b;let d;function h(y){const C=D.Registry.as(k.Extensions.Configuration),p=d;d={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[d],remove:p?[p]:[]})}h(2)}),define(te[222],ie([0,1,18,23]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(E){this.service=E}listen(E,u){throw new Error("Invalid listen")}call(E,u,m,I=t.CancellationToken.None){switch(u){case"request":return this.service.request(m[0],I).then(async({res:v,stream:b})=>{const d=await(0,w.streamToBuffer)(b);return[{statusCode:v.statusCode,headers:v.headers},d]});case"resolveProxy":return this.service.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(E){this.channel=E}async request(E,u){const[m,I]=await this.channel.call("request",[E],u);return{res:m,stream:(0,w.bufferToStream)(I)}}async resolveProxy(E){return this.channel.call("resolveProxy",[E])}}e.RequestChannelClient=R}),define(te[223],ie([0,1,224,12]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,E){return D.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:D.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(D,E,u={}){const m=(0,w.parse)(D),I=u.proxyUrl||k(m,E);if(!I)return null;const v=(0,w.parse)(I);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,t.isBoolean)(u.strictSSL)?u.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((d,h)=>{z(["http-proxy-agent"],d,h)}))(b):new(await new Promise((d,h)=>{z(["https-proxy-agent"],d,h)}))(b)}e.getProxyAgent=R}),define(te[112],ie([0,1,45,9,167,23,44,17,5,29,143,59,8]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const d=1e4;let h;async function y(p,S,f){return S["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(f)&&!S["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(f)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=b.Promises.withAsyncBody(async(g,a)=>{const i=new R.CancellationTokenSource,o=setTimeout(()=>{i.dispose(!0),a(new Error((0,k.localize)(0,null)))},d);try{g(await C(p,i.token))}catch(n){!(0,E.isCancellationError)(n)&&!i.token.isCancellationRequested?a(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(n)))):g({})}finally{clearTimeout(o),i.dispose()}})),h)}e.getResolvedShellEnv=y;async function C(p,S){const f=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",f);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",g);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const n=await(0,I.getSystemShell)(u.OS,o);return p.trace("getUnixShellEnvironment#shell",n),new Promise((r,s)=>{if(S.isCancellationRequested)return s((0,E.canceled)());const c=(0,t.basename)(n);let l,P;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(l=`& '${process.execPath}' ${M} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,P=["-Login","-Command"]):(l=`'${process.execPath}' ${M} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"?P=["-ic"]:P=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const T=(0,w.spawn)(n,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});S.onCancellationRequested(()=>(T.kill(),s((0,E.canceled)()))),T.on("error",ae=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ae)),s(ae)});const N=[];T.stdout.on("data",ae=>N.push(ae));const X=[];T.stderr.on("data",ae=>X.push(ae)),T.on("close",(ae,Q)=>{const G=Buffer.concat(N).toString("utf8");p.trace("getUnixShellEnvironment#raw",G);const Z=Buffer.concat(X).toString("utf8");if(Z.trim()&&p.trace("getUnixShellEnvironment#stderr",Z),ae||Q)return s(new Error((0,k.localize)(2,null,ae,Q)));const se=i.exec(G),he=se?se[1]:"{}";try{const V=JSON.parse(he);f?V.ELECTRON_RUN_AS_NODE=f:delete V.ELECTRON_RUN_AS_NODE,g?V.ELECTRON_NO_ATTACH_CONSOLE=g:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",V),r(V)}catch(V){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(V)),s(V)}})})}}),define(te[87],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[225],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>z(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const E=String(w._nextId++);return this.validators.set(E,D),{id:E,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=w,w._nextId=1}),define(te[38],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(te[22],ie([0,1,15,41,8,3,2,5,34,12,4,6,38,26]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var h;(function(p){p[p.QUIT=1]="QUIT",p[p.KILL=2]="KILL"})(h=e.ShutdownReason||(e.ShutdownReason={}));var y;(function(p){p[p.Starting=1]="Starting",p[p.Ready=2]="Ready",p[p.AfterWindowOpen=3]="AfterWindowOpen",p[p.Eventually=4]="Eventually"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let C=class Ct extends D.Disposable{get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(S,f,g){super(),this.logService=S,this.stateMainService=f,this.environmentMainService=g,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(Ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(Ct.QUIT_AND_RESTART_KEY)}registerListeners(){const S=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};w.app.addListener("before-quit",S);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",f),w.app.once("will-quit",g=>{this.trace("Lifecycle#app.on(will-quit)"),g.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",S),w.app.removeListener("window-all-closed",f),w.app.quit()})})}fireOnWillShutdown(S){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const f=[];return this._onWillShutdown.fire({reason:S,join(g){f.push(g)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(f)}catch(g){this.logService.error(g)}try{await this.stateMainService.close()}catch(g){this.logService.error(g)}})(),this.pendingWillShutdownPromise}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===S)return;this.trace(`lifecycle (main): phase changed (value: ${S})`),this._phase=S;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(S){if(S<=this._phase)return;let f=this.phaseWhen.get(S);f||(f=new k.Barrier,this.phaseWhen.set(S,f)),await f.wait()}registerWindow(S){const f=new D.DisposableStore;this.windowCounter++,f.add(S.onWillLoad(a=>this._onWillLoadWindow.fire({window:S,workspace:a.workspace,reason:a.reason})));const g=(0,m.assertIsDefined)(S.win);g.on("close",a=>{const i=S.id;if(this.windowToCloseRequest.has(i)){this.windowToCloseRequest.delete(i);return}this.trace(`Lifecycle#window.on('close') - window ID ${S.id}`),a.preventDefault(),this.unload(S,1).then(o=>{if(o){this.windowToCloseRequest.delete(i);return}this.windowToCloseRequest.add(i),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this._onBeforeCloseWindow.fire(S),S.close()})}),g.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(S,f){await this.unload(S,3)||S.reload(f)}unload(S,f){const g=this.mapWindowIdToPendingUnload.get(S.id);if(g)return g;const a=this.doUnload(S,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(S.id)});return this.mapWindowIdToPendingUnload.set(S.id,a),a}async doUnload(S,f){if(!S.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${S.id}`);const g=this._quitRequested?2:f,a=await this.onBeforeUnloadWindowInRenderer(S,g);return a?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.handleWindowUnloadVeto(a)):(await this.onWillUnloadWindowInRenderer(S,g),!1)}handleWindowUnloadVeto(S){return S?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(S){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(S),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(S,f){return new Promise(g=>{const a=this.oneTimeListenerTokenGenerator++,i=`vscode:ok${a}`,o=`vscode:cancel${a}`;t.validatedIpcMain.once(i,()=>{g(!1)}),t.validatedIpcMain.once(o,()=>{g(!0)}),S.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:o,reason:f})})}onWillUnloadWindowInRenderer(S,f){return new Promise(g=>{const i=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(i,()=>g()),S.send("vscode:onWillUnload",{replyChannel:i,reason:f})})}quit(S){return this.trace(`Lifecycle#quit() - begin (willRestart: ${S})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(S&&this.stateMainService.setItem(Ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}trace(S){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(S):this.logService.trace(S)}async relaunch(S){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(S?.addArgs&&f.push(...S.addArgs),S?.removeArgs)for(const i of S.removeArgs){const o=f.indexOf(i);o>=0&&f.splice(o,1)}const g=()=>{try{if(E.isWindows){const i=(0,u.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.logService.error(i)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:f})};w.app.once("quit",g),await this.quit(!0)&&w.app.removeListener("quit",g)}async kill(S){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const f of w.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let g;f.webContents&&!f.webContents.isDestroyed()?g=new Promise(a=>f.once("closed",a)):g=Promise.resolve(),f.destroy(),await g}})()]),w.app.exit(S)}};C.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",C=ve([ee(0,v.ILogService),ee(1,b.IStateMainService),ee(2,d.IEnvironmentMainService)],C),e.LifecycleMainService=C}),define(te[226],ie([0,1,5,3,2,4,22]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let E=class extends k.Disposable{constructor(I){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((v,b)=>{z(["native-keymap"],v,b)});this._keyboardLayoutData=u(I),w.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=u(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=ve([ee(0,D.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function u(m){const I=m.getKeyMap(),v=m.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:v}}}),define(te[227],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,w.createDecorator)("stateService")}),define(te[228],ie([0,1,8,18,12,36,14,6]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class u{constructor(v,b,d){this.storagePath=v,this.logService=b,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}}getItem(v,b){const d=this.storage[v];return(0,k.isUndefinedOrNull)(d)?b:d}setItem(v,b){this.setItems([{key:v,data:b}])}setItems(v){let b=!1;for(const{key:d,data:h}of v)this.storage[d]!==h&&((0,k.isUndefinedOrNull)(h)?(0,k.isUndefined)(this.storage[d])||(this.storage[d]=void 0,b=!0):(this.storage[d]=h,b=!0));b&&this.save()}removeItem(v){(0,k.isUndefined)(this.storage[v])||(this.storage[v]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const v=JSON.stringify(this.storage,null,4);if(v!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(v)),this.lastSavedStorageContents=v}catch(b){this.logService.error(b)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=u;let m=class{constructor(v,b,d){this.fileStorage=new u(v.stateResource,b,d)}async init(){await this.fileStorage.init()}getItem(v,b){return this.fileStorage.getItem(v,b)}};m=ve([ee(0,R.IEnvironmentService),ee(1,E.ILogService),ee(2,D.IFileService)],m),e.StateService=m}),define(te[229],ie([0,1,228]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends w.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(te[113],ie([0,1,5,34,7,29]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(m){if(w.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function E(m,I,v,b,d,h,y,C,p,S){const f=Object.create(null);f["common.machineId"]=y,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=d,f.version=h,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,w.PlatformToString)(w.platform),f["common.nodePlatform"]=t.platform,f["common.nodeArch"]=b,f["common.product"]=S||"desktop",C&&(f["common.msftInternal"]=C);let g=0;const a=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),w.isLinuxSnap&&(f["common.snap"]="true");const i=D(v);i&&(f["common.platformDetail"]=i);try{const o=await m.readFile(k.URI.file(p));f["common.source"]=o.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=E;function u(m){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const v=I.toLowerCase();return m.some(b=>v===b)}e.verifyMicrosoftInternalDomain=u}),define(te[32],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[230],ie([0,1,27,57,8,43,13,9,5,7,81,21,99,84,14,20,32]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function S(o,n){const r=`${o}::${n.join(":")}`,s=p.get(r);if(s)return s;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,P=new Map,M=2e4;function T(X,ae,Q,G){const Z=ae.substring(X.length+1);return k.Promises.withAsyncBody(async se=>{let he;try{he=await v.Promises.readdir(ae,{withFileTypes:!0})}catch{se();return}if(G.count>=M){G.count+=he.length,G.maxReached=!0,se();return}let V=he.length;if(V===0){se();return}let H=he;G.count+he.length>M&&(G.maxReached=!0,V=M-G.count,H=he.slice(0,V)),G.count+=he.length;for(const W of H)if(W.isDirectory()){if(Q.includes(W.name)||await T(X,(0,E.join)(ae,W.name),Q,G),--V===0){se();return}}else{const A=W.name.lastIndexOf(".");if(A>=0){const F=W.name.substring(A+1);F&&l.set(F,(l.get(F)??0)+1)}for(const F of c)F.relativePathPattern?.test(Z)!==!1&&F.filePattern.test(W.name)&&P.set(F.tag,(P.get(F.tag)??0)+1);if(--V===0){se();return}}})}const N=k.Promises.withAsyncBody(async X=>{const ae={count:0,maxReached:!1};await T(o,o,n,ae);const Q=await a(o);X({configFiles:f(P),fileTypes:f(l),fileCount:ae.count,maxFilesReached:ae.maxReached,launchConfigFiles:Q})});return p.set(r,N),N}e.collectWorkspaceStats=S;function f(o){return[...t.Iterable.map(o.entries(),([n,r])=>({name:n,count:r}))].sort((n,r)=>r.count-n.count)}function g(){const o={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},n=w.cpus();return n&&n.length>0&&(o.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),o}e.getMachineInfo=g;async function a(o){try{const n=new Map,r=(0,E.join)(o,".vscode","launch.json"),s=await v.Promises.readFile(r),c=[],l=(0,R.parse)(s.toString(),c);if(c.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const P of l.configurations){const M=P.type;M&&(n.has(M)?n.set(M,n.get(M)+1):n.set(M,1))}return f(n)}catch{return[]}}e.collectLaunchConfigs=a;let i=class{constructor(n,r){this.telemetryService=n,this.productService=r}formatMachineInfo(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}formatEnvironment(n){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const s=w.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(w.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),u.isWindows||r.push(`Load (avg):       ${w.loadavg().map(c=>Math.round(c)).join(", ")}`),r.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,b.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async s=>{let[c,l]=s,P=this.formatProcessList(n,c);return r.forEach(M=>{if((0,d.isRemoteDiagnosticError)(M))P+=`
${M.errorMessage}`,l+=`
${M.errorMessage}`;else if(P+=`

Remote: ${M.hostName}`,M.processes&&(P+=`
${this.formatProcessList(n,M.processes)}`),M.workspaceMetadata){l+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const N=M.workspaceMetadata[T];let X=`${N.fileCount} files`;N.maxFilesReached&&(X=`more than ${X}`),l+=`|    Folder (${T}): ${X}`,l+=this.formatWorkspaceStats(N)}}}),{processInfo:P,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:s,vmHint:c,os:l,cpus:P}=g(),M={os:l,memory:s,cpus:P,vmHint:c,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return u.isWindows||(M.load=`${w.loadavg().map(T=>Math.round(T)).join(", ")}`),u.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(n,r){const s=[];return(0,b.listProcesses)(n.mainPID).then(async c=>(s.push(""),s.push(this.formatEnvironment(n)),s.push(""),s.push(this.formatProcessList(n,c)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(n))),r.forEach(l=>{if((0,d.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(n,l.processes)),l.workspaceMetadata)for(const P of Object.keys(l.workspaceMetadata)){const M=l.workspaceMetadata[P];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${P}): ${T}`),s.push(this.formatWorkspaceStats(M))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(n){const r=[];let c=0;const l=(N,X)=>{const ae=` ${N}(${X})`;c+ae.length>60?(r.push(P),P="|                 ",c=P.length):c+=ae.length,P+=ae};let P="|      File types:";const M=10,T=n.fileTypes.length>M?M:n.fileTypes.length;for(let N=0;N<T;N++){const X=n.fileTypes[N];l(X.name,X.count)}if(r.push(P),n.configFiles.length>=0&&(P="|      Conf files:",c=0,n.configFiles.forEach(N=>{l(N.name,N.count)}),r.push(P)),n.launchConfigFiles.length>0){let N="|      Launch Configs:";n.launchConfigFiles.forEach(X=>{N+=X.count>1?` ${X.name}(${X.count})`:` ${X.name}`}),r.push(N)}return r.join(`
`)}expandGPUFeatures(n){const r=Math.max(...Object.keys(n).map(s=>s.length));return Object.keys(n).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${n[s]}`).join(`
                  `)}formatWorkspaceMetadata(n){const r=[],s=[];return n.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(r.push(`|  Window (${c.title})`),c.folderURIs.forEach(l=>{const P=m.URI.revive(l);if(P.scheme===D.Schemas.file){const M=P.fsPath;s.push(S(M,["node_modules",".git"]).then(T=>{let N=`${T.fileCount} files`;T.maxFilesReached&&(N=`more than ${N}`),r.push(`|    Folder (${(0,E.basename)(M)}): ${N}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else r.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(c=>r.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(n,r){const s=new Map;n.windows.forEach(l=>s.set(l.pid,l.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(n.mainPID,s,c,r,0),c.join(`
`)}formatProcessItem(n,r,s,c,l){const P=l===0;let M;P?M=c.pid===n?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(l)} ${c.name}`,c.name==="window"&&(M=`${M} (${r.get(c.pid)})`));const T=process.platform==="win32"?c.mem:w.totalmem()*(c.mem/100);s.push(`${c.load.toFixed(0).padStart(5," ")}	${(T/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(c.children)&&c.children.forEach(N=>this.formatProcessItem(n,r,s,N,l+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:s}of n.folders){const c=m.URI.revive(s);if(c.scheme!==D.Schemas.file)continue;const l=c.fsPath;try{(await S(l,["node_modules",".git"])).fileTypes.forEach(M=>r.add(M.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const s=m.URI.revive(r);if(s.scheme!==D.Schemas.file)continue;const c=s.fsPath;try{const l=await S(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:P.name,count:P.count})}),l.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:P.name,count:P.count})}),l.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};i=ve([ee(0,C.ITelemetryService),ee(1,y.IProductService)],i),e.DiagnosticsService=i}),define(te[231],ie([0,1,8,2,6,21,27,9,32,214]),function(z,e,w,t,k,R,D,E,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;class I{constructor(d,h){this.node=d,this.callFrame=h,this.children=[],this.selfTime=-1,this.totalTime=-1}toString(){return`${this.callFrame.url}#${this.callFrame.functionName}@${this.callFrame.lineNumber}:${this.callFrame.columnNumber}`}static makeTotals(d){if(d.totalTime!==-1)return d.totalTime;let h=d.selfTime;for(const y of d.children)h+=I.makeTotals(y);return d.totalTime=h,h}}let v=class{constructor(d,h,y,C){this._window=d,this._sessionId=h,this._logService=y,this._telemetryService=C,this._profileAtOrAfter=0,this._session=new t.DisposableStore,this._isStarted=!1}async stop(){await this._isProfiling,this._logService.warn("[perf] STOPPING to monitor renderer",this._sessionId),this._session.clear();try{const d=this._window.webContents.debugger;await d.sendCommand("Profiler.disable"),d.detach()}catch{this._logService.error("[perf] FAILED to disable profiler",this._sessionId)}}receiveHeartbeat(){this._profileAtOrAfter=Date.now()+1e3}async start(){if(this._isStarted){this._logService.warn("[perf] already STARTED, ignoring request",this._sessionId);return}try{const h=this._window.webContents.debugger;h.attach(),await h.sendCommand("Profiler.enable")}catch{this._logService.error("[perf] FAILED to enable profiler",this._sessionId);return}this._logService.warn("[perf] started to EXPECT frequent heartbeat",this._sessionId),this._session.clear(),this._profileAtOrAfter=Date.now();const d=setInterval(()=>{Date.now()>=this._profileAtOrAfter&&(clearInterval(d),this._captureRendererProfile())},500);this._session.add((0,t.toDisposable)(()=>{this._isStarted=!1,clearInterval(d)}))}async _captureRendererProfile(){this._logService.warn("[perf] MISSED heartbeat, trying to profile renderer",this._sessionId);const d=(async()=>{const h=this._window.webContents.debugger;await h.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,w.timeout)(5e3);const y=await h.sendCommand("Profiler.stop");this._logService.warn("[perf] profiling DONE",this._sessionId),await this._store(y.profile),this._digest(y.profile)})();this._isProfiling=d.catch(h=>{this._logService.error("[perf] profiling the renderer FAILED",this._sessionId),this._logService.error(h)}).finally(()=>{this._isProfiling=void 0})}async _store(d){try{const h=(0,E.join)((0,D.tmpdir)(),`renderer-profile-${Date.now()}.cpuprofile`);await R.Promises.writeFile(h,JSON.stringify(d)),this._logService.info("[perf] stored profile to DISK",this._sessionId,h)}catch(h){this._logService.error("[perf] FAILED to write profile to disk",this._sessionId,h)}}_digest(d){if(!d.samples||!d.timeDeltas){this._logService.warn("[perf] INVALID profile: no samples or timeDeltas",this._sessionId);return}m.Utils.rewriteAbsolutePaths(d,"piiRemoved");const h=new Map;for(const f of d.nodes)h.set(f.id,new I(f,f.callFrame));for(const f of d.nodes)if(f.children){const g=h.get(f.id);for(const a of f.children){const i=h.get(a);g.children.push(i),i.parent=g}}let C=d.endTime-d.startTime-d.timeDeltas[0];for(let f=0;f<d.samples.length-1;f++){const g=d.samples[f],a=h.get(g);if(a){const i=d.timeDeltas[f+1];a.selfTime+=i,C-=i}}const p=h.get(d.samples[d.samples.length-1]);p&&(p.selfTime+=C),h.forEach(I.makeTotals);const S=Array.from(h.values()).sort((f,g)=>g.selfTime-f.selfTime);if(S[0].callFrame.functionName==="(idle)"){this._logService.warn("[perf] top stack is IDLE, ignoring this profile...",this._sessionId),this._telemetryService.publicLog2("prof.sample",{sessionId:this._sessionId,selfTime:0,totalTime:0,functionName:"(idle)",callstack:""});return}for(let f=0;f<S.length&&!(f>4);f++){const g=S[f],a=[];let i=g;for(;i;)a.push(i.toString()),i=i.parent;const o={sessionId:this._sessionId,selfTime:g.selfTime/1e3,totalTime:g.totalTime/1e3,functionName:g.callFrame.functionName,callstack:a.join(`
`)};this._telemetryService.publicLog2("prof.freeze.sample",o)}}};v=ve([ee(2,k.ILogService),ee(3,u.ITelemetryService)],v),e.WindowProfiler=v}),define(te[232],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:E,data:u}){return this.appenders.forEach(m=>m.log(E,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[73],ie([0,1,50,95,12,19,113,32]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class m{async publicLog(i,o,n){}async publicLogError(i,o,n){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(a,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:p(o.sourceConfig)})})}e.configurationTelemetry=I;function v(a,i){return!(i.disableTelemetry||!a.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=v;function b(a){const i=a.getValue(E.TELEMETRY_SETTING_ID),o=a.getValue("telemetry.enableCrashReporter");if(a.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function d(a){const i={},o={},n={};C(a,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const s=n[r];typeof s=="number"?o[r]=s:typeof s=="boolean"?o[r]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${s.length}`),i[r]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(i[r]=s)}return{properties:i,measurements:o}}e.validateTelemetryData=d;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function y(a){if(!a)return"none";for(const i of h)if(a.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=y;function C(a,i,o=0,n){if(!!a)for(const r of Object.getOwnPropertyNames(a)){const s=a[r],c=n?n+r:r;Array.isArray(s)?i[c]=(0,w.safeStringify)(s):s instanceof Date?i[c]=s.toISOString():(0,k.isObject)(s)?o<2?C(s,i,o+1,c+"."):i[c]=(0,w.safeStringify)(s):i[c]=s}}function p(a){if(!a)return[];const i=[];return S(i,"",a),i}function S(a,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(n=>S(a,i?`${i}.${n}`:n,o[n])):a.push(i)}function f(a,i){const o=a.msftInternalDomains||[],n=i.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(o)||n}e.isInternalTelemetry=f;function g(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=g}),define(te[233],ie([0,1,189,73]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,E,u,m,I,v){const b={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,t.supportsTelemetry)(D,E)&&(0,t.getTelemetryLevel)(u)===3){const d=await(0,w.getServiceMachineId)(E,m,I),{sessionId:h}=await v.getTelemetryInfo();b["X-Market-User-Id"]=d,b["VSCode-SessionId"]=h}return b}e.resolveMarketplaceHeaders=k}),define(te[234],ie([0,1,2,50,95,5,25,168,19,62,54,20,47,32,73]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(S,f,g){this._configurationService=f,this._productService=g,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const a of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(a),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,f){this._experimentProperties[S]=f}_updateTelemetryLevel(){let S=(0,h.getTelemetryLevel)(this._configurationService);const f=this._productService.enabledTelemetryLevels;if(f){this._sendErrorTelemetry=this.sendErrorTelemetry?f.error:!1;const g=f.usage?3:f.error?2:0;S=Math.min(S,g)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties,f=S.sessionID,g=S["common.machineId"],a=S["common.firstSessionDate"],i=S["common.msftInternal"];return{sessionId:f,machineId:g,firstSessionDate:a,msftInternal:i}}dispose(){this._disposables.dispose()}_log(S,f,g,a){return this.telemetryLevel.value<f?Promise.resolve(void 0):this._commonProperties.then(i=>{g=(0,t.mixin)(g,i),g=(0,t.mixin)(g,this._experimentProperties),g=(0,t.cloneAndChange)(g,o=>{if(typeof o=="string")return this._cleanupInfo(o,a)}),this._appenders.forEach(o=>o.log(S,g))},i=>{console.error(i)})}publicLog(S,f,g){return this._log(S,3,f,g)}publicLog2(S,f,g){return this.publicLog(S,f,g)}publicLogError(S,f){return this._sendErrorTelemetry?this._log(S,2,f,!0):Promise.resolve(void 0)}publicLogError2(S,f){return this.publicLogError(S,f)}_anonymizeFilePaths(S){let f=S;const g=[];for(const n of this._cleanupPatterns)for(;;){const r=n.exec(S);if(!r)break;g.push([r.index,n.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const n=i.exec(S);if(!n)break;!a.test(n[0])&&g.every(([r,s])=>n.index<r||n.index>=s)&&(f+=S.substring(o,n.index)+"<REDACTED: user-file-path>",o=i.lastIndex)}return o<S.length&&(f+=S.substr(o)),f}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const f=S.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const a of g)if(a.regex.test(f))return`<REDACTED: ${a.label}>`;return S}_cleanupInfo(S,f){let g=S;f&&(g=this._anonymizeFilePaths(g));for(const a of this._cleanupPatterns)g=g.replace(a,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ve([ee(1,u.IConfigurationService),ee(2,v.IProductService)],y),e.TelemetryService=y;function C(){const p=(0,E.localize)(0,null,I.default.nameLong),S=I.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.isWeb?"":(0,E.localize)(3,null),g=(0,E.localize)(4,null),a=(0,E.localize)(5,null),i=(0,E.localize)(6,null),o=(0,E.localize)(7,null),n=`
|       | ${g} | ${a} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,E.localize)(8,null);return`
${p} ${S} ${f}

&nbsp;

${o}
${n}

&nbsp;

${r}
`}b.Registry.as(m.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(m.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,E.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,E.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[235],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var w;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(w=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===w.HIGH_CONTRAST_DARK||R===w.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===w.DARK||R===w.HIGH_CONTRAST_DARK}e.isDark=k}),define(te[236],ie([0,1,119,3,2,4,47,235]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var u;(function(C){function p(S){return S&&typeof S=="object"&&typeof S.id=="string"}C.isThemeColor=p})(u=e.ThemeColor||(e.ThemeColor={}));function m(C){return{id:C}}e.themeColorFromId=m;var I;(function(C){function p(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||u.isThemeColor(r.color))}C.isThemeIcon=p;const S=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const s=S.exec(r);if(!s)return;const[,c]=s;return{id:c}}C.fromString=f;function g(r){return{id:r}}C.fromId=g;function a(r,s){let c=r.id;const l=c.lastIndexOf("~");return l!==-1&&(c=c.substring(0,l)),s&&(c=`${c}~${s}`),{id:c}}C.modify=a;function i(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}C.getModifier=i;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}C.isEqual=o;function n(r,s){return{id:r.id,color:s?m(s):void 0}}C.asThemeIcon=n,C.asClassNameArray=w.CSSIcon.asClassNameArray,C.asClassName=w.CSSIcon.asClassName,C.asCSSSelector=w.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function v(C){switch(C){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case E.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(p);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const d=new b;D.Registry.add(e.Extensions.ThemingContribution,d);function h(C){return d.onColorThemeChange(C)}e.registerThemingParticipant=h;class y extends k.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,S){let f=this.theme.getColor(p);return f&&S&&(f=S(f,this.theme)),f?f.toString():null}}e.Themable=y}),define(te[64],ie([0,1,15,3,2,5,19,4,38]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",I="#1E1E1E",v="#000000",b="#FFFFFF",d="theme",h="themeBackground",y="windowSplash";e.IThemeMainService=(0,E.createDecorator)("themeMainService");let C=class extends k.Disposable{constructor(S,f){super(),this.stateMainService=S,this.configurationService=f,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors)return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&w.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:w.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const S=this.getColorScheme();if(S.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return S.dark?v:b;let f=this.stateMainService.getItem(h,null);if(!f)switch(this.stateMainService.getItem(d,"vs-dark").split(" ")[0]){case"vs":f=m;break;case"hc-black":f=v;break;case"hc-light":f=b;break;default:f=I}return R.isMacintosh&&f.toUpperCase()===I&&(f="#171717"),f}saveWindowSplash(S,f){this.stateMainService.setItems([{key:d,data:f.baseTheme},{key:h,data:f.colorInfo.background},{key:y,data:f}]),typeof S=="number"&&this.updateBackgroundColor(S,f)}updateBackgroundColor(S,f){for(const g of w.BrowserWindow.getAllWindows())if(g.id===S){g.setBackgroundColor(f.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(y)}};C=ve([ee(0,u.IStateMainService),ee(1,D.IConfigurationService)],C),e.ThemeMainService=C}),define(te[114],ie([0,1,3,5,4,6]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(y){y.Http="http",y.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(E=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var u;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(u=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=v;function b(y,C){return C?C!==1&&y<1024:!t.isWindows&&y<1024}e.isPortPrivileged=b;class d{constructor(C,p,S){this.remoteAddress=C,this.localAddress=p,this._dispose=S,this._onDispose=new w.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=d;let h=class{constructor(C){this.logService=C,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],p=Array.from(this._tunnels.values());for(const S of p){const f=Array.from(S.values());for(const g of f){const a=await g.value;a&&C.push(a)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:p}of C.values())await p.then(S=>S?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,p,S,f,g=!1,a,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${S} on local port ${f}.`),!C)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(C,p,S,f,g,a,i);return o?o.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(n);return(n.tunnelRemoteHost!==p||n.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const p=this._tunnels.get(C.tunnelRemoteHost);if(p){const S=p.get(C.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,S))}}}}async tryDisposeTunnel(C,p,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${p}.`);const f=S.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(p),f}}async closeTunnel(C,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${p} `);const S=this._tunnels.get(C);if(S&&S.has(p)){const f=S.get(p);f.refcount=0,await this.tryDisposeTunnel(C,p,f)}}addTunnelToMap(C,p,S){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(p,{refcount:1,value:S})}async removeEmptyTunnelFromMap(C,p){const S=this._tunnels.get(C);S&&(await S.get(p)||S.delete(p),S.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,p){const S=[C];I(C)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):v(C)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const f=S.map(g=>this._tunnels.get(g));for(const g of f){const a=g?.get(p);if(a)return a}}canTunnel(C){return!!m(C)}createWithProvider(C,p,S,f,g,a,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${S} on local port ${f}.`);const o=S;this._factoryInProgress.add(o);const r={elevationRequired:g?b(f===void 0?S:f):!1},s={remoteAddress:{host:p,port:S},localAddressPort:f,privacy:a,public:a?a!==E.Private:void 0,protocol:i},c=C.forwardPort(s,r);return c?(this.addTunnelToMap(p,S,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),c}};h=ve([ee(0,R.ILogService)],h),e.AbstractTunnelService=h}),define(te[237],ie([0,1,77,94,220,8,2,19,6,20,219,114,87]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function d(S,f,g,a,i){let o;for(let n=3;n&&(o?.dispose(),o=await new h(S,f,g,a,i).waitForReady(),!(i&&t.BROWSER_RESTRICTED_PORTS[i]||!t.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));n--);return o}class h extends D.Disposable{constructor(f,g,a,i,o){super(),this.defaultTunnelHost=g,this.suggestedLocalPort=o,this.privacy=v.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=w.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(g=>{g()})}async waitForReady(){let f=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),g=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(f){f.pause();const g=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,I.connectRemoteAgentTunnel)(this._options,g,this.tunnelRemotePort),i=a.getSocket().socket,o=a.readEntireBuffer();a.dispose(),o.byteLength>0&&f.write(o.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),i.end()}),f.on("close",()=>i.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),i.destroy()}),i.on("end",()=>f.end()),i.on("close",()=>f.end()),i.on("error",()=>{f.destroy()}),f.pipe(i),i.pipe(f),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),i.end()})}}let y=class extends v.AbstractTunnelService{constructor(f,g,a,i,o){super(g),this.socketFactory=f,this.signService=a,this.productService=i,this.configurationService=o}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,g,a,i,o,n,r){const s=this.getTunnelFromMap(g,a);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,g,a,i,o,n,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${g}:${a} on local port ${i}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},l=d(c,this.defaultTunnelHost,g,a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(g,a,l),l}}};y=ve([ee(1,u.ILogService),ee(2,b.ISignService),ee(3,m.IProductService),ee(4,E.IConfigurationService)],y),e.BaseTunnelService=y;let C=class extends y{constructor(f,g,a,i){super(k.nodeSocketFactory,f,g,a,i)}};C=ve([ee(0,u.ILogService),ee(1,b.ISignService),ee(2,m.IProductService),ee(3,E.IConfigurationService)],C),e.TunnelService=C;let p=class extends D.Disposable{constructor(f,g,a,i){super(),this.logService=f,this.productService=g,this.signService=a,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(f,g,a,i,o,n,r,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${o}.`),!this._tunnelServices.has(f)){const c=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(f,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(g,a,i,o,n,r,s)}};p=ve([ee(0,u.ILogService),ee(1,m.IProductService),ee(2,b.ISignService),ee(3,E.IConfigurationService)],p),e.SharedTunnelsService=p}),define(te[48],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(te[238],ie([0,1,5,169,62,47]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[239],ie([0,1,3,48]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(E){this.service=E}listen(E,u){switch(u){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${u}`)}call(E,u,m){switch(u){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(m)}throw new Error(`Call not found: ${u}`)}}e.UpdateChannel=k;class R{get state(){return this._state}set state(E){this._state=E,this._onStateChange.fire(E)}constructor(E){this.channel=E,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(u=>this.state=u),this.channel.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(E){return this.channel.call("checkForUpdates",E)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(E){return this.channel.call("_applySpecificUpdate",E)}}e.UpdateChannelClient=R}),define(te[88],ie([0,1,8,23,3,19,26,22,6,20,55,48]),function(z,e,w,t,k,R,D,E,u,m,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(h,y,C){return`${C.updateUrl}/api/update/${h}/${y}/${C.commit}`}e.createUpdateURL=b;let d=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,C,p,S,f,g){this.lifecycleMainService=y,this.configurationService=C,this.environmentMainService=p,this.requestService=S,this.logService=f,this.productService=g,this._state=v.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.getUpdateMode(),C=this.getProductQuality(y);if(!C){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(C),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(v.State.Idle(this.getUpdateType())),y==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(y){return y==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(y=60*60*1e3){return(0,w.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(y){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(y){}getUpdateType(){return 1}doQuitAndInstall(){}};d=ve([ee(0,E.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,D.IEnvironmentMainService),ee(3,I.IRequestService),ee(4,u.ILogService),ee(5,m.IProductService)],d),e.AbstractUpdateService=d}),define(te[240],ie([0,1,15,53,3,2,19,26,22,6,20,55,32,48,88]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let y=class extends h.AbstractUpdateService{get onRawError(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"error",(p,S)=>S)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(p,S,f)=>({url:S,version:f,productVersion:f}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(p,S,f,g)=>({releaseNotes:S,version:f,productVersion:f,date:g}))}constructor(p,S,f,g,a,i,o){super(p,S,g,a,i,o),this.telemetryService=f,this.disposables=new R.DisposableStore}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const f=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(d.State.Idle(1,f))}buildUpdateFeedUrl(p){let S;this.productService.darwinUniversalAssetId?S=this.productService.darwinUniversalAssetId:S=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,h.createUpdateURL)(S,p,this.productService);try{w.autoUpdater.setFeedURL({url:f})}catch(g){this.logService.error("Failed to set update feed URL",g);return}return f}doCheckForUpdates(p){this.setState(d.State.CheckingForUpdates(p)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(d.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(d.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],y.prototype,"onRawError",null),ve([t.memoize],y.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],y.prototype,"onRawUpdateAvailable",null),ve([t.memoize],y.prototype,"onRawUpdateDownloaded",null),y=ve([ee(0,u.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,b.ITelemetryService),ee(3,E.IEnvironmentMainService),ee(4,v.IRequestService),ee(5,m.ILogService),ee(6,I.IProductService)],y),e.DarwinUpdateService=y}),define(te[241],ie([0,1,45,40,8,3,9,26,22,6,32,48]),function(z,e,w,t,k,R,D,E,u,m,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{get state(){return this._state}setState(y){this.logService.info("update#setState",y.type),this._state=y,this._onStateChange.fire(y)}constructor(y,C,p){if(this.lifecycleMainService=y,this.logService=p,this._state=v.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,C.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(v.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}scheduleCheckForUpdates(y=60*60*1e3){return(0,k.timeout)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(y){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(y)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(y){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(y=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(y){}};b=ve([ee(0,u.ILifecycleMainService),ee(1,E.IEnvironmentMainService),ee(2,m.ILogService)],b);let d=class extends b{constructor(y,C,p,S,f,g){super(p,S,f),this.snap=y,this.snapRevision=C,this.telemetryService=g;const a=(0,t.watch)(D.dirname(this.snap)),i=R.Event.fromNodeEventEmitter(a,"change",(s,c)=>c),o=R.Event.filter(i,s=>s==="current"),r=R.Event.debounce(o,(s,c)=>c,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{r.dispose(),a.close()})}doCheckForUpdates(){this.setState(v.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(y=>{y?this.setState(v.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(v.State.Idle(2)))},y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(v.State.Idle(2,y.message||y))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const y=await new Promise((p,S)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(f,g)=>f?S(f):p(g))),C=D.basename(y);return this.snapRevision!==C}isLatestVersion(){return this.isUpdateAvailable().then(void 0,y=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=ve([ee(2,u.ILifecycleMainService),ee(3,E.IEnvironmentMainService),ee(4,m.ILogService),ee(5,I.ITelemetryService)],d),e.SnapUpdateService=d}),define(te[51],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,w.createDecorator)("IUriIdentityService")}),define(te[242],ie([0,1,51,190,14,16,126,3,2]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(b){this.uri=b,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let I=class{constructor(b){this._fileService=b,this._dispooables=new u.DisposableStore,this._limit=2**16;const d=new Map,h=y=>{let C=d.get(y.scheme);return C===void 0&&(C=b.hasProvider(y)&&!this._fileService.hasCapability(y,1024),d.set(y.scheme,C)),C};this._dispooables.add(E.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(y=>{d.delete(y.scheme)})),this.extUri=new R.ExtUri(h),this._canonicalUris=new D.SkipList((y,C)=>this.extUri.compare(y,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(b){this._fileService.hasProvider(b)&&(b=(0,R.normalizePath)(b));const d=this._canonicalUris.get(b);return d?d.touch().uri.with({fragment:b.fragment}):(this._canonicalUris.set(b,new m(b)),this._checkTrim(),b)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const b=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);m._clock=0,this._canonicalUris.clear();const d=this._limit*.5;for(let h=0;h<d;h++)this._canonicalUris.set(b[h][0],b[h][1].touch())}};I=ve([ee(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(w.IUriIdentityService,I,!0)}),define(te[115],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(te[243],ie([0,1,7]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(E){this.handler=E}listen(E,u){throw new Error(`Event not found: ${u}`)}call(E,u,m){switch(u){case"handleURL":return this.handler.handleURL(w.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${u}`)}}e.URLHandlerChannel=t;class k{constructor(E){this.channel=E}handleURL(E,u){return this.channel.call("handleURL",[E.toJSON(),u])}}e.URLHandlerChannelClient=k;class R{constructor(E){this.next=E}async routeCall(E,u,m,I){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(m){const v=w.URI.revive(m);if(v&&v.query){const b=/\bwindowId=(\d+)/.exec(v.query);if(b){const d=b[1],h=new RegExp(`window:${d}`),y=E.connections.find(C=>h.test(C.ctx));if(y)return y}}}return this.next.routeCall(E,u,m,I)}routeEvent(E,u){throw new Error(`Event not found: ${u}`)}}e.URLHandlerRouter=R}),define(te[244],ie([0,1,8,2,7,20]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(m,I){const v=[...this.handlers.values()];return(0,w.first)(v.map(b=>()=>b.handleURL(m,I)),void 0,!1).then(b=>b||!1)}registerHandler(m){return this.handlers.add(m),(0,t.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=D;let E=class extends D{constructor(m){super(),this.productService=m}create(m){let{authority:I,path:v,query:b,fragment:d}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&v&&v.indexOf("/")!==0&&(v=`/${v}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:v,query:b,fragment:d})}};E=ve([ee(0,R.IProductService)],E),e.NativeURLService=E}),define(te[245],ie([0,1,15,8,3,2,5,7]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function u(I){try{return E.URI.parse(I)}catch{return null}}class m{constructor(v,b,d,h,y){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=v,D.isWindows){const S=h.isBuilt?[]:[`"${h.appRoot}"`];S.push("--open-url","--"),w.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,S)}const C=k.Event.map(k.Event.fromNodeEventEmitter(w.app,"open-url",(S,f)=>({event:S,url:f})),({event:S,url:f})=>(S.preventDefault(),f));this.disposables.add(C(S=>{const f=u(S);!f||this.urlService.open(f,{originalUrl:S})})),d.getWindows().filter(S=>S.isReady).length>0?this.flush():k.Event.once(d.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const v=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||v.push(b);v.length!==0&&(this.uris=v,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(te[246],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(te[247],ie([0,1,15,2,13,7]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const u=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(k.Schemas.vscodeWebview,u)}handleWebviewRequest(u,m){try{const I=R.URI.parse(u.url),v=D.validWebviewFilePaths.get(I.path);if(typeof v=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${v}`,d=k.FileAccess.asFileUri(b,z);return m({path:decodeURIComponent(d.fsPath),headers:{...k.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[74],ie([0,1,5]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function k(I){return!!I.folderUri}e.isFolderToOpen=k;function R(I){return!!I.fileUri}e.isFileToOpen=R;function D(I){const v=E(I),b=I.getValue("window.menuBarVisibility");return b==="default"||v==="native"&&b==="compact"||w.isMacintosh&&w.isNative?"classic":b}e.getMenuBarVisibility=D;function E(I){if(w.isWeb)return"custom";const v=I.getValue("window");if(v){if(w.isMacintosh&&v.nativeTabs===!0||w.isMacintosh&&v.nativeFullScreen===!1)return"native";const h=v.titleBarStyle;if(h==="native"||h==="custom")return h}return w.isLinux?"native":"custom"}e.getTitleBarStyle=E;function u(I){if(!w.isWindows||w.isWeb||E(I)==="native")return!1;const v=I.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!1}e.useWindowControlsOverlay=u;function m(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=m}),define(te[116],ie([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(E){E[E.INITIAL=1]="INITIAL",E[E.LOAD=2]="LOAD",E[E.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var t;(function(E){E[E.CLOSE=1]="CLOSE",E[E.QUIT=2]="QUIT",E[E.RELOAD=3]="RELOAD",E[E.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(E=1){return{width:1024,height:768,mode:E}};e.defaultWindowState=k;var R;(function(E){E[E.Maximized=0]="Maximized",E[E.Normal=1]="Normal",E[E.Minimized=2]="Minimized",E[E.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(E){E[E.UNRESPONSIVE=1]="UNRESPONSIVE",E[E.PROCESS_GONE=2]="PROCESS_GONE",E[E.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(te[33],ie([0,1,4]),function(z,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(te[248],ie([0,1,15,23,3,66,2,29,69,104,6,20,33]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let h=class extends D.Disposable{constructor(C,p,S,f,g){super(),this.logService=C,this.windowsMainService=p,this.credentialsService=S,this.encryptionMainService=f,this.productService=g,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=d.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const C=k.Event.fromNodeEventEmitter(w.app,"login",(p,S,f,g,a)=>({event:p,webContents:S,req:f,authInfo:g,callback:a}));this._register(C(this.onLogin,this))}async onLogin({event:C,authInfo:p,req:S,callback:f}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===d.LoginDialogShown&&S.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}C.preventDefault();let g;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{g=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}f(g?.username,g?.password)}async resolveProxyCredentials(C){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(C);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(C){this.logService.trace("auth#doResolveProxyCredentials - enter",C);const p=String((0,R.hash)({scheme:C.scheme,host:C.host,port:C.port}));let S,f;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(o){const n=JSON.parse(await this.encryptionMainService.decrypt(o));S=n.username,f=n.password}}catch(o){this.logService.error(o)}if(this.state!==d.StoredCredentialsUsed&&typeof S=="string"&&typeof f=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=d.StoredCredentialsUsed,{username:S,password:f};const g=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!g){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const a={authInfo:C,username:this.sessionCredentials?.username??S,password:this.sessionCredentials?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.generateUuid)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,a),this.state=d.LoginDialogShown;const i=await new Promise(o=>{const n=async(r,s,c)=>{if(s===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",n),c){const l={username:c.username,password:c.password};try{if(c.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(P){this.logService.error(P)}o({username:l.username,password:l.password})}else o(void 0)};g.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=i,i}};h=ve([ee(0,I.ILogService),ee(1,b.IWindowsMainService),ee(2,u.ICredentialsMainService),ee(3,m.IEncryptionMainService),ee(4,v.IProductService)],h),e.ProxyAuthHandler=h}),define(te[249],ie([0,1,69,6,36,20,33,202]),function(z,e,w,t,k,R,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let u=class extends E.BaseCredentialsMainService{constructor(I,v,b,d){super(I),this.environmentMainService=v,this.productService=b,this.windowsMainService=d,this.surfaceKeytarLoadError=h=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",h.message??h)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((v,b)=>{z(["keytar"],v,b)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};u=ve([ee(0,t.ILogService),ee(1,k.INativeEnvironmentService),ee(2,R.IProductService),ee(3,D.IWindowsMainService)],u),e.CredentialsNativeMainService=u}),define(te[250],ie([0,1,17,2,3,6,22,79,45,280,8,13,50,5,34,15,33]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=y.UtilityProcess,S=typeof p<"u";let f=class Ut{constructor(o,n,r){this._logService=o,this._windowsMainService=r,this._shutdown=!1,this._extHosts=new Map,n.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const n=this._extHosts.get(o);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return S}async createExtensionHost(o){if(this._shutdown)throw(0,w.canceled)();const n=String(++Ut._lastId);let r;if(o){if(!S)throw new Error("Cannot use UtilityProcess!");r=new a(n,this._logService,this._windowsMainService)}else r=new g(n,this._logService);return this._extHosts.set(n,r),r.onExit(({pid:s,code:c,signal:l})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${c}, signal: ${l}.`),setTimeout(()=>{r.dispose(),this._extHosts.delete(n)})}),{id:n}}async start(o,n){if(this._shutdown)throw(0,w.canceled)();return this._getExtHost(o).start(n)}async enableInspectPort(o){if(this._shutdown)throw(0,w.canceled)();const n=this._extHosts.get(o);return n?n.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,w.canceled)();const n=this._extHosts.get(o);!n||n.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const n=[];for(const[,r]of this._extHosts)n.push(r.waitForExit(o));return I.Promises.settled(n).then(()=>{})}};f._lastId=0,f=ve([ee(0,R.ILogService),ee(1,D.ILifecycleMainService),ee(2,C.IWindowsMainService)],f),e.ExtensionHostStarter=f;let g=class extends t.Disposable{constructor(o,n){super(),this.id=o,this._logService=n,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){d.isCI&&this._logService.info("Calling fork to start extension host...");const n=E.StopWatch.create(!1);this._process=(0,u.fork)(v.FileAccess.asFileUri("bootstrap-fork",z).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,b.mixin)({cwd:(0,h.cwd)()},o));const r=n.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${r} ms).`);const c=new m.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const M=typeof P=="string"?P:c.write(P);this._onStdout.fire(M)});const l=new m.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const M=typeof P=="string"?P:l.write(P);this._onStderr.fire(M)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,w.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,M)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:P,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):d.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${n} did not exit within ${o}ms.`),this._process.kill())}};g=ve([ee(1,R.ILogService)],g);let a=class extends t.Disposable{constructor(o,n,r){super(),this.id=o,this._logService=n,this._windowsMainService=r,this.onError=k.Event.None,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const n=this._windowsMainService.getWindowById(o.responseWindowId);if(!n){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=n.win;if(!r||r.isDestroyed()||r.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,c=v.FileAccess.asFileUri("bootstrap-fork.js",z).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],P=o.execArgv||[],M={...o.env},T=!0;for(const Z of Object.keys(M))M[Z]=String(M[Z]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new p(c,l,{serviceName:s,env:M,execArgv:P,allowLoadingUnsignedLibraries:T});const N=new m.StringDecoder("utf-8");this._process.stdout?.on("data",Z=>{const se=typeof Z=="string"?Z:N.write(Z);this._onStdout.fire(se)});const X=new m.StringDecoder("utf-8");this._process.stderr?.on("data",Z=>{const se=typeof Z=="string"?Z:X.write(Z);this._onStderr.fire(se)}),this._process.on("message",Z=>{this._onMessage.fire(Z)}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const ae=k.Event.fromNodeEventEmitter(this._process,"exit",(Z,se)=>se);this._register(ae(Z=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${Z}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:Z,signal:""})}));const{port1:Q,port2:G}=new y.MessageChannelMain;this._process.postMessage("null",[G]),r.webContents.postMessage(o.responseChannel,o.responseNonce,[Q])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):!1):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const n=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};a=ve([ee(1,R.ILogService),ee(2,C.IWindowsMainService)],a)}),define(te[251],ie([0,1,15,3,2,247,33]),function(z,e,w,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let E=class extends k.Disposable{constructor(m){super(),this.windowsMainService=m,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,I){let v;if(typeof m.windowId=="number"){const{windowId:b}=m,d=this.windowsMainService.getWindowById(b);if(!d?.win)throw new Error(`Invalid windowId: ${b}`);v=d.win.webContents}else{const{webContentsId:b}=m;if(v=w.webContents.fromId(b),!v)throw new Error(`Invalid webContentsId: ${b}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(I)}async findInFrame(m,I,v,b){const h=this.getFrameByName(m,I);if(typeof h.findInFrame=="function"){h.findInFrame(v,{findNext:b.findNext,forward:b.forward});const y=(C,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),h.removeListener("found-in-frame",y))};h.on("found-in-frame",y)}}async stopFindInFrame(m,I,v){const d=this.getFrameByName(m,I);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,I){const v=this.windowsMainService.getWindowById(m.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${m}`);const b=v.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===I);if(!b)throw new Error(`Unknown frame: ${I}`);return b}};E=ve([ee(0,D.IWindowsMainService)],E),e.WebviewMainService=E}),define(te[252],ie([0,1,8,3,2]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:E,onDidFocusWindow:u,getActiveWindowId:m}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(E,u))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>m()),(async()=>{try{const v=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:v}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(E){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=E}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[28],ie([0,1,173,9,31,16,7,4,13]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,E.createDecorator)("contextService");function m(o){const n=o;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,n){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=I;function v(o){const n=o;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=v;function b(o){const n=o;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=b;var d;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const n=o;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=h;function y(o){const n=o;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=y;class C{constructor(n,r,s,c,l){this._id=n,this._transient=s,this._configuration=c,this._ignorePathCasing=l,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function S(o){return new p({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(o,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,n.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function g(o){let n;return D.URI.isUri(o)?n=o:n=o.configuration,n?.scheme===u.Schemas.tmp}e.isTemporaryWorkspace=g;function a(o,n){return!f(o,n)&&!g(o)}e.isSavedWorkspace=a;function i(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(te[56],ie([0,1,15,8,66,35,2,80,5,12,21,150,4,6,28]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,b.createDecorator)("dialogMainService");let y=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,S){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},S)}pickFolder(p,S){return this.doPick({...p,pickFolders:!0,title:(0,v.localize)(1,null)},S)}pickFile(p,S){return this.doPick({...p,pickFiles:!0,title:(0,v.localize)(2,null)},S)}pickWorkspace(p,S){const f=(0,v.localize)(3,null),g=(0,R.mnemonicButtonLabel)((0,v.localize)(4,null)),a=h.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:f,filters:a,buttonLabel:g},S)}async doPick(p,S){const f={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(f.properties=void 0,p.pickFiles&&p.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),u.isMacintosh&&f.properties.push("treatPackageAsDirectory");const g=await this.showOpenDialog(f,(0,m.withNullAsUndefined)(S||w.BrowserWindow.getFocusedWindow()));if(g&&g.filePaths&&g.filePaths.length>0)return g.filePaths}getWindowDialogQueue(p){if(p){let S=this.windowDialogQueues.get(p.id);return S||(S=new t.Queue,this.windowDialogQueues.set(p.id,S)),S}else return this.noWindowDialogueQueue}showMessageBox(p,S){return this.getWindowDialogQueue(S).queue(async()=>S?w.dialog.showMessageBox(S,p):w.dialog.showMessageBox(p))}async showSaveDialog(p,S){const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(S).queue(async()=>{let g;return S?g=await w.dialog.showSaveDialog(S,p):g=await w.dialog.showSaveDialog(p),g.filePath=this.normalizePath(g.filePath),g})}finally{(0,D.dispose)(f)}}normalizePath(p){return p&&u.isMacintosh&&(p=(0,E.normalizeNFC)(p)),p}normalizePaths(p){return p.map(S=>this.normalizePath(S))}async showOpenDialog(p,S){p.defaultPath&&(await I.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const f=this.acquireFileDialogLock(p,S);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(S).queue(async()=>{let g;return S?g=await w.dialog.showOpenDialog(S,p):g=await w.dialog.showOpenDialog(p),g.filePaths=this.normalizePaths(g.filePaths),g})}finally{(0,D.dispose)(f)}}acquireFileDialogLock(p,S){if(!S)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let f=this.windowFileDialogLocks.get(S.id);f||(f=new Set,this.windowFileDialogLocks.set(S.id,f));const g=(0,k.hash)(p);if(!f.has(g))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),f.add(g),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),f?.delete(g),f?.size===0&&this.windowFileDialogLocks.delete(S.id)})}};y=ve([ee(0,d.ILogService)],y),e.DialogMainService=y}),define(te[253],ie([0,1,3,2,67,28]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(u,m){super(),this.logService=u,this.storageMainService=m,this.onDidChangeApplicationStorageEmitter=this._register(new w.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(m.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(u,m){this._register(w.Event.debounce(u.onDidChangeStorage,(I,v)=>(I?I.push(v):I=[v],I),D.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&m.fire(this.serializeStorageChangeEvents(I,u))}))}serializeStorageChangeEvents(u,m){const I=new Map,v=new Set;return u.forEach(b=>{const d=m.get(b.key);typeof d=="string"?I.set(b.key,d):v.add(b.key)}),{changed:Array.from(I.entries()),deleted:Array.from(v.values())}}listen(u,m,I){switch(m){case"onDidChangeStorage":{const v=I.profile?(0,k.revive)(I.profile):void 0;if(!v)return this.onDidChangeApplicationStorageEmitter.event;let b=this.mapProfileToOnDidChangeProfileStorageEmitter.get(v.id);return b||(b=this._register(new w.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(v),b),this.mapProfileToOnDidChangeProfileStorageEmitter.set(v.id,b)),b.event}}throw new Error(`Event not found: ${m}`)}async call(u,m,I){const v=I.profile?(0,k.revive)(I.profile):void 0,b=(0,R.reviveIdentifier)(I.workspace),d=await this.withStorageInitialized(v,b);switch(m){case"getItems":return Array.from(d.items.entries());case"updateItems":{const h=I;if(h.insert)for(const[y,C]of h.insert)d.set(y,C);h.delete?.forEach(y=>d.delete(y));break}case"isUsed":{const h=I.payload;if(typeof h=="string")return this.storageMainService.isUsed(h)}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(u,m){let I;m?I=this.storageMainService.workspaceStorage(m):u?I=this.storageMainService.profileStorage(u):I=this.storageMainService.applicationStorage;try{await I.init()}catch(v){this.logService.error(`StorageIPC#init: Unable to init ${m?"workspace":u?"profile":"application"} storage due to ${v}`)}return I}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(te[39],ie([0,1,66,3,2,16,12,7,170,36,14,4,6,28,31,51,8,29,25]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function f(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&E.URI.isUri(r.location)&&E.URI.isUri(r.globalStorageHome)&&E.URI.isUri(r.settingsResource)&&E.URI.isUri(r.keybindingsResource)&&E.URI.isUri(r.tasksResource)&&E.URI.isUri(r.snippetsHome)&&((0,D.isUndefined)(r.extensionsResource)||E.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=f,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,v.createDecorator)("IUserDataProfilesService");function g(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:E.URI.revive(n.location).with({scheme:r}),globalStorageHome:E.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:E.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:E.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:E.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:E.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:E.URI.revive(n.extensionsResource)?.with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function a(n,r,s,c){return{id:n,name:r,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(s,"globalStorage"),settingsResource:(0,R.joinPath)(s,"settings.json"),keybindingsResource:(0,R.joinPath)(s,"keybindings.json"),tasksResource:(0,R.joinPath)(s,"tasks.json"),snippetsHome:(0,R.joinPath)(s,"snippets"),extensionsResource:(0,R.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=a;let i=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,s,c,l){super(),this.environmentService=r,this.fileService=s,this.uriIdentityService=c,this.logService=l,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(P=>a((0,R.basename)(P.location),P.name,P.location,{shortName:P.shortName,useDefaultFlags:P.useDefaultFlags})):[];let s;const c=new h.ResourceMap,l=a((0,w.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,u.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...l,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0||this.transientProfilesObject.profiles.length>0?l.extensionsResource:void 0}),r.length){const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[M,T]of Object.entries(P.workspaces)){const N=E.URI.parse(M),X=E.URI.parse(T),ae=r.find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,X));ae&&c.set(N,ae)}if(P.emptyWindow){const M=E.URI.parse(P.emptyWindow);s=r.find(T=>this.uriIdentityService.extUri.isEqual(T.location,M))}}this._profilesObject={profiles:r,workspaces:c,emptyWindow:s}}return this._profilesObject}async createTransientProfile(r){const s="Temp",c=new RegExp(`${(0,S.escapeRegExpCharacters)(s)}\\s(\\d+)`);let l=0;for(const M of this.profiles){const T=c.exec(M.name),N=T?parseInt(T[1]):0;l=N>l?N:l}const P=`${s} ${l+1}`;return this.createProfile((0,w.hash)((0,p.generateUuid)()).toString(16),P,{transient:!0},r)}async createNamedProfile(r,s,c){return this.createProfile((0,w.hash)((0,p.generateUuid)()).toString(16),r,s,c)}async createProfile(r,s,c,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const P=await this.doCreateProfile(r,s,c);return l&&await this.setProfileForWorkspace(l,P),P}async doCreateProfile(r,s,c){let l=this.profileCreationPromises.get(s);return l||(l=(async()=>{try{const P=this.profiles.find(N=>N.name===s||N.id===r);if(P)return P;const M=a(r,s,(0,R.joinPath)(this.profilesHome,r),c);await this.fileService.createFolder(M.location);const T=[];return this._onWillCreateProfile.fire({profile:M,join(N){T.push(N)}}),await C.Promises.settled(T),this.updateProfiles([M],[],[]),M}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,l)),l}async updateProfile(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(l=>l.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=a(c.id,s.name??c.name,c.location,{shortName:s.shortName??c.shortName,transient:s.transient??c.isTransient,useDefaultFlags:s.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(l=>l.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:s,join(l){c.push(l)}});try{await Promise.allSettled(c)}catch(l){this.logService.error(l)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(r,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(r);return c||(c=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,c)),c}async setProfileForWorkspace(r,s){this.setProfileForWorkspaceSync(r,s)}setProfileForWorkspaceSync(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(l=>l.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(r,c)}unsetWorkspace(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(r.map(s=>this.removeProfile(s)))}getProfileForWorkspace(r){const s=this.getWorkspace(r);return E.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(r){return(0,d.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,d.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}isProfileAssociatedToWorkspace(r){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,r.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,r.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location)))}updateProfiles(r,s,c){const l=[...this.profiles,...r],P=[];this.transientProfilesObject.profiles=[];for(let M of l)M.isDefault||s.some(T=>M.id===T.id)||(M=c.find(T=>M.id===T.id)??M,M.isTransient?this.transientProfilesObject.profiles.push(M):P.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(r,s,c)}triggerProfilesChanges(r,s,c){this._onDidChangeProfiles.fire({added:r,removed:s,updated:c,all:this.profiles})}updateWorkspaceAssociation(r,s,c){c=s?.isTransient?!0:c,c||this.updateWorkspaceAssociation(r,void 0,!0);const l=this.getWorkspace(r),P=c?this.transientProfilesObject:this.profilesObject;E.URI.isUri(l)?(P.workspaces.delete(l),s&&P.workspaces.set(l,s)):P.emptyWindow=s,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[c,l]of this.profilesObject.workspaces.entries())r[c.toString()]=l.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=ve([ee(0,m.IEnvironmentService),ee(1,I.IFileService),ee(2,y.IUriIdentityService),ee(3,b.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=o}),define(te[89],ie([0,1,24,8,50,18,17,43,136,2,13,9,5,16,188,96,12,7,155,36,111,110,187,14,4,6,20,3,67,72,39,51,186]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o,n,r,s,c,l,P,M,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(V){function H(W,A){if(W===A)return!0;const F=Object.keys(W),U=new Set;for(const J of Object.keys(A))U.add(J);if(F.length!==U.size)return!1;for(const J of F){if(W[J]!==A[J])return!1;U.delete(J)}return U.size===0}V.equals=H})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let ae=class extends m.Disposable{constructor(H,W,A,F,U,J,B,$,L,O,_){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=W,this.extensionsControlLocation=A,this.cacheLocation=F,this.userDataProfilesService=U,this.extensionsProfileScannerService=J,this.fileService=B,this.logService=$,this.environmentService=L,this.productService=O,this.instantiationService=_,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,d.joinPath)(this.cacheLocation,a.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(Z,(0,d.joinPath)(this.cacheLocation,a.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(G,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,W,A){const[F,U]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(W)]),J=A?await this.scanExtensionsUnderDevelopment(H,[...F,...U]):[];return this.dedupExtensions(F,U,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const W=[];W.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),W.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[A,F]=await Promise.all(W);return this.applyScanOptions([...A,...F],0,H,!1)}async scanUserExtensions(H){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(H.profileLocation??this.userExtensionsLocation,!!H.profileLocation,1,!H.includeUninstalled,H.language);let F=await(H.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return F=await this.applyScanOptions(F,1,H,!0),this.logService.trace("Scanned user extensions:",F.length),F}async scanExtensionsUnderDevelopment(H,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(F=>F.scheme===I.Schemas.file).map(async F=>{const U=await this.createExtensionScannerInput(F,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(U)).map(B=>(B.type=W.find($=>(0,g.areSameExtensions)($.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,U)))}))).flat();return this.applyScanOptions(A,"development",H,!0)}return[]}async scanExistingExtension(H,W,A){const F=await this.createExtensionScannerInput(H,!1,W,!0,A.language),U=await this.extensionsScanner.scanExtension(F);return!U||!A.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(H,W,A){const F=await this.createExtensionScannerInput(H,!1,W,!0,A.language),U=await this.extensionsScanner.scanOneOrMultipleExtensions(F);return this.applyScanOptions(U,W,A,!0)}async scanMetadata(H){const W=(0,d.joinPath)(H,"package.json"),A=(await this.fileService.readFile(W)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(H,W){const A=(0,d.joinPath)(H,"package.json"),F=(await this.fileService.readFile(A)).value.toString(),U=JSON.parse(F);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,U.__metadata={...U.__metadata,...W},await this.fileService.writeFile((0,d.joinPath)(H,"package.json"),R.VSBuffer.fromString(JSON.stringify(U,null,"	")))}async applyScanOptions(H,W,A,F){return A.includeAllVersions||(H=this.dedupExtensions(W===0?H:void 0,W===1?H:void 0,W==="development"?H:void 0,await this.getTargetPlatform(),F)),A.includeInvalid||(H=H.filter(U=>U.isValid)),H.sort((U,J)=>{const B=v.basename(U.location.fsPath),$=v.basename(J.location.fsPath);return B<$?-1:B>$?1:0})}dedupExtensions(H,W,A,F,U){const J=($,L,O)=>{if($.isValid&&!L.isValid)return!1;if($.isValid===L.isValid){if(U&&h.gt($.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${$.location.path} with version ${$.manifest.version}`),!1;if(h.eq($.manifest.version,L.manifest.version)){if($.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${$.location.path} with same version`),!1;if($.targetPlatform===F)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${$.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${$.location.path} with ${L.location.path}.`),!0},B=new Map;return H?.forEach($=>{const L=a.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!1))&&B.set(L,$)}),W?.forEach($=>{const L=a.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);if(!O&&H&&$.type===0){this.logService.debug(`Skipping obsolete system extension ${$.location.path}.`);return}(!O||J(O,$,!1))&&B.set(L,$)}),A?.forEach($=>{const L=a.ExtensionIdentifier.toKey($.identifier.id),O=B.get(L);(!O||J(O,$,!0))&&B.set(L,$),B.set(L,$)}),[...B.values()]}async scanDefaultSystemExtensions(H,W){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),U=await(H&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",U.length),U}async scanDevSystemExtensions(H,W){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const F=W?await this.getBuiltInExtensionControl():{},U=[],J=p.URI.file(v.normalize(v.join(I.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions")));for(const $ of A){const L=F[$.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":U.push((0,d.joinPath)(J,$.name));break;default:U.push(p.URI.file(L));break}}const B=await Promise.all(U.map(async $=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput($,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,w.coalesce)(B)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,W,A,F,U,J=!0){const B=await this.getTranslations(U??b.language),$=await this.getMtime(H),L=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new Q(H,$,L,O,W,A,F,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,U,B)}async getMtime(H){try{const W=await this.fileService.stat(H);if(typeof W.mtime=="number")return W.mtime}catch{}}};ae=ve([ee(4,M.IUserDataProfilesService),ee(5,P.IExtensionsProfileScannerService),ee(6,o.IFileService),ee(7,r.ILogService),ee(8,f.IEnvironmentService),ee(9,s.IProductService),ee(10,n.IInstantiationService)],ae),e.AbstractExtensionsScannerService=ae;class Q{constructor(H,W,A,F,U,J,B,$,L,O,_,j,Y,oe){this.location=H,this.mtime=W,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=F,this.profile=U,this.type=J,this.excludeObsolete=B,this.validate=$,this.productVersion=L,this.productDate=O,this.productCommit=_,this.devMode=j,this.language=Y,this.translations=oe}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,W){return(0,d.isEqual)(H.location,W.location)&&H.mtime===W.mtime&&(0,d.isEqual)(H.applicationExtensionslocation,W.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&H.profile===W.profile&&H.type===W.type&&H.excludeObsolete===W.excludeObsolete&&H.validate===W.validate&&H.productVersion===W.productVersion&&H.productDate===W.productDate&&H.productCommit===W.productCommit&&H.devMode===W.devMode&&H.language===W.language&&X.equals(H.translations,W.translations)}}let G=class extends m.Disposable{constructor(H,W,A,F,U){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=W,this.uriIdentityService=A,this.fileService=F,this.logService=U}async scanExtensions(H){const W=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let A={};if(H.excludeObsolete&&H.type===1)try{const F=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(F)}catch{}return(0,C.isEmptyObject)(A)?W:W.filter(F=>!A[g.ExtensionKey.create(F).toString()])}async scanExtensionsFromLocation(H){const W=await this.fileService.resolve(H.location);if(!W.children?.length)return[];const A=await Promise.all(W.children.map(async F=>{if(!F.isDirectory||H.type===1&&(0,d.basename)(F.resource).indexOf(".")===0)return null;const U=new Q(F.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(U)}));return(0,w.coalesce)(A).sort((F,U)=>F.location.path<U.location.path?-1:1)}async scanExtensionsFromProfile(H){let W=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){W=W.filter(F=>!F.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,H);W.push(...A)}return W}async scanExtensionsFromProfileResource(H,W,A){const F=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!F.length)return[];const U=await Promise.all(F.map(async J=>{if(W(J)){const B=new Q(J.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,J.metadata)}return null}));return(0,w.coalesce)(U)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,d.joinPath)(H.location,"package.json"))){const W=await this.scanExtension(H);return W?[W]:[]}else return await this.scanExtensions(H)}catch(W){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,D.getErrorMessage)(W)),[]}}async scanExtension(H,W){try{let A=await this.scanExtensionManifest(H.location);if(A){A.publisher||(A.publisher=a.UNDEFINED_PUBLISHER),W=W??A.__metadata,delete A.__metadata;const F=(0,g.getGalleryExtensionId)(A.publisher,A.name),U=W?.id?{id:F,uuid:W.id}:{id:F},J=W?.isSystem?0:H.type,B=J===0||!!W?.isBuiltin;A=await this.translateManifest(H.location,A,Q.createNlsConfiguration(H));const $={type:J,identifier:U,manifest:A,location:H.location,isBuiltin:B,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return H.validate?this.validate($,H):$}}catch(A){H.type!==0&&this.logService.error(A)}return null}validate(H,W){let A=!0;const F=(0,i.validateExtensionManifest)(W.productVersion,W.productDate,W.location,H.manifest,H.isBuiltin);for(const[U,J]of F)U===y.default.Error&&(A=!1,this.logService.error(this.formatMessage(W.location,J)));return H.isValid=A,H.validations=F,H}async scanExtensionManifest(H){const W=(0,d.joinPath)(H,"package.json");let A;try{A=(await this.fileService.readFile(W)).value.toString()}catch(U){return(0,o.toFileOperationResult)(U)!==1&&this.logService.error(this.formatMessage(H,(0,S.localize)(0,null,W.path,U.message))),null}let F;try{F=JSON.parse(A)}catch{const J=[];(0,E.parse)(A,J);for(const B of J)this.logService.error(this.formatMessage(H,(0,S.localize)(1,null,W.path,B.offset,B.length,(0,u.getParseErrorMessage)(B.error))));return null}return(0,E.getNodeType)(F)!=="object"?(this.logService.error(this.formatMessage(H,(0,S.localize)(2,null,W.path))),null):F}async translateManifest(H,W,A){const F=await this.getLocalizedMessages(H,W,A);if(F)try{const U=[],J=await this.resolveOriginalMessageBundle(F.default,U);if(U.length>0)return U.forEach($=>{this.logService.error(this.formatMessage(H,(0,S.localize)(3,null,F.default?.path,(0,u.getParseErrorMessage)($.error))))}),W;if((0,E.getNodeType)(F)!=="object")return this.logService.error(this.formatMessage(H,(0,S.localize)(4,null,F.default?.path))),W;const B=F.values||Object.create(null);return(0,N.localizeManifest)(W,B,J)}catch{}return W}async getLocalizedMessages(H,W,A){const F=(0,d.joinPath)(H,"package.nls.json"),U=(L,O)=>{O.forEach(_=>{this.logService.error(this.formatMessage(H,(0,S.localize)(5,null,L?.path,(0,u.getParseErrorMessage)(_.error))))})},J=L=>{this.logService.error(this.formatMessage(H,(0,S.localize)(6,null,L?.path)))},B=`${W.publisher}.${W.name}`,$=A.translations[B];if($)try{const L=p.URI.file($),O=(await this.fileService.readFile(L)).value.toString(),_=[],j=(0,E.parse)(O,_);return _.length>0?(U(L,_),{values:void 0,default:F}):(0,E.getNodeType)(j)!=="object"?(J(L),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.fileService.exists(F))return;let O;try{O=await this.findMessageBundles(H,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const _=(await this.fileService.readFile(O.localized)).value.toString(),j=[],Y=(0,E.parse)(_,j);return j.length>0?(U(O.localized,j),{values:void 0,default:O.original}):(0,E.getNodeType)(Y)!=="object"?(J(O.localized),{values:void 0,default:O.original}):{values:Y,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(H,W){if(H)try{const A=(await this.fileService.readFile(H)).value.toString();return(0,E.parse)(A,W)}catch{}}findMessageBundles(H,W){return new Promise((A,F)=>{const U=J=>{const B=(0,d.joinPath)(H,`package.nls.${J}.json`);this.fileService.exists(B).then($=>{$&&A({localized:B,original:(0,d.joinPath)(H,"package.nls.json")});const L=J.lastIndexOf("-");L===-1?A({localized:(0,d.joinPath)(H,"package.nls.json"),original:null}):(J=J.substring(0,L),U(J))})};if(W.devMode||W.pseudo||!W.language)return A({localized:(0,d.joinPath)(H,"package.nls.json"),original:null});U(W.language)})}formatMessage(H,W){return`[${H.path}]: ${W}`}};G=ve([ee(1,P.IExtensionsProfileScannerService),ee(2,T.IUriIdentityService),ee(3,o.IFileService),ee(4,r.ILogService)],G);let Z=class extends G{constructor(H,W,A,F,U,J){super(W,A,F,U,J),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const W=await this.readExtensionCache();if(this.input=H,W&&W.input&&Q.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(F=>(F.location=p.URI.revive(F.location),F));const A=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:A}),A}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),W=JSON.parse(H.value.toString());return{result:W.result,input:(0,l.revive)(W.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify(H)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const W=H.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(F){this.logService.error(F)}}};Z=ve([ee(2,P.IExtensionsProfileScannerService),ee(3,T.IUriIdentityService),ee(4,o.IFileService),ee(5,r.ILogService)],Z);function se(V,H){const W=(0,g.getExtensionId)(V.manifest.publisher,V.manifest.name);return{id:W,identifier:new a.ExtensionIdentifier(W),isBuiltin:V.type===0,isUserBuiltin:V.type===1&&V.isBuiltin,isUnderDevelopment:H,extensionLocation:V.location,uuid:V.identifier.uuid,targetPlatform:V.targetPlatform,...V.manifest}}e.toExtensionDescription=se;class he extends ae{constructor(H,W,A,F,U,J,B,$,L,O,_){super(H,W,(0,d.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(F,a.MANIFEST_CACHE_FOLDER),U,J,B,$,L,O,_),this.translationsPromise=(async()=>{if(b.translationsConfigFile)try{const j=await this.fileService.readFile(p.URI.file(b.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=he}),define(te[254],ie([0,1,7,36,72,89,14,4,6,20,39]),function(z,e,w,t,k,R,D,E,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=class extends R.NativeExtensionsScannerService{constructor(d,h,y,C,p,S,f){super(w.URI.file(p.builtinExtensionsPath),w.URI.file(p.extensionsPath),p.userHome,w.URI.file(p.userDataPath),d,h,y,C,p,S,f)}};v=ve([ee(0,I.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,D.IFileService),ee(3,u.ILogService),ee(4,t.INativeEnvironmentService),ee(5,m.IProductService),ee(6,E.IInstantiationService)],v),e.ExtensionsScannerService=v}),define(te[255],ie([0,1,15,41,2,31,13,9,5,7,29,36,6,39]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let h=class extends k.Disposable{constructor(C,p,S){super(),this.environmentService=C,this.logService=S,this.validRoots=R.TernarySearchTree.forPaths(!u.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(C.appRoot),this.addValidFileRoot(C.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(C.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:C}=w.session;C.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(p,S)=>this.handleResourceRequest(p,S)),C.protocol.interceptFileProtocol(D.Schemas.file,(p,S)=>this.handleFileRequest(p,S)),this._register((0,k.toDisposable)(()=>{C.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),C.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(C){const p=(0,E.normalize)(C);return this.validRoots.get(p)?k.Disposable.None:(this.validRoots.set(p,!0),(0,k.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(C,p){const S=m.URI.parse(C.url);return this.logService.error(`Refused to load resource ${S.fsPath} from ${D.Schemas.file}: protocol (original URL: ${C.url})`),p({error:-3})}handleResourceRequest(C,p){const S=this.requestToNormalizedFilePath(C);let f;return this.environmentService.crossOriginIsolated&&((0,E.basename)(S)==="workbench.html"||(0,E.basename)(S)==="workbench-dev.html"?f=D.COI.CoopAndCoep:f=D.COI.getHeadersFromQuery(C.url)),this.validRoots.findSubstr(S)?p({path:S,headers:f}):this.validExtensions.has((0,E.extname)(S).toLowerCase())?p({path:S}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${S} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${C.url})`),p({error:-3}))}requestToNormalizedFilePath(C){const p=m.URI.parse(C.url),S=D.FileAccess.asFileUri(p);return(0,E.normalize)(S.fsPath)}createIPCObjectUrl(){let C;const p=m.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),S=p.toString(),f=async()=>C;return t.validatedIpcMain.handle(S,f),this.logService.trace(`IPC Object URL: Registered new channel ${S}.`),{resource:p,update:g=>C=g,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${S}.`),t.validatedIpcMain.removeHandler(S)}}}};h=ve([ee(0,v.INativeEnvironmentService),ee(1,d.IUserDataProfilesService),ee(2,b.ILogService)],h),e.ProtocolMainService=h}),define(te[256],ie([0,1,15,41,8,3,2,13,12,101,26,22,6,54,61,64,44,39,37]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let f=class extends D.Disposable{constructor(a,i,o,n,r,s,c,l,P){super(),this.machineId=a,this.userEnv=i,this.environmentMainService=o,this.userDataProfilesService=n,this.lifecycleMainService=r,this.logService=s,this.policyService=c,this.themeMainService=l,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(a,i)=>this.onWindowConnection(a,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(a,i)=>this.onWorkerConnection(a,i)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(a,i){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(a.sender.isDestroyed())return o.close();a.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[o])}onWorkerConnection(a,i){this.logService.trace("SharedProcess: onWorkerConnection",i);const o=new D.DisposableStore,n=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,i),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",i))},r=w.BrowserWindow.fromId(i.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===r)(()=>n("load"))),o.add(R.Event.fromNodeEventEmitter(r,"closed")(()=>n("closed"))),r.webContents.postMessage(i.reply.channel,i.reply.nonce,a.ports)}onWillShutdown(){const a=this.window;!a||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(a.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{a.close()}catch{}this.window=void 0},0))}send(a,...i){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${a}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(a,...i)}catch(o){this.logService.warn(`Error sending IPC message to channel '${a}' of shared process: ${(0,C.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),a()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(a=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),a()}))})()),this._whenIpcReady}createWindow(){const a=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),a.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:d.default,policiesData:this.policyService.serialize()}),this.window.loadURL(E.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=a=>{this.logService.trace("SharedProcess#close prevented"),a.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(a,i)=>this._onDidError.fire({type:2,details:i})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(a,i,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:i}})))}async connect(){await this.whenIpcReady;const a=(0,u.assertIsDefined)(this.window);return(0,m.connect)(a)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const a=this.window;return a?!a.isDestroyed()&&!a.webContents.isDestroyed():!1}};f=ve([ee(2,I.IEnvironmentMainService),ee(3,p.IUserDataProfilesService),ee(4,v.ILifecycleMainService),ee(5,b.ILogService),ee(6,S.IPolicyService),ee(7,y.IThemeMainService),ee(8,h.IProtocolMainService)],f),e.SharedProcess=f}),define(te[90],ie([0,1,8,3,2,71,12,102,4,39]),function(z,e,w,t,k,R,D,E,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var I;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(S){S[S.APPLICATION=-1]="APPLICATION",S[S.PROFILE=0]="PROFILE",S[S.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var b;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function d(S){const f=S.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=d;class h extends k.Disposable{constructor(f={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=f,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,g){if(g===e.TARGET_KEY){switch(f){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:f})}else this._onDidChangeValue.fire({scope:f,key:g,target:this.getKeyTargets(f)[g]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,g,a){return this.getStorage(g)?.get(f,a)}getBoolean(f,g,a){return this.getStorage(g)?.getBoolean(f,a)}getNumber(f,g,a){return this.getStorage(g)?.getNumber(f,a)}store(f,g,a,i){if((0,D.isUndefinedOrNull)(g)){this.remove(f,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,a,i),this.getStorage(a)?.set(f,g)})}remove(f,g){this.withPausedEmitters(()=>{this.updateKeyTarget(f,g,void 0),this.getStorage(g)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,g){const a=[],i=this.getKeyTargets(f);for(const o of Object.keys(i))i[o]===g&&a.push(o);return a}updateKeyTarget(f,g,a){const i=this.getKeyTargets(g);typeof a=="number"?i[f]!==a&&(i[f]=a,this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[f]=="number"&&(delete i[f],this.getStorage(g)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(f){switch(f){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(f){const g=this.getStorage(f);return g?d(g):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this._onWillSaveState.fire({reason:f});const g=this.getStorage(-1),a=this.getStorage(0),i=this.getStorage(1);switch(f){case I.NONE:await w.Promises.settled([g?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await w.Promises.settled([g?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.getStorage(-1)?.items??new Map,g=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return p(f,g,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(f,g){return this.emitWillSaveState(I.NONE),(0,m.isUserDataProfile)(f)?this.switchToProfile(f,g):this.switchToWorkspace(f,g)}canSwitchProfile(f,g){return!(f.id===g.id||y(g)&&y(f))}switchData(f,g,a,i){this.withPausedEmitters(()=>{if(i)for(const[o,n]of f)g.set(o,n);else{const o=new Set;for(const[n,r]of f)o.add(n),g.get(n)!==r&&this.emitDidChangeValue(a,n);for(const[n]of g.items)o.has(n)||this.emitDidChangeValue(a,n)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function y(S){return S.isDefault||!!S.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class C extends h{constructor(){super(),this.applicationStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.profileStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.profileStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),this._register(this.applicationStorage.onDidChangeStorage(f=>this.emitDidChangeValue(-1,f)))}getStorage(f){switch(f){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(f){return!1}}e.InMemoryStorageService=C;async function p(S,f,g,a,i,o){const n=X=>{try{return JSON.parse(X)}catch{return X}},r=new Map,s=new Map;S.forEach((X,ae)=>{r.set(ae,X),s.set(ae,n(X))});const c=new Map,l=new Map;f.forEach((X,ae)=>{c.set(ae,X),l.set(ae,n(X))});const P=new Map,M=new Map;g.forEach((X,ae)=>{P.set(ae,X),M.set(ae,n(X))}),console.group(a!==i?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const T=[];if(r.forEach((X,ae)=>{T.push({key:ae,value:X})}),console.table(T),console.groupEnd(),console.log(s),a!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const X=[];c.forEach((ae,Q)=>{X.push({key:Q,value:ae})}),console.table(X),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const N=[];P.forEach((X,ae)=>{N.push({key:ae,value:X})}),console.table(N),console.groupEnd(),console.log(M)}e.logStorage=p}),define(te[257],ie([0,1,24,8,3,2,9,79,7,21,102,147,6,90,32,28]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class C extends R.Disposable{get storage(){return this._storage}constructor(o,n){super(),this.logService=o,this.fileService=n,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(r=>this._onDidChangeStorage.fire({key:r}))),await this.doInit(o);const n=o.getBoolean(d.IS_NEW_KEY);n===void 0?o.set(d.IS_NEW_KEY,!0):n&&o.set(d.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===b.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,n){return this._storage.get(o,n)}set(o,n){return this._storage.set(o,n)}delete(o){return this._storage.delete(o)}async close(){const o=new E.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>C.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const n=(0,w.top)(Array.from(this._storage.items.entries()).map(([s,c])=>({key:s,length:c.length})),(s,c)=>c.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.fileService.stat(u.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${r}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}C.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends C{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,p.STORAGE_NAME)}constructor(o,n,r,s){super(r,s),this.profile=o,this.options=n}async doCreate(){return new I.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}p.STORAGE_NAME="state.vscdb";class S extends p{constructor(o,n,r,s){super(o,n,r,s)}}e.ProfileStorageMain=S;class f extends p{constructor(o,n,r,s){super(n.defaultProfile,o,r,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(h.firstSessionDateStorageKey,void 0)===void 0&&o.set(h.firstSessionDateStorageKey,new Date().toUTCString());const r=o.get(h.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(h.lastSessionDateStorageKey,typeof r>"u"?null:r),o.set(h.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=f;class g extends C{get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,g.WORKSPACE_STORAGE_NAME)}constructor(o,n,r,s,c){super(r,c),this.workspace=o,this.options=n,this.environmentService=s}async doCreate(){const{storageFilePath:o,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new v.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:n?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,D.join)(o,g.WORKSPACE_STORAGE_NAME);return await m.Promises.exists(o)?{storageFilePath:n,wasCreated:!1}:(await m.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let n;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const r=(0,D.join)(o,g.WORKSPACE_META_NAME);await m.Promises.exists(r)||await m.Promises.writeFile(r,JSON.stringify(n,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json";class a extends C{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=a}),define(te[258],ie([0,1,67,36,14,6,227,51,39]),function(z,e,w,t,k,R,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class At extends u.UserDataProfilesService{constructor(v,b,d,h,y){super(d,h,b,y),this.stateService=v}getStoredProfiles(){return(0,w.revive)(this.stateService.getItem(At.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,w.revive)(this.stateService.getItem(At.PROFILE_ASSOCIATIONS_KEY,{}))}};m=ve([ee(0,D.IStateService),ee(1,E.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,k.IFileService),ee(4,R.ILogService)],m),e.UserDataProfilesService=m}),define(te[42],ie([0,1,7,36,14,4,6,38,51,39,258]),function(z,e,w,t,k,R,D,E,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let v=class dt extends I.UserDataProfilesService{constructor(d,h,y,C,p){super(d,h,y,C,p),this.stateMainService=d}setEnablement(d){super.setEnablement(d),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(d){if(!!this.isEnabled()){if(d.profile){const h=this.profiles.find(y=>y.name===d.profile);return h?Promise.resolve(h):this.createNamedProfile(d.profile)}if(d["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(d){d.length?this.stateMainService.setItem(dt.PROFILES_KEY,d):this.stateMainService.removeItem(dt.PROFILES_KEY)}saveStoredProfileAssociations(d){d.emptyWindow||d.workspaces?this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,d):this.stateMainService.removeItem(dt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const d="workspaceAndProfileInfo",h=this.stateMainService.getItem(d,void 0);if(h){this.stateMainService.removeItem(d);const y=h.reduce((C,{workspace:p,profile:S})=>(C[w.URI.revive(p).toString()]=w.URI.revive(S).toString(),C),{});this.stateMainService.setItem(dt.PROFILE_ASSOCIATIONS_KEY,{workspaces:y})}return super.getStoredProfileAssociations()}};v=ve([ee(0,E.IStateMainService),ee(1,u.IUriIdentityService),ee(2,t.IEnvironmentService),ee(3,k.IFileService),ee(4,D.ILogService)],v),e.UserDataProfilesMainService=v}),define(te[259],ie([0,1,2,16,72,89,14,6,39,42]),function(z,e,w,t,k,R,D,E,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let I=class extends w.Disposable{constructor(b,d,h,y,C){super(),this.userDataProfilesService=b,this.fileService=d,this.extensionsScannerService=h,this.extensionsProfileScannerService=y,b.isEnabled()?(this._register(b.onWillCreateProfile(p=>{b.profiles.length===1&&p.join(this.initialize())})),this._register(b.onDidChangeProfiles(p=>{b.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,p=>C.error(p))}async initialize(){const b=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(b)}catch{}const d=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(d.map(h=>[h,h.metadata]),b)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,u.EXTENSIONS_RESOURCE_NAME)}};I=ve([ee(0,m.IUserDataProfilesMainService),ee(1,D.IFileService),ee(2,R.IExtensionsScannerService),ee(3,k.IExtensionsProfileScannerService),ee(4,E.ILogService)],I),e.DefaultExtensionsProfileInitHandler=I}),define(te[260],ie([0,1,15,24,5,7,21,19,59,4,6,115,33,42]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let h=class{constructor(C,p,S,f,g){this.logService=C,this.windowsMainService=p,this.urlService=S,this.configurationService=f,this.userDataProfilesMainService=g}async start(C,p){this.logService.trace("Received data from other instance: ",C,p),k.isMacintosh&&w.app.focus({steal:!0});const S=this.parseOpenUrl(C);if(S.length){let f=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));g&&(f=g.ready())}f.then(()=>{for(const{uri:g,url:a}of S)this.urlService.open(g,{originalUrl:a})})}else return this.startOpenWindow(C,p)}parseOpenUrl(C){return C["open-url"]&&C._urls&&C._urls.length>0?(0,t.coalesce)(C._urls.map(p=>{try{return{uri:R.URI.parse(p),url:p}}catch{return null}})):[]}async startOpenWindow(C,p){const S=(0,u.isLaunchedFromCli)(p)?0:4;let f=[];const g=C.wait&&C.waitMarkerFilePath?R.URI.file(C.waitMarkerFilePath):void 0,a=C.remote||void 0,i=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(C),o={context:S,cli:C,userEnv:p,waitMarkerFileURI:g,remoteAuthority:a,profile:i};if(C.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(C.extensionDevelopmentPath,o);else if(!C._.length&&!C["folder-uri"]&&!C["file-uri"]){let n=!1;if(C["new-window"]||C["unity-launch"]||i)n=!0;else if(C["reuse-window"])n=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":n=!0;break;case"off":n=!1;break;default:n=!k.isMacintosh}if(n)f=await this.windowsMainService.open({...o,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,o),f=[r]):f=await this.windowsMainService.open({...o,forceEmpty:!0})}}else f=await this.windowsMainService.open({...o,forceNewWindow:C["new-window"],preferNewWindow:!C["reuse-window"]&&!C.wait,forceReuseWindow:C["reuse-window"],diffMode:C.diff,mergeMode:C.merge,addMode:C.add,noRecentEntry:!!C["skip-add-to-recently-opened"],gotoLineMode:C.goto});if(g&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,D.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};h=ve([ee(0,I.ILogService),ee(1,b.IWindowsMainService),ee(2,v.IURLService),ee(3,E.IConfigurationService),ee(4,d.IUserDataProfilesMainService)],h),e.LaunchMainService=h}),define(te[91],ie([0,1,7,49,3,2,36,14,4,22,6,90,257,39,42,51]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,u.createDecorator)("storageMainService");let C=class extends R.Disposable{constructor(f,g,a,i,o,n){super(),this.logService=f,this.environmentService=g,this.userDataProfilesService=a,this.lifecycleMainService=i,this.fileService=o,this.uriIdentityService=n,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new k.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(f=>{f.window.profile&&this.profileStorage(f.window.profile).init(),f.workspace&&this.workspaceStorage(f.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(f=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=f.reason,f.join(this.applicationStorage.close());for(const[,g]of this.mapProfileToStorage)f.join(g.close());for(const[,g]of this.mapWorkspaceToStorage)f.join(g.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(f=>{f.join((async()=>{await this.fileService.exists(f.profile.globalStorageHome)||await this.fileService.createFolder(f.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(f=>{const g=this.mapProfileToStorage.get(f.profile.id);g&&f.join(g.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const f=new b.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,t.once)(f.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),f}profileStorage(f){if((0,v.isProfileUsingDefaultStorage)(f))return this.applicationStorage;let g=this.mapProfileToStorage.get(f.id);if(!g){this.logService.trace(`StorageMainService: creating profile storage (${f.name})`),g=this.createProfileStorage(f),this.mapProfileToStorage.set(f.id,g);const a=this._register(g.onDidChangeStorage(i=>this._onDidChangeProfileStorage.fire({...i,storage:g,profile:f})));(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${f.name})`),this.mapProfileToStorage.delete(f.id),a.dispose()})}return g}createProfileStorage(f){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.ProfileStorageMain(f,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(f){let g=this.mapWorkspaceToStorage.get(f.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${f.id})`),g=this.createWorkspaceStorage(f),this.mapWorkspaceToStorage.set(f.id,g),(0,t.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${f.id})`),this.mapWorkspaceToStorage.delete(f.id)})),g}createWorkspaceStorage(f){return this.shutdownReason===2?new b.InMemoryStorageMain(this.logService,this.fileService):new b.WorkspaceStorageMain(f,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(f){const g=w.URI.file(f);for(const a of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(!!a.path&&this.uriIdentityService.extUri.isEqualOrParent(w.URI.file(a.path),g))return!0;return!1}};C=ve([ee(0,I.ILogService),ee(1,D.IEnvironmentService),ee(2,h.IUserDataProfilesMainService),ee(3,m.ILifecycleMainService),ee(4,E.IFileService),ee(5,y.IUriIdentityService)],C),e.StorageMainService=C,e.IApplicationStorageMainService=(0,u.createDecorator)("applicationStorageMainService");let p=class extends v.AbstractStorageService{constructor(f,g){super(),this.userDataProfilesService=f,this.storageMainService=g,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(f){if(f===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(f){if(f===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};p=ve([ee(0,d.IUserDataProfilesService),ee(1,e.IStorageMainService)],p),e.ApplicationStorageMainService=p}),define(te[261],ie([0,1,2,22,42]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends w.Disposable{constructor(E,u){super(),this.userDataProfilesService=u,this._register(E.onWillLoadWindow(m=>{m.reason===2&&this.unsetTransientProfileForWorkspace(m.window.openedWorkspace??"empty-window")})),this._register(E.onBeforeCloseWindow(m=>this.unsetTransientProfileForWorkspace(m.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(E){this.userDataProfilesService.getOrSetProfileForWorkspace(E).isTransient&&(this.userDataProfilesService.unsetWorkspace(E,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([ee(0,t.ILifecycleMainService),ee(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(te[262],ie([0,1,3,2,90]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(E,u,m){super(),this.storageMainService=E,this.userDataProfilesService=u,this.logService=m;const I=this._register(new t.MutableDisposable);this._onDidChange=this._register(new w.Emitter({onFirstListenerAdd:()=>I.value=this.registerStorageChangeListeners(),onLastListenerRemove:()=>I.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new t.DisposableStore;return E.add(w.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(u,m)=>(u?u.push(m.key):u=[m.key],u),100)(u=>this.onDidChangeApplicationStorage(u))),E.add(w.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(u,m)=>{u||(u=new Map);let I=u.get(m.profile.id);return I||u.set(m.profile.id,I={profile:m.profile,keys:[],storage:m.storage}),I.keys.push(m.key),u},100)(u=>this.onDidChangeProfileStorage(u))),E}onDidChangeApplicationStorage(E){const u=E.includes(k.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],m=[];if(E=E.filter(I=>I!==k.TARGET_KEY),E.length){const I=(0,k.loadKeyTargets)(this.storageMainService.applicationStorage.storage);m.push({profile:this.userDataProfilesService.defaultProfile,changes:E.map(v=>({key:v,scope:0,target:I[v]}))})}this.triggerEvents(u,m)}onDidChangeProfileStorage(E){const u=[],m=new Map;for(const[I,v]of E.entries()){v.keys.includes(k.TARGET_KEY)&&u.push(v.profile);const b=v.keys.filter(d=>d!==k.TARGET_KEY);if(b.length){const d=(0,k.loadKeyTargets)(v.storage.storage);m.set(I,{profile:v.profile,changes:b.map(h=>({key:h,scope:0,target:d[h]}))})}}this.triggerEvents(u,[...m.values()])}triggerEvents(E,u){(E.length||u.length)&&this._onDidChange.fire({valueChanges:u,targetChanges:E})}listen(E,u,m){switch(u){case"onDidChange":return this._onDidChange.event}throw new Error(`Event not found: ${u}`)}async call(E,u){throw new Error(`Call not found: ${u}`)}}e.ProfileStorageChangesListenerChannel=R}),define(te[117],ie([0,1,16,7,28]),function(z,e,w,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(u,m,I){for(const b of u){const d=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(d)){const h=await I(d);if(h){if(h.folders.some(y=>w.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.uri)))return b}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(m,d.configPath))return b}}const v=u.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(m,b.openedWorkspace.uri));if(v.length)return v.sort((b,d)=>-(b.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(u,m){for(const I of u)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,m))return I}e.findWindowOnWorkspaceOrFolder=D;function E(u,m){const I=v=>m.some(b=>w.extUriBiasedIgnorePathCase.isEqual(t.URI.file(b),t.URI.file(v)));for(const v of u)if(v.config?.extensionDevelopmentPath?.some(b=>I(b)))return v}e.findWindowOnExtensionDevelopmentPath=E}),define(te[263],ie([0,1,15,2,5,16,7,19,22,6,38,33,116,28]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let h=class Tt extends t.Disposable{get state(){return this._state}constructor(g,a,i,o,n){super(),this.windowsMainService=g,this.stateMainService=a,this.lifecycleMainService=i,this.logService=o,this.configurationService=n,this._state=y(this.stateMainService.getItem(Tt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(g=>this.onBeforeCloseWindow(g)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(g=>{g.newCount-g.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(g=>this.onBeforeCloseWindow(g))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const g=new Set,a={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!a.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),n&&(a.lastActiveWindow=this.toWindowState(n),a.lastActiveWindow.uiState.mode===3&&g.add(a.lastActiveWindow.uiState.display))}const i=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(a.lastPluginDevelopmentHostWindow=this.toWindowState(i),a.lastPluginDevelopmentHostWindow.uiState.mode===3&&(g.has(a.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(a.lastPluginDevelopmentHostWindow.uiState.mode=1):g.add(a.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(a.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const r=this.toWindowState(n);return r.uiState.mode===3&&(g.has(r.uiState.display)?k.isMacintosh&&r.windowId!==a.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(r.uiState.mode=1):g.add(r.uiState.display)),r}));const o=p(a);this.stateMainService.setItem(Tt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(g){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(g);g.isExtensionDevelopmentHost&&!g.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!g.isExtensionDevelopmentHost&&g.openedWorkspace&&this._state.openedWindows.forEach(i=>{const o=(0,d.isWorkspaceIdentifier)(g.openedWorkspace)&&i.workspace?.id===g.openedWorkspace.id,n=(0,d.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,g.openedWorkspace.uri);(o||n)&&(i.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(g){return{windowId:g.id,workspace:(0,d.isWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)?g.openedWorkspace.uri:void 0,backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.serializeWindowState()}}getNewWindowState(g){const a=this.doGetNewWindowState(g),i=this.configurationService.getValue("window");if(a.mode===3){let o;a.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||i?.restoreFullscreen),o||(a.mode=1)}return a}doGetNewWindowState(g){const a=this.windowsMainService.getLastActiveWindow();if(!g.extensionTestsPath){if(!!g.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=g.workspace;if((0,d.isWorkspaceIdentifier)(c)){const P=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===c.id).map(M=>M.uiState);if(P.length)return P[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(c)){const P=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,c.uri)).map(M=>M.uiState);if(P.length)return P[0]}else if(g.backupPath){const P=this.state.openedWindows.filter(M=>M.backupPath===g.backupPath).map(M=>M.uiState);if(P.length)return P[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!a&&l)return l.uiState}let i;const o=w.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(k.isMacintosh){const c=w.screen.getCursorScreenPoint();i=w.screen.getDisplayNearestPoint(c)}!i&&a&&(i=w.screen.getDisplayMatching(a.getBounds())),i||(i=w.screen.getPrimaryDisplay()||o[0])}let n=(0,b.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")n.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")n.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const c=a.serializeWindowState();c.mode===3?n.mode=3:n=c,s=n.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(g){if(this.windowsMainService.getWindows().length===0)return g;g.x=typeof g.x=="number"?g.x:0,g.y=typeof g.y=="number"?g.y:0;const a=this.windowsMainService.getWindows().map(i=>i.getBounds());for(;a.some(i=>i.x===g.x||i.y===g.y);)g.x+=30,g.y+=30;return g}};h.windowsStateStorageKey="windowsState",h=ve([ee(0,v.IWindowsMainService),ee(1,I.IStateMainService),ee(2,u.ILifecycleMainService),ee(3,m.ILogService),ee(4,E.IConfigurationService)],h),e.WindowsStateHandler=h;function y(f){const g={openedWindows:[]},a=f||{openedWindows:[]};return a.lastActiveWindow&&(g.lastActiveWindow=C(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(g.lastPluginDevelopmentHostWindow=C(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(g.openedWindows=a.openedWindows.map(i=>C(i))),g}e.restoreWindowsState=y;function C(f){const g={uiState:f.uiState};return f.backupPath&&(g.backupPath=f.backupPath),f.remoteAuthority&&(g.remoteAuthority=f.remoteAuthority),f.folder&&(g.folderUri=D.URI.parse(f.folder)),f.workspaceIdentifier&&(g.workspace={id:f.workspaceIdentifier.id,configPath:D.URI.parse(f.workspaceIdentifier.configURIPath)}),g}function p(f){return{lastActiveWindow:f.lastActiveWindow&&S(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&S(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(g=>S(g))}}e.getWindowsStateStoreData=p;function S(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(te[92],ie([0,1,30,43,123,35,13,9,5,16,7,4,63,28]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function h(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=h;function y(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=y;function C(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=C;function p(M){return S(M)||f(M)}e.isStoredWorkspaceFolder=p;function S(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function f(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function g(M,T,N,X,ae){if(M.scheme!==X.scheme)return{name:N,uri:M.toString(!0)};let Q=T?void 0:ae.relativePath(X,M);if(Q!==void 0)Q.length===0?Q=".":u.isWindows&&(Q=a(Q));else if(M.scheme===D.Schemas.file)Q=M.fsPath,u.isWindows&&(Q=a(Q));else if(ae.isEqualAuthority(M.authority,X.authority))Q=M.path;else return{name:N,uri:M.toString(!0)};return{name:N,path:Q}}e.getStoredWorkspaceFolder=g;function a(M){return M=(0,R.normalizeDriveLetter)(M),(0,w.isUNC)(M)||(M=(0,w.toSlashes)(M)),M}function i(M,T,N){const X=[],ae=new Set,Q=N.dirname(T);for(const G of M){let Z;if(S(G))G.path&&(Z=N.resolvePath(Q,G.path));else if(f(G))try{Z=I.URI.parse(G.uri),Z.path[0]!==E.posix.sep&&(Z=Z.with({path:E.posix.sep+Z.path}))}catch(se){console.warn(se)}if(Z){const se=N.getComparisonKey(Z);if(!ae.has(se)){ae.add(se);const he=G.name||N.basenameOrAuthority(Z);X.push(new d.WorkspaceFolder({uri:Z,name:he,index:X.length},G))}}}return X}e.toWorkspaceFolders=i;function o(M,T,N,X,ae){const Q=n(T,M),G=ae.dirname(T),Z=ae.dirname(X),se=[];for(const W of Q.folders){const A=S(W)?ae.resolvePath(G,W.path):I.URI.parse(W.uri);let F;N?F=!1:F=!S(W)||(0,E.isAbsolute)(W.path),se.push(g(A,F,W.name,Z,ae))}const he={insertSpaces:!1,tabSize:4,eol:u.isLinux||u.isMacintosh?`
`:`\r
`},V=k.setProperty(M,["folders"],se,he);let H=k.applyEdits(M,V);return(0,m.isEqualAuthority)(Q.remoteAuthority,(0,b.getRemoteAuthority)(X))&&(H=k.applyEdits(H,k.removeProperty(H,["remoteAuthority"],he))),H}e.rewriteWorkspaceFileForNewLocation=o;function n(M,T){const N=t.parse(T);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(X=>p(X));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function r(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function s(M){return typeof M.folderUri=="string"}function c(M){return typeof M.fileUri=="string"}function l(M,T){const N={workspaces:[],files:[]};if(M){const X=function(Q,G){for(let Z=0;Z<Q.length;Z++)try{G(Q[Z],Z)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(Q[Z])}: ${se.toString()}. Skip entry.`)}},ae=M;Array.isArray(ae.entries)&&X(ae.entries,Q=>{const G=Q.label,Z=Q.remoteAuthority;r(Q)?N.workspaces.push({label:G,remoteAuthority:Z,workspace:{id:Q.workspace.id,configPath:I.URI.parse(Q.workspace.configPath)}}):s(Q)?N.workspaces.push({label:G,remoteAuthority:Z,folderUri:I.URI.parse(Q.folderUri)}):c(Q)&&N.files.push({label:G,remoteAuthority:Z,fileUri:I.URI.parse(Q.fileUri)})})}return N}e.restoreRecentlyOpened=l;function P(M){const T={entries:[]};for(const N of M.workspaces)y(N)?T.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):T.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)T.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return T}e.toStoreData=P}),define(te[93],ie([0,1,76,13,5,16]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(m){function I(){let v=m.scheme===t.Schemas.file?(0,R.originalFSPath)(m):m.toString();return k.isLinux||(v=v.toLowerCase()),(0,w.createHash)("md5").update(v).digest("hex")}return{id:I(),configPath:m}}e.getWorkspaceIdentifier=D;function E(m,I){function v(){if(m.scheme!==t.Schemas.file)return(0,w.createHash)("md5").update(m.toString()).digest("hex");if(!I)return;let d;return k.isLinux?d=I.ino:k.isMacintosh?d=I.birthtime.getTime():k.isWindows&&(typeof I.birthtimeMs=="number"?d=Math.floor(I.birthtimeMs):d=I.birthtime.getTime()),(0,w.createHash)("md5").update(m.fsPath).update(d?String(d):"").digest("hex")}const b=v();if(typeof b=="string")return{id:b,uri:m}}e.getSingleFolderWorkspaceIdentifier=E;function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=u}),define(te[264],ie([0,1,76,30,13,9,5,16,21,177,19,26,38,14,6,176,28,93]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class Ot{constructor(g,a,i,o){this.environmentMainService=g,this.configurationService=a,this.logService=i,this.stateMainService=o,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=E.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,r)=>(0,t.isEqual)(n,r,!D.isLinux)}}async initialize(){const g=await this.initializeAndMigrateBackupWorkspacesMetadata();this.emptyWindows=await this.validateEmptyWorkspaces(g.emptyWindows),this.workspaces=await this.validateWorkspaces((0,m.deserializeWorkspaceInfos)(g)),this.folders=await this.validateFolders((0,m.deserializeFolderInfos)(g)),this.storeWorkspacesMetadata()}async initializeAndMigrateBackupWorkspacesMetadata(){let g=this.stateMainService.getItem(Ot.backupWorkspacesMetadataStorageKey);if(!g)try{const a=(0,R.join)(this.backupHome,"workspaces.json"),i=await u.Promises.readFile(a,"utf8");try{await u.Promises.unlink(a)}catch{}const o=JSON.parse(i);g={workspaces:Array.isArray(o.rootURIWorkspaces)?o.rootURIWorkspaces:[],folders:Array.isArray(o.folderWorkspaceInfos)?o.folderWorkspaceInfos:[],emptyWindows:Array.isArray(o.emptyWorkspaceInfos)?o.emptyWorkspaceInfos:[]}}catch(a){a.code!=="ENOENT"&&this.logService.error(`Backup: Could not migrate legacy backup workspaces metadata: ${a.toString()}`)}return g??{workspaces:[],folders:[],emptyWindows:[]}}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(g,a){this.workspaces.some(o=>g.workspace.id===o.workspace.id)||(this.workspaces.push(g),this.storeWorkspacesMetadata());const i=(0,R.join)(this.backupHome,g.workspace.id);return a?this.moveBackupFolder(i,a).then(()=>i):i}async moveBackupFolder(g,a){if(await u.Promises.exists(g)&&await this.convertToEmptyWindowBackup(g),await u.Promises.exists(a))try{await u.Promises.rename(a,g)}catch(i){this.logService.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(g){return this.folders.some(a=>this.backupUriComparer.isEqual(g.folderUri,a.folderUri))||(this.folders.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,this.getFolderHash(g))}registerEmptyWindowBackup(g){return this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,g.backupFolder))||(this.emptyWindows.push(g),this.storeWorkspacesMetadata()),(0,R.join)(this.backupHome,g.backupFolder)}async validateWorkspaces(g){if(!Array.isArray(g))return[];const a=new Set,i=[];for(const o of g){const n=o.workspace;if(!(0,C.isWorkspaceIdentifier)(n))return[];if(!a.has(n.id)){a.add(n.id);const r=(0,R.join)(this.backupHome,n.id);await this.doHasBackups(r)?n.configPath.scheme!==k.Schemas.file||await u.Promises.exists(n.configPath.fsPath)?i.push(o):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return i}async validateFolders(g){if(!Array.isArray(g))return[];const a=[],i=new Set;for(const o of g){const n=o.folderUri,r=this.backupUriComparer.getComparisonKey(n);if(!i.has(r)){i.add(r);const s=(0,R.join)(this.backupHome,this.getFolderHash(o));await this.doHasBackups(s)?n.scheme!==k.Schemas.file||await u.Promises.exists(n.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(g){if(!Array.isArray(g))return[];const a=[],i=new Set;for(const o of g){const n=o.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const r=(0,R.join)(this.backupHome,n);await this.doHasBackups(r)?a.push(o):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(g){try{await u.Promises.rm(g,u.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}prepareNewEmptyWindowBackup(){let g=(0,p.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,g.id));)g=(0,p.createEmptyWorkspaceIdentifier)();return{backupFolder:g.id}}async convertToEmptyWindowBackup(g){const a=this.prepareNewEmptyWindowBackup(),i=(0,R.join)(this.backupHome,a.backupFolder);try{await u.Promises.rename(g,i)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push(a),!0}async getDirtyWorkspaces(){const g=[];for(const a of this.workspaces)await this.hasBackups(a)&&g.push(a);for(const a of this.folders)await this.hasBackups(a)&&g.push(a);return g}hasBackups(g){let a;return(0,m.isEmptyWindowBackupInfo)(g)?a=(0,R.join)(this.backupHome,g.backupFolder):(0,y.isFolderBackupInfo)(g)?a=(0,R.join)(this.backupHome,this.getFolderHash(g)):a=(0,R.join)(this.backupHome,g.workspace.id),this.doHasBackups(a)}async doHasBackups(g){try{const a=await u.Promises.readdir(g);for(const i of a)try{if((await u.Promises.readdir((0,R.join)(g,i))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const g={workspaces:this.workspaces.map(({workspace:a,remoteAuthority:i})=>{const o={id:a.id,configURIPath:a.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.folders.map(({folderUri:a,remoteAuthority:i})=>{const o={folderUri:a.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.emptyWindows.map(({backupFolder:a,remoteAuthority:i})=>{const o={backupFolder:a};return i&&(o.remoteAuthority=i),o})};this.stateMainService.setItem(Ot.backupWorkspacesMetadataStorageKey,g)}getFolderHash(g){const a=g.folderUri;let i;return a.scheme===k.Schemas.file?i=D.isLinux?a.fsPath:a.fsPath.toLowerCase():i=a.toString().toLowerCase(),(0,w.createHash)("md5").update(i).digest("hex")}};S.backupWorkspacesMetadataStorageKey="backupWorkspaces",S=ve([ee(0,v.IEnvironmentMainService),ee(1,I.IConfigurationService),ee(2,h.ILogService),ee(3,b.IStateMainService)],S),e.BackupMainService=S}),define(te[52],ie([0,1,15,3,43,35,2,13,9,16,12,21,175,60,56,26,4,6,20,42,117,28,92,93]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,C.createDecorator)("workspacesManagementMainService");let n=class extends D.Disposable{constructor(s,c,l,P,M,T){super(),this.environmentMainService=s,this.logService=c,this.userDataProfilesMainService=l,this.backupMainService=P,this.dialogMainService=M,this.productService=T,this._onDidDeleteUntitledWorkspace=this._register(new t.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new t.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const s=(await v.Promises.readdir(this.untitledWorkspacesHome.fsPath)).map(c=>(0,m.joinPath)(this.untitledWorkspacesHome,c,a.UNTITLED_WORKSPACE_NAME));for(const c of s){const l=(0,o.getWorkspaceIdentifier)(c),P=await this.resolveLocalWorkspace(c);P?this.untitledWorkspaces.push({workspace:l,remoteAuthority:P.remoteAuthority}):await this.deleteUntitledWorkspace(l)}}catch(s){s.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${s}).`)}}resolveLocalWorkspace(s){return this.doResolveLocalWorkspace(s,c=>v.Promises.readFile(c,"utf8"))}doResolveLocalWorkspace(s,c){if(!!this.isWorkspacePath(s)&&s.scheme===E.Schemas.file)try{const l=c(s.fsPath);return l instanceof Promise?l.then(P=>this.doResolveWorkspace(s,P),P=>{}):this.doResolveWorkspace(s,l)}catch{return}}isWorkspacePath(s){return(0,a.isUntitledWorkspace)(s,this.environmentMainService)||(0,a.hasWorkspaceFileExtension)(s)}doResolveWorkspace(s,c){try{const l=this.doParseStoredWorkspace(s,c),P=(0,o.getWorkspaceIdentifier)(s);return{id:P.id,configPath:P.configPath,folders:(0,i.toWorkspaceFolders)(l.folders,P.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:l.remoteAuthority,transient:l.transient}}catch(l){this.logService.warn(l.toString())}}doParseStoredWorkspace(s,c){const l=(0,k.parse)(c);if(l&&Array.isArray(l.folders))l.folders=l.folders.filter(P=>(0,i.isStoredWorkspaceFolder)(P));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return l}async createUntitledWorkspace(s,c){const{workspace:l,storedWorkspace:P}=this.newUntitledWorkspace(s,c),M=l.configPath.fsPath;return await v.Promises.mkdir((0,u.dirname)(M),{recursive:!0}),await v.Promises.writeFile(M,JSON.stringify(P,null,"	")),this.untitledWorkspaces.push({workspace:l,remoteAuthority:c}),l}newUntitledWorkspace(s=[],c){const l=(Date.now()+Math.round(Math.random()*1e3)).toString(),P=(0,m.joinPath)(this.untitledWorkspacesHome,l),M=(0,m.joinPath)(P,a.UNTITLED_WORKSPACE_NAME),T=[];for(const N of s)T.push((0,i.getStoredWorkspaceFolder)(N.uri,!0,N.name,P,m.extUriBiasedIgnorePathCase));return{workspace:(0,o.getWorkspaceIdentifier)(M),storedWorkspace:{folders:T,remoteAuthority:c}}}async getWorkspaceIdentifier(s){return(0,o.getWorkspaceIdentifier)(s)}isUntitledWorkspace(s){return(0,a.isUntitledWorkspace)(s.configPath,this.environmentMainService)}async deleteUntitledWorkspace(s){!this.isUntitledWorkspace(s)||(await this.doDeleteUntitledWorkspace(s),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(s),this._onDidDeleteUntitledWorkspace.fire(s))}async doDeleteUntitledWorkspace(s){const c=(0,m.originalFSPath)(s.configPath);try{await v.Promises.rm((0,u.dirname)(c));const l=(0,u.join)(this.environmentMainService.workspaceStorageHome.fsPath,s.id);await v.Promises.exists(l)&&await v.Promises.writeFile((0,u.join)(l,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(P=>P.workspace.id!==s.id)}catch(l){this.logService.warn(`Unable to delete untitled workspace ${c} (${l}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(s,c,l){if(!s||!s.win||!s.isReady||!await this.isValidTargetWorkspacePath(s,c,l))return;const M=await this.doEnterWorkspace(s,(0,o.getWorkspaceIdentifier)(l));if(!!M)return this._onDidEnterWorkspace.fire({window:s,workspace:M.workspace}),M}async isValidTargetWorkspacePath(s,c,l){if(!l)return!0;if((0,a.isWorkspaceIdentifier)(s.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(s.openedWorkspace.configPath,l))return!1;if((0,g.findWindowOnWorkspaceOrFolder)(c,l)){const P={title:this.productService.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(0,null))],message:(0,b.localize)(1,null,(0,m.basename)(l)),detail:(0,b.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(P,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}async doEnterWorkspace(s,c){if(!s.config)return;s.focus();let l;return s.config.extensionDevelopmentPath||(s.config.backupPath?l=await this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority},s.config.backupPath):l=this.backupMainService.registerWorkspaceBackup({workspace:c,remoteAuthority:s.remoteAuthority})),(0,a.isWorkspaceIdentifier)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=c,s.config.backupPath=l,{workspace:c,backupPath:l}}};n=ve([ee(0,y.IEnvironmentMainService),ee(1,p.ILogService),ee(2,f.IUserDataProfilesMainService),ee(3,d.IBackupMainService),ee(4,h.IDialogMainService),ee(5,S.IProductService)],n),e.WorkspacesManagementMainService=n}),define(te[118],ie([0,1,15,41,23,4,33,28,52,12,6]),function(z,e,w,t,k,R,D,E,u,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let v=class{constructor(d,h,y){this.windowsMainService=d,this.workspacesManagementMainService=h,this.logService=y}async getRemoteDiagnostics(d){const h=this.windowsMainService.getWindows();return(await Promise.all(h.map(async C=>{const p=C.remoteAuthority;if(!p)return;const S=`vscode:getDiagnosticInfoResponse${C.id}`,f={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.getFolderURIs(C):void 0};return new Promise(g=>{C.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:S,args:f}),t.validatedIpcMain.once(S,(a,i)=>{i||g({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),g(i)}),setTimeout(()=>{g({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)})}))).filter(C=>!!C)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const d=[];for(const h of w.BrowserWindow.getAllWindows()){const y=this.windowsMainService.getWindowById(h.id);y?d.push(await this.codeWindowToInfo(y)):d.push(this.browserWindowToInfo(h))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}async codeWindowToInfo(d){const h=await this.getFolderURIs(d),y=(0,m.assertIsDefined)(d.win);return this.browserWindowToInfo(y,h,d.remoteAuthority)}browserWindowToInfo(d,h=[],y){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:h,remoteAuthority:y}}async getFolderURIs(d){const h=[],y=d.openedWorkspace;if((0,E.isSingleFolderWorkspaceIdentifier)(y))h.push(y.uri);else if((0,E.isWorkspaceIdentifier)(y)){const C=await this.workspacesManagementMainService.resolveLocalWorkspace(y.configPath);C&&C.folders.forEach(S=>{h.push(S.uri)})}return h}};v=ve([ee(0,D.IWindowsMainService),ee(1,u.IWorkspacesManagementMainService),ee(2,I.ILogService)],v),e.DiagnosticsMainService=v}),define(te[65],ie([0,1,45,15,27,141,53,3,35,2,13,9,5,7,98,81,21,94,165,56,26,4,22,6,20,64,33,28,52,18,221,231,32]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o,n,r,s,c,l,P,M,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let X=class extends m.Disposable{constructor(Q,G,Z,se,he,V,H,W,A,F){super(),this.sharedProcess=Q,this.windowsMainService=G,this.dialogMainService=Z,this.lifecycleMainService=se,this.environmentMainService=he,this.logService=V,this.productService=H,this.themeMainService=W,this.workspacesManagementMainService=A,this.telemetryService=F,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,U=>U.id),this.onDidTriggerSystemContextMenu=E.Event.filter(E.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:U,x:J,y:B})=>({windowId:U.id,x:J,y:B})),({windowId:U})=>!!this.windowsMainService.getWindowById(U)),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),U=>!!U),U=>U.id),E.Event.filter(E.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(U,J)=>J.id),U=>!!this.windowsMainService.getWindowById(U))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(U,J,B)=>B),U=>!(Array.isArray(U)&&U.length===1&&U[0]==="workArea")),E.Event.fromNodeEventEmitter(t.screen,"display-added"),E.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100),this._profilingSessions=new Map}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(G=>({id:G.id,workspace:G.openedWorkspace??(0,c.toWorkspaceIdentifier)(G.backupPath,G.isExtensionDevelopmentHost),title:G.win?.getTitle()??"",filename:G.getRepresentedFilename(),dirty:G.isDocumentEdited()}))}async getWindowCount(Q){return this.windowsMainService.getWindowCount()}async getActiveWindowId(Q){const G=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(G)return G.id}openWindow(Q,G,Z){return Array.isArray(G)?this.doOpenWindow(Q,G,Z):this.doOpenEmptyWindow(Q,G)}async doOpenWindow(Q,G,Z=Object.create(null)){G.length>0&&await this.windowsMainService.open({context:5,contextWindowId:Q,urisToOpen:G,cli:this.environmentMainService.args,forceNewWindow:Z.forceNewWindow,forceReuseWindow:Z.forceReuseWindow,preferNewWindow:Z.preferNewWindow,diffMode:Z.diffMode,mergeMode:Z.mergeMode,addMode:Z.addMode,gotoLineMode:Z.gotoLineMode,noRecentEntry:Z.noRecentEntry,waitMarkerFileURI:Z.waitMarkerFileURI,remoteAuthority:Z.remoteAuthority||void 0})}async doOpenEmptyWindow(Q,G){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:Q},G)}async toggleFullScreen(Q){this.windowById(Q)?.toggleFullScreen()}async handleTitleDoubleClick(Q){this.windowById(Q)?.handleTitleDoubleClick()}async isMaximized(Q){const G=this.windowById(Q);return G?.win?G.win.isMaximized():!1}async maximizeWindow(Q){const G=this.windowById(Q);G?.win&&G.win.maximize()}async unmaximizeWindow(Q){const G=this.windowById(Q);G?.win&&G.win.unmaximize()}async minimizeWindow(Q){const G=this.windowById(Q);G?.win&&G.win.minimize()}async updateWindowControls(Q,G){const Z=this.windowById(Q);Z&&Z.updateWindowControls(G)}async focusWindow(Q,G){G&&typeof G.windowId=="number"&&(Q=G.windowId),this.windowById(Q)?.focus({force:G?.force??!1})}async setMinimumSize(Q,G,Z){const se=this.windowById(Q);if(se?.win){const[he,V]=se.win.getSize(),[H,W]=se.win.getMinimumSize(),[A,F]=[G??H,Z??W],[U,J]=[Math.max(he,A),Math.max(V,F)];(H!==A||W!==F)&&se.win.setMinimumSize(A,F),(he!==U||V!==J)&&se.win.setSize(U,J)}}async saveWindowSplash(Q,G){this.themeMainService.saveWindowSplash(Q,G)}async installShellCommand(Q){const{source:G,target:Z}=await this.getShellCommandLink();try{const{symbolicLink:se}=await C.SymlinkSupport.stat(G);if(se&&!se.dangling){const he=await(0,h.realpath)(G);if(Z===he)return}await C.Promises.unlink(G)}catch(se){if(se.code!=="ENOENT")throw se}try{await C.Promises.symlink(Z,G)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:he}=await this.showMessageBox(Q,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(he===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Z}' '${G}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(V)}catch{throw new Error((0,S.localize)(3,null,G))}}}async uninstallShellCommand(Q){const{source:G}=await this.getShellCommandLink();try{await C.Promises.unlink(G)}catch(Z){switch(Z.code){case"EACCES":{const{response:se}=await this.showMessageBox(Q,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,u.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,u.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const he=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,R.promisify)(w.exec)(he)}catch{throw new Error((0,S.localize)(7,null,G))}break}case"ENOENT":break;default:throw Z}}}async getShellCommandLink(){const Q=(0,v.resolve)(this.environmentMainService.appRoot,"bin","code"),G=`/usr/local/bin/${this.productService.applicationName}`;if(!await C.Promises.exists(Q))throw new Error((0,S.localize)(8,null,Q));return{source:G,target:Q}}async showMessageBox(Q,G){return this.dialogMainService.showMessageBox(G,this.toBrowserWindow(Q))}async showSaveDialog(Q,G){return this.dialogMainService.showSaveDialog(G,this.toBrowserWindow(Q))}async showOpenDialog(Q,G){return this.dialogMainService.showOpenDialog(G,this.toBrowserWindow(Q))}toBrowserWindow(Q){const G=this.windowById(Q);if(G?.win)return G.win}async pickFileFolderAndOpen(Q,G){const Z=await this.dialogMainService.pickFileFolder(G);Z&&await this.doOpenPicked(await Promise.all(Z.map(async se=>await C.SymlinkSupport.existsDirectory(se)?{folderUri:d.URI.file(se)}:{fileUri:d.URI.file(se)})),G,Q)}async pickFolderAndOpen(Q,G){const Z=await this.dialogMainService.pickFolder(G);Z&&await this.doOpenPicked(Z.map(se=>({folderUri:d.URI.file(se)})),G,Q)}async pickFileAndOpen(Q,G){const Z=await this.dialogMainService.pickFile(G);Z&&await this.doOpenPicked(Z.map(se=>({fileUri:d.URI.file(se)})),G,Q)}async pickWorkspaceAndOpen(Q,G){const Z=await this.dialogMainService.pickWorkspace(G);Z&&await this.doOpenPicked(Z.map(se=>({workspaceUri:d.URI.file(se)})),G,Q)}async doOpenPicked(Q,G,Z){await this.windowsMainService.open({context:3,contextWindowId:Z,cli:this.environmentMainService.args,urisToOpen:Q,forceNewWindow:G.forceNewWindow})}async showItemInFolder(Q,G){t.shell.showItemInFolder(G)}async setRepresentedFilename(Q,G){this.windowById(Q)?.setRepresentedFilename(G)}async setDocumentEdited(Q,G){this.windowById(Q)?.setDocumentEdited(G)}async openExternal(Q,G){return b.isLinuxSnap?this.safeSnapOpenExternal(G):t.shell.openExternal(G),!0}safeSnapOpenExternal(Q){const G=process.env.GDK_PIXBUF_MODULE_FILE,Z=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(Q),process.env.GDK_PIXBUF_MODULE_FILE=G,process.env.GDK_PIXBUF_MODULEDIR=Z}moveItemToTrash(Q,G){return t.shell.trashItem(G)}async isAdmin(){let Q;return b.isWindows?Q=(await new Promise((G,Z)=>{z(["native-is-elevated"],G,Z)}))():Q=process.getuid()===0,Q}async writeElevated(Q,G,Z,se){const he=await new Promise((V,H)=>{z(["@vscode/sudo-prompt"],V,H)});return new Promise((V,H)=>{const W=[`"${this.cliPath}"`];se?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${G.fsPath}"`,`"${Z.fsPath}"`);const A={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};he.exec(W.join(" "),A,(F,U,J)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),J&&this.logService.trace(`[sudo-prompt] received stderr: ${J}`),F?H(F):V(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,v.join)(this.environmentMainService.appRoot,"bin","code"):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(Q,G,Z){process.kill(G,Z)}async readClipboardText(Q,G){return t.clipboard.readText(G)}async writeClipboardText(Q,G,Z){return t.clipboard.writeText(G,Z)}async readClipboardFindText(Q){return t.clipboard.readFindText()}async writeClipboardFindText(Q,G){return t.clipboard.writeFindText(G)}async writeClipboardBuffer(Q,G,Z,se){return t.clipboard.writeBuffer(G,Buffer.from(Z.buffer),se)}async readClipboardBuffer(Q,G){return P.VSBuffer.wrap(t.clipboard.readBuffer(G))}async hasClipboard(Q,G,Z){return t.clipboard.has(G,Z)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(Q,G){this.windowById(Q)?.updateTouchBar(G)}async notifyReady(Q){this.windowById(Q)?.setReady()}async relaunch(Q,G){return this.lifecycleMainService.relaunch(G)}async reload(Q,G){const Z=this.windowById(Q);if(Z){if((0,c.isWorkspaceIdentifier)(Z.openedWorkspace)){const se=Z.openedWorkspace.configPath;if(se.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(se))?.transient)return this.openWindow(Z.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Z,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(Q){this.closeWindowById(Q,Q)}async closeWindowById(Q,G){const Z=this.windowById(G);if(Z?.win)return Z.win.close()}async quit(Q){const G=this.windowsMainService.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&G.win?G.win.close():this.lifecycleMainService.quit()}async exit(Q,G){await this.lifecycleMainService.kill(G)}async resolveProxy(Q,G){const se=this.windowById(Q)?.win?.webContents?.session;if(se)return se.resolveProxy(G)}findFreePort(Q,G,Z,se,he=1){return(0,p.findFreePort)(G,Z,se,he)}async openDevTools(Q,G){const Z=this.windowById(Q);Z?.win&&Z.win.webContents.openDevTools(G)}async toggleDevTools(Q){const G=this.windowById(Q);G?.win&&G.win.webContents.toggleDevTools()}async sendInputEvent(Q,G){const Z=this.windowById(Q);Z?.win&&(G.type==="mouseDown"||G.type==="mouseUp")&&Z.win.webContents.sendInputEvent(G)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async startHeartbeat(Q,G){const Z=this.windowById(Q);if(!Z||!Z.win)return!1;if(!this._profilingSessions.has(Z.id)){const se=new T.WindowProfiler(Z.win,G,this.logService,this.telemetryService);this._profilingSessions.set(Z.id,se),se.start()}return!0}async sendHeartbeat(Q,G){const Z=this.windowById(Q);return!Z||!this._profilingSessions.has(Z.id)||this._profilingSessions.get(Z.id).receiveHeartbeat(),!1}async stopHeartbeat(Q,G){const Z=this.windowById(Q);return!Z||!this._profilingSessions.has(Z.id)||(this._profilingSessions.get(Z.id).stop(),this._profilingSessions.delete(Z.id)),!1}async windowsGetStringRegKey(Q,G,Z,se){if(!b.isWindows)return;const he=await new Promise((V,H)=>{z(["@vscode/windows-registry"],V,H)});try{return he.GetStringRegKey(G,Z,se)}catch{return}}windowById(Q){if(typeof Q=="number")return this.windowsMainService.getWindowById(Q)}};ve([D.memoize],X.prototype,"cliPath",null),X=ve([ee(1,s.IWindowsMainService),ee(2,f.IDialogMainService),ee(3,i.ILifecycleMainService),ee(4,g.IEnvironmentMainService),ee(5,o.ILogService),ee(6,n.IProductService),ee(7,r.IThemeMainService),ee(8,l.IWorkspacesManagementMainService),ee(9,N.ITelemetryService)],X),e.NativeHostMainService=X}),define(te[265],ie([0,1,15,41,27,35,2,13,5,99,163,84,118,56,26,4,6,65,54,20,61,74,30,12]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let n=class Nt{constructor(s,c,l,P,M,T,N,X,ae){this.userEnv=s,this.environmentMainService=c,this.logService=l,this.diagnosticsService=P,this.diagnosticsMainService=M,this.dialogMainService=T,this.nativeHostMainService=N,this.protocolMainService=X,this.productService=ae,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[c,l]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),P=await this.diagnosticsService.getSystemInfo(c,l);this.safeSend(s,"vscode:issueSystemInfoResponse",P)}),t.validatedIpcMain.on("vscode:listProcesses",async s=>{const c=[];try{c.push({name:(0,I.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(P=>{(0,v.isRemoteDiagnosticError)(P)?c.push({name:P.hostName,rootProcess:P}):P.processes&&c.push({name:P.hostName,rootProcess:P.processes})})}catch(l){this.logService.error(`Listing processes failed: ${l}`)}this.safeSend(s,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{const c={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const l=await this.dialogMainService.showMessageBox(c,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",l.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const c=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(s,c)=>{const{id:l,from:P,args:M}=c;let T;switch(P){case"issueReporter":T=this.issueReporterParentWindow;break;case"processExplorer":T=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${P}`)}T?.webContents.send("vscode:runAction",{id:l,from:P,args:M})}),t.validatedIpcMain.on("vscode:openExternal",(s,c)=>{this.nativeHostMainService.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const c=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(s,"vscode:windowsInfoResponse",c.windows)})}safeSend(s,c,...l){s.sender.isDestroyed()||s.sender.send(c,...l)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const c=new D.DisposableStore,l=c.add(this.protocolMainService.createIPCObjectUrl()),P=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(P,l,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),l.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:S.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,c.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,c.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const c=new D.DisposableStore,l=c.add(this.protocolMainService.createIPCObjectUrl()),P=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(P,l,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),l.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:S.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,c.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,c.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,c,l,P){const M=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:l.title,backgroundColor:l.backgroundColor||Nt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${P}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,a.zoomLevelToZoomFactor)(l.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:l.alwaysOnTop,experimentalDarkMode:!0});return M.setMenuBarVisibility(!1),M}async getSystemStatus(){const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,c)}getWindowPosition(s,c,l){let P;const M=w.screen.getAllDisplays();if(M.length===1)P=M[0];else{if(u.isMacintosh){const X=w.screen.getCursorScreenPoint();P=w.screen.getDisplayNearestPoint(X)}!P&&s&&(P=w.screen.getDisplayMatching(s.getBounds())),P||(P=w.screen.getPrimaryDisplay()||M[0])}const T={width:c,height:l},N=P.bounds;return T.x=N.x+N.width/2-T.width/2,T.y=N.y+N.height/2-T.height/2,N.width>0&&N.height>0&&(T.x<N.x&&(T.x=N.x),T.y<N.y&&(T.y=N.y),T.x>N.x+N.width&&(T.x=N.x),T.y>N.y+N.height&&(T.y=N.y),T.width>N.width&&(T.width=N.width),T.height>N.height&&(T.height=N.height)),T}async getPerformanceInfo(){try{const[s,c]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,c)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.environmentMainService.args.trace)return;const s=await w.contentTracing.stopRecording(`${(0,i.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,I.localize)(9,null),detail:(0,I.localize)(10,null,s),buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(11,null))],defaultId:0,noLink:!0},(0,o.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),this.nativeHostMainService.showItemInFolder(void 0,s)}};n.DEFAULT_BACKGROUND_COLOR="#1E1E1E",n=ve([ee(1,h.IEnvironmentMainService),ee(2,C.ILogService),ee(3,v.IDiagnosticsService),ee(4,b.IDiagnosticsMainService),ee(5,d.IDialogMainService),ee(6,p.INativeHostMainService),ee(7,g.IProtocolMainService),ee(8,f.IProductService)],n),e.IssueMainService=n}),define(te[266],ie([0,1,23,19,26,22,6,65,20,55,32,48,88]),function(z,e,w,t,k,R,D,E,u,m,I,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends b.AbstractUpdateService{constructor(y,C,p,S,f,g,a,i){super(y,C,S,f,g,i),this.telemetryService=p,this.nativeHostMainService=a}buildUpdateFeedUrl(y){return(0,b.createUpdateURL)(`linux-${process.arch}`,y,this.productService)}doCheckForUpdates(y){!this.url||(this.setState(v.State.CheckingForUpdates(y)),this.requestService.request({url:this.url},w.CancellationToken.None).then(m.asJson).then(C=>{!C||!C.url||!C.version||!C.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y}),this.setState(v.State.Idle(1))):this.setState(v.State.AvailableForDownload(C))}).then(void 0,C=>{this.logService.error(C),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!y});const p=y?C.message||C:void 0;this.setState(v.State.Idle(1,p))}))}async doDownloadUpdate(y){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):y.update.url&&this.nativeHostMainService.openExternal(void 0,y.update.url),this.setState(v.State.Idle(1))}};d=ve([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,I.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,m.IRequestService),ee(5,D.ILogService),ee(6,E.INativeHostMainService),ee(7,u.IProductService)],d),e.LinuxUpdateService=d}),define(te[267],ie([0,1,45,40,27,8,23,53,9,7,127,21,19,26,14,22,6,65,20,55,32,48,88]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(c,l=1e3){for(;!c();)await(0,R.timeout)(l)}let n;function r(){return typeof n>"u"&&(n=t.existsSync(u.join(u.dirname(process.execPath),"unins000.exe"))?0:1),n}let s=class extends i.AbstractUpdateService{get cachePath(){const l=u.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return v.Promises.mkdir(l,{recursive:!0}).then(()=>l)}constructor(l,P,M,T,N,X,ae,Q,G){super(l,P,T,N,X,G),this.telemetryService=M,this.fileService=ae,this.nativeHostMainService=Q}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(l){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),r()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,i.createUpdateURL)(P,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(a.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},D.CancellationToken.None).then(f.asJson).then(P=>{const M=r();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(a.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(a.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(a.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>v.Promises.exists(T).then(N=>{if(N)return Promise.resolve(T);const X=P.url,ae=P.hash,Q=`${T}.tmp`;return this.requestService.request({url:X},D.CancellationToken.None).then(G=>this.fileService.writeFile(m.URI.file(Q),G.stream)).then(ae?()=>(0,I.checksum)(Q,P.hash):()=>{}).then(()=>v.Promises.rename(Q,T)).then(()=>T)})).then(T=>{const N=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},N&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(P)):this.setState(a.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const M=l?P.message||P:void 0;this.setState(a.State.Idle(r(),M))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(a.State.Idle(r()))}async getUpdatePackagePath(l){const P=await this.cachePath;return u.join(P,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const P=l?X=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(X):()=>!0,M=await this.cachePath,N=(await v.Promises.readdir(M)).filter(P).map(async X=>{try{await v.Promises.unlink(u.join(M,X))}catch{}});await Promise.all(N)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(a.State.Updating(l));const P=await this.cachePath;this.availableUpdate.updateFilePath=u.join(P,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await v.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(a.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,N=await new Promise((X,ae)=>{z(["windows-mutex"],X,ae)});o(()=>N.isActive(T)).then(()=>this.setState(a.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(l){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(a.State.Downloading(M)),this.availableUpdate={packagePath:l},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(a.State.Downloaded(M)):this.setState(a.State.Ready(M))}};ve([E.memoize],s.prototype,"cachePath",null),s=ve([ee(0,y.ILifecycleMainService),ee(1,b.IConfigurationService),ee(2,g.ITelemetryService),ee(3,d.IEnvironmentMainService),ee(4,f.IRequestService),ee(5,C.ILogService),ee(6,h.IFileService),ee(7,p.INativeHostMainService),ee(8,S.IProductService)],s),e.Win32UpdateService=s}),define(te[268],ie([0,1,15,8,23,44,3,35,2,13,9,71,5,7,171,60,19,56,26,59,14,22,6,20,61,233,91,32,236,64,74,33,28,52,116,120,37,38,54,42]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o,n,r,s,c,l,P,M,T,N,X,ae,Q,G,Z,se,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(W){W[W.NONE=0]="NONE",W[W.NAVIGATING=1]="NAVIGATING",W[W.READY=2]="READY"})(V||(V={}));let H=class Ft extends u.Disposable{get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(A,F,U,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae){super(),this.logService=F,this.environmentMainService=U,this.policyService=J,this.userDataProfilesService=B,this.fileService=$,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=_,this.themeMainService=j,this.workspacesManagementMainService=Y,this.backupMainService=oe,this.telemetryService=q,this.dialogMainService=re,this.lifecycleMainService=ne,this.productService=ce,this.protocolMainService=ge,this.windowsMainService=De,this.stateMainService=Ae,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Le]=this.restoreWindowState(A.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const qe=this.windowState.mode===0||this.windowState.mode===3,me=this.configurationService.getValue("window");let we=!1;typeof me?.experimental?.useSandbox=="boolean"?we=me.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const Ee={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!qe,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(me?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):b.isWindows&&!this.environmentMainService.isBuilt&&(Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.useNativeFullScreen()&&(Ee.fullscreenable=!1),b.isMacintosh&&(Ee.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const x=b.isMacintosh&&me?.nativeTabs===!0;x&&(Ee.tabbingIdentifier=this.productService.nameShort);const le=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(Ee.titleBarStyle="hidden",b.isMacintosh||(Ee.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService))){const fe=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Se=Q.Color.fromHex(fe).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:fe,symbolColor:Se},this.hasWindowControlOverlay=!0}if((0,v.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(Ee),(0,v.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,b.isMacintosh&&le&&this._win.setSheetOffset(22),le&&(b.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService)||b.isMacintosh)){const fe=this.stateMainService.getItem(Ft.windowControlHeightStateStorageKey);fe&&this.updateWindowControls({height:fe})}b.isWindows&&le&&this._win.hookWindowMessage(278,()=>{const[Se,Ie]=this._win.getPosition(),Te=w.screen.getCursorScreenPoint(),Oe=Te.x-Se,Ne=Te.y-Ie;return(()=>!(Oe>30&&Ne>=0&&Ne<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Oe,y:Ne})),0}),(b.isMacintosh||b.isWindows)&&Le&&(!x||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(fe=>typeof fe=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),qe&&((0,v.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,v.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setRepresentedFilename(A){b.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return b.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){b.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return b.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){b.isMacintosh&&A?.force&&w.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function F(){U.dispose(),J.dispose(),A()}const U=this.onDidClose(()=>F()),J=this.onWillLoad(()=>F())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(F,U)=>this.onWindowError(2,U)),this._win.webContents.on("did-fail-load",(F,U,J)=>this.onWindowError(3,{reason:J,exitCode:U})),this._win.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",F=>{this._config&&(this._config.maximized=!0),w.app.emit("browser-window-maximize",F,this._win)}),this._win.on("unmaximize",F=>{this._config&&(this._config.maximized=!1),w.app.emit("browser-window-unmaximize",F,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(F=>this.onConfigurationUpdated(F))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(F=>this.onDidDeleteUntitledWorkspace(F)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(F,U)=>{const J=await this.getMarketplaceHeaders();U({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,J)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,F){switch(A){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:F?.reason,code:F?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,h.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,h.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,h.localize)(2,null))],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,h.localize)(5,null):void 0},this._win);if(U.response!==1){const J=U.response===0;await this.destroyWindow(J,U.checkboxChecked)}}else if(A===2){let U;F?U=(0,h.localize)(7,null,F.reason,F.exitCode??"<unknown>"):U=(0,h.localize)(6,null);const J=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,h.localize)(8,null)),(0,E.mnemonicButtonLabel)((0,h.localize)(9,null))],message:U,detail:(0,h.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,h.localize)(11,null):void 0},this._win),B=J.response===0;await this.destroyWindow(B,J.checkboxChecked)}break}}async destroyWindow(A,F){const U=this._config?.workspace;if(F&&U)try{const J=this.storageMainService.workspaceStorage(U);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.logService.error(J)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let J,B;(0,N.isSingleFolderWorkspaceIdentifier)(U)?J={folderUri:U.uri}:(0,N.isWorkspaceIdentifier)(U)?J={workspaceUri:U.configPath}:B=!0;const[$]=await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});$.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const F=this.getMenuBarVisibility();F!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=F,this.setMenuBarVisibility(F));let U=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const J=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.currentHttpProxy||J!==this.currentNoProxy)){this.currentHttpProxy=U,this.currentNoProxy=J;const B=U||"",$=J?`${J},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(A){b.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,F=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!F.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,F),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`,z).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:F.isReload?3:U?2:1})}updateConfiguration(A,F){const U=(this._config??this.pendingLoadConfig)?.userEnv;if(U){const J=(0,f.isLaunchedFromCli)(U)&&!(0,f.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(J||B)&&(A.userEnv={...U,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(A["disable-extensions"]=F.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,v.mark)("code/willOpenNewWindow"),A.perfMarks=(0,v.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const F=Object.assign({},this._config);F.workspace=await this.validateWorkspaceBeforeReload(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&A&&(F.verbose=A.verbose,F.debugId=A.debugId,F.extensionEnvironment=A.extensionEnvironment,F["inspect-extensions"]=A["inspect-extensions"],F["inspect-brk-extensions"]=A["inspect-brk-extensions"],F["extensions-dir"]=A["extensions-dir"]),F.isInitialStartup=!1,F.policiesData=this.policyService.serialize(),F.continueOn=this.environmentMainService.continueOn,F.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(F,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,N.isWorkspaceIdentifier)(A.workspace)){const F=A.workspace.configPath;if(F.scheme===m.Schemas.file&&!await this.fileService.exists(F))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(A.workspace)){const F=A.workspace.uri;if(F.scheme===m.Schemas.file&&!await this.fileService.exists(F))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,ae.defaultWindowState)();if(this.isFullScreen){let U;try{U=w.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,ae.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||J.width,height:this.windowState.height||J.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let F;if(!b.isMacintosh&&this._win.isMaximized()?F=0:F=1,F===0?A.mode=0:A.mode=1,F===1||F===0){let U;F===1?U=this.getBounds():U=this._win.getNormalBounds(),A.x=U.x,A.y=U.y,A.width=U.width,A.height=U.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Ft.windowControlHeightStateStorageKey,A.height),b.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):b.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,v.mark)("code/willRestoreCodeWindowState");let F=!1;if(A)try{const U=w.screen.getAllDisplays();F=U.length>1,A=this.validateWindowState(A,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,v.mark)("code/didRestoreCodeWindowState"),[A||(0,ae.defaultWindowState)(),F]}validateWindowState(A,F){if(this.logService.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const B=this.getWorkingArea(F[0]);if(B){let $=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),$()}return A}if(A.display&&A.mode===3){const B=F.find($=>$.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,ae.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let U,J;try{U=w.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),J=this.getWorkingArea(U)}catch{}if(U&&J&&A.x+A.width>J.x&&A.y+A.height>J.y&&A.x<J.x+J.width&&A.y<J.y+J.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",J),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,F]=this._win.getPosition(),[U,J]=this._win.getSize();return{x:A,y:F,width:U,height:J}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return b.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){b.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,F=!0){b.isMacintosh||(A==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,h.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const F=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!F),this._win.autoHideMenuBar=F;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,F,...U){this.isReady?this.send(A,...U):this.ready().then(()=>{F.isCancellationRequested||this.send(A,...U)})}send(A,...F){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...F)}catch(U){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(U)}`)}}}updateTouchBar(A){!b.isMacintosh||this.touchBarGroups.forEach((F,U)=>{const J=A[U];F.segments=this.createTouchBarGroupSegments(J)})}createTouchBar(){if(!!b.isMacintosh){for(let A=0;A<10;A++){const F=this.createTouchBarGroup();this.touchBarGroups.push(F)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const F=this.createTouchBarGroupSegments(A),U=new w.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:U.segments[J].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(A=[]){return A.map(U=>{let J;U.icon&&!l.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===m.Schemas.file&&(J=w.nativeImage.createFromPath(d.URI.revive(U.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let B;return typeof U.title=="string"?B=U.title:B=U.title.value,{id:U.id,label:J?void 0:B,icon:J}})}dispose(){super.dispose(),this._win=null}};H.windowControlHeightStateStorageKey="windowControlHeight",H=ve([ee(1,i.ILogService),ee(2,S.IEnvironmentMainService),ee(3,G.IPolicyService),ee(4,he.IUserDataProfilesMainService),ee(5,g.IFileService),ee(6,s.IApplicationStorageMainService),ee(7,s.IStorageMainService),ee(8,C.IConfigurationService),ee(9,P.IThemeMainService),ee(10,X.IWorkspacesManagementMainService),ee(11,y.IBackupMainService),ee(12,c.ITelemetryService),ee(13,p.IDialogMainService),ee(14,a.ILifecycleMainService),ee(15,o.IProductService),ee(16,n.IProtocolMainService),ee(17,T.IWindowsMainService),ee(18,Z.IStateMainService)],H),e.CodeWindow=H}),define(te[75],ie([0,1,15,24,8,3,35,2,13,5,16,7,21,174,4,22,6,91,92,28,52,31]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let i=class rt extends E.Disposable{constructor(n,r,s,c){super(),this.logService=n,this.workspacesManagementMainService=r,this.lifecycleMainService=s,this.applicationStorageMainService=c,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let r=[],s=[];for(const l of n)if((0,S.isRecentWorkspace)(l))!this.workspacesManagementMainService.isUntitledWorkspace(l.workspace)&&!this.containsWorkspace(r,l.workspace)&&r.push(l);else if((0,S.isRecentFolder)(l))this.containsFolder(r,l.folderUri)||r.push(l);else{const P=this.containsFile(s,l.fileUri),M=l.fileUri.scheme===u.Schemas.file&&rt.COMMON_FILES_FILTER.indexOf((0,I.basename)(l.fileUri))>=0;!P&&!M&&(s.push(l),m.isWindows&&l.fileUri.scheme===u.Schemas.file&&w.app.addRecentDocument(l.fileUri.fsPath))}const c=await this.mergeEntriesFromStorage({workspaces:r,files:s});r=c.workspaces,s=c.files,r.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=rt.MAX_TOTAL_RECENT_ENTRIES),s.length>rt.MAX_TOTAL_RECENT_ENTRIES&&(s.length=rt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:r,files:s}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(n){const r=P=>{const M=this.location(P);for(const T of n)if(I.extUriBiasedIgnorePathCase.isEqual(T,M))return!1;return!0},s=await this.getRecentlyOpened(),c=s.workspaces.filter(r),l=s.files.filter(r);(c.length!==s.workspaces.length||l.length!==s.files.length)&&(await this.saveRecentlyOpened({files:l,workspaces:c}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(n){const r=new a.ResourceMap(l=>I.extUriBiasedIgnorePathCase.getComparisonKey(l));if(n?.workspaces)for(const l of n.workspaces)r.set(this.location(l),l);const s=new a.ResourceMap(l=>I.extUriBiasedIgnorePathCase.getComparisonKey(l));if(n?.files)for(const l of n.files)s.set(this.location(l),l);const c=await this.getRecentlyOpenedFromStorage();for(const l of c.workspaces){const P=r.get(this.location(l));P?P.label=P.label??l.label:r.set(this.location(l),l)}for(const l of c.files){const P=s.get(this.location(l));P?P.label=P.label??l.label:s.set(this.location(l),l)}return{workspaces:[...r.values()],files:[...s.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let n;const r=this.applicationStorageMainService.get(rt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof r=="string")try{n=JSON.parse(r)}catch(s){this.logService.error("Unexpected error parsing opened paths list",s)}return(0,S.restoreRecentlyOpened)(n,this.logService)}async saveRecentlyOpened(n){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(rt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,S.toStoreData)(n)),-1,1)}location(n){return(0,S.isRecentFolder)(n)?n.folderUri:(0,S.isRecentFile)(n)?n.fileUri:n.workspace.configPath}containsWorkspace(n,r){return!!n.find(s=>(0,S.isRecentWorkspace)(s)&&s.workspace.id===r.id)}containsFolder(n,r){return!!n.find(s=>(0,S.isRecentFolder)(s)&&I.extUriBiasedIgnorePathCase.isEqual(s.folderUri,r))}containsFile(n,r){return!!n.find(s=>I.extUriBiasedIgnorePathCase.isEqual(s.fileUri,r))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const l of w.app.getJumpListSettings().removedItems){const P=l.args;if(P){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(P);M&&r.push(v.URI.parse(M[2]))}}await this.removeRecentlyOpened(r);let s=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(l=>{const P=(0,S.isRecentWorkspace)(l)?l.workspace:l.folderUri,{title:M,description:T}=this.getWindowsJumpListLabel(P,l.label);let N;return v.URI.isUri(P)?N=`--folder-uri "${P.toString()}"`:(s=!0,N=`--file-uri "${P.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:T.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:s?(0,d.localize)(2,null):(0,d.localize)(3,null),items:c})}n.push({type:"recent"});try{const r=w.app.setJumpList(n);r&&r!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.logService.warn("updateWindowsJumpList#setJumpList",r)}}getWindowsJumpListLabel(n,r){if(r)return{title:(0,D.splitName)(r).name,description:r};if(v.URI.isUri(n))return{title:(0,I.basename)(n),description:this.renderJumpListPathDescription(n)};if(this.workspacesManagementMainService.isUntitledWorkspace(n))return{title:(0,d.localize)(4,null),description:""};let s=(0,I.basename)(n.configPath);return s.endsWith(f.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-f.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,s),description:this.renderJumpListPathDescription(n.configPath)}}renderJumpListPathDescription(n){return n.scheme==="file"?(0,D.normalizeDriveLetter)(n.fsPath):n.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;w.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),r=[];let s=0;for(let l=0;l<n.workspaces.length&&s<rt.MAX_MACOS_DOCK_RECENT_WORKSPACES;l++){const P=this.location(n.workspaces[l]);if(P.scheme===u.Schemas.file){const M=(0,I.originalFSPath)(P);await b.Promises.exists(M)&&(r.push(M),s++)}}const c=[];for(let l=0;l<n.files.length&&s<rt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;l++){const P=this.location(n.files[l]);if(P.scheme===u.Schemas.file){const M=(0,I.originalFSPath)(P);if(rt.COMMON_FILES_FILTER.includes((0,I.basename)(P))||r.includes(M))continue;await b.Promises.exists(M)&&(c.push(M),s++)}}c.reverse().forEach(l=>w.app.addRecentDocument(l)),r.reverse().forEach(l=>w.app.addRecentDocument(l))}};i.MAX_TOTAL_RECENT_ENTRIES=500,i.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",i.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,i.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,i.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,i.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],i=ve([ee(0,C.ILogService),ee(1,g.IWorkspacesManagementMainService),ee(2,y.ILifecycleMainService),ee(3,p.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(te[269],ie([0,1,15,8,23,35,5,7,164,19,26,22,6,210,65,20,38,32,48,74,33,75]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let o=class Wt{constructor(s,c,l,P,M,T,N,X,ae,Q,G){this.updateService=s,this.configurationService=c,this.windowsMainService=l,this.environmentMainService=P,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=N,this.lifecycleMainService=X,this.logService=ae,this.nativeHostMainService=Q,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,f.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(Wt.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,N,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,N,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:N?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,N,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,N,X)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,N,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const c=this.productService.requestFeatureUrl;c&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(c,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,c){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(Wt.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=w.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(D.isMacintosh?new w.Menu:null);return}const c=new w.Menu;let l;if(D.isMacintosh){const M=new w.Menu;l=new w.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),c.append(l)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new w.Menu;M.append(new w.MenuItem({label:this.mnemonicLabel(u.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(1,null)),submenu:M});this.setMenuById(M,"File"),c.append(T)}if(this.shouldDrawMenu("Edit")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),c.append(T)}if(this.shouldDrawMenu("Selection")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),c.append(T)}if(this.shouldDrawMenu("View")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(4,null)),submenu:M});this.setMenuById(M,"View"),c.append(T)}if(this.shouldDrawMenu("Go")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),c.append(T)}if(this.shouldDrawMenu("Run")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),c.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),c.append(T)}let P;if(this.shouldDrawMenu("Window")){const M=new w.Menu;P=new w.MenuItem({label:this.mnemonicLabel(u.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(P&&c.append(P),this.shouldDrawMenu("Help")){const M=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(u.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),c.append(T)}c.items&&c.items.length>0?w.Menu.setApplicationMenu(c):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const c=this.createMenuItem(u.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const Z=new w.Menu;this.setMenuById(Z,"Preferences"),P=new w.MenuItem({label:this.mnemonicLabel(u.localize(11,null)),submenu:Z})}const M=new w.Menu,T=new w.MenuItem({label:u.localize(12,null),role:"services",submenu:M}),N=new w.MenuItem({label:u.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new w.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new w.MenuItem({label:u.localize(15,null),role:"unhide"}),Q=new w.MenuItem(this.likeAction("workbench.action.quit",{label:u.localize(16,null,this.productService.nameLong),click:async(Z,se,he)=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&await this.confirmBeforeQuit(he)&&this.nativeHostMainService.quit(void 0)}})),G=[c];G.push(...l),P&&G.push(n(),P),G.push(n(),T,n(),N,X,ae,n(),Q),G.forEach(Z=>s.append(Z))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const c=this.configurationService.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.isKeyboardEvent(s)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(u.localize(17,null)),(0,R.mnemonicButtonLabel)(u.localize(18,null))],message:u.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return P===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,f.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,c){c.forEach(l=>{if((0,d.isMenubarMenuItemSeparator)(l))s.append(n());else if((0,d.isMenubarMenuItemSubmenu)(l)){const P=new w.Menu,M=new w.MenuItem({label:this.mnemonicLabel(l.label),submenu:P});this.setMenu(P,l.submenu.items),s.append(M)}else(0,d.isMenubarMenuItemRecentAction)(l)?s.append(this.createOpenRecentMenuItem(l)):(0,d.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?s.append(new w.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):s.append(this.createMenuItem(l.label,l.id,!1,l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):s.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(s,c){this.menubarMenus&&this.menubarMenus[c]&&this.setMenu(s,this.menubarMenus[c].items)}insertCheckForUpdatesItems(s){const c=this.getUpdateMenuItems();c.length&&(c.forEach(l=>s.append(l)),s.append(n()))}createOpenRecentMenuItem(s){const c=E.URI.revive(s.uri),l=s.id,P=l==="openRecentFile"?{fileUri:c}:l==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new w.MenuItem(this.likeAction(l,{label:s.label,click:async(M,T,N)=>{const X=this.isOptionClick(N);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:s.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([c])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,c,l){const P={label:this.mnemonicLabel(s),role:l,enabled:!0};return new w.MenuItem(this.withKeybinding(c,P))}setMacWindowMenu(s){const c=new w.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new w.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new w.MenuItem({label:u.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(u.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(n()),T.push(this.createMenuItem(u.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,l,n(),M,...T,n(),P].forEach(N=>s.append(N))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(u.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,c,l,P){const M=this.mnemonicLabel(s),T=typeof c=="function"?c:(G,Z,se)=>{const he=G?G.userSettingsLabel:null;let V=c;Array.isArray(c)&&(V=this.isOptionClick(se)?c[1]:c[0]),he&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:he}):this.runActionInRenderer({type:"commandId",commandId:V})},N=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,X=typeof P=="boolean"?P:!1,ae={label:M,click:T,enabled:N};X&&(ae.type="checkbox",ae.checked=X);let Q;return typeof c=="string"?Q=c:Array.isArray(c)&&(Q=c[0]),D.isMacintosh&&(Q==="editor.action.clipboardCutAction"?ae.role="cut":Q==="editor.action.clipboardCopyAction"?ae.role="copy":Q==="editor.action.clipboardPasteAction"&&(ae.role="paste"),Q==="undo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):Q==="redo"?ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):Q==="editor.action.selectAll"&&(ae.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(Q,ae))}makeContextAwareClickHandler(s,c){return(l,P,M)=>{const T=w.BrowserWindow.getFocusedWindow();if(!T)return c.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return c.inDevTools(T.webContents.devToolsWebContents);s(l,P||T,M)}}runActionInRenderer(s){let c=w.BrowserWindow.getFocusedWindow();if(!c){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(c=P.win)}const l=c?this.windowsMainService.getWindowById(c.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const P={id:s.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:s.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,c){const l=typeof s=="string"?this.keybindings[s]:void 0;if(l?.label){if(l.isNative!==!1)c.accelerator=l.label,c.userSettingsLabel=l.userSettingsLabel;else if(typeof c.label=="string"){const P=c.label.indexOf("[");P>=0?c.label=`${c.label.substr(0,P)} [${l.label}]`:c.label=`${c.label} [${l.label}]`}}else c.accelerator=void 0;return c}likeAction(s,c,l=!c.accelerator){l&&(c=this.withKeybinding(s,c));const P=c.click;return c.click=(M,T,N)=>{this.reportMenuActionTelemetry(s),P?.(M,T,N)},c}openUrl(s,c){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(c)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:i})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([ee(0,S.IUpdateService),ee(1,m.IConfigurationService),ee(2,g.IWindowsMainService),ee(3,I.IEnvironmentMainService),ee(4,p.ITelemetryService),ee(5,a.IWorkspacesHistoryMainService),ee(6,C.IStateMainService),ee(7,v.ILifecycleMainService),ee(8,b.ILogService),ee(9,h.INativeHostMainService),ee(10,y.IProductService)],o),e.Menubar=o;function n(){return new w.MenuItem({type:"separator"})}}),define(te[270],ie([0,1,4,22,6,269]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let D=class{constructor(u,m,I){this.instantiationService=u,this.lifecycleMainService=m,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(u,m){this.logService.trace("menubarService#updateMenubar",u),(await this.menubar).updateMenu(m,u)}};D=ve([ee(0,w.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,k.ILogService)],D),e.MenubarMainService=D}),define(te[271],ie([0,1,15,21,27,24,23,3,30,49,35,2,13,9,71,5,34,16,12,7,172,60,19,56,26,14,4,22,6,54,20,61,63,38,74,268,117,263,28,93,75,52,64,37,42]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o,n,r,s,c,l,P,M,T,N,X,ae,Q,G,Z,se,he,V,H,W,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U($){return(0,se.isWorkspaceIdentifier)($?.workspace)}function J($){return(0,se.isSingleFolderWorkspaceIdentifier)($?.workspace)}let B=class ft extends v.Disposable{constructor(L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae,ke,Le,qe,me,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=_,this.stateMainService=j,this.policyService=Y,this.environmentMainService=oe,this.userDataProfilesMainService=q,this.lifecycleMainService=re,this.backupMainService=ne,this.configurationService=ce,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=De,this.instantiationService=Ae,this.dialogMainService=ke,this.fileService=Le,this.productService=qe,this.protocolMainService=me,this.themeMainService=we,this._onDidOpenWindow=this._register(new E.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new E.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new E.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new E.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new E.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new Z.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new v.DisposableStore;if(O.add(E.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const _ of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(_));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const _=this.environmentMainService.args,j=O?.remoteAuthority||void 0,Y=!0,oe=O?.forceReuseWindow,q=!oe;return this.open({...L,cli:_,forceEmpty:Y,forceNewWindow:q,forceReuseWindow:oe,remoteAuthority:j})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}async open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],_=[],j=[],Y=[],oe=[];let q,re=0;const ne=await this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const ke of ne)J(ke)?L.addMode?O.push(ke):_.push(ke):U(ke)?j.push(ke):ke.fileUri?(q||(q={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),q.filesToOpenOrCreate.push(ke)):ke.backupPath?oe.push({backupFolder:(0,d.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):re++;L.diffMode&&q&&q.filesToOpenOrCreate.length>=2&&(q.filesToDiff=q.filesToOpenOrCreate.slice(0,2),q.filesToOpenOrCreate=[]),L.mergeMode&&q&&q.filesToOpenOrCreate.length===4&&(q.filesToMerge=q.filesToOpenOrCreate.slice(0,4),q.filesToOpenOrCreate=[],q.filesToDiff=[]),q&&L.waitMarkerFileURI&&(q.filesToWait={paths:(0,R.coalesce)([...q.filesToDiff,q.filesToMerge[3],...q.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),j.push(...Y),oe.push(...this.backupMainService.getEmptyWindowBackups())):oe.length=0;const{windows:ce,filesOpenedInWindow:ge}=await this.doOpen(L,j,_,oe,re,q,O);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${_.length}, emptyToRestore: ${oe.length}, emptyToOpen: ${re})`),ce.length>1)if(ge)ge.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Le=!0,qe=!0;if(ke){const me=ce.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Le=!1,qe=!1)}if(Le)for(let me=ce.length-1;me>=0;me--){const we=ce[me];if(!(we.openedWorkspace&&Y.some(Ee=>we.openedWorkspace&&Ee.workspace.id===we.openedWorkspace.id)||we.backupPath&&oe.some(Ee=>we.backupPath&&Ee.backupFolder===(0,d.basename)(we.backupPath)))){we.focus(),qe=!1;break}}qe&&ce[ce.length-1].focus()}const De=q&&q.filesToDiff.length>0,Ae=q&&q.filesToMerge.length>0;if(!ce.some(ke=>ke.isExtensionDevelopmentHost)&&!De&&!Ae&&!L.noRecentEntry){const ke=[];for(const Le of ne)U(Le)&&!Le.transient?ke.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):J(Le)?ke.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&ke.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(L,ce),ce}handleWaitMarkerFile(L,O){const _=L.waitMarkerFileURI;L.context===0&&_&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}async doOpen(L,O,_,j,Y,oe,q){const re=[];let ne;function ce(me,we){re.push(me),we&&(ne=me,oe=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:De}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&q.length>0){const me=q[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(me);we&&ce(this.doAddFoldersToExistingWindow(we,q.map(Ee=>Ee.workspace.uri)))}const Ae=_.length+O.length+j.length;if(oe&&Ae===0){const me=oe.filesToOpenOrCreate[0]||oe.filesToDiff[0]||oe.filesToMerge[3],we=this.getWindows().filter(x=>oe&&(0,p.isEqualAuthority)(x.remoteAuthority,oe.remoteAuthority));let Ee;me?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(Ee=await(0,G.findWindowOnFile)(we,me.fileUri,async x=>x.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(x.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(we))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?_.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(L,Ee,oe),!0):ce(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:oe,forceNewWindow:!0,remoteAuthority:oe.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const ke=(0,R.distinct)(O,me=>me.workspace.id);if(ke.length>0){const me=(0,R.coalesce)(ke.map(we=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],Ee=(0,p.isEqualAuthority)(oe?.remoteAuthority,we.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of ke){if(me.some(le=>le.openedWorkspace&&le.openedWorkspace.id===we.workspace.id))continue;const Ee=we.remoteAuthority,x=(0,p.isEqualAuthority)(oe?.remoteAuthority,Ee)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,we,ge,x),!!x),ge=!0}}const Le=(0,R.distinct)(_,me=>p.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Le.length>0){const me=(0,R.coalesce)(Le.map(we=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],Ee=(0,p.isEqualAuthority)(oe?.remoteAuthority,we.remoteAuthority)?oe:void 0;ce(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}for(const we of Le){if(me.some(le=>(0,se.isSingleFolderWorkspaceIdentifier)(le.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(le.openedWorkspace.uri,we.workspace.uri)))continue;const Ee=we.remoteAuthority,x=(0,p.isEqualAuthority)(oe?.remoteAuthority,Ee)?oe:void 0;ce(this.doOpenFolderOrWorkspace(L,we,ge,x),!!x),ge=!0}}const qe=(0,R.distinct)(j,me=>me.backupFolder);if(qe.length>0)for(const me of qe){const we=me.remoteAuthority,Ee=(0,p.isEqualAuthority)(oe?.remoteAuthority,we)?oe:void 0;ce(this.doOpenEmpty(L,!0,we,Ee,me),!!Ee),ge=!0}if(re.length===0||oe){oe&&!Y&&Y++;const me=oe?oe.remoteAuthority:L.remoteAuthority;for(let we=0;we<Y;we++)ce(this.doOpenEmpty(L,ge,me,oe),!!oe),ge=!0}return{windows:(0,R.distinct)(re),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(L,O,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),O.focus();const j={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,j),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const _={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,_),L}doOpenEmpty(L,O,_,j,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:_,filesToOpen:j,forceNewWindow:O});let oe;return!O&&typeof L.contextWindowId=="number"&&(oe=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:_,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:oe,emptyWindowBackupInfo:Y,profile:L.profile})}doOpenFolderOrWorkspace(L,O,_,j,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:j}),!_&&!Y&&typeof L.contextWindowId=="number"&&(Y=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:Y,profile:L.profile})}async getPathsToOpen(L){let O,_=!1,j=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=await this.doExtractPathsFromAPI(L),_=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=await this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),_=!0):(O=await this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),j=!0),!L.addMode&&_){const Y=O.filter(oe=>J(oe));if(Y.length>1){const oe=Y[0].remoteAuthority;if(Y.every(q=>(0,p.isEqualAuthority)(q.remoteAuthority,oe))){const q=await this.workspacesManagementMainService.createUntitledWorkspace(Y.map(re=>({uri:re.workspace.uri})));O.push({workspace:q,remoteAuthority:oe}),O=O.filter(re=>!J(re))}}}if(L.initialStartup&&!j&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const Y=await this.doGetPathsFromLastSession();O.unshift(...Y.filter(oe=>U(oe)||J(oe)||oe.backupPath))}return O}async doExtractPathsFromAPI(L){const O={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},_=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async j=>{const Y=await this.resolveOpenable(j,O);if(Y)return Y.label=j.label,Y;const oe=this.resourceFromOpenable(j),q={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,g.localize)(0,null))],defaultId:0,message:oe.scheme===b.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:oe.scheme===b.Schemas.file?(0,g.localize)(3,null,(0,I.getPathLabel)(oe,{os:y.OS,tildify:this.environmentMainService})):(0,g.localize)(4,null,oe.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(q,(0,S.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(_)}async doExtractPathsFromCLI(L){const O=[],_={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},j=L["folder-uri"];if(j){const q=await Promise.all(j.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable({folderUri:ne},_)}));O.push(...(0,R.coalesce)(q))}const Y=L["file-uri"];if(Y){const q=await Promise.all(Y.map(re=>{const ne=this.cliArgToUri(re);if(!!ne)return this.resolveOpenable((0,se.hasWorkspaceFileExtension)(re)?{workspaceUri:ne}:{fileUri:ne},_)}));O.push(...(0,R.coalesce)(q))}const oe=await Promise.all(L._.map(q=>_.remoteAuthority?this.doResolveRemotePath(q,_):this.doResolveFilePath(q,_)));return O.push(...(0,R.coalesce)(oe)),O}cliArgToUri(L){try{const O=f.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}async doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const _=await Promise.all(O.map(async j=>{if(j.workspace){const Y=await this.resolveOpenable({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(U(Y))return Y}else if(j.folderUri){const Y=await this.resolveOpenable({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(J(Y))return Y}else if(L!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,R.coalesce)(_)}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async resolveOpenable(L,O=Object.create(null)){const _=this.resourceFromOpenable(L);return _.scheme===b.Schemas.file?((0,ae.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let _=this.resourceFromOpenable(L);const j=(0,N.getRemoteAuthority)(_)||O.remoteAuthority;if(_=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(_)),(0,ae.isFileToOpen)(L)){if(O.gotoLineMode){const{path:Y,line:oe,column:q}=(0,u.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:Y}),options:{selection:oe?{startLineNumber:oe,startColumn:q||1}:void 0},remoteAuthority:j}}return{fileUri:_,remoteAuthority:j}}else if((0,ae.isWorkspaceToOpen)(L))return{workspace:(0,he.getWorkspaceIdentifier)(_),remoteAuthority:j};return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:j}}resourceFromOpenable(L){return(0,ae.isWorkspaceToOpen)(L)?L.workspaceUri:(0,ae.isFolderToOpen)(L)?L.folderUri:L.fileUri}async doResolveFilePath(L,O){let _,j;O.gotoLineMode&&({path:L,line:_,column:j}=(0,u.parseLineAndColumnAware)(L)),L=(0,u.sanitizeFilePath)((0,d.normalize)(L),(0,C.cwd)());try{const Y=await t.Promises.stat(L);if(Y.isFile()){if(!O.forceOpenWorkspaceAsFile){const oe=await this.workspacesManagementMainService.resolveLocalWorkspace(f.URI.file(L));if(oe)return oe.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:oe.id,configPath:oe.configPath},type:r.FileType.File,exists:!0,remoteAuthority:oe.remoteAuthority,transient:oe.transient}}return{fileUri:f.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:j||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(f.URI.file(L),Y),type:r.FileType.Directory,exists:!0};if(!y.isWindows&&L==="/dev/null")return{fileUri:f.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const oe=f.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([oe]),O.ignoreFileNotFound)return{fileUri:oe,type:r.FileType.File,exists:!1}}}doResolveRemotePath(L,O){const _=L.charCodeAt(0),j=O.remoteAuthority;let Y,oe;O.gotoLineMode&&({path:L,line:Y,column:oe}=(0,u.parseLineAndColumnAware)(L)),_!==47&&((0,u.isWindowsDriveLetter)(_)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,u.toSlashes)(L)),L=`/${L}`);const q=f.URI.from({scheme:b.Schemas.vscodeRemote,authority:j,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:q,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,he.getWorkspaceIdentifier)(q),remoteAuthority:j};if(O.gotoLineMode||d.posix.basename(L).indexOf(".")!==-1)return{fileUri:q,options:{selection:Y?{startLineNumber:Y,startColumn:oe||1}:void 0},remoteAuthority:j}}return{workspace:(0,he.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:j}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),_=O?.openFoldersInNewWindow||"default",j=O?.openFilesInNewWindow||"off";let Y=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(_==="on"||_==="off")&&(Y=_==="on");let oe=!1;return L.forceNewWindow||L.forceReuseWindow?oe=!!L.forceNewWindow&&!L.forceReuseWindow:(y.isMacintosh?L.context===1&&(oe=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(oe=!0),!L.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(oe=j==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:oe}}async openExtensionDevelopmentHostWindow(L,O){const _=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(_)return this.lifecycleMainService.reload(_,O.cli),_.focus(),[_];let j=O.cli["folder-uri"]||[],Y=O.cli["file-uri"]||[],oe=O.cli._;if(!oe.length&&!j.length&&!Y.length&&!O.cli.extensionTestsPath){const ne=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ce=ne?.workspace??ne?.folderUri;ce&&(f.URI.isUri(ce)?ce.scheme===b.Schemas.file?oe=[ce.fsPath]:j=[ce.toString()]:ce.configPath.scheme===b.Schemas.file?oe=[(0,p.originalFSPath)(ce.configPath)]:Y=[ce.configPath.toString()])}let q=O.remoteAuthority;for(const ne of L)if(ne.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=f.URI.parse(ne),ge=(0,N.getRemoteAuthority)(ce);ge&&(q?(0,p.isEqualAuthority)(ge,q)||this.logService.error("more than one extension development path authority"):q=ge)}oe=oe.filter(ne=>{const ce=f.URI.file(ne);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,p.isEqualAuthority)((0,N.getRemoteAuthority)(ce),q)}),j=j.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,N.getRemoteAuthority)(ce),q):!1}),Y=Y.filter(ne=>{const ce=this.cliArgToUri(ne);return ce&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,p.isEqualAuthority)((0,N.getRemoteAuthority)(ce),q):!1}),O.cli._=oe,O.cli["folder-uri"]=j,O.cli["file-uri"]=Y;const re={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!oe.length&&!j.length&&!Y.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:q,profile:O.profile};return this.open(re)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,d.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,h.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};let j;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(j=L.windowToUse||this.getLastActiveWindow(),j&&j.focus()),j){const Y=j.config;!_.extensionDevelopmentPath&&Y?.extensionDevelopmentPath&&(_.extensionDevelopmentPath=Y.extensionDevelopmentPath,_.extensionDevelopmentKind=Y.extensionDevelopmentKind,_["enable-proposed-api"]=Y["enable-proposed-api"],_.verbose=Y.verbose,_["inspect-extensions"]=Y["inspect-extensions"],_["inspect-brk-extensions"]=Y["inspect-brk-extensions"],_.debugId=Y.debugId,_.extensionEnvironment=Y.extensionEnvironment,_["extensions-dir"]=Y["extensions-dir"],_["disable-extensions"]=Y["disable-extensions"])}else{const Y=this.windowsStateHandler.getNewWindowState(_);(0,h.mark)("code/willCreateCodeWindow");const oe=j=this.instantiationService.createInstance(Q.CodeWindow,{state:Y,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});(0,h.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),ft.WINDOWS.push(oe),this._onDidOpenWindow.fire(oe),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(oe.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(oe)),(0,m.once)(oe.onDidClose)(()=>this.onWindowClosed(oe)),(0,m.once)(oe.onDidDestroy)(()=>this._onDidDestroyWindow.fire(oe)),oe.onDidTriggerSystemContextMenu(({x:re,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:oe,x:re,y:ne}));const q=(0,S.assertIsDefined)(oe.win?.webContents);q.removeAllListeners("devtools-reload-page"),q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(oe)),this.lifecycleMainService.registerWindow(oe)}return _.windowId=j.id,j.isReady?this.lifecycleMainService.unload(j,4).then(Y=>{Y||this.doOpenInBrowserWindow(j,_,L)}):this.doOpenInBrowserWindow(j,_,L),j}doOpenInBrowserWindow(L,O,_){O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,he.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ft.WINDOWS.indexOf(L);ft.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=w.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,p.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(_=>_.lastFocusTime));return L.find(_=>_.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,_){for(const j of this.getWindows())_&&_.indexOf(j.id)>=0||j.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ft.WINDOWS}getWindowCount(){return ft.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(_=>_.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=w.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([ee(2,l.ILogService),ee(3,X.IStateMainService),ee(4,A.IPolicyService),ee(5,n.IEnvironmentMainService),ee(6,F.IUserDataProfilesMainService),ee(7,c.ILifecycleMainService),ee(8,a.IBackupMainService),ee(9,i.IConfigurationService),ee(10,V.IWorkspacesHistoryMainService),ee(11,H.IWorkspacesManagementMainService),ee(12,s.IInstantiationService),ee(13,o.IDialogMainService),ee(14,r.IFileService),ee(15,M.IProductService),ee(16,T.IProtocolMainService),ee(17,W.IThemeMainService)],B),e.WindowsMainService=B}),define(te[272],ie([0,1,60,33,75,52]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(u,m,I,v){this.workspacesManagementMainService=u,this.windowsMainService=m,this.workspacesHistoryMainService=I,this.backupMainService=v,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(u,m){const I=this.windowsMainService.getWindowById(u);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(u,m,I){return this.workspacesManagementMainService.createUntitledWorkspace(m,I)}deleteUntitledWorkspace(u,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(u,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(u){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(u,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(u,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(u){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,k.IWorkspacesHistoryMainService),ee(3,w.IBackupMainService)],D),e.WorkspacesMainService=D}),define(te[273],ie([0,1,15,41,27,18,44,17,30,49,43,35,2,13,9,5,12,7,29,81,131,46,145,101,248,148,60,264,19,69,181,84,118,56,104,179,26,59,112,193,213,194,250,105,195,196,14,206,86,68,4,85,265,226,260,22,6,208,270,65,20,63,256,87,38,253,91,113,32,232,234,73,48,239,240,266,241,267,115,243,244,245,246,251,33,271,252,28,92,75,272,52,249,37,212,42,259,222,55,72,89,254,261,262,8]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o,n,r,s,c,l,P,M,T,N,X,ae,Q,G,Z,se,he,V,H,W,A,F,U,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae,ke,Le,qe,me,we,Ee,x,le,fe,Se,Ie,Te,Oe,Ne,Be,ze,Ke,Ue,Ge,K,ue,de,pe,ye,Re,_e,it,xe,je,et,nt,lt,gt,St,Bt,zt,$t,_t,qt,Ht,jt,Vt,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pt=class extends b.Disposable{constructor(be,Pe,Me,Ce,Fe,$e,Ze,tt,We,Ve,Qe){super(),this.mainProcessNodeIpcServer=be,this.userEnv=Pe,this.mainInstantiationService=Me,this.logService=Ce,this.environmentMainService=Fe,this.lifecycleMainService=$e,this.configurationService=Ze,this.stateMainService=tt,this.fileService=We,this.productService=Ve,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const be=We=>We?.startsWith(`${d.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((We,Ve,Qe,Je)=>be(Je.requestingUrl)?Qe(Pe.has(Ve)):Qe(!1)),w.session.defaultSession.setPermissionCheckHandler((We,Ve,Qe,Je)=>be(Je.requestingUrl)?Pe.has(Ve):!1);const Me=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Ce=We=>{for(let Ve=We;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Fe=We=>We.resourceType==="xhr"||Ce(We.frame),$e=We=>{const Ve=We.frame;if(!Ve||!this.windowsMainService)return!1;const Qe=w.BrowserWindow.getAllWindows();for(const Je of Qe)if(Ve.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ze=(We,Ve)=>{if(We.path!=="/index.html")return!0;const Qe=Ve.frame;if(!Qe||!this.windowsMainService)return!1;for(const Je of this.windowsMainService.getWindows())if(Je.win&&Qe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((We,Ve)=>{const Qe=p.URI.parse(We.url);return Qe.scheme===d.Schemas.vscodeWebview&&!Ze(Qe,We)?(this.logService.error("Blocked vscode-webview request",We.url),Ve({cancel:!0})):Qe.scheme===d.Schemas.vscodeFileResource&&!$e(We)?(this.logService.error("Blocked vscode-file request",We.url),Ve({cancel:!0})):Qe.path.endsWith(".svg")&&!Me.has(Qe.scheme)?Ve({cancel:!Fe(We)}):Ve({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((We,Ve)=>{const Qe=We.responseHeaders,Je=Qe["content-type"]||Qe["Content-Type"];if(Je&&Array.isArray(Je)){const ot=p.URI.parse(We.url);if(ot.path.endsWith(".svg")&&Me.has(ot.scheme))return Qe["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Qe});if(!ot.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(ct=>ct.toLowerCase().includes("image/svg")))return Ve({cancel:!Fe(We)})}return Ve({cancel:!1})});const tt=w.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,h.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(Me=>this.onUnexpectedError(Me)),process.on("uncaughtException",Me=>(0,E.onUnexpectedError)(Me)),process.on("unhandledRejection",Me=>(0,E.onUnexpectedError)(Me)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(Me,Ce)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ce)}),w.app.on("activate",async(Me,Ce)=>{this.logService.trace("app#activate"),Ce||await this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(Me,Ce)=>{Ce.on("will-navigate",Fe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ce.setWindowOpenHandler(({url:Fe})=>(this.nativeHostMainService?.openExternal(void 0,Fe),{action:"deny"}))});let be=[],Pe;w.app.on("open-file",(Me,Ce)=>{this.logService.trace("app#open-file: ",Ce),Me.preventDefault(),be.push((0,_e.hasWorkspaceFileExtension)(Ce)?{workspaceUri:p.URI.file(Ce)}:{fileUri:p.URI.file(Ce)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:be,gotoLineMode:!1,preferNewWindow:!0}),be=[],Pe=void 0},100)}),w.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Me=>{const Ce=this.windowsMainService?.getWindowByWebContents(Me.sender);let Fe,$e;return Ce?.config?(Fe=Ce.config,$e={...process.env,...Ce.config.userEnv}):(Fe=this.environmentMainService.args,$e=process.env),this.resolveShellEnvironment(Fe,$e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Me,Ce,Fe)=>{const $e=this.validateNlsPath([Ce]);if(!$e||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile($e,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Me,...Ce)=>{const Fe=this.validateNlsPath(Ce);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Me=>Me.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Me=>Me.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Me=>Me.sender.reload())}validateNlsPath(be){let Pe;for(const Me of be)typeof Me=="string"&&(typeof Pe!="string"?Pe=Me:Pe=(0,h.join)(Pe,Me));if(!(typeof Pe!="string"||!(0,h.isAbsolute)(Pe)||!(0,u.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!y.isLinux)))return p.URI.file(Pe)}onUnexpectedError(be){if(be){const Pe={message:`[uncaught exception in main]: ${be.message}`,stack:be.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${be}`),be.stack&&this.logService.error(be.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const be=this.productService.win32AppUserModelId;y.isWindows&&be&&w.app.setAppUserModelId(be);try{y.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.logService.error(We)}const Pe=new i.Server;this.lifecycleMainService.onWillShutdown(We=>{We.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Me=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:Ce,sharedProcessReady:Fe,sharedProcessClient:$e}=this.setupSharedProcess(Me),Ze=await this.initServices(Me,Ce,Fe);this.setUpHandlers(Ze),Ze.invokeFunction(We=>this.initChannels(We,Pe,$e)),await Ze.invokeFunction(We=>this.openFirstWindow(We,Pe)),Ze.invokeFunction(We=>this.afterWindowOpen(We,Ce)),this._register(new It.RunOnceScheduler(()=>{this._register((0,It.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(be){this._register(be.createInstance(n.ProxyAuthHandler)),this._register(be.createInstance(Bt.DefaultExtensionsProfileInitHandler)),this._register(be.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let be=this.stateMainService.getItem(x.machineIdKey);return(!be||y.isMacintosh&&be==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(be=await(0,f.getMachineId)(),this.stateMainService.setItem(x.machineIdKey,be)),be}setupSharedProcess(be){const Pe=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,be,this.userEnv)),Me=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Fe=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Fe,"main")})(),Ce=(async()=>(await Pe.whenReady(),Me))();return{sharedProcess:Pe,sharedProcessReady:Ce,sharedProcessClient:Me}}async initServices(be,Pe,Me){const Ce=new _.ServiceCollection;switch(process.platform){case"win32":Ce.set(Ie.IUpdateService,new L.SyncDescriptor(ze.Win32UpdateService));break;case"linux":y.isLinuxSnap?Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Ce.set(Ie.IUpdateService,new L.SyncDescriptor(Oe.DarwinUpdateService));break}Ce.set(pe.IWindowsMainService,new L.SyncDescriptor(ye.WindowsMainService,[be,this.userEnv],!1));const Fe=new X.DialogMainService(this.logService);Ce.set(X.IDialogMainService,Fe),Ce.set(oe.ILaunchMainService,new L.SyncDescriptor(oe.LaunchMainService,void 0,!1)),Ce.set(N.IDiagnosticsMainService,new L.SyncDescriptor(N.DiagnosticsMainService,void 0,!1)),Ce.set(T.IDiagnosticsService,a.ProxyChannel.toService((0,a.getDelayedChannel)(Me.then(tt=>tt.getChannel("diagnostics"))))),Ce.set(j.IIssueMainService,new L.SyncDescriptor(j.IssueMainService,[this.userEnv])),Ce.set(ae.IEncryptionMainService,new L.SyncDescriptor(Q.EncryptionMainService,[be])),Ce.set(Y.IKeyboardLayoutMainService,new L.SyncDescriptor(Y.KeyboardLayoutMainService)),Ce.set(ge.INativeHostMainService,new L.SyncDescriptor(ge.NativeHostMainService,[Pe],!1)),Ce.set(P.ICredentialsMainService,new L.SyncDescriptor(nt.CredentialsNativeMainService)),Ce.set(ue.IWebviewManagerService,new L.SyncDescriptor(de.WebviewMainService)),Ce.set(ce.IMenubarMainService,new L.SyncDescriptor(ce.MenubarMainService)),Ce.set(he.IExtensionUrlTrustService,new L.SyncDescriptor(V.ExtensionUrlTrustService)),Ce.set(H.IExtensionHostStarter,new L.SyncDescriptor(W.ExtensionHostStarter)),Ce.set(we.IStorageMainService,new L.SyncDescriptor(we.StorageMainService)),Ce.set(we.IApplicationStorageMainService,new L.SyncDescriptor(we.ApplicationStorageMainService)),y.isWindows?Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.WindowsExternalTerminalService)):y.isMacintosh?Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.MacExternalTerminalService)):y.isLinux&&Ce.set(A.IExternalTerminalMainService,new L.SyncDescriptor(F.LinuxExternalTerminalService));const $e=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateMainService);Ce.set(s.IBackupMainService,$e);const Ze=new et.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,$e,Fe,this.productService);if(Ce.set(et.IWorkspacesManagementMainService,Ze),Ce.set(it.IWorkspacesService,new L.SyncDescriptor(je.WorkspacesMainService,void 0,!1)),Ce.set(xe.IWorkspacesHistoryMainService,new L.SyncDescriptor(xe.WorkspacesHistoryMainService,void 0,!1)),Ce.set(Ke.IURLService,new L.SyncDescriptor(Ge.NativeURLService,void 0,!1)),(0,Se.supportsTelemetry)(this.productService,this.environmentMainService)){const tt=(0,Se.isInternalTelemetry)(this.productService,this.configurationService),We=(0,a.getDelayedChannel)(Me.then(ct=>ct.getChannel("telemetryAppender"))),Ve=new le.TelemetryAppenderClient(We),Qe=(0,Ee.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,be,tt,this.environmentMainService.installSourcePath),Je=(0,Se.getPiiPathsFromEnvironment)(this.environmentMainService),ot={appenders:[Ve],commonProperties:Qe,piiPaths:Je,sendErrorTelemetry:!0};Ce.set(x.ITelemetryService,new L.SyncDescriptor(fe.TelemetryService,[ot],!1))}else Ce.set(x.ITelemetryService,Se.NullTelemetryService);return Ce.set(_t.IExtensionsProfileScannerService,new L.SyncDescriptor(_t.ExtensionsProfileScannerService,void 0,!0)),Ce.set(qt.IExtensionsScannerService,new L.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await It.Promises.settled([$e.initialize(),Ze.initialize()]),this.mainInstantiationService.createChild(Ce)}initChannels(be,Pe,Me){const Ce=a.ProxyChannel.fromService(be.get(oe.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ce);const Fe=a.ProxyChannel.fromService(be.get(N.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Fe);const $e=new gt.PolicyChannel(be.get(lt.IPolicyService));Pe.registerChannel("policy",$e),Me.then(Ye=>Ye.registerChannel("policy",$e));const Ze=this.fileService.getProvider(d.Schemas.file);(0,C.assertType)(Ze instanceof $.DiskFileSystemProvider);const tt=new B.DiskFileSystemProviderChannel(Ze,this.logService,this.environmentMainService);Pe.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Me.then(Ye=>Ye.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const We=a.ProxyChannel.fromService(be.get(St.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",We),Me.then(Ye=>Ye.registerChannel("userDataProfiles",We));const Ve=new zt.RequestChannel(be.get($t.IRequestService));Me.then(Ye=>Ye.registerChannel("request",Ve));const Qe=new Te.UpdateChannel(be.get(Ie.IUpdateService));Pe.registerChannel("update",Qe);const Je=a.ProxyChannel.fromService(be.get(j.IIssueMainService));Pe.registerChannel("issue",Je);const ot=a.ProxyChannel.fromService(be.get(ae.IEncryptionMainService));Pe.registerChannel("encryption",ot);const ct=a.ProxyChannel.fromService(be.get(P.ICredentialsMainService));Pe.registerChannel("credentials",ct);const kt=a.ProxyChannel.fromService(be.get(Le.ISignService));Pe.registerChannel("sign",kt);const Xe=a.ProxyChannel.fromService(be.get(Y.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=be.get(ge.INativeHostMainService);const mt=a.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",mt),Me.then(Ye=>Ye.registerChannel("nativeHost",mt));const pt=a.ProxyChannel.fromService(be.get(it.IWorkspacesService));Pe.registerChannel("workspaces",pt);const yt=a.ProxyChannel.fromService(be.get(ce.IMenubarMainService));Pe.registerChannel("menubar",yt);const Mt=a.ProxyChannel.fromService(be.get(Ke.IURLService));Pe.registerChannel("url",Mt);const Dt=a.ProxyChannel.fromService(be.get(he.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",Dt);const wt=a.ProxyChannel.fromService(be.get(ue.IWebviewManagerService));Pe.registerChannel("webview",wt);const ut=this._register(new me.StorageDatabaseChannel(this.logService,be.get(we.IStorageMainService)));Pe.registerChannel("storage",ut),Me.then(Ye=>Ye.registerChannel("storage",ut));const bt=this._register(new Vt.ProfileStorageChangesListenerChannel(be.get(we.IStorageMainService),be.get(St.IUserDataProfilesMainService),this.logService));Me.then(Ye=>Ye.registerChannel("profileStorageListener",bt));const vt=a.ProxyChannel.fromService(be.get(A.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",vt);const He=new ne.LogLevelChannel(be.get(re.ILogService));Pe.registerChannel("logLevel",He),Me.then(Ye=>Ye.registerChannel("logLevel",He));const st=new ne.LoggerChannel(be.get(re.ILoggerService));Pe.registerChannel("logger",st),Me.then(Ye=>Ye.registerChannel("logger",st));const ht=new M.ElectronExtensionHostDebugBroadcastChannel(be.get(pe.IWindowsMainService),be.get(St.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",ht);const at=a.ProxyChannel.fromService(be.get(H.IExtensionHostStarter));Pe.registerChannel(H.ipcExtensionHostStarterChannelName,at)}async openFirstWindow(be,Pe){const Me=this.windowsMainService=be.get(pe.IWindowsMainService),Ce=be.get(Ke.IURLService),Fe=be.get(ge.INativeHostMainService);this.lifecycleMainService.phase=2;const $e=[],Ze=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(He=>{try{return{uri:p.URI.parse(He),url:He}}catch{return}}).filter(He=>{if(!He||this.shouldBlockURI(He.uri))return!1;const st=this.getWindowOpenableFromProtocolLink(He.uri);return st?($e.push(st),!1):!0}),tt=this,We=this.environmentMainService,Ve=this.productService,Qe=this.logService;Ce.registerHandler({async handleURL(He,st){if(Qe.trace("app#handleURL: ",He.toString(!0),st),He.scheme===Ve.urlProtocol&&He.path==="workspace"&&(He=He.with({authority:"file",path:p.URI.parse(He.query).path,query:""})),tt.shouldBlockURI(He))return!0;let ht=!1;const at=new URLSearchParams(He.query);at.get("windowId")==="_blank"&&(at.delete("windowId"),He=He.with({query:at.toString()}),ht=!0),ht||=y.isMacintosh&&Me.getWindowCount()===0;const Ye=at.get("continueOn");Ye!==null&&(We.continueOn=Ye??void 0,at.delete("continueOn"),He=He.with({query:at.toString()}));const Rt=tt.getWindowOpenableFromProtocolLink(He);if(Qe.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[Lt]=await Me.open({context:5,cli:{...We.args},urisToOpen:[Rt],forceNewWindow:ht,gotoLineMode:!0});return Lt.focus(),!0}if(ht){const[Lt]=await Me.open({context:5,cli:{...We.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ae.getRemoteAuthority)(He)});return await Lt.ready(),Ce.open(He,st)}return!1}});const Je=this._register(new Re.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),ot=new a.StaticRouter(He=>Je.getActiveClientId().then(st=>He===st)),ct=new Ue.URLHandlerRouter(ot),kt=Pe.getChannel("urlHandler",ct);Ce.registerHandler(new Ue.URLHandlerChannelClient(kt)),this._register(new K.ElectronURLListener(Ze,Ce,Me,this.environmentMainService,this.productService));const Xe=this.environmentMainService.args,mt=global.macOpenFiles,pt=(0,Z.isLaunchedFromCli)(process.env)?0:4,yt=Xe._.length,Mt=!!Xe["folder-uri"],Dt=!!Xe["file-uri"],wt=Xe["skip-add-to-recently-opened"]===!0,ut=Xe.wait&&Xe.waitMarkerFilePath?p.URI.file(Xe.waitMarkerFilePath):void 0,bt=Xe.remote||void 0;if($e.length>0)return Me.open({context:pt,cli:Xe,urisToOpen:$e,gotoLineMode:!0,initialStartup:!0});const vt=await this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args);if(!yt&&!Mt&&!Dt){if(Xe["new-window"]||vt)return Me.open({context:pt,cli:Xe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:bt,profile:vt});if(mt.length)return Me.open({context:1,cli:Xe,urisToOpen:mt.map(He=>(0,_e.hasWorkspaceFileExtension)(He)?{workspaceUri:p.URI.file(He)}:{fileUri:p.URI.file(He)}),noRecentEntry:wt,waitMarkerFileURI:ut,initialStartup:!0})}return Me.open({context:pt,cli:Xe,forceNewWindow:Xe["new-window"]||!yt&&Xe["unity-launch"],diffMode:Xe.diff,mergeMode:Xe.merge,noRecentEntry:wt,waitMarkerFileURI:ut,gotoLineMode:Xe.goto,initialStartup:!0,remoteAuthority:bt,profile:vt})}shouldBlockURI(be){return!!(be.authority===d.Schemas.file&&y.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,v.mnemonicButtonLabel)((0,r.localize)(0,null)),(0,v.mnemonicButtonLabel)((0,r.localize)(1,null))],defaultId:0,cancelId:1,message:(0,r.localize)(2,null,(0,v.getPathLabel)(be,{os:y.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,r.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(be){if(!!be.path){if(be.authority===d.Schemas.file){const Pe=p.URI.file(be.fsPath);return(0,_e.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(be.authority===d.Schemas.vscodeRemote){const Pe=be.path.indexOf(h.posix.sep,1);if(Pe!==-1){const Me=be.path.substring(1,Pe),Ce=be.path.substring(Pe),Fe=p.URI.from({scheme:d.Schemas.vscodeRemote,authority:Me,path:Ce,query:be.query,fragment:be.fragment});return(0,_e.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Fe}:/:[\d]+$/.test(Ce)?{fileUri:Fe}:{folderUri:Fe}}}}}afterWindowOpen(be,Pe){const Me=be.get(x.ITelemetryService),Ce=be.get(Ie.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Me,Pe),this.installMutex(),w.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Fe,$e)=>{$e({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ce instanceof ze.Win32UpdateService||Ce instanceof Ne.LinuxUpdateService||Ce instanceof Oe.DarwinUpdateService)&&Ce.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const be=this.productService.win32MutexName;if(y.isWindows&&be)try{const Pe=await new Promise((Ce,Fe)=>{z(["windows-mutex"],Ce,Fe)}),Me=new Pe.Mutex(be);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(be,Pe){let Me=!1;(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Me=!0),this._register(Pe.onDidError(({type:Ce,details:Fe})=>{let $e;switch(Ce){case 1:$e="SharedProcess: detected unresponsive window";break;case 2:$e=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:$e=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error($e)),be.publicLog2("sharedprocesserror",{type:Ce,reason:Fe?.reason,code:Fe?.exitCode,visible:Pe.isVisible(),shuttingdown:Me})}))}async resolveShellEnvironment(be,Pe,Me){try{return await(0,se.getResolvedShellEnv)(this.logService,be,Pe)}catch(Ce){const Fe=(0,D.toErrorMessage)(Ce);Me?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.logService.error(Fe)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Me=JSON.parse((0,I.stripComments)(Pe)),Fe=(0,Se.getTelemetryLevel)(this.configurationService)>=1;if(Me["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,S.generateUuid)()}"`,"}"],Ze=Pe.substring(0,Pe.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString(Ze))}else{const $e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);$e!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,R.VSBuffer.fromString($e))}}catch(be){this.logService.error(be)}}};Pt=ve([ee(2,O.IInstantiationService),ee(3,re.ILogService),ee(4,G.IEnvironmentMainService),ee(5,q.ILifecycleMainService),ee(6,l.IConfigurationService),ee(7,qe.IStateMainService),ee(8,J.IFileService),ee(9,De.IProductService),ee(10,St.IUserDataProfilesMainService)],Pt),e.CodeApplication=Pt}),define(te[274],ie([0,1,37,8,281,2]),function(z,e,w,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends w.AbstractPolicyService{constructor(u){super(),this.productName=u,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(u){await this.throttler.queue(()=>new Promise((m,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,u,v=>{for(const b in v){const d=v[b];d===void 0?this.policies.delete(b):this.policies.set(b,d)}this._onDidChange.fire(Object.keys(v)),m()})}catch(v){I(v)}}))}}e.NativePolicyService=D}),define(te[275],ie([0,1,224,8,18,17,2,12,19,36,112,6,223,282]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let h=class extends D.Disposable{constructor(C,p,S){super(),this.environmentService=p,this.logService=S,this.configure(C.getValue()),this._register(C.onDidChangeConfiguration(()=>this.configure(C.getValue()),this))}configure(C){this.proxyUrl=C.http&&C.http.proxy,this.strictSSL=!!(C.http&&C.http.proxyStrictSSL),this.authorization=C.http&&C.http.proxyAuthorization}async request(C,p){this.logService.trace("RequestService#request (node) - begin",C.url);const{proxyUrl:S,strictSSL:f}=this;let g;try{g=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const a={...process.env,...g},i=C.agent?C.agent:await(0,b.getProxyAgent)(C.url||"",a,{proxyUrl:S,strictSSL:f});C.agent=i,C.strictSSL=f,this.authorization&&(C.headers={...C.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(C,p);return this.logService.trace("RequestService#request (node) - success",C.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",C.url,o),o}}async getNodeRequest(C){return((0,w.parse)(C.url).protocol==="https:"?await new Promise((f,g)=>{z(["https"],f,g)}):await new Promise((f,g)=>{z(["http"],f,g)})).request}_request(C,p){return t.Promises.withAsyncBody(async(S,f)=>{const g=(0,w.parse)(C.url),a=C.getRawRequest?C.getRawRequest(C):await this.getNodeRequest(C),i={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:C.type||"GET",headers:C.headers,agent:C.agent,rejectUnauthorized:(0,E.isBoolean)(C.strictSSL)?C.strictSSL:!0};C.user&&C.password&&(i.auth=C.user+":"+C.password);const o=a(i,n=>{const r=(0,E.isNumber)(C.followRedirects)?C.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request({...C,url:n.headers.location,followRedirects:r-1},p).then(S,f);else{let s=n;n.headers["content-encoding"]==="gzip"&&(s=n.pipe((0,d.createGunzip)())),S({res:n,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",f),C.timeout&&o.setTimeout(C.timeout),C.data&&typeof C.data=="string"&&o.write(C.data),o.end(),p.onCancellationRequested(()=>{o.abort(),f(new R.CancellationError)})})}async resolveProxy(C){}};h=ve([ee(0,u.IConfigurationService),ee(1,m.INativeEnvironmentService),ee(2,v.ILogService)],h),e.RequestService=h}),define(te[276],ie([0,1,15,275]),function(z,e,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return w.net.request}class R extends t.RequestService{request(E,u){return super.request({...E||{},getRawRequest:k},u)}}e.RequestMainService=R}),define(te[283],ie([0,1,15,40,7,24,8,44,17,30,49,35,13,9,71,5,34,25,21,46,83,273,10,19,217,230,26,59,185,14,204,86,68,201,85,22,107,6,209,108,54,20,61,255,114,237,55,276,87,225,38,229,73,64,42,37,274,211,2,51,242,39,238]),function(z,e,w,t,k,R,D,E,u,m,I,v,b,d,h,y,C,p,S,f,g,a,i,o,n,r,s,c,l,P,M,T,N,X,ae,Q,G,Z,se,he,V,H,W,A,F,U,J,B,$,L,O,_,j,Y,oe,q,re,ne,ce,ge,De,Ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(me){console.error(me.message),w.app.exit(1)}}async startup(){(0,u.setUnexpectedErrorHandler)(Te=>console.error(Te));const[me,we,Ee,x,le,fe,Se,Ie]=this.createServices();try{try{await this.initServices(Ee,Ie,x,le,Se)}catch(Te){throw this.handleStartupDataDirError(Ee,Se.nameLong,Te),Te}await me.invokeFunction(async Te=>{const Oe=Te.get(Z.ILogService),Ne=Te.get(Q.ILifecycleMainService),Be=Te.get(P.IFileService),ze=await this.claimInstance(Oe,Ee,Ne,me,Se,!0);return S.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Ke=>{Oe.warn(`Error writing main lockfile: ${Ke.stack}`)}),fe.logger=new he.SpdLogLogger("main",(0,d.join)(Ee.logsPath,"main.log"),!0,!1,fe.getLevel()),(0,I.once)(Ne.onWillShutdown)(Ke=>{Be.dispose(),x.dispose(),Ke.join(S.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),me.createInstance(a.CodeApplication,ze,we).startup()})}catch(Te){me.invokeFunction(this.quit,Te)}}createServices(){const me=new ae.ServiceCollection,we=new ce.DisposableStore;process.once("exit",()=>we.dispose());const Ee={_serviceBrand:void 0,...V.default};me.set(H.IProductService,Ee);const x=new s.EnvironmentMainService(this.resolveArgs(),Ee),le=this.patchEnvironment(x);me.set(s.IEnvironmentMainService,x);const fe=new G.BufferLogService,Se=we.add(new Z.MultiplexLogService([new Z.ConsoleMainLogger((0,Z.getLogLevel)(x)),fe]));me.set(Z.ILogService,Se);const Ie=new M.FileService(Se);me.set(P.IFileService,Ie);const Te=new T.DiskFileSystemProvider(Se);Ie.registerProvider(b.Schemas.file,Te);const Oe=new De.UriIdentityService(Ie);me.set(ge.IUriIdentityService,Oe),me.set(Z.ILoggerService,new se.LoggerService(Se,Ie));const Ne=new _.StateMainService(x,Se,Ie);me.set(O.IStateMainService,Ne);const Be=new oe.UserDataProfilesMainService(Ne,Oe,x,Ie,Se);me.set(oe.IUserDataProfilesMainService,Be);const ze=y.isWindows&&Ee.win32RegValueName?we.add(new re.NativePolicyService(Ee.win32RegValueName)):x.policyFile?we.add(new ne.FilePolicyService(x.policyFile,Ie,Se)):new q.NullPolicyService;me.set(q.IPolicyService,ze);const Ke=new n.ConfigurationService(Be.defaultProfile.settingsResource,Ie,ze,Se);return me.set(o.IConfigurationService,Ke),me.set(Q.ILifecycleMainService,new N.SyncDescriptor(Q.LifecycleMainService,void 0,!1)),me.set(J.IRequestService,new N.SyncDescriptor(B.RequestMainService,void 0,!0)),me.set(Y.IThemeMainService,new N.SyncDescriptor(Y.ThemeMainService)),me.set($.ISignService,new N.SyncDescriptor(L.SignService,void 0,!1)),me.set(F.ITunnelService,new N.SyncDescriptor(U.TunnelService)),me.set(W.IProtocolMainService,new A.ProtocolMainService(x,Be,Se)),[new X.InstantiationService(me,!0),le,x,Ke,Ne,fe,Ee,Be]}patchEnvironment(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const x=process.env[Ee];typeof x=="string"&&(we[Ee]=x)}),Object.assign(process.env,we),we}async initServices(me,we,Ee,x,le){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,we.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(fe=>fe?S.Promises.mkdir(fe,{recursive:!0}):void 0)),x.init(),Ee.initialize()]),we.setEnablement(le.quality!=="stable"||Ee.getValue(Ae.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,we,Ee,x,le,fe){let Se;try{(0,h.mark)("code/willStartMainServer"),Se=await(0,g.serve)(we.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),(0,I.once)(Ee.onWillShutdown)(()=>Se.dispose())}catch(Ie){if(Ie.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,le.nameLong,Ie),Ie;let Te;try{Te=await(0,g.connect)(we.mainIPCHandle,"main")}catch(ze){if(!fe||y.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,i.localize)(0,null,le.nameShort),(0,i.localize)(1,null),le.nameLong),ze;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Ke){throw me.warn("Could not delete obsolete instance handle",Ke),Ke}return this.claimInstance(me,we,Ee,x,le,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error(ze),Te.dispose(),new Error(ze)}let Oe;!we.args.wait&&!we.args.status&&(Oe=setTimeout(()=>{this.showStartupWarningDialog((0,i.localize)(2,null,le.nameShort),(0,i.localize)(3,null),le.nameLong)},1e4));const Ne=f.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Be=f.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return x.invokeFunction(async()=>{const ze=new r.DiagnosticsService(j.NullTelemetryService,le),Ke=await Be.getMainDiagnostics(),Ue=await Be.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await ze.getDiagnostics(Ke,Ue);throw console.log(Ge),new u.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,me),me.trace("Sending env to running instance..."),await Ne.start(we.args,process.env),Te.dispose(),Oe&&clearTimeout(Oe),new u.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new u.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(me,we,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const x=(0,R.coalesce)([me.userDataPath,me.extensionsPath,g.XDG_RUNTIME_DIR]).map(le=>(0,v.getPathLabel)(k.URI.file(le),{os:y.OS,tildify:me}));this.showStartupWarningDialog((0,i.localize)(4,null),(0,i.localize)(5,null,(0,E.toErrorMessage)(Ee),x.join(`
`)),we)}}showStartupWarningDialog(me,we,Ee){w.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,v.mnemonicButtonLabel)((0,i.localize)(6,null))],message:me,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,we){if(y.isWindows){const Ee=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((x,le)=>{z(["windows-foreground-love"],x,le)})).allowSetForegroundWindow(Ee)}catch(x){we.error(x)}}}quit(me,we){const Ee=me.get(Z.ILogService),x=me.get(Q.ILifecycleMainService);let le=0;we&&(we.isExpected?we.message&&Ee.trace(we.message):(le=1,we.stack?Ee.error(we.stack):Ee.error(`Startup error: ${we.toString()}`))),x.kill(le)}resolveArgs(){const me=this.validatePaths((0,c.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,l.createWaitMarkerFileSync)(me.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.doValidatePaths(me._,me.goto);me._=we}return me}doValidatePaths(me,we){const Ee=(0,C.cwd)(),x=me.map(Se=>{let Ie=String(Se),Te;we&&(Te=(0,m.parseLineAndColumnAware)(Ie),Ie=Te.path),Ie&&(Ie=this.preparePath(Ee,Ie));const Oe=(0,m.sanitizeFilePath)(Ie,Ee),Ne=(0,d.basename)(Oe);return Ne&&!(0,m.isValidBasename)(Ne)?null:we&&Te?(Te.path=Oe,this.toPath(Te)):Oe}),le=y.isWindows||y.isMacintosh,fe=(0,R.distinct)(x,Se=>Se&&le?Se.toLowerCase():Se||"");return(0,R.coalesce)(fe)}preparePath(me,we){return y.isWindows&&(we=(0,p.rtrim)(we,'"')),we=(0,p.trim)((0,p.trim)(we," "),"	"),y.isWindows&&(we=(0,d.resolve)(me,we),we=(0,p.rtrim)(we,".")),we}toPath(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9fb452c4852ef098206ec67a2b236ad5fd0ba828/core/vs/code/electron-main/main.js.map
