/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(B){for(var t=[],D=0,C=B.length;D<C;D++)t[D]=Q[B[D]];return t};define(Q[49],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function D(L){return(p,a,d)=>{let I=null,w=null;if(typeof d.value=="function"?(I="value",w=d.value):typeof d.get=="function"&&(I="get",w=d.get),!w)throw new Error("not supported");d[I]=L(w,a)}}t.createDecorator=D;function C(L,p,a){let d=null,I=null;if(typeof a.value=="function"?(d="value",I=a.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(d="get",I=a.get),!I)throw new Error("not supported");const w=`$memoize$${p}`;a[d]=function(...h){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,h)}),this[w]}}t.memoize=C;function P(L,p,a){return D((d,I)=>{const w=`$debounce$${I}`,h=`$debounce$result$${I}`;return function(...v){this[h]||(this[h]=a?a():void 0),clearTimeout(this[w]),p&&(this[h]=p(this[h],...v),v=[this[h]]),this[w]=setTimeout(()=>{d.apply(this,v),this[h]=a?a():void 0},L)}})}t.debounce=P;function T(L,p,a){return D((d,I)=>{const w=`$throttle$timer$${I}`,h=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,f=`$throttle$pending$${I}`;return function(...m){if(this[h]||(this[h]=a?a():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[h]=p(this[h],...m)),this[f])return;const E=this[v]+L;E<=Date.now()?(this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=a?a():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=a?a():void 0},E-Date.now()))}})}t.throttle=T}),define(Q[68],Z([0,1,11]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function C(a,d){if(!a)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}t.ok=C;function P(a,d="Unreachable"){throw new Error(d)}t.assertNever=P;function T(a){if(!a)throw new D.BugIndicatingError("Assertion Failed")}t.assert=T;function L(a){if(!a()){debugger;a(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}t.assertFn=L;function p(a,d){let I=0;for(;I<a.length-1;){const w=a[I],h=a[I+1];if(!d(w,h))return!1;I++}return!0}t.checkAdjacentItems=p}),define(Q[50],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=t.ScanError||(t.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=t.SyntaxKind||(t.SyntaxKind={}));var P;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(P=t.ParseErrorCode||(t.ParseErrorCode={}));var T;(function(e){e.DEFAULT={allowTrailingComma:!0}})(T=t.ParseOptions||(t.ParseOptions={}));function L(e,r=!1){let i=0;const n=e.length;let o="",S=0,y=16,b=0;function R(se){let fe=0,le=0;for(;fe<se;){const ie=e.charCodeAt(i);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;i++,fe++}return fe<se&&(le=-1),le}function j(se){i=se,o="",S=0,y=16,b=0}function _(){const se=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&d(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&d(e.charCodeAt(i)))for(i++;i<e.length&&d(e.charCodeAt(i));)i++;else return b=3,e.substring(se,i);let fe=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&d(e.charCodeAt(i))){for(i++;i<e.length&&d(e.charCodeAt(i));)i++;fe=i}else b=3;return e.substring(se,fe)}function J(){let se="",fe=i;for(;;){if(i>=n){se+=e.substring(fe,i),b=2;break}const le=e.charCodeAt(i);if(le===34){se+=e.substring(fe,i),i++;break}if(le===92){if(se+=e.substring(fe,i),i++,i>=n){b=2;break}switch(e.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const V=R(4);V>=0?se+=String.fromCharCode(V):b=4;break}default:b=5}fe=i;continue}if(le>=0&&le<=31)if(a(le)){se+=e.substring(fe,i),b=2;break}else b=6;i++}return se}function H(){if(o="",b=0,S=i,i>=n)return S=n,y=17;let se=e.charCodeAt(i);if(p(se)){do i++,o+=String.fromCharCode(se),se=e.charCodeAt(i);while(p(se));return y=15}if(a(se))return i++,o+=String.fromCharCode(se),se===13&&e.charCodeAt(i)===10&&(i++,o+=`
`),y=14;switch(se){case 123:return i++,y=1;case 125:return i++,y=2;case 91:return i++,y=3;case 93:return i++,y=4;case 58:return i++,y=6;case 44:return i++,y=5;case 34:return i++,o=J(),y=10;case 47:{const fe=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<n&&!a(e.charCodeAt(i));)i++;return o=e.substring(fe,i),y=12}if(e.charCodeAt(i+1)===42){i+=2;const le=n-1;let ie=!1;for(;i<le;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,b=1),o=e.substring(fe,i),y=13}return o+=String.fromCharCode(se),i++,y=16}case 45:if(o+=String.fromCharCode(se),i++,i===n||!d(e.charCodeAt(i)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),y=11;default:for(;i<n&&ne(se);)i++,se=e.charCodeAt(i);if(S!==i){switch(o=e.substring(S,i),o){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return o+=String.fromCharCode(se),i++,y=16}}function ne(se){if(p(se)||a(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=H();while(se>=12&&se<=15);return se}return{setPosition:j,getPosition:()=>i,scan:r?re:H,getToken:()=>y,getTokenValue:()=>o,getTokenOffset:()=>S,getTokenLength:()=>i-S,getTokenError:()=>b}}t.createScanner=L;function p(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function a(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var I;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(I||(I={}));function w(e,r){const i=[],n=new Object;let o;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function b(R,j,_,J){S.value=R,S.offset=j,S.length=_,S.type=J,S.colonOffset=void 0,o=S}try{g(e,{onObjectBegin:(R,j)=>{if(r<=R)throw n;o=void 0,y=r>R,i.push("")},onObjectProperty:(R,j,_)=>{if(r<j||(b(R,j,_,"property"),i[i.length-1]=R,r<=j+_))throw n},onObjectEnd:(R,j)=>{if(r<=R)throw n;o=void 0,i.pop()},onArrayBegin:(R,j)=>{if(r<=R)throw n;o=void 0,i.push(0)},onArrayEnd:(R,j)=>{if(r<=R)throw n;o=void 0,i.pop()},onLiteralValue:(R,j,_)=>{if(r<j||(b(R,j,_,s(R)),r<=j+_))throw n},onSeparator:(R,j,_)=>{if(r<=j)throw n;if(R===":"&&o&&o.type==="property")o.colonOffset=j,y=!1,o=void 0;else if(R===","){const J=i[i.length-1];typeof J=="number"?i[i.length-1]=J+1:(y=!0,i[i.length-1]=""),o=void 0}}})}catch(R){if(R!==n)throw R}return{path:i,previousNode:o,isAtPropertyKey:y,matches:R=>{let j=0;for(let _=0;j<R.length&&_<i.length;_++)if(R[j]===i[_]||R[j]==="*")j++;else if(R[j]!=="**")return!1;return j===R.length}}}t.getLocation=w;function h(e,r=[],i=T.DEFAULT){let n=null,o=[];const S=[];function y(R){Array.isArray(o)?o.push(R):n!==null&&(o[n]=R)}return g(e,{onObjectBegin:()=>{const R={};y(R),S.push(o),o=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{o=S.pop()},onArrayBegin:()=>{const R=[];y(R),S.push(o),o=R,n=null},onArrayEnd:()=>{o=S.pop()},onLiteralValue:y,onError:(R,j,_)=>{r.push({error:R,offset:j,length:_})}},i),o[0]}t.parse=h;function v(e,r=[],i=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){n.type==="property"&&(n.length=R-n.offset,n=n.parent)}function S(R){return n.children.push(R),R}g(e,{onObjectBegin:R=>{n=S({type:"object",offset:R,length:-1,parent:n,children:[]})},onObjectProperty:(R,j,_)=>{n=S({type:"property",offset:j,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:R,offset:j,length:_,parent:n})},onObjectEnd:(R,j)=>{n.length=R+j-n.offset,n=n.parent,o(R+j)},onArrayBegin:(R,j)=>{n=S({type:"array",offset:R,length:-1,parent:n,children:[]})},onArrayEnd:(R,j)=>{n.length=R+j-n.offset,n=n.parent,o(R+j)},onLiteralValue:(R,j,_)=>{S({type:s(R),offset:j,length:_,parent:n,value:R}),o(j+_)},onSeparator:(R,j,_)=>{n.type==="property"&&(R===":"?n.colonOffset=j:R===","&&o(j))},onError:(R,j,_)=>{r.push({error:R,offset:j,length:_})}},i);const b=n.children[0];return b&&delete b.parent,b}t.parseTree=v;function f(e,r){if(!e)return;let i=e;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const S of i.children)if(Array.isArray(S.children)&&S.children[0].value===n){i=S.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}t.findNodeAtLocation=f;function m(e){if(!e.parent||!e.parent.children)return[];const r=m(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;r.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&r.push(i)}return r}t.getNodePath=m;function E(e){switch(e.type){case"array":return e.children.map(E);case"object":{const r=Object.create(null);for(const i of e.children){const n=i.children[1];n&&(r[i.children[0].value]=E(n))}return r}case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=E;function c(e,r,i=!1){return r>=e.offset&&r<e.offset+e.length||i&&r===e.offset+e.length}t.contains=c;function u(e,r,i=!1){if(c(e,r,i)){const n=e.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const S=u(n[o],r,i);if(S)return S}return e}}t.findNodeAtOffset=u;function g(e,r,i=T.DEFAULT){const n=L(e,!1);function o(A){return A?()=>A(n.getTokenOffset(),n.getTokenLength()):()=>!0}function S(A){return A?U=>A(U,n.getTokenOffset(),n.getTokenLength()):()=>!0}const y=o(r.onObjectBegin),b=S(r.onObjectProperty),R=o(r.onObjectEnd),j=o(r.onArrayBegin),_=o(r.onArrayEnd),J=S(r.onLiteralValue),H=S(r.onSeparator),ne=o(r.onComment),re=S(r.onError),se=i&&i.disallowComments,fe=i&&i.allowTrailingComma;function le(){for(;;){const A=n.scan();switch(n.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:se||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:se?ie(10):ne();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,U=[],k=[]){if(re(A),U.length+k.length>0){let O=n.getToken();for(;O!==17;){if(U.indexOf(O)!==-1){le();break}else if(k.indexOf(O)!==-1)break;O=le()}}}function V(A){const U=n.getTokenValue();return A?J(U):b(U),le(),!0}function N(){switch(n.getToken()){case 11:{let A=0;try{A=JSON.parse(n.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}J(A);break}case 7:J(null);break;case 8:J(!0);break;case 9:J(!1);break;default:return!1}return le(),!0}function F(){return n.getToken()!==10?(ie(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(H(":"),le(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function z(){y(),le();let A=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),H(","),le(),n.getToken()===2&&fe)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return R(),n.getToken()!==2?ie(7,[2],[]):le(),!0}function $(){j(),le();let A=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(A||ie(4,[],[]),H(","),le(),n.getToken()===4&&fe)break}else A&&ie(6,[],[]);Y()||ie(4,[],[4,5]),A=!0}return _(),n.getToken()!==4?ie(8,[4],[]):le(),!0}function Y(){switch(n.getToken()){case 3:return $();case 1:return z();case 10:return V(!0);default:return N()}}return le(),n.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(n.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}t.visit=g;function l(e,r){const i=L(e),n=[];let o,S=0,y;do switch(y=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:S!==y&&n.push(e.substring(S,y)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),S=i.getPosition();break}while(o!==17);return n.join("")}t.stripComments=l;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function B(P){const T=[];typeof P=="number"&&T.push("code/timeOrigin",P);function L(a){T.push(a,Date.now())}function p(){const a=[];for(let d=0;d<T.length;d+=2)a.push({name:T[d],startTime:T[d+1]});return a}return{mark:L,getMarks:p}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(P+L.startTime)});return T}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function D(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=t()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=D(C))}(),function(B,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var D=t();for(var C in D)(typeof exports=="object"?exports:B)[C]=D[C]}}(typeof self<"u"?self:this,function(){return function(B){var t={};function D(C){if(t[C])return t[C].exports;var P=t[C]={i:C,l:!1,exports:{}};return B[C].call(P.exports,P,P.exports,D),P.l=!0,P.exports}return D.m=B,D.c=t,D.d=function(C,P,T){D.o(C,P)||Object.defineProperty(C,P,{enumerable:!0,get:T})},D.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},D.t=function(C,P){if(1&P&&(C=D(C)),8&P||4&P&&typeof C=="object"&&C&&C.__esModule)return C;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:C}),2&P&&typeof C!="string")for(var L in C)D.d(T,L,function(p){return C[p]}.bind(null,L));return T},D.n=function(C){var P=C&&C.__esModule?function(){return C.default}:function(){return C};return D.d(P,"a",P),P},D.o=function(C,P){return Object.prototype.hasOwnProperty.call(C,P)},D.p="",D(D.s=0)}([function(B,t,D){(function(C){var P;t=B.exports=k,P=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,p=t.re=[],a=t.src=[],d=0,I=d++;a[I]="0|[1-9]\\d*";var w=d++;a[w]="[0-9]+";var h=d++;a[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=d++;a[v]="("+a[I]+")\\.("+a[I]+")\\.("+a[I]+")";var f=d++;a[f]="("+a[w]+")\\.("+a[w]+")\\.("+a[w]+")";var m=d++;a[m]="(?:"+a[I]+"|"+a[h]+")";var E=d++;a[E]="(?:"+a[w]+"|"+a[h]+")";var c=d++;a[c]="(?:-("+a[m]+"(?:\\."+a[m]+")*))";var u=d++;a[u]="(?:-?("+a[E]+"(?:\\."+a[E]+")*))";var g=d++;a[g]="[0-9A-Za-z-]+";var l=d++;a[l]="(?:\\+("+a[g]+"(?:\\."+a[g]+")*))";var s=d++,e="v?"+a[v]+a[c]+"?"+a[l]+"?";a[s]="^"+e+"$";var r="[v=\\s]*"+a[f]+a[u]+"?"+a[l]+"?",i=d++;a[i]="^"+r+"$";var n=d++;a[n]="((?:<|>)?=?)";var o=d++;a[o]=a[w]+"|x|X|\\*";var S=d++;a[S]=a[I]+"|x|X|\\*";var y=d++;a[y]="[v=\\s]*("+a[S]+")(?:\\.("+a[S]+")(?:\\.("+a[S]+")(?:"+a[c]+")?"+a[l]+"?)?)?";var b=d++;a[b]="[v=\\s]*("+a[o]+")(?:\\.("+a[o]+")(?:\\.("+a[o]+")(?:"+a[u]+")?"+a[l]+"?)?)?";var R=d++;a[R]="^"+a[n]+"\\s*"+a[y]+"$";var j=d++;a[j]="^"+a[n]+"\\s*"+a[b]+"$";var _=d++;a[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var J=d++;a[J]="(?:~>?)";var H=d++;a[H]="(\\s*)"+a[J]+"\\s+",p[H]=new RegExp(a[H],"g");var ne=d++;a[ne]="^"+a[J]+a[y]+"$";var re=d++;a[re]="^"+a[J]+a[b]+"$";var se=d++;a[se]="(?:\\^)";var fe=d++;a[fe]="(\\s*)"+a[se]+"\\s+",p[fe]=new RegExp(a[fe],"g");var le=d++;a[le]="^"+a[se]+a[y]+"$";var ie=d++;a[ie]="^"+a[se]+a[b]+"$";var V=d++;a[V]="^"+a[n]+"\\s*("+r+")$|^$";var N=d++;a[N]="^"+a[n]+"\\s*("+e+")$|^$";var F=d++;a[F]="(\\s*)"+a[n]+"\\s*("+r+"|"+a[y]+")",p[F]=new RegExp(a[F],"g");var z=d++;a[z]="^\\s*("+a[y]+")\\s+-\\s+("+a[y]+")\\s*$";var $=d++;a[$]="^\\s*("+a[b]+")\\s+-\\s+("+a[b]+")\\s*$";var Y=d++;a[Y]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)P(A,a[A]),p[A]||(p[A]=new RegExp(a[A]));function U(x,G){if(x instanceof k)return x;if(typeof x!="string"||x.length>T||!(G?p[i]:p[s]).test(x))return null;try{return new k(x,G)}catch{return null}}function k(x,G){if(x instanceof k){if(x.loose===G)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof k))return new k(x,G);P("SemVer",x,G),this.loose=G;var X=x.trim().match(G?p[i]:p[s]);if(!X)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<L)return me}return ue}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}t.parse=U,t.valid=function(x,G){var X=U(x,G);return X?X.version:null},t.clean=function(x,G){var X=U(x.trim().replace(/^[=v]+/,""),G);return X?X.version:null},t.SemVer=k,k.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},k.prototype.toString=function(){return this.version},k.prototype.compare=function(x){return P("SemVer.compare",this.version,this.loose,x),x instanceof k||(x=new k(x,this.loose)),this.compareMain(x)||this.comparePre(x)},k.prototype.compareMain=function(x){return x instanceof k||(x=new k(x,this.loose)),M(this.major,x.major)||M(this.minor,x.minor)||M(this.patch,x.patch)},k.prototype.comparePre=function(x){if(x instanceof k||(x=new k(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var G=0;do{var X=this.prerelease[G],ue=x.prerelease[G];if(P("prerelease compare",G,X,ue),X===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(X===void 0)return-1;if(X!==ue)return M(X,ue)}while(++G)},k.prototype.inc=function(x,G){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,G,X,ue){typeof X=="string"&&(ue=X,X=void 0);try{return new k(x,X).inc(G,ue).version}catch{return null}},t.diff=function(x,G){if(ae(x,G))return null;var X=U(x),ue=U(G);if(X.prerelease.length||ue.prerelease.length){for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in X)if((me==="major"||me==="minor"||me==="patch")&&X[me]!==ue[me])return me},t.compareIdentifiers=M;var O=/^[0-9]+$/;function M(x,G){var X=O.test(x),ue=O.test(G);return X&&ue&&(x=+x,G=+G),X&&!ue?-1:ue&&!X?1:x<G?-1:x>G?1:0}function W(x,G,X){return new k(x,X).compare(new k(G,X))}function q(x,G,X){return W(x,G,X)>0}function K(x,G,X){return W(x,G,X)<0}function ae(x,G,X){return W(x,G,X)===0}function ce(x,G,X){return W(x,G,X)!==0}function pe(x,G,X){return W(x,G,X)>=0}function Se(x,G,X){return W(x,G,X)<=0}function te(x,G,X,ue){var me;switch(G){case"===":typeof x=="object"&&(x=x.version),typeof X=="object"&&(X=X.version),me=x===X;break;case"!==":typeof x=="object"&&(x=x.version),typeof X=="object"&&(X=X.version),me=x!==X;break;case"":case"=":case"==":me=ae(x,X,ue);break;case"!=":me=ce(x,X,ue);break;case">":me=q(x,X,ue);break;case">=":me=pe(x,X,ue);break;case"<":me=K(x,X,ue);break;case"<=":me=Se(x,X,ue);break;default:throw new TypeError("Invalid operator: "+G)}return me}function oe(x,G){if(x instanceof oe){if(x.loose===G)return x;x=x.value}if(!(this instanceof oe))return new oe(x,G);P("comparator",x,G),this.loose=G,this.parse(x),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}t.rcompareIdentifiers=function(x,G){return M(G,x)},t.major=function(x,G){return new k(x,G).major},t.minor=function(x,G){return new k(x,G).minor},t.patch=function(x,G){return new k(x,G).patch},t.compare=W,t.compareLoose=function(x,G){return W(x,G,!0)},t.rcompare=function(x,G,X){return W(G,x,X)},t.sort=function(x,G){return x.sort(function(X,ue){return t.compare(X,ue,G)})},t.rsort=function(x,G){return x.sort(function(X,ue){return t.rcompare(X,ue,G)})},t.gt=q,t.lt=K,t.eq=ae,t.neq=ce,t.gte=pe,t.lte=Se,t.cmp=te,t.Comparator=oe;var de={};function he(x,G){if(x instanceof he)return x.loose===G?x:new he(x.raw,G);if(x instanceof oe)return new he(x.value,G);if(!(this instanceof he))return new he(x,G);if(this.loose=G,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ve(x){return!x||x.toLowerCase()==="x"||x==="*"}function ke(x,G,X,ue,me,De,we,Le,be,Ce,Me,Re,Te){return((G=ve(X)?"":ve(ue)?">="+X+".0.0":ve(me)?">="+X+"."+ue+".0":">="+G)+" "+(Le=ve(be)?"":ve(Ce)?"<"+(+be+1)+".0.0":ve(Me)?"<"+be+"."+(+Ce+1)+".0":Re?"<="+be+"."+Ce+"."+Me+"-"+Re:"<="+Le)).trim()}function Fe(x,G){for(var X=0;X<x.length;X++)if(!x[X].test(G))return!1;if(G.prerelease.length){for(X=0;X<x.length;X++)if(P(x[X].semver),x[X].semver!==de&&x[X].semver.prerelease.length>0){var ue=x[X].semver;if(ue.major===G.major&&ue.minor===G.minor&&ue.patch===G.patch)return!0}return!1}return!0}function Ue(x,G,X){try{G=new he(G,X)}catch{return!1}return G.test(x)}function xe(x,G,X,ue){var me,De,we,Le,be;switch(x=new k(x,ue),G=new he(G,ue),X){case">":me=q,De=Se,we=K,Le=">",be=">=";break;case"<":me=K,De=pe,we=q,Le="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,G,ue))return!1;for(var Ce=0;Ce<G.set.length;++Ce){var Me=G.set[Ce],Re=null,Te=null;if(Me.forEach(function(Ae){Ae.semver===de&&(Ae=new oe(">=0.0.0")),Re=Re||Ae,Te=Te||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Te.semver,ue)&&(Te=Ae)}),Re.operator===Le||Re.operator===be||(!Te.operator||Te.operator===Le)&&De(x,Te.semver)||Te.operator===be&&we(x,Te.semver))return!1}return!0}oe.prototype.parse=function(x){var G=this.loose?p[V]:p[N],X=x.match(G);if(!X)throw new TypeError("Invalid comparator: "+x);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new k(X[2],this.loose):this.semver=de},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(x){return P("Comparator.test",x,this.loose),this.semver===de||(typeof x=="string"&&(x=new k(x,this.loose)),te(x,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(x,G){if(!(x instanceof oe))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new he(x.value,G),Ue(this.value,X,G);if(x.operator==="")return X=new he(this.value,G),Ue(x.semver,X,G);var ue=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=te(this.semver,"<",x.semver,G)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),be=te(this.semver,">",x.semver,G)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ue||me||De&&we||Le||be},t.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(x){var G=this.loose;x=x.trim(),P("range",x,G);var X=G?p[$]:p[z];x=x.replace(X,ke),P("hyphen replace",x),x=x.replace(p[F],"$1$2$3"),P("comparator trim",x,p[F]),x=(x=(x=x.replace(p[H],"$1~")).replace(p[fe],"$1^")).split(/\s+/).join(" ");var ue=G?p[V]:p[N],me=x.split(" ").map(function(De){return function(we,Le){return P("comp",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){P("caret",Re,Te);var Ae=Te?p[ie]:p[le];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return P("caret",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(P("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(P("no pr"),Oe=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),P("caret return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),P("caret",we),we=function(be,Ce){return be.trim().split(/\s+/).map(function(Me){return function(Re,Te){var Ae=Te?p[re]:p[ne];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Oe;return P("tilde",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?Oe="":ve(Ee)?Oe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?Oe=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(P("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Oe=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):Oe=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",P("tilde return",Oe),Oe})}(Me,Ce)}).join(" ")}(we,Le),P("tildes",we),we=function(be,Ce){return P("replaceXRanges",be,Ce),be.split(/\s+/).map(function(Me){return function(Re,Te){Re=Re.trim();var Ae=Te?p[j]:p[R];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,Oe){P("xRange",Re,Ne,ye,Ee,Pe,Ie,Oe);var Ve=ve(Ee),ze=Ve||ve(Pe),je=ze||ve(Ie);return ye==="="&&je&&(ye=""),Ve?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),P("xRange return",Ne),Ne})}(Me,Ce)}).join(" ")}(we,Le),P("xrange",we),we=function(be,Ce){return P("replaceStars",be,Ce),be.trim().replace(p[Y],"")}(we,Le),P("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(ue)})),me=me.map(function(De){return new oe(De,G)})},he.prototype.intersects=function(x,G){if(!(x instanceof he))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(ue){return x.set.some(function(me){return me.every(function(De){return ue.intersects(De,G)})})})})},t.toComparators=function(x,G){return new he(x,G).set.map(function(X){return X.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},he.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new k(x,this.loose));for(var G=0;G<this.set.length;G++)if(Fe(this.set[G],x))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(x,G,X){var ue=null,me=null;try{var De=new he(G,X)}catch{return null}return x.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==-1||(me=new k(ue=we,X)))}),ue},t.minSatisfying=function(x,G,X){var ue=null,me=null;try{var De=new he(G,X)}catch{return null}return x.forEach(function(we){De.test(we)&&(ue&&me.compare(we)!==1||(me=new k(ue=we,X)))}),ue},t.validRange=function(x,G){try{return new he(x,G).range||"*"}catch{return null}},t.ltr=function(x,G,X){return xe(x,G,"<",X)},t.gtr=function(x,G,X){return xe(x,G,">",X)},t.outside=xe,t.prerelease=function(x,G){var X=U(x,G);return X&&X.prerelease.length?X.prerelease:null},t.intersects=function(x,G,X){return x=new he(x,X),G=new he(G,X),x.intersects(G)},t.coerce=function(x){if(x instanceof k)return x;if(typeof x!="string")return null;var G=x.match(p[_]);return G==null?null:U((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,D(1))},function(B,t){var D,C,P=B.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function p(E){if(D===setTimeout)return setTimeout(E,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(E,0);try{return D(E,0)}catch{try{return D.call(null,E,0)}catch{return D.call(this,E,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{C=typeof clearTimeout=="function"?clearTimeout:L}catch{C=L}})();var a,d=[],I=!1,w=-1;function h(){I&&a&&(I=!1,a.length?d=a.concat(d):w=-1,d.length&&v())}function v(){if(!I){var E=p(h);I=!0;for(var c=d.length;c;){for(a=d,d=[];++w<c;)a&&a[w].run();w=-1,c=d.length}a=null,I=!1,function(u){if(C===clearTimeout)return clearTimeout(u);if((C===L||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(u);try{C(u)}catch{try{return C.call(null,u)}catch{return C.call(this,u)}}}(E)}}function f(E,c){this.fun=E,this.array=c}function m(){}P.nextTick=function(E){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];d.push(new f(E,c)),d.length!==1||I||p(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=m,P.addListener=m,P.once=m,P.off=m,P.removeListener=m,P.removeAllListeners=m,P.emit=m,P.prependListener=m,P.prependOnceListener=m,P.listeners=function(E){return[]},P.binding=function(E){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(E){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(B,t){"use strict";var D;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class C{constructor(p,a,d){this.level=p,this.key=a,this.value=d,this.forward=[]}}const P=void 0;class T{constructor(p,a=2**16){this.comparator=p,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(a)|0),this._header=new C(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new C(this._maxLevel,P,P)}has(p){return Boolean(T._search(this,p,this.comparator))}get(p){return T._search(this,p,this.comparator)?.value}set(p,a){return T._insert(this,p,a,this.comparator)&&(this._size+=1),this}delete(p){const a=T._delete(this,p,this.comparator);return a&&(this._size-=1),a}forEach(p,a){let d=this._header.forward[0];for(;d;)p.call(a,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",a=this._header.forward[0];for(;a;)p+=`node(${a.key}, ${a.value}, lvl:${a.level})`,a=a.forward[0];return p}static _search(p,a,d){let I=p._header;for(let w=p._level-1;w>=0;w--)for(;I.forward[w]&&d(I.forward[w].key,a)<0;)I=I.forward[w];if(I=I.forward[0],I&&d(I.key,a)===0)return I}static _insert(p,a,d,I){const w=[];let h=p._header;for(let v=p._level-1;v>=0;v--){for(;h.forward[v]&&I(h.forward[v].key,a)<0;)h=h.forward[v];w[v]=h}if(h=h.forward[0],h&&I(h.key,a)===0)return h.value=d,!1;{const v=T._randomLevel(p);if(v>p._level){for(let f=p._level;f<v;f++)w[f]=p._header;p._level=v}h=new C(v,a,d);for(let f=0;f<v;f++)h.forward[f]=w[f].forward[f],w[f].forward[f]=h;return!0}}static _randomLevel(p,a=.5){let d=1;for(;Math.random()<a&&d<p._maxLevel;)d+=1;return d}static _delete(p,a,d){const I=[];let w=p._header;for(let h=p._level-1;h>=0;h--){for(;w.forward[h]&&d(w.forward[h].key,a)<0;)w=w.forward[h];I[h]=w}if(w=w.forward[0],!w||d(w.key,a)!==0)return!1;for(let h=0;h<p._level&&I[h].forward[h]===w;h++)I[h].forward[h]=w.forward[h];for(;p._level>0&&p._header.forward[p._level-1]===P;)p._level-=1;return!0}}t.SkipList=T}),define(Q[43],Z([0,1,11,2]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function P(l){const s=l;return s?typeof s.read=="function":!1}t.isReadable=P;function T(l){const s=l;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}t.isReadableStream=T;function L(l){const s=l;return s?T(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=L;function p(l,s){return new a(l,s)}t.newWriteableStream=p;class a{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(e);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(l,s){const e=[];let r;for(;(r=l.read())!==null;)e.push(r);return s(e)}t.consumeReadable=d;function I(l,s,e){const r=[];let i;for(;(i=l.read())!==null&&r.length<e;)r.push(i);return i===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return l.read()}}}t.peekReadable=I;function w(l,s){return new Promise((e,r)=>{const i=[];h(l,{onData:n=>{s&&i.push(n)},onError:n=>{s?r(n):e(void 0)},onEnd:()=>{e(s?s(i):void 0)}})})}t.consumeStream=w;function h(l,s){let e=!1;return l.on("error",r=>{e||s.onError(r)}),l.on("end",()=>{e||s.onEnd()}),l.on("data",r=>{e||s.onData(r)}),(0,C.toDisposable)(()=>e=!0)}t.listenStream=h;function v(l,s){return new Promise((e,r)=>{const i=new C.DisposableStore,n=[],o=b=>{if(n.push(b),n.length>s)return i.dispose(),l.pause(),e({stream:l,buffer:n,ended:!1})},S=b=>r(b),y=()=>e({stream:l,buffer:n,ended:!0});i.add((0,C.toDisposable)(()=>l.removeListener("error",S))),l.on("error",S),i.add((0,C.toDisposable)(()=>l.removeListener("end",y))),l.on("end",y),i.add((0,C.toDisposable)(()=>l.removeListener("data",o))),l.on("data",o)})}t.peekStream=v;function f(l,s){const e=p(s);return e.end(l),e}t.toStream=f;function m(){const l=p(()=>{throw new Error("not supported")});return l.end(),l}t.emptyStream=m;function E(l){let s=!1;return{read:()=>s?null:(s=!0,l)}}t.toReadable=E;function c(l,s,e){const r=p(e);return h(l,{onData:i=>r.write(s.data(i)),onError:i=>r.error(s.error?s.error(i):i),onEnd:()=>r.end()}),r}t.transform=c;function u(l,s,e){let r=!1;return{read:()=>{const i=s.read();return r?i:(r=!0,i!==null?e([l,i]):l)}}}t.prefixedReadable=u;function g(l,s,e){let r=!1;const i=p(e);return h(s,{onData:n=>r?i.write(n):(r=!0,i.write(e([l,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(l)),i.end()}}),i}t.prefixedStream=g}),define(Q[15],Z([0,1,43]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const C=typeof Buffer<"u";let P,T;class L{static alloc(b){return C?new L(Buffer.allocUnsafe(b)):new L(new Uint8Array(b))}static wrap(b){return C&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new L(b)}static fromString(b,R){return!(R?.dontUseNodeBuffer||!1)&&C?new L(Buffer.from(b)):(P||(P=new TextEncoder),new L(P.encode(b)))}static fromByteArray(b){const R=L.alloc(b.length);for(let j=0,_=b.length;j<_;j++)R.buffer[j]=b[j];return R}static concat(b,R){if(typeof R>"u"){R=0;for(let J=0,H=b.length;J<H;J++)R+=b[J].byteLength}const j=L.alloc(R);let _=0;for(let J=0,H=b.length;J<H;J++){const ne=b[J];j.set(ne,_),_+=ne.byteLength}return j}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=L.alloc(this.byteLength);return b.set(this),b}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(b,R){return new L(this.buffer.subarray(b,R))}set(b,R){if(b instanceof L)this.buffer.set(b.buffer,R);else if(b instanceof Uint8Array)this.buffer.set(b,R);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),R);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,R){I(this.buffer,b,R)}readUInt32LE(b){return w(this.buffer,b)}writeUInt32LE(b,R){h(this.buffer,b,R)}readUInt8(b){return v(this.buffer,b)}writeUInt8(b,R){f(this.buffer,b,R)}}t.VSBuffer=L;function p(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0}t.readUInt16LE=p;function a(y,b,R){y[R+0]=b&255,b=b>>>8,y[R+1]=b&255}t.writeUInt16LE=a;function d(y,b){return y[b]*2**24+y[b+1]*2**16+y[b+2]*2**8+y[b+3]}t.readUInt32BE=d;function I(y,b,R){y[R+3]=b,b=b>>>8,y[R+2]=b,b=b>>>8,y[R+1]=b,b=b>>>8,y[R]=b}t.writeUInt32BE=I;function w(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0|y[b+2]<<16>>>0|y[b+3]<<24>>>0}t.readUInt32LE=w;function h(y,b,R){y[R+0]=b&255,b=b>>>8,y[R+1]=b&255,b=b>>>8,y[R+2]=b&255,b=b>>>8,y[R+3]=b&255}t.writeUInt32LE=h;function v(y,b){return y[b]}t.readUInt8=v;function f(y,b,R){y[R]=b}t.writeUInt8=f;function m(y){return D.consumeReadable(y,b=>L.concat(b))}t.readableToBuffer=m;function E(y){return D.toReadable(y)}t.bufferToReadable=E;function c(y){return D.consumeStream(y,b=>L.concat(b))}t.streamToBuffer=c;async function u(y){return y.ended?L.concat(y.buffer):L.concat([...y.buffer,await c(y.stream)])}t.bufferedStreamToBuffer=u;function g(y){return D.toStream(y,b=>L.concat(b))}t.bufferToStream=g;function l(y){return D.transform(y,{data:b=>typeof b=="string"?L.fromString(b):L.wrap(b)},b=>L.concat(b))}t.streamToBufferReadableStream=l;function s(y){return D.newWriteableStream(b=>L.concat(b),y)}t.newWriteableBufferStream=s;function e(y,b){return D.prefixedReadable(y,b,R=>L.concat(R))}t.prefixedBufferReadable=e;function r(y,b){return D.prefixedStream(y,b,R=>L.concat(R))}t.prefixedBufferStream=r;function i(y){let b=0,R=0,j=0;const _=new Uint8Array(Math.floor(y.length/4*3)),J=ne=>{switch(R){case 3:_[j++]=b|ne,R=0;break;case 2:_[j++]=b|ne>>>2,b=ne<<6,R=3;break;case 1:_[j++]=b|ne>>>4,b=ne<<4,R=2;break;default:b=ne<<2,R=1}};for(let ne=0;ne<y.length;ne++){const re=y.charCodeAt(ne);if(re>=65&&re<=90)J(re-65);else if(re>=97&&re<=122)J(re-97+26);else if(re>=48&&re<=57)J(re-48+52);else if(re===43||re===45)J(62);else if(re===47||re===95)J(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${y[ne]}`)}}const H=j;for(;R>0;)J(0);return L.wrap(_).slice(0,H)}t.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:y},b=!0,R=!1){const j=R?o:n;let _="";const J=y.byteLength%3;let H=0;for(;H<y.byteLength-J;H+=3){const ne=y[H+0],re=y[H+1],se=y[H+2];_+=j[ne>>>2],_+=j[(ne<<4|re>>>4)&63],_+=j[(re<<2|se>>>6)&63],_+=j[se&63]}if(J===1){const ne=y[H+0];_+=j[ne>>>2],_+=j[ne<<4&63],b&&(_+="==")}else if(J===2){const ne=y[H+0],re=y[H+1];_+=j[ne>>>2],_+=j[(ne<<4|re>>>4)&63],_+=j[re<<2&63],b&&(_+="=")}return _}t.encodeBase64=S}),define(Q[26],Z([0,1,5]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.keys(c).forEach(g=>{c[g]&&typeof c[g]=="object"?u[g]=C(c[g]):u[g]=c[g]}),u}t.deepClone=C;function P(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const l in g)if(T.call(g,l)){const s=g[l];typeof s=="object"&&!Object.isFrozen(s)&&!(0,D.isTypedArray)(s)&&u.push(s)}}return c}t.deepFreeze=P;const T=Object.prototype.hasOwnProperty;function L(c,u){return p(c,u,new Set)}t.cloneAndChange=L;function p(c,u,g){if((0,D.isUndefinedOrNull)(c))return c;const l=u(c);if(typeof l<"u")return l;if(Array.isArray(c)){const s=[];for(const e of c)s.push(p(e,u,g));return s}if((0,D.isObject)(c)){if(g.has(c))throw new Error("Cannot clone recursive data-structure");g.add(c);const s={};for(const e in c)T.call(c,e)&&(s[e]=p(c[e],u,g));return g.delete(c),s}return c}function a(c,u,g=!0){return(0,D.isObject)(c)?((0,D.isObject)(u)&&Object.keys(u).forEach(l=>{l in c?g&&((0,D.isObject)(c[l])&&(0,D.isObject)(u[l])?a(c[l],u[l],g):c[l]=u[l]):c[l]=u[l]}),c):u}t.mixin=a;function d(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let g,l;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(g=0;g<c.length;g++)if(!d(c[g],u[g]))return!1}else{const s=[];for(l in c)s.push(l);s.sort();const e=[];for(l in u)e.push(l);if(e.sort(),!d(s,e))return!1;for(g=0;g<s.length;g++)if(!d(c[s[g]],u[s[g]]))return!1}return!0}t.equals=d;function I(c){const u=new Set;return JSON.stringify(c,(g,l)=>{if((0,D.isObject)(l)||Array.isArray(l)){if(u.has(l))return"[Circular]";u.add(l)}return l})}t.safeStringify=I;function w(c,u){const g=Object.create(null);return!c||!u||Object.keys(u).forEach(s=>{const e=c[s],r=u[s];d(e,r)||(g[s]=r)}),g}t.distinct=w;function h(c,u){const g=u.toLowerCase(),l=Object.keys(c).find(s=>s.toLowerCase()===g);return l?c[l]:c[u]}t.getCaseInsensitive=h;function v(c,u){const g=Object.create(null);for(const[l,s]of Object.entries(c))u(l,s)&&(g[l]=s);return g}t.filter=v;function f(c){let u=[],g=Object.getPrototypeOf(c);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}t.getAllPropertyNames=f;function m(c){const u=[];for(const g of f(c))typeof c[g]=="function"&&u.push(g);return u}t.getAllMethodNames=m;function E(c,u){const g=s=>function(){const e=Array.prototype.slice.call(arguments,0);return u(s,e)},l={};for(const s of c)l[s]=g(s);return l}t.createProxyObject=E}),define(Q[30],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(P){return D.test(P)}t.isUUID=C,t.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(p){for(let a=0;a<p.length;a++)p[a]=Math.floor(Math.random()*256);return p};const T=new Uint8Array(16),L=[];for(let p=0;p<256;p++)L.push(p.toString(16).padStart(2,"0"));return function(){P(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let a=0,d="";return d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d}}()}),define(Q[70],Z([6,7]),function(B,t){return B.create("vs/base/common/date",t)}),define(Q[71],Z([0,1,70]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const C=60,P=C*60,T=P*24,L=T*7,p=T*30,a=T*365;function d(w,h,v){typeof w!="number"&&(w=w.getTime());const f=Math.round((new Date().getTime()-w)/1e3);if(f<-30)return(0,D.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let m;return f<C?(m=f,h?m===1?v?(0,D.localize)(2,null,m):(0,D.localize)(3,null,m):v?(0,D.localize)(4,null,m):(0,D.localize)(5,null,m):m===1?v?(0,D.localize)(6,null,m):(0,D.localize)(7,null,m):v?(0,D.localize)(8,null,m):(0,D.localize)(9,null,m)):f<P?(m=Math.floor(f/C),h?m===1?v?(0,D.localize)(10,null,m):(0,D.localize)(11,null,m):v?(0,D.localize)(12,null,m):(0,D.localize)(13,null,m):m===1?v?(0,D.localize)(14,null,m):(0,D.localize)(15,null,m):v?(0,D.localize)(16,null,m):(0,D.localize)(17,null,m)):f<T?(m=Math.floor(f/P),h?m===1?v?(0,D.localize)(18,null,m):(0,D.localize)(19,null,m):v?(0,D.localize)(20,null,m):(0,D.localize)(21,null,m):m===1?v?(0,D.localize)(22,null,m):(0,D.localize)(23,null,m):v?(0,D.localize)(24,null,m):(0,D.localize)(25,null,m)):f<L?(m=Math.floor(f/T),h?m===1?(0,D.localize)(26,null,m):(0,D.localize)(27,null,m):m===1?(0,D.localize)(28,null,m):(0,D.localize)(29,null,m)):f<p?(m=Math.floor(f/L),h?m===1?v?(0,D.localize)(30,null,m):(0,D.localize)(31,null,m):v?(0,D.localize)(32,null,m):(0,D.localize)(33,null,m):m===1?v?(0,D.localize)(34,null,m):(0,D.localize)(35,null,m):v?(0,D.localize)(36,null,m):(0,D.localize)(37,null,m)):f<a?(m=Math.floor(f/p),h?m===1?v?(0,D.localize)(38,null,m):(0,D.localize)(39,null,m):v?(0,D.localize)(40,null,m):(0,D.localize)(41,null,m):m===1?v?(0,D.localize)(42,null,m):(0,D.localize)(43,null,m):v?(0,D.localize)(44,null,m):(0,D.localize)(45,null,m)):(m=Math.floor(f/a),h?m===1?v?(0,D.localize)(46,null,m):(0,D.localize)(47,null,m):v?(0,D.localize)(48,null,m):(0,D.localize)(49,null,m):m===1?v?(0,D.localize)(50,null,m):(0,D.localize)(51,null,m):v?(0,D.localize)(52,null,m):(0,D.localize)(53,null,m))}t.fromNow=d;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=I}),define(Q[72],Z([6,7]),function(B,t){return B.create("vs/base/common/errorMessage",t)}),define(Q[31],Z([0,1,19,5,72]),function(B,t,D,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function T(w,h){return h&&(w.stack||w.stacktrace)?P.localize(0,null,p(w),L(w.stack)||L(w.stacktrace)):p(w)}function L(w){return Array.isArray(w)?w.join(`
`):w}function p(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(1,null,w.message):w.message||P.localize(2,null)}function a(w=null,h=!1){if(!w)return P.localize(3,null);if(Array.isArray(w)){const v=D.coalesce(w),f=a(v[0],h);return v.length>1?P.localize(4,null,f,v.length):f}if(C.isString(w))return w;if(w.detail){const v=w.detail;if(v.error)return T(v.error,h);if(v.exception)return T(v.exception,h)}return w.stack?T(w,h):w.message?w.message:P.localize(5,null)}t.toErrorMessage=a;function d(w){const h=w;return h instanceof Error&&Array.isArray(h.actions)}t.isErrorWithActions=d;function I(w,h){let v;return typeof w=="string"?v=new Error(w):v=w,v.actions=h,v}t.createErrorWithActions=I}),define(Q[73],Z([6,7]),function(B,t){return B.create("vs/base/common/jsonErrorMessages",t)}),define(Q[74],Z([0,1,73]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=void 0;function C(P){switch(P){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}t.getParseErrorMessage=C}),define(Q[51],Z([0,1,13]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeDangerousEnvVariables=t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var P;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(P=t.TerminateResponseCode||(t.TerminateResponseCode={}));function T(p,...a){const d=a.reduce((h,v)=>(h[v]=!0,h),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(h=>!d[h]).forEach(h=>{for(let v=0;v<I.length;v++)if(h.search(I[v])!==-1){delete p[h];break}})}t.sanitizeProcessEnvironment=T;function L(p){!p||(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}t.removeDangerousEnvVariables=L}),define(Q[52],Z([0,1,4,2]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MutableObservableValue=t.staticObservableValue=void 0;const P=L=>({onDidChange:D.Event.None,value:L});t.staticObservableValue=P;class T extends C.Disposable{get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}constructor(p){super(),this._value=p,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}t.MutableObservableValue=T}),define(Q[53],Z([0,1,27]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function C(c){return P(c,0)}t.hash=C;function P(c,u){switch(typeof c){case"object":return c===null?T(349,u):Array.isArray(c)?a(c,u):d(c,u);case"string":return p(c,u);case"boolean":return L(c,u);case"number":return T(c,u);case"undefined":return T(937,u);default:return T(617,u)}}t.doHash=P;function T(c,u){return(u<<5)-u+c|0}t.numberHash=T;function L(c,u){return T(c?433:863,u)}function p(c,u){u=T(149417,u);for(let g=0,l=c.length;g<l;g++)u=T(c.charCodeAt(g),u);return u}t.stringHash=p;function a(c,u){return u=T(104579,u),c.reduce((g,l)=>P(l,g),u)}function d(c,u){return u=T(181387,u),Object.keys(c).sort().reduce((g,l)=>(g=p(l,g),P(c[l],g)),u)}class I{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=P(u,this._value),this._value}}t.Hasher=I;var w;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function h(c,u,g=32){const l=g-u,s=~((1<<l)-1);return(c<<u|(s&c)>>>l)>>>0}function v(c,u=0,g=c.byteLength,l=0){for(let s=0;s<g;s++)c[u+s]=l}function f(c,u,g="0"){for(;c.length<u;)c=g+c;return c}function m(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(g=>g.toString(16).padStart(2,"0")).join(""):f((c>>>0).toString(16),u/4)}t.toHexString=m;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const l=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,r,i;for(e!==0?(r=e,i=-1,e=0):(r=u.charCodeAt(0),i=0);;){let n=r;if(D.isHighSurrogate(r))if(i+1<g){const o=u.charCodeAt(i+1);D.isLowSurrogate(o)?(i++,n=D.computeCodePoint(r,o)):n=65533}else{e=r;break}else D.isLowSurrogate(r)&&(n=65533);if(s=this._push(l,s,n),i++,i<g)r=u.charCodeAt(i);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(u,g,l){return l<128?u[g++]=l:l<2048?(u[g++]=192|(l&1984)>>>6,u[g++]=128|(l&63)>>>0):l<65536?(u[g++]=224|(l&61440)>>>12,u[g++]=128|(l&4032)>>>6,u[g++]=128|(l&63)>>>0):(u[g++]=240|(l&1835008)>>>18,u[g++]=128|(l&258048)>>>12,u[g++]=128|(l&4032)>>>6,u[g++]=128|(l&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=E._bigBlock32,g=this._buffDV;for(let y=0;y<64;y+=4)u.setUint32(y,g.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)u.setUint32(y,h(u.getUint32(y-12,!1)^u.getUint32(y-32,!1)^u.getUint32(y-56,!1)^u.getUint32(y-64,!1),1),!1);let l=this._h0,s=this._h1,e=this._h2,r=this._h3,i=this._h4,n,o,S;for(let y=0;y<80;y++)y<20?(n=s&e|~s&r,o=1518500249):y<40?(n=s^e^r,o=1859775393):y<60?(n=s&e|s&r|e&r,o=2400959708):(n=s^e^r,o=3395469782),S=h(l,5)+n+i+o+u.getUint32(y*4,!1)&4294967295,i=r,r=e,e=h(s,30),s=l,l=S;this._h0=this._h0+l&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}t.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const T="error",L="warning",p="warn",a="info",d="ignore";function I(h){return h?D.equalsIgnoreCase(T,h)?P.Error:D.equalsIgnoreCase(L,h)||D.equalsIgnoreCase(p,h)?P.Warning:D.equalsIgnoreCase(a,h)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function w(h){switch(h){case P.Error:return T;case P.Warning:return L;case P.Info:return a;default:return d}}P.toString=w}(C||(C={})),t.default=C}),define(Q[75],Z([0,1,10]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function C(d){const I=d;return I&&typeof I.type=="string"&&typeof I.severity=="string"}t.isRemoteConsoleLog=C;function P(d){const I=[];let w;try{const h=JSON.parse(d.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),w=v.__$stack),I.push(...h)}catch{I.push("Unable to log remote console arguments",d.arguments)}return{args:I,stack:w}}t.parse=P;function T(d){if(typeof d!="string")return T(P(d).stack);const I=d;if(I){const w=L(I),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}t.getFirstFrame=T;function L(d){if(!d)return d;const I=d.indexOf(`
`);return I===-1?d:d.substring(0,I)}function p(d,I){const{args:w,stack:h}=P(d),v=typeof w[0]=="string"&&w.length===1;let f=L(h);f&&(f=`(${f.trim()})`);let m=[];if(typeof w[0]=="string"?f&&v?m=[`%c[${I}] %c${w[0]} %c${f}`,a("blue"),a(""),a("grey")]:m=[`%c[${I}] %c${w[0]}`,a("blue"),a(""),...w.slice(1)]:m=[`%c[${I}]%`,a("blue"),...w],f&&!v&&m.push(f),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,m)}t.log=p;function a(d){return`color: ${d}`}}),define(Q[44],Z([0,1,15,27,10]),function(B,t,D,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function T(d){return JSON.stringify(d,p)}t.stringify=T;function L(d){let I=JSON.parse(d);return I=a(I),I}t.parse=L;function p(d,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,C.regExpFlags)(I)}:I}function a(d,I=0){if(!d||I>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return P.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof D.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let w=0;w<d.length;++w)d[w]=a(d[w],I+1);else for(const w in d)Object.hasOwnProperty.call(d,w)&&(d[w]=a(d[w],I+1))}return d}t.revive=a}),define(Q[76],Z([0,1,38,14,20]),function(B,t,D,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var a;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(a||(a={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(s,e,r){this.exePath=s,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:l=!1}={}){return l?d===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:l=!1,findPreview:s=!1}={}){const e=h({useAlternateBitness:l});if(!e)return null;const r=C.join(e,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const y of await P.Promises.readdir(r)){let b=-1;if(s){const j=y.indexOf("-");if(j<0)continue;const _=y.substring(0,j);if(!T.test(_)||y.substring(j+1)!=="preview")continue;b=parseInt(_,10)}else{if(!T.test(y))continue;b=parseInt(y,10)}if(b<=i)continue;const R=C.join(r,y,"pwsh.exe");!await P.SymlinkSupport.existsFile(R)||(n=R,i=b)}if(!n)return null;const o=e.includes("x86")?" (x86)":"",S=s?" Preview":"";return new w(n,`PowerShell${S}${o}`,!0)}async function f({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const s=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=l?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const i of await P.Promises.readdir(s))if(e.test(i)){const n=C.join(s,i,"pwsh.exe");return new w(n,r)}return null}function m(){const l=C.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(l,".NET Core PowerShell Global Tool")}function E(){const l=C.join(process.env.windir,d===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(l,"Windows PowerShell",!0)}async function*c(){let l=await v();l&&(yield l),l=await v({useAlternateBitness:!0}),l&&(yield l),l=await f(),l&&(yield l),l=m(),l&&(yield l),l=await v({findPreview:!0}),l&&(yield l),l=await f({findPreview:!0}),l&&(yield l),l=await v({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=E(),l&&(yield l)}async function*u(){for await(const l of c())await l.exists()&&(yield l)}t.enumeratePowerShellInstallations=u;async function g(){for await(const l of u())return l;return null}t.getFirstAvailablePowerShellInstallation=g}),define(Q[55],Z([0,1,14,13,32,51,5,20]),function(B,t,D,C,P,T,L,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function a(w=P.env){return w.comspec||"cmd.exe"}t.getWindowsShell=a;function d(w){let h=[],v=!1;const f=function(m){if(v){h.push(m);return}(!w.send(m,c=>{if(c&&console.error(c),v=!1,h.length>0){const u=h.slice(0);h=[],u.forEach(g=>f(g))}})||C.isWindows)&&(v=!0)};return{send:f}}t.createQueuedSender=d;var I;(function(w){async function h(v,f,m){if(D.isAbsolute(v))return v;if(f===void 0&&(f=P.cwd()),D.dirname(v)!=="."||(m===void 0&&L.isString(P.env.PATH)&&(m=P.env.PATH.split(D.delimiter)),m===void 0||m.length===0))return D.join(f,v);async function c(u){if(await p.Promises.exists(u)){let g;try{g=await p.Promises.stat(u)}catch(l){l.message.startsWith("EACCES")&&(g=await p.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of m){let g;if(D.isAbsolute(u)?g=D.join(u,v):g=D.join(f,u,v),await c(g))return g;let l=g+".com";if(await c(l)||(l=g+".exe",await c(l)))return l}return D.join(f,v)}w.findExecutable=h})(I=t.win32||(t.win32={}))}),define(Q[77],Z([0,1,38,13,76,55]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function L(v,f){return v===1?C.isWindows?w():T.getWindowsShell(f):d(v,f)}t.getSystemShell=L;function p(v,f){return v===1?C.isWindows?h(f):T.getWindowsShell(f):d(v,f)}t.getSystemShellSync=p;let a=null;function d(v,f){if(C.isLinux&&v===2||C.isMacintosh&&v===3)return"/bin/bash";if(!a){let m;if(C.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,D.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}a=m}return a}let I=null;async function w(){return I||(I=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),I}function h(v){if(I)return I;const f=C.isWindows&&parseFloat((0,D.release)())>=10,m=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${v.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?E:T.getWindowsShell(v)}});var ge=this&&this.__decorate||function(B,t,D,C){var P=arguments.length,T=P<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,D):C,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(B,t,D,C);else for(var p=B.length-1;p>=0;p--)(L=B[p])&&(T=(P<3?L(T):P>3?L(t,D,T):L(t,D))||T);return P>3&&T&&Object.defineProperty(t,D,T),T};define(Q[56],Z([0,1,19,3,15,24,49,11,4,2,44,27,5]),function(B,t,D,C,P,T,L,p,a,d,I,w,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var v;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(v=t.RequestType||(t.RequestType={}));function f(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(m=t.ResponseType||(t.ResponseType={}));function E(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(c||(c={}));class u{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class g{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var l;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(l||(l={}));function s(N){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(N,0),F}function e(N){return N.read(4).readUInt32BE(0)}function r(N){const F=P.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const i={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object)},n=typeof Buffer<"u";function o(N,F){if(typeof F>"u")N.write(i.Undefined);else if(typeof F=="string"){const z=P.VSBuffer.fromString(F);N.write(i.String),N.write(s(z.byteLength)),N.write(z)}else if(n&&Buffer.isBuffer(F)){const z=P.VSBuffer.wrap(F);N.write(i.Buffer),N.write(s(z.byteLength)),N.write(z)}else if(F instanceof P.VSBuffer)N.write(i.VSBuffer),N.write(s(F.byteLength)),N.write(F);else if(Array.isArray(F)){N.write(i.Array),N.write(s(F.length));for(const z of F)o(N,z)}else{const z=P.VSBuffer.fromString(JSON.stringify(F));N.write(i.Object),N.write(s(z.byteLength)),N.write(z)}}function S(N){switch(N.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return N.read(e(N)).toString();case l.Buffer:return N.read(e(N)).buffer;case l.VSBuffer:return N.read(e(N));case l.Array:{const z=e(N),$=[];for(let Y=0;Y<z;Y++)$.push(S(N));return $}case l.Object:return JSON.parse(N.read(e(N)).toString())}}class y{constructor(F,z,$=null,Y=1e3){this.protocol=F,this.ctx=z,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger?.logOutgoing(z,0,1,E(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(z,F.id,1,E(F.type),F.data);return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const z=new u(F),$=S(z),Y=S(z),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=new T.CancellationTokenSource;let Y;try{Y=z.call(this.ctx,F.name,F.arg,$.token)}catch(k){Y=Promise.reject(k)}const A=F.id;Y.then(k=>{this.sendResponse({id:A,data:k,type:201}),this.activeRequests.delete(F.id)},k=>{k instanceof Error?this.sendResponse({id:A,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:A,data:k,type:203}),this.activeRequests.delete(F.id)});const U=(0,d.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,U)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=F.id,A=z.listen(this.ctx,F.name,F.arg)(U=>this.sendResponse({id:$,data:U,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=y;var b;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(b=t.RequestInitiator||(t.RequestInitiator={}));class R{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new a.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=z}getChannel(F){const z=this;return{call($,Y,A){return z.isDisposed?Promise.reject(new p.CancellationError):z.requestPromise(F,$,Y,A)},listen($,Y){return z.isDisposed?a.Event.None:z.requestEvent(F,$,Y)}}}requestPromise(F,z,$,Y=T.CancellationToken.None){const A=this.lastRequestId++,k={id:A,type:100,channelName:F,name:z,arg:$};if(Y.isCancellationRequested)return Promise.reject(new p.CancellationError);let O;return new Promise((W,q)=>{if(Y.isCancellationRequested)return q(new p.CancellationError);const K=()=>{const Se=te=>{switch(te.type){case 201:this.handlers.delete(A),W(te.data);break;case 202:{this.handlers.delete(A);const oe=new Error(te.data.message);oe.stack=te.data.stack,oe.name=te.data.name,q(oe);break}case 203:this.handlers.delete(A),q(te.data);break}};this.handlers.set(A,Se),this.sendRequest(k)};let ae=null;this.state===c.Idle?K():(ae=(0,C.createCancelablePromise)(Se=>this.whenInitialized()),ae.then(()=>{ae=null,K()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:A,type:101}),q(new p.CancellationError)},pe=Y.onCancellationRequested(ce);O=(0,d.combinedDisposable)((0,d.toDisposable)(ce),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(F,z,$){const Y=this.lastRequestId++,U={id:Y,type:102,channelName:F,name:z,arg:$};let k=null;const O=new a.Emitter({onFirstListenerAdd:()=>{k=(0,C.createCancelablePromise)(W=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(O),this.sendRequest(U)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(O),this.sendRequest({id:Y,type:103}))}}),M=W=>O.fire(W.data);return this.handlers.set(Y,M),O.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(z,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger?.logOutgoing(z,F.id,0,f(F.type));return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const z=new u(F),$=S(z),Y=S(z),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,E(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,E(A),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return a.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([L.memoize],R.prototype,"onDidInitializePromise",null),t.ChannelClient=R;class j{get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new a.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new a.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:$})=>{a.Event.once(z.onMessage)(A=>{const U=new u(A),k=S(U),O=new y(z,k),M=new R(z);this.channels.forEach((q,K)=>O.registerChannel(K,q));const W={channelServer:O,channelClient:M,ctx:k};this._connections.add(W),this._onDidAddConnection.fire(W),$(()=>{O.dispose(),M.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(F,z){const $=this;return{call(Y,A,U){let k;if((0,h.isFunction)(z)){const M=(0,D.getRandomElement)($.connections.filter(z));k=M?Promise.resolve(M):a.Event.toPromise(a.Event.filter($.onDidAddConnection,z))}else k=z.routeCall($,Y,A);const O=k.then(M=>M.channelClient.getChannel(F));return J(O).call(Y,A,U)},listen(Y,A){if((0,h.isFunction)(z))return $.getMulticastEvent(F,z,Y,A);const U=z.routeEvent($,Y,A).then(k=>k.channelClient.getChannel(F));return J(U).listen(Y,A)}}}getMulticastEvent(F,z,$,Y){const A=this;let U=new d.DisposableStore;const k=new a.Emitter({onFirstListenerAdd:()=>{U=new d.DisposableStore;const O=new a.EventMultiplexer,M=new Map,W=K=>{const ce=K.channelClient.getChannel(F).listen($,Y),pe=O.add(ce);M.set(K,pe)},q=K=>{const ae=M.get(K);!ae||(ae.dispose(),M.delete(K))};A.connections.filter(z).forEach(W),a.Event.filter(A.onDidAddConnection,z)(W,void 0,U),A.onDidRemoveConnection(q,void 0,U),O.event(k.fire,k,U),U.add(O)},onLastListenerRemove:()=>{U.dispose()}});return k.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach($=>{$.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=j;class _{constructor(F,z,$=null){const Y=new g;o(Y,z),F.send(Y.buffer),this.channelClient=new R(F,$),this.channelServer=new y(F,z,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=_;function J(N){return{call(F,z,$){return N.then(Y=>Y.call(F,z,$))},listen(F,z){const $=new a.Relay;return N.then(Y=>$.input=Y.listen(F,z)),$.event}}}t.getDelayedChannel=J;function H(N){let F=!1;return{call(z,$,Y){return F?N.call(z,$,Y):(0,C.timeout)(0).then(()=>F=!0).then(()=>N.call(z,$,Y))},listen(z,$){if(F)return N.listen(z,$);const Y=new a.Relay;return(0,C.timeout)(0).then(()=>F=!0).then(()=>Y.input=N.listen(z,$)),Y.event}}}t.getNextTickChannel=H;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await a.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=ne;var re;(function(N){function F(A,U){const k=A,O=U&&U.disableMarshalling,M=new Map;for(const W in k)$(W)&&M.set(W,a.Event.buffer(k[W],!0));return new class{listen(W,q,K){const ae=M.get(q);if(ae)return ae;if(Y(q)){const ce=k[q];if(typeof ce=="function")return ce.call(k,K)}throw new Error(`Event not found: ${q}`)}call(W,q,K){const ae=k[q];if(typeof ae=="function"){if(!O&&Array.isArray(K))for(let ce=0;ce<K.length;ce++)K[ce]=(0,I.revive)(K[ce]);return ae.apply(k,K)}throw new Error(`Method not found: ${q}`)}}}N.fromService=F;function z(A,U){const k=U&&U.disableMarshalling;return new Proxy({},{get(O,M){if(typeof M=="string")return U?.properties?.has(M)?U.properties.get(M):Y(M)?function(W){return A.listen(M,W)}:$(M)?A.listen(M):async function(...W){let q;U&&!(0,h.isUndefinedOrNull)(U.context)?q=[U.context,...W]:q=W;const K=await A.call(M,q);return k?K:(0,I.revive)(K)};throw new Error(`Property not found: ${String(M)}`)}})}N.toService=z;function $(A){return A[0]==="o"&&A[1]==="n"&&w.isUpperAsciiLetter(A.charCodeAt(2))}function Y(A){return/^onDynamic/.test(A)&&w.isUpperAsciiLetter(A.charCodeAt(9))}})(re=t.ProxyChannel||(t.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function le(N){return Array.isArray(N)?N.map(fe):fe(N)}function ie(N,F,z,$,Y,A,U){U=le(U);const k=se[Y],O=k[$%k.length];let M=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(A)?(M=M.concat(U),M.push(")")):M.push(U),console.log.apply(console,M)}t.logWithColors=ie;class V{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,$,Y,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,z,$,Y,A)}logIncoming(F,z,$,Y,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,z,$,Y,A)}}t.IPCLogger=V}),define(Q[78],Z([0,1,57,3,15,24,75,11,4,2,26,55,51,56]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class f extends v.ChannelServer{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:a.Event.fromNodeEventEmitter(process,"message",u=>P.VSBuffer.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}t.Server=f;class m{constructor(c,u){this.modulePath=c,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new a.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new C.Delayer(g),this.child=null,this._client=null}getChannel(c){const u=this;return{call(g,l,s){return u.requestPromise(c,g,l,s)},listen(g,l){return u.requestEvent(c,g,l)}}}requestPromise(c,u,g,l=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(c),e=(0,C.createCancelablePromise)(n=>s.call(u,g,n)),r=l.onCancellationRequested(()=>e.cancel()),i=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(i),e.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(c,u,g){if(!this.disposeDelayer)return a.Event.None;this.disposeDelayer.cancel();let l;const s=new a.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(c).listen(u,g)(s.fire,s),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const c=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,h.removeDangerousEnvVariables)(u.env),this.child=(0,D.fork)(this.modulePath,c,u);const g=new a.Emitter;a.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(P.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),r=g.event,i={send:e,onMessage:r};this._client=new v.ChannelClient(i);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,S)=>{process.removeListener("exit",n),this.activeRequests.forEach(y=>(0,d.dispose)(y)),this.activeRequests.clear(),o!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+S),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:S})})}return this._client}getCachedChannel(c){let u=this.channels.get(c);return u||(u=this.client.getChannel(c),this.channels.set(c,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=m}),define(Q[79],Z([0,1,3,4,2,5]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var L;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=t.StorageHint||(t.StorageHint={}));function p(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}t.isStorageItemsChangeEvent=p;var a;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(a=t.StorageState||(t.StorageState={}));class d extends P.Disposable{constructor(h,v=Object.create(null)){super(),this.database=h,this.options=v,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,f)=>this.accept(f,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===a.Closed)return;let f=!1;(0,T.isUndefinedOrNull)(v)?f=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),f=!0),f&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const f=this.cache.get(h);return(0,T.isUndefinedOrNull)(f)?v:f}getBoolean(h,v){const f=this.get(h);return(0,T.isUndefinedOrNull)(f)?v:f==="true"}getNumber(h,v){const f=this.get(h);return(0,T.isUndefinedOrNull)(f)?v:parseInt(f,10)}async set(h,v){if(this.state===a.Closed)return;if((0,T.isUndefinedOrNull)(v))return this.delete(h);const f=String(v);if(this.cache.get(h)!==f)return this.cache.set(h,f),this.pendingInserts.set(h,f),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===a.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((v,f)=>this.items.set(f,v)),h.delete?.forEach(v=>this.items.delete(v))}async close(){}}t.InMemoryStorageDatabase=I}),define(Q[80],Z([6,7]),function(B,t){return B.create("vs/base/node/zip",t)}),define(Q[81],Z([6,7]),function(B,t){return B.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[82],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Q[83],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[84],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionManagementCLI",t)}),define(Q[85],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionNls",t)}),define(Q[86],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(Q[87],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[88],Z([6,7]),function(B,t){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[89],Z([6,7]),function(B,t){return B.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[90],Z([6,7]),function(B,t){return B.create("vs/platform/files/common/fileService",t)}),define(Q[91],Z([6,7]),function(B,t){return B.create("vs/platform/files/common/io",t)}),define(Q[92],Z([6,7]),function(B,t){return B.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[93],Z([6,7]),function(B,t){return B.create("vs/platform/languagePacks/common/languagePacks",t)}),define(Q[94],Z([6,7]),function(B,t){return B.create("vs/platform/request/common/request",t)}),define(Q[95],Z([6,7]),function(B,t){return B.create("vs/platform/shell/node/shellEnv",t)}),define(Q[96],Z([6,7]),function(B,t){return B.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[97],Z([6,7]),function(B,t){return B.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(Q[98],Z([6,7]),function(B,t){return B.create("vs/platform/workspace/common/workspace",t)}),define(Q[99],Z([0,1,71,49,17,14,32,18,10]),function(B,t,D,C,P,T,L,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{get appRoot(){return(0,T.dirname)(P.FileAccess.asFileUri("",B).fsPath)}get userHome(){return a.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return a.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return a.URI.file(this.paths.tmpDir)}get cacheHome(){return a.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return a.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return a.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(a.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=L.env.VSCODE_PORTABLE;return m?a.URI.file((0,T.join)(m,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return a.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,T.resolve)(m):(0,T.normalize)((0,T.join)(P.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,T.resolve)(m):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,T.resolve)(m);const E=L.env.VSCODE_EXTENSIONS;if(E)return E;const c=L.env.VSCODE_PORTABLE;return c?(0,T.join)(c,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(E=>/^[^:/?#]+?:\/\//.test(E)?a.URI.parse(E):a.URI.file((0,T.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?a.URI.parse(m):a.URI.file((0,T.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(a.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return a.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return a.URI.file((0,T.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=L.env.VSCODE_PORTABLE;return m?a.URI.file((0,T.join)(m,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this._args}constructor(m,E,c){this._args=m,this.paths=E,this.productService=c,this.editSessionId=this.args.editSessionId}}ge([C.memoize],d.prototype,"appRoot",null),ge([C.memoize],d.prototype,"userHome",null),ge([C.memoize],d.prototype,"userDataPath",null),ge([C.memoize],d.prototype,"appSettingsHome",null),ge([C.memoize],d.prototype,"tmpDir",null),ge([C.memoize],d.prototype,"cacheHome",null),ge([C.memoize],d.prototype,"stateResource",null),ge([C.memoize],d.prototype,"userRoamingDataHome",null),ge([C.memoize],d.prototype,"userDataSyncHome",null),ge([C.memoize],d.prototype,"userDataSyncLogResource",null),ge([C.memoize],d.prototype,"editSessionsLogResource",null),ge([C.memoize],d.prototype,"sync",null),ge([C.memoize],d.prototype,"machineSettingsResource",null),ge([C.memoize],d.prototype,"workspaceStorageHome",null),ge([C.memoize],d.prototype,"localHistoryHome",null),ge([C.memoize],d.prototype,"keyboardLayoutResource",null),ge([C.memoize],d.prototype,"argvResource",null),ge([C.memoize],d.prototype,"isExtensionDevelopment",null),ge([C.memoize],d.prototype,"untitledWorkspacesHome",null),ge([C.memoize],d.prototype,"installSourcePath",null),ge([C.memoize],d.prototype,"builtinExtensionsPath",null),ge([C.memoize],d.prototype,"extensionsPath",null),ge([C.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ge([C.memoize],d.prototype,"extensionDevelopmentKind",null),ge([C.memoize],d.prototype,"extensionTestsLocationURI",null),ge([C.memoize],d.prototype,"debugExtensionHost",null),ge([C.memoize],d.prototype,"serviceMachineIdResource",null),ge([C.memoize],d.prototype,"telemetryLogResource",null),ge([C.memoize],d.prototype,"disableWorkspaceTrust",null),ge([C.memoize],d.prototype,"policyFile",null),t.AbstractNativeEnvironmentService=d;function I(f,m){return v(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}t.parseExtensionHostPort=I;function w(f,m){return v(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}t.parseSearchPort=w;function h(f,m){return v(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}t.parsePtyHostPort=h;function v(f,m,E,c,u,g){const s=Number(m||f)||(c?null:E),e=s?Boolean(!!m):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:s,break:e,debugId:u,env:r}}}),function(){"use strict";function B(t,D,C){function P(L,p){const a=T(L,p),d=[a];return t.isAbsolute(a)||d.unshift(C),t.resolve(...d)}function T(L,p){process.env.VSCODE_DEV&&(p="code-oss-dev");const a=process.env.VSCODE_PORTABLE;if(a)return t.join(a,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,p);const I=L["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(w,"AppData","Roaming")}break;case"darwin":d=t.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,p)}return{getUserDataPath:P}}if(typeof define=="function")define(Q[100],Z([149,38,32]),function(t,D,C){return B(t,D,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),D=require("os");module.exports=B(t,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,38,99,100]),function(B,t,D,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class T extends C.AbstractNativeEnvironmentService{constructor(p,a){super(p,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,P.getUserDataPath)(p,a.nameShort)},a)}}t.NativeEnvironmentService=T}),define(Q[102],Z([0,1,5,85]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;function P(L,p,a){try{T(L,p,a)}catch{}return L}t.localizeManifest=P;function T(L,p,a){const d=(I,w,h)=>{const v=I[w];if((0,D.isString)(v)){const f=v,m=f.length;if(m>1&&f[0]==="%"&&f[m-1]==="%"){const E=f.substr(1,m-2);let c=p[E];c===void 0&&a&&(c=a[E]);const u=typeof c=="string"?c:c.message;if(u!==void 0){const g=a?.[E],l=typeof g=="string"?g:g?.message;if(h&&(w==="title"||w==="category")&&l&&l!==u){const s={value:u,original:l};I[w]=s}else I[w]=u}else console.warn(`[${L.name}]: ${(0,C.localize)(0,null,E)}`)}}else if((0,D.isObject)(v))for(const f in v)v.hasOwnProperty(f)&&(f==="commands"?d(v,f,!0):d(v,f,h));else if(Array.isArray(v))for(let f=0;f<v.length;f++)d(v,f,h)};for(const I in L)L.hasOwnProperty(I)&&d(L,I)}}),define(Q[45],Z([0,1,18,54,89,39]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.validateExtensionManifest=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function a(c){return c=c.trim(),c==="*"||L.test(c)}t.isValidVersionStr=a;function d(c){if(!a(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}t.parseVersion=d;function I(c){if(!c)return null;const u=c.majorBase,g=c.majorMustEqual,l=c.minorBase;let s=c.minorMustEqual;const e=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(u===0||(s=!1),r=!1);let i=0;if(c.preRelease){const n=p.exec(c.preRelease);if(n){const[,o,S,y]=n;i=Date.UTC(Number(o),Number(S)-1,Number(y))}}return{majorBase:u,majorMustEqual:g,minorBase:l,minorMustEqual:s,patchBase:e,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:i}}t.normalizeVersion=I;function w(c,u,g){let l;typeof c=="string"?l=I(d(c)):l=c;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let e;if(typeof g=="string"?e=I(d(g)):e=g,!l||!e)return!1;const r=l.majorBase,i=l.minorBase,n=l.patchBase;let o=e.majorBase,S=e.minorBase,y=e.patchBase;const b=e.notBefore;let R=e.majorMustEqual,j=e.minorMustEqual,_=e.patchMustEqual;return e.isMinimum?r>o?!0:r<o?!1:i>S?!0:i<S||s&&s<b?!1:n>=y:(r===1&&o===0&&(!R||!j||!_)&&(o=1,S=0,y=0,R=!0,j=!1,_=!1),r<o?!1:r>o?!R:i<S?!1:i>S?!j:n<y?!1:n>y?!_:!(s&&s<b))}t.isValidVersion=w;function h(c,u,g,l,s){const e=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return e.push([C.default.Error,P.localize(0,null)]),e;if(typeof l.name!="string")return e.push([C.default.Error,P.localize(1,null,"name")]),e;if(typeof l.version!="string")return e.push([C.default.Error,P.localize(2,null,"version")]),e;if(!l.engines)return e.push([C.default.Error,P.localize(3,null,"engines")]),e;if(typeof l.engines.vscode!="string")return e.push([C.default.Error,P.localize(4,null,"engines.vscode")]),e;if(typeof l.extensionDependencies<"u"&&!E(l.extensionDependencies))return e.push([C.default.Error,P.localize(5,null,"extensionDependencies")]),e;if(typeof l.activationEvents<"u"){if(!E(l.activationEvents))return e.push([C.default.Error,P.localize(6,null,"activationEvents")]),e;if(typeof l.main>"u"&&typeof l.browser>"u")return e.push([C.default.Error,P.localize(7,null,"activationEvents","main")]),e}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&e.push([C.default.Warning,P.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return e.push([C.default.Error,P.localize(9,null,"main")]),e;{const n=(0,D.joinPath)(g,l.main);(0,D.isEqualOrParent)(n,g)||e.push([C.default.Warning,P.localize(10,null,n.path,g.path)])}if(typeof l.activationEvents>"u")return e.push([C.default.Error,P.localize(11,null,"activationEvents","main")]),e}if(typeof l.browser<"u"){if(typeof l.browser!="string")return e.push([C.default.Error,P.localize(12,null,"browser")]),e;{const n=(0,D.joinPath)(g,l.browser);(0,D.isEqualOrParent)(n,g)||e.push([C.default.Warning,P.localize(13,null,n.path,g.path)])}if(typeof l.activationEvents>"u")return e.push([C.default.Error,P.localize(14,null,"activationEvents","browser")]),e}if(!T.valid(l.version))return e.push([C.default.Error,P.localize(15,null)]),e;const r=[];if(!v(c,u,l,s,r))for(const n of r)e.push([C.default.Error,n]);return e}t.validateExtensionManifest=h;function v(c,u,g,l,s){return l||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(c,u,g.engines.vscode,s)}t.isValidExtensionVersion=v;function f(c,u,g){return c==="*"||m(u,g,c)}t.isEngineValid=f;function m(c,u,g,l=[]){const s=I(d(g));if(!s)return l.push(P.localize(16,null,g)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return l.push(P.localize(17,null,g)),!1}else if(!s.majorMustEqual)return l.push(P.localize(18,null,g)),!1;return w(c,u,s)?!0:(l.push(P.localize(19,null,c,g)),!1)}function E(c){if(!Array.isArray(c))return!1;for(let u=0,g=c.length;u<g;u++)if(typeof c[u]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function P(T,L,p){let a=p&&p.get("storage.serviceMachineId",-1)||null;if(a)return a;try{const I=(await L.readFile(T.serviceMachineIdResource)).value.toString();a=(0,C.isUUID)(I)?I:null}catch{a=null}if(!a){a=(0,C.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(a))}catch{}}return p?.store("storage.serviceMachineId",a,-1,1),a}t.getServiceMachineId=P}),define(Q[46],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class D{constructor(P,T=[],L=!1){this.ctor=P,this.staticArguments=T,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=D}),define(Q[104],Z([0,1,46]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const C=[];var P;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(P=t.InstantiationType||(t.InstantiationType={}));function T(p,a,d){a instanceof D.SyncDescriptor||(a=new D.SyncDescriptor(a,[],Boolean(d))),C.push([p,a])}t.registerSingleton=T;function L(){return C}t.getSingletonServiceDescriptors=L}),define(Q[105],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class D{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}t.Node=D;class C{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const p=this.lookupOrInsertNode(T),a=this.lookupOrInsertNode(L);p.outgoing.set(a.key,a),a.incoming.set(p.key,p)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(const p of this._nodes.values())p.outgoing.delete(L),p.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let p=this._nodes.get(L);return p||(p=new D(L,T),this._nodes.set(L,p)),p}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[L,p]of this._nodes)T.push(`${L}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this._nodes){const p=new Set([T]),a=this._findCycle(L,p);if(a)return a}}_findCycle(T,L){for(const[p,a]of T.outgoing){if(L.has(p))return[...L,p].join(" -> ");L.add(p);const d=this._findCycle(a,L);if(d)return d;L.delete(p)}}}t.Graph=C}),define(Q[21],Z([0,1,5,10,8]),function(B,t,D,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLanguageTagSettingPlainKey=t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,P.createDecorator)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof C.URI)}t.isConfigurationOverrides=T;function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof C.URI)}t.isConfigurationUpdateOverrides=L;var p;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(p=t.ConfigurationTarget||(t.ConfigurationTarget={}));function a(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}t.ConfigurationTargetToString=a;function d(c,u){const g=Object.create(null);for(const l in c)I(g,l,c[l],u);return g}t.toValuesTree=d;function I(c,u,g,l){const s=u.split("."),e=s.pop();let r=c;for(let i=0;i<s.length;i++){const n=s[i];let o=r[n];switch(typeof o){case"undefined":o=r[n]=Object.create(null);break;case"object":break;default:l(`Ignoring ${u} as ${s.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[e]=g}catch{l(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}else l(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(r)}`)}t.addToValueTree=I;function w(c,u){const g=u.split(".");h(c,g)}t.removeFromValueTree=w;function h(c,u){const g=u.shift();if(u.length===0){delete c[g];return}if(Object.keys(c).indexOf(g)!==-1){const l=c[g];typeof l=="object"&&!Array.isArray(l)&&(h(l,u),Object.keys(l).length===0&&delete c[g])}}function v(c,u,g){function l(r,i){let n=r;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const s=u.split("."),e=l(c,s);return typeof e>"u"?g:e}t.getConfigurationValue=v;function f(c,u,g){Object.keys(u).forEach(l=>{l!=="__proto__"&&(l in c?D.isObject(c[l])&&D.isObject(u[l])?f(c[l],u[l],g):g&&(c[l]=u[l]):c[l]=u[l])})}t.merge=f;function m(c,u,g){const l=c.inspect(u),s=c.inspect(g);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:l.defaultValue}t.getMigratedSettingValue=m;function E(c){return c.replace(/[\[\]]/g,"")}t.getLanguageTagSettingPlainKey=E}),define(Q[58],Z([0,1,8]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Q[16],Z([0,1,8]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,D.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,D.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[22],Z([0,1,83,8]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function P(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=P;function T(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=T;function L(c,u){switch(c){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=L;function p(c,u){return u==="web"&&!c.includes("web")}t.isNotWebExtensionInWebTargetPlatform=p;function a(c,u,g){return p(u,g)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===g?!0:d(g).includes(c)}t.isTargetPlatformCompatible=a;function d(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=d;function I(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}t.isIExtensionIdentifier=I;var w;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(w=t.SortBy||(t.SortBy={}));var h;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(h=t.SortOrder||(t.SortOrder={}));var v;(function(c){c.Install="install",c.Uninstall="uninstall"})(v=t.StatisticType||(t.StatisticType={}));var f;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var m;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(m=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class E extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,15,11,91,12]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(I,w,h,v,f,m){let E;try{await p(I,w,h,v,f,m)}catch(c){E=c}finally{E&&f.errorTransformer&&(E=f.errorTransformer(E)),typeof E<"u"&&h.error(E),h.end()}}t.readFileIntoStream=L;async function p(I,w,h,v,f,m){a(m);const E=await I.open(w,{create:!1});try{a(m);let c=0,u=0,g=f&&typeof f.length=="number"?f.length:void 0,l=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),s=f&&typeof f.position=="number"?f.position:0,e=0;do u=await I.read(E,s,l.buffer,e,l.byteLength-e),s+=u,e+=u,c+=u,typeof g=="number"&&(g-=u),e===l.byteLength&&(await h.write(v(l)),l=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),e=0);while(u>0&&(typeof g!="number"||g>0)&&a(m)&&d(c,f));if(e>0){let r=e;typeof g=="number"&&(r=Math.min(e,g)),h.write(v(l.slice(0,r)))}}catch(c){throw(0,T.ensureFileSystemProviderError)(c)}finally{await I.close(E)}}function a(I){if(I.isCancellationRequested)throw(0,C.canceled)();return!0}function d(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,T.createFileSystemProviderError)((0,P.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,T.createFileSystemProviderError)((0,P.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,150,2,13,151]),function(B,t,D,C,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class p extends P.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const I=this.normalizeRequests(d),w=I.filter(v=>{const f=this.watchers.get(v.path);return f?!(0,C.patternsEquals)(f.request.excludes,v.excludes)||!(0,C.patternsEquals)(f.request.includes,v.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:v})=>!I.find(f=>f.path===v.path&&(0,C.patternsEquals)(f.excludes,v.excludes)&&(0,C.patternsEquals)(f.includes,v.includes))).map(({request:v})=>v.path);w.length&&this.trace(`Request to start watching: ${w.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const v of h)this.stopWatching(v);for(const v of w)this.startWatching(v)}startWatching(d){const I=new L.NodeJSFileWatcherLibrary(d,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),w={request:d,instance:I};this.watchers.set(d.path,w)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const I=this.watchers.get(d);I&&(this.watchers.delete(d),I.instance.dispose())}normalizeRequests(d){const I=new Map;for(const w of d){const h=T.isLinux?w.path:w.path.toLowerCase();I.set(h,w)}return Array.from(I.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,I]of this.watchers)I.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,I){return I?`[File Watcher (node.js)] ${d} (path: ${I.request.path})`:`[File Watcher (node.js)] ${d}`}}t.NodeJSWatcher=p}),define(Q[107],Z([0,1,60,106]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class P extends D.AbstractNonRecursiveWatcherClient{constructor(L,p,a){super(L,p,a),this.init()}createWatcher(){return new C.NodeJSWatcher}}t.NodeJSWatcherClient=P}),define(Q[108],Z([0,1,17,56,78,60]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class L extends T.AbstractUniversalWatcherClient{constructor(a,d,I){super(a,d,I),this.init()}createWatcher(a){const d=a.add(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return a.add(d.onDidProcessExit(({code:I,signal:w})=>this.onError(`terminated by itself with code ${I}, signal: ${w}`))),C.ProxyChannel.toService((0,C.getNextTickChannel)(d.getChannel("watcher")))}}t.UniversalWatcherClient=L}),define(Q[61],Z([0,1]),function(B,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class D{constructor(...P){this._entries=new Map;for(const[T,L]of P)this.set(T,L)}set(P,T){const L=this._entries.get(P);return this._entries.set(P,T),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}t.ServiceCollection=D}),define(Q[109],Z([0,1,3,11,46,105,8,61]),function(B,t,D,C,P,T,L,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const a=!1;class d extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class I{constructor(f=new p.ServiceCollection,m=!1,E,c=a){this._services=f,this._strict=m,this._parent=E,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(L.IInstantiationService,this),this._globalGraph=c?E?._globalGraph??new T.Graph(u=>u):void 0}createChild(f){return new I(f,this._strict,this,this._enableTracing)}invokeFunction(f,...m){const E=h.traceInvocation(this._enableTracing,f);let c=!1;try{return f({get:g=>{if(c)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(g,E);if(!l)throw new Error(`[invokeFunction] unknown service '${g}'`);return l}},...m)}finally{c=!0,E.stop()}}createInstance(f,...m){let E,c;return f instanceof P.SyncDescriptor?(E=h.traceCreation(this._enableTracing,f.ctor),c=this._createInstance(f.ctor,f.staticArguments.concat(m),E)):(E=h.traceCreation(this._enableTracing,f),c=this._createInstance(f,m,E)),E.stop(),c}_createInstance(f,m=[],E){const c=L._util.getServiceDependencies(f).sort((l,s)=>l.index-s.index),u=[];for(const l of c){const s=this._getOrCreateServiceInstance(l.id,E);s||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),u.push(s)}const g=c.length>0?c[0].index:m.length;if(m.length!==g){console.trace(`[createInstance] First service dependency of ${f.name} at position ${g+1} conflicts with ${m.length} static arguments`);const l=g-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,g)}return new f(...m,...u)}_setServiceInstance(f,m){if(this._services.get(f)instanceof P.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const E=this._getServiceInstanceOrDescriptor(f);return E instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,E,m.branch(f,!0)):(m.branch(f,!1),E)}_safeCreateAndCacheServiceInstance(f,m,E){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,E)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,E){const c=new T.Graph(l=>l.id.toString());let u=0;const g=[{id:f,desc:m,_trace:E}];for(;g.length;){const l=g.pop();if(c.lookupOrInsertNode(l),u++>1e3)throw new d(c);for(const s of L._util.getServiceDependencies(l.desc.ctor)){const e=this._getServiceInstanceOrDescriptor(s.id);if(e||this._throwIfStrict(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(s.id)),e instanceof P.SyncDescriptor){const r={id:s.id,desc:e,_trace:l._trace.branch(s.id,!0)};c.insertEdge(l,r),g.push(r)}}}for(;;){const l=c.roots();if(l.length===0){if(!c.isEmpty())throw new d(c);break}for(const{data:s}of l){if(this._getServiceInstanceOrDescriptor(s.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}c.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,E=[],c,u){if(this._services.get(f)instanceof P.SyncDescriptor)return this._createServiceInstance(f,m,E,c,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,E,c,u);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m,E=[],c,u){if(c){const g=new I(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(f);const l=new D.IdleValue(()=>g._createInstance(m,E,u));return new Proxy(Object.create(null),{get(s,e){if(e in s)return s[e];const r=l.value;let i=r[e];return typeof i!="function"||(i=i.bind(r),s[e]=i),i},set(s,e,r){return l.value[e]=r,!0}})}else return this._createInstance(m,E,u)}_throwIfStrict(f,m){if(m&&console.warn(f),this._strict)throw new Error(f)}}t.InstantiationService=I;var w;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(w||(w={}));class h{static traceInvocation(f,m){return f?new h(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(f,m){return f?new h(0,m.name):h._None}constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}branch(f,m){const E=new h(2,f.toString());return this._dep.push([f,m,E]),E}stop(){const f=Date.now()-this._start;h._totals+=f;let m=!1;function E(u,g){const l=[],s=new Array(u+1).join("	");for(const[e,r,i]of g._dep)if(r&&i){m=!0,l.push(`${s}CREATES -> ${e}`);const n=E(u+1,i);n&&l.push(n)}else l.push(`${s}uses -> ${e}`);return l.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||m)&&h.all.add(c.join(`
`))}}t.Trace=h,h.all=new Set,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0});var ee=this&&this.__param||function(B,t){return function(D,C){t(D,C,B)}};define(Q[62],Z([0,1,24,2,13,93,22,8]),function(B,t,D,C,P,T,L,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackBaseService=t.ILanguagePackService=void 0,t.ILanguagePackService=(0,p.createDecorator)("languagePackService");let a=class extends C.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const v=w.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],E=this.getLocale(f);return{...this.createQuickPickItem(E,m,f),extensionId:f.identifier.id,galleryExtension:f}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(I){return I.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I,w,h){const v=w??I;let f;if(v!==I&&(f=`(${I})`),I.toLowerCase()===P.language.toLowerCase()&&(f??="",f+=(0,T.localize)(0,null)),h?.installCount){f??="";const m=h.installCount;let E;m>1e6?E=`${Math.floor(m/1e5)/10}M`:m>1e3?E=`${Math.floor(m/1e3)}K`:E=String(m),f+=` $(cloud-download) ${E}`}return{id:I,label:v,description:f}}};a=ge([ee(0,L.IExtensionGalleryService)],a),t.LanguagePackBaseService=a}),define(Q[9],Z([0,1,31,4,2,13,8]),function(B,t,D,C,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,L.createDecorator)("logService"),t.ILoggerService=(0,L.createDecorator)("loggerService");function p(){return new Date().toISOString()}var a;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(a=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=a.Info;function d(r,i,n){switch(i){case a.Trace:r.trace(n);break;case a.Debug:r.debug(n);break;case a.Info:r.info(n);break;case a.Warning:r.warn(n);break;case a.Error:r.error(n);break;case a.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}t.log=d;function I(r){let i="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}t.format=I;class w extends P.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=w;class h extends w{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(a.Trace)&&this.log(a.Trace,I([i,...n]))}debug(i,...n){this.checkLogLevel(a.Debug)&&this.log(a.Debug,I([i,...n]))}info(i,...n){this.checkLogLevel(a.Info)&&this.log(a.Info,I([i,...n]))}warn(i,...n){this.checkLogLevel(a.Warning)&&this.log(a.Warning,I([i,...n]))}error(i,...n){if(this.checkLogLevel(a.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(a.Error,I(o))}else this.log(a.Error,I([i,...n]))}critical(i,...n){this.checkLogLevel(a.Critical)&&this.log(a.Critical,I([i,...n]))}flush(){}}t.AbstractMessageLogger=h;class v extends w{constructor(i=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!T.isWindows}trace(i,...n){this.getLevel()<=a.Trace&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,i,...n):console.log(`[main ${p()}]`,i,...n))}debug(i,...n){this.getLevel()<=a.Debug&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,i,...n):console.log(`[main ${p()}]`,i,...n))}info(i,...n){this.getLevel()<=a.Info&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,i,...n):console.log(`[main ${p()}]`,i,...n))}warn(i,...n){this.getLevel()<=a.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,i,...n):console.warn(`[main ${p()}]`,i,...n))}error(i,...n){this.getLevel()<=a.Error&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,i,...n):console.error(`[main ${p()}]`,i,...n))}critical(i,...n){this.getLevel()<=a.Critical&&(this.useColors?console.error(`\x1B[90m[main ${p()}]\x1B[0m`,i,...n):console.error(`[main ${p()}]`,i,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=v;class f extends w{constructor(i=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.getLevel()<=a.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=a.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=a.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=a.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=a.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=a.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}t.ConsoleLogger=f;class m extends w{constructor(i,n=t.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=a.Trace&&this.adapter.log(a.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=a.Debug&&this.adapter.log(a.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=a.Info&&this.adapter.log(a.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=a.Warning&&this.adapter.log(a.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=a.Error&&this.adapter.log(a.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=a.Critical&&this.adapter.log(a.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=a.Trace)}dispose(){}flush(){}}t.AdapterLogger=m;class E extends w{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=E;class c extends P.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}t.LogService=c;class u extends P.Disposable{constructor(i,n){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(S=>S.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?a.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=u;class g{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(i){}getLevel(){return a.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}t.NullLogService=g;function l(r){if(r.verbose)return a.Trace;if(typeof r.logLevel=="string"){const i=s(r.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=l;function s(r){switch(r){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Critical;case"off":return a.Off}}t.parseLogLevel=s;function e(r){switch(r){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Critical:return"critical";case a.Off:return"off"}}t.LogLevelToString=e}),define(Q[110],Z([0,1,19,3,11,4,2,14,60,9]),function(B,t,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class I extends L.Disposable{constructor(h,v){super(),this.logService=h,this.options=v,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new C.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}watch(h,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,v):this.watchNonRecursive(h,v)}watchUniversal(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:v.recursive},m=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,a.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const v of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const v of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(v)&&h.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:!1},m=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,a.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,p.normalize)(h.fsPath)}}t.AbstractDiskFileSystemProvider=I}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,36,17,112,18,43,90,12,59,9]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let g=class extends d.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const r=new d.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),r.add(e.onDidChangeFile(i=>this._onDidFilesChange.fire(new E.FileChangesEvent(i,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&r.add(e.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,d.dispose)(r)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(r){e.push(r)}}),!this.provider.has(s)&&await C.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const r=this.provider.get(s.scheme);return!!(r&&r.capabilities&e)}listCapabilities(){return a.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,v.isAbsolutePath)(s))throw new E.FileOperationError((0,m.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const r=new Error;throw r.name="ENOPRO",r.message=(0,m.localize)(1,null,s.toString()),r}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(e)||(0,E.hasReadWriteCapability)(e)||(0,E.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,E.hasOpenReadWriteCloseCapability)(e)||(0,E.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(r){throw(0,E.toFileSystemProviderErrorCode)(r)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,m.localize)(2,null,this.resourceForError(s)),1):(0,E.ensureFileSystemProviderError)(r)}}async doResolveFile(s,e){const r=await this.withProvider(s),i=this.isPathCaseSensitive(r),n=e?.resolveTo,o=e?.resolveSingleChildDescendants,S=e?.resolveMetadata,y=await r.stat(s);let b;return this.toFileStat(r,s,y,void 0,!!S,(R,j)=>(b||(b=I.TernarySearchTree.forUris(()=>!i),b.set(s,!0),n&&b.fill(!0,n)),b.get(R.resource)||b.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&o?j===1:!1))}async toFileStat(s,e,r,i,n,o){const{providerExtUri:S}=this.getExtUri(s),y={resource:e,name:S.basename(e),isFile:(r.type&E.FileType.File)!==0,isDirectory:(r.type&E.FileType.Directory)!==0,isSymbolicLink:(r.type&E.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(y.isDirectory&&o(y,i)){try{const b=await s.readdir(e),R=await C.Promises.settled(b.map(async([j,_])=>{try{const J=S.joinPath(e,j),H=n?await s.stat(J):{type:_};return await this.toFileStat(s,J,H,b.length,n,o)}catch(J){return this.logService.trace(J),null}}));y.children=(0,D.coalesce)(R)}catch(b){this.logService.trace(b),y.children=[]}return y}return y}async resolveAll(s){return C.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),r=await e.stat(s);return this.toFileStat(e,s,r,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(r){return r}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,m.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(s,r);const i=await this.writeFile(s,e);return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,i)),i}async writeFile(s,e,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,r)||await this.mkdirp(i,n.dirname(s));let S;if((0,E.hasReadWriteCapability)(i)&&!(e instanceof P.VSBuffer))if((0,f.isReadableStream)(e)){const y=await(0,f.peekStream)(e,3);y.ended?S=P.VSBuffer.concat(y.buffer):S=y}else S=(0,f.peekReadable)(e,y=>P.VSBuffer.concat(y),3);else S=e;!(0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)&&S instanceof P.VSBuffer?await this.doWriteUnbuffered(i,s,r,S):await this.doWriteBuffered(i,s,r,S instanceof P.VSBuffer?(0,P.bufferToReadable)(S):S),this._onDidRunOperation.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,m.localize)(4,null,this.resourceForError(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),r)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,r){if(!!r?.unlock&&!(s.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(e)));let n;try{n=await s.stat(e)}catch{return}if((n.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,m.localize)(6,null,this.resourceForError(e)),0,r);if(this.throwIfFileIsReadonly(e,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==E.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,E.etag)({mtime:r.mtime,size:n.size}))throw new E.FileOperationError((0,m.localize)(7,null),3,r);return n}async readFile(s,e,r){const i=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(i,s,e,r):this.doReadFile(i,s,e,r)}async doReadFileAtomic(s,e,r,i){return new Promise((n,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const S=await this.doReadFile(s,e,r,i);n(S)}catch(S){o(S)}})})}async doReadFile(s,e,r,i){const n=await this.doReadFileStream(s,e,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,P.streamToBuffer)(n.value)}}async readFileStream(s,e,r){const i=await this.withReadProvider(s);return this.doReadFileStream(i,s,e,r)}async doReadFileStream(s,e,r,i){const n=new T.CancellationTokenSource(i),o=this.validateReadFile(e,r).then(y=>y,y=>{throw n.cancel(),y});let S;try{return typeof r?.etag=="string"&&r.etag!==E.ETAG_DISABLED&&await o,r?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&r?.preferUnbuffered?S=this.readFileUnbuffered(s,e,r):(0,E.hasFileReadStreamCapability)(s)?S=this.readFileStreamed(s,e,n.token,r):S=this.readFileBuffered(s,e,n.token,r),{...await o,value:S}}catch(y){S&&await(0,f.consumeStream)(S);const b=(0,m.localize)(8,null,this.resourceForError(e),(0,E.ensureFileSystemProviderError)(y).toString());throw y instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(b,y.stat,r):new E.FileOperationError(b,(0,E.toFileOperationResult)(y),r)}}readFileStreamed(s,e,r,i=Object.create(null)){const n=s.readFileStream(e,i,r);return(0,f.transform)(n,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,m.localize)(9,null,this.resourceForError(e),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},o=>P.VSBuffer.concat(o))}readFileBuffered(s,e,r,i=Object.create(null)){const n=(0,P.newWriteableBufferStream)();return(0,c.readFileIntoStream)(s,e,n,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new E.FileOperationError((0,m.localize)(10,null,this.resourceForError(e),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},r),n}readFileUnbuffered(s,e,r){const i=(0,f.newWriteableStream)(n=>P.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?n=await s.readFile(e,{atomic:!0}):n=await s.readFile(e),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(e,n.byteLength,r),i.end(P.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,e){const r=await this.resolve(s,{resolveMetadata:!0});if(r.isDirectory)throw new E.FileOperationError((0,m.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==E.ETAG_DISABLED&&e.etag===r.etag)throw new E.NotModifiedSinceFileOperationError((0,m.localize)(12,null),r,e);return this.validateReadFileLimits(s,r.size,e),r}validateReadFileLimits(s,e,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&e>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&e>r.limits.size&&(i=7),typeof i=="number")throw new E.FileOperationError((0,m.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,e,r){return this.doCanMoveCopy(s,e,"move",r)}async canCopy(s,e,r){return this.doCanMoveCopy(s,e,"copy",r)}async doCanMoveCopy(s,e,r,i){if(s.toString()!==e.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,s,o,e,r,i)}catch(n){return n}return!0}async move(s,e,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(i,s,n,e,"move",!!r),S=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="move"?2:3,S)),S}async copy(s,e,r){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(i,s,n,e,"copy",!!r),S=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,o==="copy"?3:2,S)),S}async doMoveCopy(s,e,r,i,n,o){if(e.toString()===i.toString())return n;const{exists:S,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(s,e,r,i,n,o);if(S&&!y&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),n==="copy"){if(s===r&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(e,i,{overwrite:o});else{const b=await this.resolve(e);b.isDirectory?await this.doCopyFolder(s,b,r,i):await this.doCopyFile(s,e,r,i)}return n}else return s===r?(await s.rename(e,i,{overwrite:o}),n):(await this.doMoveCopy(s,e,r,i,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,r,i){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(s,e,r,i);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(s,e,r,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(s,e,r,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(r))return this.doPipeUnbuffered(s,e,r,i)}async doCopyFolder(s,e,r,i){await r.mkdir(i),Array.isArray(e.children)&&await C.Promises.settled(e.children.map(async n=>{const o=this.getExtUri(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),r,o):this.doCopyFile(s,n.resource,r,o)}))}async doValidateMoveCopy(s,e,r,i,n,o){let S=!1;if(s===r){const{providerExtUri:b,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(S=b.isEqual(e,i)),S&&n==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(e),this.resourceForError(i)));if(!S&&b.isEqualOrParent(i,e))throw new Error((0,m.localize)(15,null,this.resourceForError(e),this.resourceForError(i)))}const y=await this.exists(i);if(y&&!S){if(!o)throw new E.FileOperationError((0,m.localize)(16,null,this.resourceForError(e),this.resourceForError(i)),4);if(s===r){const{providerExtUri:b}=this.getExtUri(s);if(b.isEqualOrParent(e,i))throw new Error((0,m.localize)(17,null,this.resourceForError(e),this.resourceForError(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:S}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const r=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(s,0,r)),r}async mkdirp(s,e){const r=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(e,i.dirname(e));)try{if(((await s.stat(e)).type&E.FileType.Directory)===0)throw new Error((0,m.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,E.toFileSystemProviderErrorCode)(n)!==E.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(e)),e=i.dirname(e)}for(let n=r.length-1;n>=0;n--){e=i.joinPath(e,r[n]);try{await s.mkdir(e)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(r){return r}return!0}async doValidateDelete(s,e){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(r.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(s)));let n;try{n=await r.stat(s)}catch{}if(n)this.throwIfFileIsReadonly(s,n);else throw new E.FileOperationError((0,m.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const S=await this.resolve(s);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(s)))}return r}async del(s,e){const r=await this.doValidateDelete(s,e),i=!!e?.useTrash,n=!!e?.recursive;await r.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,e){const r=await this.withProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(s,e))return;if(r===i&&(0,E.hasFileCloneCapability)(r))return r.cloneFile(s,e);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(e));const n=this.writeQueue.queueFor(s,this.getExtUri(r).providerExtUri);return r===i&&(0,E.hasFileFolderCopyCapability)(r)?n.queue(()=>r.copy(s,e,{overwrite:!0})):n.queue(()=>this.doCopyFile(r,s,i,e))}watch(s,e={recursive:!1,excludes:[]}){const r=new d.DisposableStore;let i=!1,n=()=>{i=!0};return r.add((0,d.toDisposable)(()=>n())),(async()=>{try{const o=await this.doWatch(s,e);i?(0,d.dispose)(o):n=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(s,e){const r=await this.withProvider(s),i=(0,p.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(s),e]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:r.watch(s,e)},this.activeWatchers.set(i,n)),n.count+=1,(0,d.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,d.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,r,i){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(e,{create:!0,unlock:r?.unlock??!1});try{(0,f.isReadableStream)(i)||(0,f.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,n,i):await this.doWriteReadableBufferedQueued(s,n,i)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,e,r){let i=0,n;if((0,f.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,S)=>{(0,f.listenStream)(n,{onData:async y=>{n.pause();try{await this.doWriteBuffer(s,e,y,y.byteLength,i,0)}catch(b){return S(b)}i+=y.byteLength,setTimeout(()=>n.resume())},onError:y=>S(y),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,r){let i=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(s,e,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,e,r,i,n,o){let S=0;for(;S<i;)S+=await s.write(e,n+S,r.buffer,o+S,i-S)}async doWriteUnbuffered(s,e,r,i){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,r,i))}async doWriteUnbufferedQueued(s,e,r,i){let n;i instanceof P.VSBuffer?n=i:(0,f.isReadableStream)(i)?n=await(0,P.streamToBuffer)(i):(0,f.isReadableBufferedStream)(i)?n=await(0,P.bufferedStreamToBuffer)(i):n=(0,P.readableToBuffer)(i),await s.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(s,e,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,r,i))}async doPipeBufferedQueued(s,e,r,i){let n,o;try{n=await s.open(e,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const S=P.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,b=0,R=0;do R=await s.read(n,y,S.buffer,b,S.byteLength-b),await this.doWriteBuffer(r,o,S,R,y,b),y+=R,b+=R,b===S.byteLength&&(b=0);while(R>0)}catch(S){throw(0,E.ensureFileSystemProviderError)(S)}finally{await C.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,r,i))}async doPipeUnbufferedQueued(s,e,r,i){return r.writeFile(i,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,r,i))}async doPipeUnbufferedToBufferedQueued(s,e,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(r,n,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(s,e,r,i){const n=await(0,P.streamToBuffer)(this.readFileBuffered(s,e,T.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,n)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new E.FileOperationError((0,m.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,m.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};g=ge([ee(0,u.ILogService)],g),t.FileService=g}),define(Q[113],Z([0,1,114,152,3,36,15,4,153,2,14,13,18,43,20,92,12,59,110,31,108,107]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c,u,g,l,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,C.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class e extends u.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new T.ResourceMap(o=>h.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:o}=await f.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await f.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async S=>{try{let y;S.isSymbolicLink()?y=(await this.stat((0,h.joinPath)(i,S.name))).type:y=this.toType(S),o.push([S.name,y])}catch(y){this.logService.trace(y)}})),o}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let o;return n?.dangling?o=E.FileType.Unknown:i.isFile()?o=E.FileType.File:i.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,n&&(o|=E.FileType.SymbolicLink),o}async createResourceLock(i){const n=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const S=new P.Barrier;return this.resourceLocks.set(i,S),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,d.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===S&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),S.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const S=this.toFilePath(i);return await f.Promises.readFile(S)}catch(S){throw this.toFileSystemProviderError(S)}finally{o?.dispose()}}traceLock(i){e.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,n,o){const S=(0,v.newWriteableStream)(y=>L.VSBuffer.concat(y.map(b=>L.VSBuffer.wrap(b))).buffer);return(0,c.readFileIntoStream)(this,i,S,y=>y.buffer,{...n,bufferSize:256*1024},o),S}async writeFile(i,n,o){let S;try{const y=this.toFilePath(i);if(!o.create||!o.overwrite){if(await f.Promises.exists(y)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,m.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,m.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(S,0,n,0,n.byteLength)}catch(y){throw await this.toFileSystemProviderWriteError(i,y)}finally{typeof S=="number"&&await this.close(S)}}static configureFlushOnWrite(i){e.canFlush=i}async open(i,n){const o=this.toFilePath(i);let S;(0,E.isFileOpenForWriteOptions)(n)&&(S=await this.createResourceLock(i));let y;try{if((0,E.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:R}=await f.SymlinkSupport.stat(o);R.mode&128||await f.Promises.chmod(o,R.mode|128)}catch(R){this.logService.trace(R)}let b;if((0,E.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await f.Promises.truncate(o,0),b="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}b||(b="w")}else b="r";y=await f.Promises.open(o,b)}catch(b){throw S?.dispose(),(0,E.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,b):this.toFileSystemProviderError(b)}if(this.mapHandleToPos.set(y,0),(0,E.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(y,i),S){const b=this.mapHandleToLock.get(y);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${o})`),this.mapHandleToLock.set(y,S),b&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${o})`),b.dispose())}return y}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&e.canFlush)try{await f.Promises.fdatasync(i)}catch(o){e.configureFlushOnWrite(!1),this.logService.error(o)}return await f.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,S,y){const b=this.normalizePos(i,n);let R=null;try{R=(await f.Promises.read(i,o,S,y,b)).bytesRead}catch(j){throw this.toFileSystemProviderError(j)}finally{this.updatePos(i,b,R)}return R}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,o){const S=this.mapHandleToPos.get(i);typeof S=="number"&&(typeof n=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,S+o):this.mapHandleToPos.delete(i)))}async write(i,n,o,S,y){return(0,P.retry)(()=>this.doWrite(i,n,o,S,y),100,3)}async doWrite(i,n,o,S,y){const b=this.normalizePos(i,n);let R=null;try{R=(await f.Promises.write(i,o,S,y,b)).bytesWritten}catch(j){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),j)}finally{this.updatePos(i,b,R)}return R}async mkdir(i){try{await f.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const o=this.toFilePath(i);n.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,n,o){const S=this.toFilePath(i),y=this.toFilePath(n);if(S!==y)try{await this.validateTargetDeleted(i,n,"move",o.overwrite),await f.Promises.move(S,y)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(2,null,(0,I.basename)(S),(0,I.basename)((0,I.dirname)(y)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(i,n,o){const S=this.toFilePath(i),y=this.toFilePath(n);if(S!==y)try{await this.validateTargetDeleted(i,n,"copy",o.overwrite),await f.Promises.copy(S,y,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,m.localize)(3,null,(0,I.basename)(S),(0,I.basename)((0,I.dirname)(y)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(i,n,o,S){const y=this.toFilePath(i),b=this.toFilePath(n);let R=!1;if(!!(this.capabilities&1024)||(R=(0,a.isEqual)(y,b,!0)),R&&o==="copy")throw(0,E.createFileSystemProviderError)((0,m.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!R&&await f.Promises.exists(b)){if(!S)throw(0,E.createFileSystemProviderError)((0,m.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.doCloneFile(i,n,!1)}async doCloneFile(i,n,o){const S=this.toFilePath(i),y=this.toFilePath(n),b=!!(this.capabilities&1024);if((0,a.isEqual)(S,y,!b))return;const R=new d.DisposableStore;try{const[j,_]=await Promise.all([this.createResourceLock(i),this.createResourceLock(n)]);R.add(j),R.add(_),o&&await f.Promises.mkdir((0,I.dirname)(y),{recursive:!0}),await f.Promises.copyFile(S,y)}catch(j){if(j.code==="ENOENT"&&!o)return this.doCloneFile(i,n,!0);throw this.toFileSystemProviderError(j)}finally{R.dispose()}}createUniversalWatcher(i,n,o){return new l.UniversalWatcherClient(S=>i(S),S=>n(S),o)}createNonRecursiveWatcher(i,n,o){return new s.NodeJSWatcherClient(S=>i(S),S=>n(S),o)}toFileSystemProviderError(i){if(i instanceof E.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=E.FileSystemProviderErrorCode.NoPermissions;break;default:n=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let o=this.toFileSystemProviderError(n);if(i&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await f.SymlinkSupport.stat(this.toFilePath(i));S.mode&128||(o=(0,E.createFileSystemProviderError)(n,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return o}}t.DiskFileSystemProvider=e,e.TRACE_LOG_RESOURCE_LOCKS=!1,e.canFlush=!0}),define(Q[115],Z([0,1,12,9]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function P(p,a,d,I,w){try{const h=await new Promise((f,m)=>{B(["spdlog"],f,m)});h.setFlushOn(C.LogLevel.Trace);const v=await h.createAsyncRotatingLogger(p,a,d,I);return w&&v.clearFormatters(),v}catch(h){console.error(h)}return null}function T(p,a,d){switch(a){case C.LogLevel.Trace:p.trace(d);break;case C.LogLevel.Debug:p.debug(d);break;case C.LogLevel.Info:p.info(d);break;case C.LogLevel.Warning:p.warn(d);break;case C.LogLevel.Error:p.error(d);break;case C.LogLevel.Critical:p.critical(d);break;default:throw new Error("Invalid log level")}}class L extends C.AbstractMessageLogger{constructor(a,d,I,w,h){super(),this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(a,d,I,w),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(a,d,I,w){const h=I?6:1,v=30/h*D.ByteSize.MB,f=await P(a,d,v,h,w);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:m,message:E}of this.buffer)T(this._logger,m,E);this.buffer=[]}}log(a,d){this._logger?T(this._logger,a,d):this.getLevel()<=a&&this.buffer.push({level:a,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Q[37],Z([0,1,4,63,2,8]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullPolicyService=t.AbstractPolicyService=t.IPolicyService=void 0,t.IPolicyService=(0,T.createDecorator)("policy");class L extends P.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),C.Iterable.reduce(this.policies.entries(),(w,[h,v])=>({...w,[h]:v}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return C.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[I,w])=>({...d,[I]:{definition:w,value:this.policies.get(I)}}),{})}}t.AbstractPolicyService=L;class p{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.NullPolicyService=p}),define(Q[116],Z([0,1,3,4,63,5,12,9,37]),function(B,t,D,C,P,T,L,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FilePolicyService=void 0;function d(w,h){const v=[];for(const f of P.Iterable.concat(w.keys(),h.keys()))w.get(f)!==h.get(f)&&v.push(f);return v}let I=class extends a.AbstractPolicyService{constructor(h,v,f){super(),this.file=h,this.fileService=v,this.logService=f,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const m=C.Event.filter(v.onDidFilesChange,E=>E.affects(h));this._register(v.watch(h)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(h){await this.refresh()}async read(){const h=new Map;try{const v=await this.fileService.readFile(this.file),f=JSON.parse(v.value.toString());if(!(0,T.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(f))this.policyDefinitions[m]&&h.set(m,f[m])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return h}async refresh(){const h=await this.read(),v=d(this.policies,h);this.policies=h,v.length>0&&this._onDidChange.fire(v)}};I=ge([ee(1,L.IFileService),ee(2,p.ILogService)],I),t.FilePolicyService=I}),define(Q[28],Z([0,1,8]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,D.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,68,5]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class P{constructor(){this.data=new Map}add(L,p){D.ok(C.isString(L)),D.ok(C.isObject(p)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,p)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new P}),define(Q[117],Z([0,1,4,33]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function P(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(a,d){this.schemasById[P(a)]=d,this._onDidChangeSchema.fire(a)}notifySchemaChanged(a){this._onDidChangeSchema.fire(a)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;C.Registry.add(t.Extensions.JSONContribution,L)}),define(Q[40],Z([0,1,19,4,5,81,21,117,33]),function(B,t,D,C,P,T,L,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var I;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=a.Registry.as(p.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,r=!0){this.registerConfigurations([e],r)}registerConfigurations(e,r=!0){const i=this.doRegisterConfigurations(e,r);w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(e){const r=this.doDeregisterConfigurations(e);w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:e,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(e,!1)),w.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(i)})}registerDefaultConfigurations(e){const r=[],i=[];for(const{overrides:n,source:o}of e)for(const S in n)if(r.push(S),t.OVERRIDE_PROPERTY_REGEX.test(S)){const y=this.configurationDefaultsOverrides.get(S),b=y?.valuesSources??new Map;if(o)for(const J of Object.keys(n[S]))b.set(J,o);const R={...y?.value||{},...n[S]};this.configurationDefaultsOverrides.set(S,{source:o,value:R,valuesSources:b});const j=(0,L.getLanguageTagSettingPlainKey)(S),_={type:"object",default:R,description:T.localize(1,null,j),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:P.isString(o)?void 0:o,defaultValueSource:o};i.push(...m(S)),this.configurationProperties[S]=_,this.defaultLanguageConfigurationOverridesNode.properties[S]=_}else{this.configurationDefaultsOverrides.set(S,{value:n[S],source:o});const y=this.configurationProperties[S];y&&(this.updatePropertyDefaultValue(S,y),this.updateSchema(S,y))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const r=[];for(const{overrides:i,source:n}of e)for(const o in i){const S=this.configurationDefaultsOverrides.get(o),y=P.isString(n)?n:n?.id,b=P.isString(S?.source)?S?.source:S?.source?.id;if(y===b)if(r.push(o),this.configurationDefaultsOverrides.delete(o),t.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const R=this.configurationProperties[o];R&&(this.updatePropertyDefaultValue(o,R),this.updateSchema(o,R))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const r of e)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,r){const i=[];return e.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(e){const r=[],i=n=>{if(n.properties)for(const o in n.properties){r.push(o);const S=this.configurationProperties[o];S?.policy?.name&&this.policyConfigurations.delete(S.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of e){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(e,r=!0,i,n,o=3){o=P.isUndefinedOrNull(e.scope)?o:e.scope;const S=[],y=e.properties;if(y)for(const R in y){const j=y[R];if(r&&g(R,j)){delete y[R];continue}if(j.source=i,j.defaultDefaultValue=y[R].default,this.updatePropertyDefaultValue(R,j),t.OVERRIDE_PROPERTY_REGEX.test(R)?j.scope=void 0:(j.scope=P.isUndefinedOrNull(j.scope)?o:j.scope,j.restricted=P.isUndefinedOrNull(j.restricted)?!!n?.includes(R):j.restricted),y[R].hasOwnProperty("included")&&!y[R].included){this.excludedConfigurationProperties[R]=y[R],delete y[R];continue}else this.configurationProperties[R]=y[R],y[R].policy?.name&&this.policyConfigurations.set(y[R].policy.name,R);!y[R].deprecationMessage&&y[R].markdownDeprecationMessage&&(y[R].deprecationMessage=y[R].markdownDeprecationMessage),S.push(R)}const b=e.allOf;if(b)for(const R of b)S.push(...this.validateAndRegisterProperties(R,r,i,n,o));return S}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const r=i=>{const n=i.properties;if(n)for(const S in n)this.updateSchema(S,n[S]);i.allOf?.forEach(r)};r(e)}updateSchema(e,r){switch(t.allSettings.properties[e]=r,r.scope){case 1:t.applicationSettings.properties[e]=r;break;case 2:t.machineSettings.properties[e]=r;break;case 6:t.machineOverridableSettings.properties[e]=r;break;case 3:t.windowSettings.properties[e]=r;break;case 4:t.resourceSettings.properties[e]=r;break;case 5:t.resourceSettings.properties[e]=r,this.resourceLanguageSettingsSchema.properties[e]=r;break}}removeFromSchema(e,r){switch(delete t.allSettings.properties[e],r.scope){case 1:delete t.applicationSettings.properties[e];break;case 2:delete t.machineSettings.properties[e];break;case 6:delete t.machineOverridableSettings.properties[e];break;case 3:delete t.windowSettings.properties[e];break;case 4:case 5:delete t.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),t.allSettings.properties[r]=i,t.applicationSettings.properties[r]=i,t.machineSettings.properties[r]=i,t.machineOverridableSettings.properties[r]=i,t.windowSettings.properties[r]=i,t.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,r){const i=this.configurationDefaultsOverrides.get(e);let n=i?.value,o=i?.source;P.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),P.isUndefined(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function m(s){const e=[];if(t.OVERRIDE_PROPERTY_REGEX.test(s)){let r=f.exec(s);for(;r?.length;){const i=r[1].trim();i&&e.push(i),r=f.exec(s)}}return(0,D.distinct)(e)}t.overrideIdentifiersFromKey=m;function E(s){return s.reduce((e,r)=>`${e}[${r}]`,"")}t.keyFromOverrideIdentifiers=E;function c(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=c;const u=new h;a.Registry.add(t.Extensions.Configuration,u);function g(s,e){return s.trim()?t.OVERRIDE_PROPERTY_REGEX.test(s)?T.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?T.localize(8,null,s):e.policy?.name&&u.getPolicyConfigurations().get(e.policy?.name)!==void 0?T.localize(9,null,s,e.policy?.name,u.getPolicyConfigurations().get(e.policy?.name)):null:T.localize(6,null)}t.validateProperty=g;function l(){const s=[],e=u.getConfigurationProperties();for(const r of Object.keys(e))s.push([r,e[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}t.getScopes=l}),define(Q[64],Z([0,1,19,4,50,2,36,26,5,10,21,40,33]),function(B,t,D,C,P,T,L,p,a,d,I,w,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.ConfigurationModel=void 0;class v{constructor(e={},r=[],i=[],n){this._contents=e,this._keys=r,this._overrides=i,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const e=this.raw.map(r=>{if(r instanceof v)return r;const i=new f("");return i.parseRaw(r),i.configurationModel});this._rawConfiguration=e.reduce((r,i)=>i===r?i:r.merge(i),e[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,I.getConfigurationValue)(this.contents,e):this.contents}inspect(e,r){const i=this.rawConfiguration.getValue(e),n=r?this.rawConfiguration.getOverrideValue(e,r):void 0,o=r?this.rawConfiguration.override(r).getValue(e):i;return{value:i,override:n,merged:o}}getOverrideValue(e,r){const i=this.getContentsForOverrideIdentifer(r);return i?e?(0,I.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){const r=[];for(const i of this.overrides)i.identifiers.includes(e)&&r.push(...i.keys);return D.distinct(r)}getAllOverrideIdentifiers(){const e=[];for(const r of this.overrides)e.push(...r.identifiers);return D.distinct(e)}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=p.deepClone(this.contents),i=p.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const S of e)if(o.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.mergeContents(r,S.contents);for(const y of S.overrides){const[b]=i.filter(R=>D.equals(R.identifiers,y.identifiers));b?(this.mergeContents(b.contents,y.contents),b.keys.push(...y.keys),b.keys=D.distinct(b.keys)):i.push(p.deepClone(y))}for(const y of S.keys)n.indexOf(y)===-1&&n.push(y)}return new v(r,n,i,o.every(S=>S instanceof v)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new v(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const i={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let o=this.contents[n];const S=r[n];S&&(typeof o=="object"&&typeof S=="object"?(o=p.deepClone(o),this.mergeContents(o,S)):o=S),i[n]=o}return new v(i,this.keys,this.overrides)}mergeContents(e,r){for(const i of Object.keys(r)){if(i in e&&a.isObject(e[i])&&a.isObject(r[i])){this.mergeContents(e[i],r[i]);continue}e[i]=p.deepClone(r[i])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?p.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let r=null,i=null;const n=o=>{o&&(i?this.mergeContents(i,o):i=p.deepClone(o))};for(const o of this.overrides)D.equals(o.identifiers,[e])?r=o.contents:o.identifiers.includes(e)&&n(o.contents);return n(r),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,I.addToValueTree)(this.contents,e,r,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,I.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let i=0;i<r;i++)e.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,e)}removeKey(e){const r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}t.ConfigurationModel=v;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!a.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:i,keys:n,overrides:o,restricted:S,hasExcludedProperties:y}=this.doParseRaw(e,r);this._configurationModel=new v(i,n,o,y?[e]:void 0),this._restrictedConfigurations=S||[]}doParseContent(e){let r={},i=null,n=[];const o=[],S=[];function y(R){Array.isArray(n)?n.push(R):i!==null&&(n[i]=R)}const b={onObjectBegin:()=>{const R={};y(R),o.push(n),n=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const R=[];y(R),o.push(n),n=R,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:y,onError:(R,j,_)=>{S.push({error:R,offset:j,length:_})}};if(e)try{P.visit(e,b),r=n[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return r}doParseRaw(e,r){const i=h.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,i,!0,r);e=n.raw;const o=(0,I.toValuesTree)(e,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),S=Object.keys(e),y=this.toOverrides(e,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:o,keys:S,overrides:y,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(e,r,i,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[],hasExcludedProperties:o};const S={},y=[];for(const b in e)if(w.OVERRIDE_PROPERTY_REGEX.test(b)&&i){const R=this.filter(e[b],r,!1,n);S[b]=R.raw,o=o||R.hasExcludedProperties,y.push(...R.restricted)}else{const R=r[b],j=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&y.push(b),(j===void 0||n.scopes===void 0||n.scopes.includes(j))&&!(n.skipRestricted&&R?.restricted)?S[b]=e[b]:o=!0}return{raw:S,restricted:y,hasExcludedProperties:o}}toOverrides(e,r){const i=[];for(const n of Object.keys(e))if(w.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const S in e[n])o[S]=e[n][S];i.push({identifiers:(0,w.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,I.toValuesTree)(o,r)})}return i}}t.ConfigurationModelParser=f;class m extends T.Disposable{constructor(e,r,i,n){super(),this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&i.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=m;class E{constructor(e,r,i,n,o=new v,S=new v,y=new L.ResourceMap,b=new v,R=new L.ResourceMap,j=!0){this._defaultConfiguration=e,this._policyConfiguration=r,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=S,this._folderConfigurations=y,this._memoryConfiguration=b,this._memoryConfigurationByResource=R,this._freeze=j,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,r,i){return this.getConsolidatedConfigurationModel(e,r,i).getValue(e)}updateValue(e,r,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new v,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,i){const n=this.getConsolidatedConfigurationModel(e,r,i),o=this.getFolderConfigurationModelForResource(r.resource,i),S=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,y=this._defaultConfiguration.inspect(e,r.overrideIdentifier),b=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(e),R=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(e),j=this.userConfiguration.freeze().inspect(e,r.overrideIdentifier),_=this.localUserConfiguration.freeze().inspect(e,r.overrideIdentifier),J=this.remoteUserConfiguration.freeze().inspect(e,r.overrideIdentifier),H=i?this._workspaceConfiguration.freeze().inspect(e,r.overrideIdentifier):void 0,ne=o?o.freeze().inspect(e,r.overrideIdentifier):void 0,re=S.inspect(e,r.overrideIdentifier),se=n.getValue(e),fe=D.distinct(n.overrides.map(le=>le.identifiers).flat()).filter(le=>n.getOverrideValue(e,le)!==void 0);return{defaultValue:y?y.merged:void 0,policyValue:b?b.merged:void 0,applicationValue:R?R.merged:void 0,userValue:j?j.merged:void 0,userLocalValue:_?_.merged:void 0,userRemoteValue:J?J.merged:void 0,workspaceValue:H?H.merged:void 0,workspaceFolderValue:ne?ne.merged:void 0,memoryValue:re?re.merged:void 0,value:se,default:y.value!==void 0||y.override!==void 0?{value:y.value,override:y.override}:void 0,policy:b?.value!==void 0?{value:b.value}:void 0,application:R?.value!==void 0||R?.override!==void 0?{value:R.value,override:R.override}:void 0,user:j.value!==void 0||j.override!==void 0?{value:j.value,override:j.override}:void 0,userLocal:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userRemote:J.value!==void 0||J.override!==void 0?{value:J.value,override:J.override}:void 0,workspace:H?.value!==void 0||H?.override!==void 0?{value:H.value,override:H.override}:void 0,workspaceFolder:ne?.value!==void 0||ne?.override!==void 0?{value:ne.value,override:ne.override}:void 0,memory:re.value!==void 0||re.override!==void 0?{value:re.value,override:re.override}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const i=[];if(!r){const{added:n,updated:o,removed:S}=g(this._defaultConfiguration,e);r=[...n,...o,...S]}for(const n of r)for(const o of(0,w.overrideIdentifiersFromKey)(n)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(o),y=e.getKeysForOverrideIdentifier(o),b=[...y.filter(R=>S.indexOf(R)===-1),...S.filter(R=>y.indexOf(R)===-1),...S.filter(R=>!p.equals(this._defaultConfiguration.override(o).getValue(R),e.override(o).getValue(R)))];i.push([o,b])}return this.updateDefaultConfiguration(e),{keys:r,overrides:i}}compareAndUpdatePolicyConfiguration(e){const{added:r,updated:i,removed:n}=g(this._policyConfiguration,e),o=[...r,...i,...n];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=g(this.applicationConfiguration,e),S=[...r,...i,...n];return S.length&&this.updateApplicationConfiguration(e),{keys:S,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=g(this.localUserConfiguration,e),S=[...r,...i,...n];return S.length&&this.updateLocalUserConfiguration(e),{keys:S,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=g(this.remoteUserConfiguration,e),S=[...r,...i,...n];return S.length&&this.updateRemoteUserConfiguration(e),{keys:S,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:i,removed:n,overrides:o}=g(this.workspaceConfiguration,e),S=[...r,...i,...n];return S.length&&this.updateWorkspaceConfiguration(e),{keys:S,overrides:o}}compareAndUpdateFolderConfiguration(e,r){const i=this.folderConfigurations.get(e),{added:n,updated:o,removed:S,overrides:y}=g(i,r),b=[...n,...o,...S];return(b.length||!i)&&this.updateFolderConfiguration(e,r),{keys:b,overrides:y}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:n,removed:o,overrides:S}=g(r,void 0);return{keys:[...i,...n,...o],overrides:S}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,r,i){let n=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier&&(n=n.override(r.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:e},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const o=this._memoryConfigurationByResource.get(e);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=i.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=i}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const i=r.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:i,overrides:n,keys:o}=this._folderConfigurations.get(r);return e.push([r,{contents:i,overrides:n,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.policy),n=this.parseConfigurationModel(e.application),o=this.parseConfigurationModel(e.user),S=this.parseConfigurationModel(e.workspace),y=e.folders.reduce((b,R)=>(b.set(d.URI.revive(R[0]),this.parseConfigurationModel(R[1])),b),new L.ResourceMap);return new E(r,i,n,o,new v,S,y,new v,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new v(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=E;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,r=new Map;for(const n of s)n.keys.forEach(o=>e.add(o)),n.overrides.forEach(([o,S])=>{const y=(0,L.getOrSet)(r,o,new Set);S.forEach(b=>y.add(b))});const i=[];return r.forEach((n,o)=>i.push([o,[...n.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=c;class u{constructor(e,r,i,n){this.change=e,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(y=>o.add(y)),e.overrides.forEach(([,y])=>y.forEach(b=>o.add(b))),this.affectedKeys=[...o.values()];const S=new v;this.affectedKeys.forEach(y=>S.setValue(y,{})),this.affectedKeysTree=S.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!p.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let i=(0,I.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(e=e[n],!e)return!1;i=i[n]}return!0}}t.ConfigurationChangeEvent=u;function g(s,e){const{added:r,removed:i,updated:n}=l(e,s),o=[],S=s?.getAllOverrideIdentifiers()||[],y=e?.getAllOverrideIdentifiers()||[];if(e){const b=y.filter(R=>!S.includes(R));for(const R of b)o.push([R,e.getKeysForOverrideIdentifier(R)])}if(s){const b=S.filter(R=>!y.includes(R));for(const R of b)o.push([R,s.getKeysForOverrideIdentifier(R)])}if(e&&s){for(const b of S)if(y.includes(b)){const R=l({contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)},{contents:e.getOverrideValue(void 0,b)||{},keys:e.getKeysForOverrideIdentifier(b)});o.push([b,[...R.added,...R.removed,...R.updated]])}}return{added:r,removed:i,updated:n,overrides:o}}function l(s,e){const r=s?e?s.keys.filter(o=>e.keys.indexOf(o)===-1):[...s.keys]:[],i=e?s?e.keys.filter(o=>s.keys.indexOf(o)===-1):[...e.keys]:[],n=[];if(s&&e){for(const o of e.keys)if(s.keys.indexOf(o)!==-1){const S=(0,I.getConfigurationValue)(e.contents,o),y=(0,I.getConfigurationValue)(s.contents,o);p.equals(S,y)||n.push(o)}}return{added:r,removed:i,updated:n}}}),define(Q[118],Z([0,1,19,4,2,26,5,21,64,40,9,37,33]),function(B,t,D,C,P,T,L,p,a,d,I,w,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PolicyConfiguration=t.NullPolicyConfiguration=t.DefaultConfigurationModel=t.DefaultConfiguration=void 0;class v extends P.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.onDidUpdateConfiguration(u,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(u,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}}t.DefaultConfiguration=v;class f extends a.ConfigurationModel{constructor(u={}){const g=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(g),s=Object.create(null),e=[];for(const r in g){const i=u[r],n=i!==void 0?i:g[r].default;(0,p.addToValueTree)(s,r,n,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(r)&&e.push({identifiers:(0,d.overrideIdentifiersFromKey)(r),keys:Object.keys(s[r]),contents:(0,p.toValuesTree)(s[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(s,l,e)}}t.DefaultConfigurationModel=f;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new a.ConfigurationModel}async initialize(){return this.configurationModel}}t.NullPolicyConfiguration=m;let E=class extends P.Disposable{get configurationModel(){return this._configurationModel}constructor(u,g,l){super(),this.defaultConfiguration=u,this.policyService=g,this.logService=l,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new a.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.registerPolicyDefinitions(u),!0))),this._configurationModel}async registerPolicyDefinitions(u){const g={},l=[],s=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const e of u){const r=s[e];if(!r){l.push(e);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}l.push(e),g[r.policy.name]={type:r.type}}}return(0,L.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),l}onDidChangePolicies(u){const g=h.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),l=(0,D.coalesce)(u.map(s=>g.get(s)));this.update(l,!0)}update(u,g){const l=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const r of u){const i=l[r]?.policy?.name;if(i){const n=this.policyService.getPolicyValue(i);(e?n!==void 0:!(0,T.equals)(this._configurationModel.getValue(r),n))&&s.push([r,n])}else this._configurationModel.getValue(r)!==void 0&&s.push([r,void 0])}if(s.length){const r=this._configurationModel;this._configurationModel=new a.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,n]of s)n===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,n);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};E=ge([ee(1,w.IPolicyService),ee(2,I.ILogService)],E),t.PolicyConfiguration=E}),define(Q[119],Z([0,1,3,4,2,18,21,64,118,37]),function(B,t,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class I extends P.Disposable{constructor(h,v,f,m){super(),this.settingsResource=h,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new a.DefaultConfiguration),this.policyConfiguration=f instanceof d.NullPolicyService?new a.NullPolicyConfiguration:this._register(new a.PolicyConfiguration(this.defaultConfiguration,f,m)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,v)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:E,properties:c})=>this.onDidDefaultConfigurationChange(E,c))),this._register(this.policyConfiguration.onDidChangeConfiguration(E=>this.onDidPolicyConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,v,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(h,v,new p.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const f=typeof h=="string"?h:void 0,m=(0,L.isConfigurationOverrides)(h)?h:(0,L.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(f,m,void 0)}updateValue(h,v,f,m){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,v,2)}onDidDefaultConfigurationChange(h,v){const f=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(h,v);this.trigger(m,f,7)}onDidPolicyConfigurationChange(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(f,v,7)}trigger(h,v,f){const m=new p.ConfigurationChangeEvent(h,{data:v},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=I}),define(Q[120],Z([0,1,17]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseAuthorityWithOptionalPort=t.parseAuthorityWithPort=t.getRemoteServerRootPath=t.getRemoteName=t.getRemoteAuthority=void 0;function C(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=C;function P(d){if(!d)return;const I=d.indexOf("+");return I<0?d:d.substr(0,I)}t.getRemoteName=P;function T(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}t.getRemoteServerRootPath=T;function L(d){const{host:I,port:w}=a(d);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:w}}t.parseAuthorityWithPort=L;function p(d,I){let{host:w,port:h}=a(d);return typeof h>"u"&&(h=I),{host:w,port:h}}t.parseAuthorityWithOptionalPort=p;function a(d){const I=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const w=d.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const h=d.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:d,port:void 0}}}),define(Q[34],Z([0,1,27,8,120]),function(B,t,D,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.isApplicationScopedExtension=t.ExtensionIdentifier=t.TargetPlatform=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}t.getWorkspaceSupportTypeMessage=T;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(p=t.ExtensionType||(t.ExtensionType={}));var a;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(a=t.TargetPlatform||(t.TargetPlatform={}));class d{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,E){if(typeof m>"u"||m===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof m=="string"||typeof E=="string"){const c=typeof m=="string"?m:m.value,u=typeof E=="string"?E:E.value;return D.equalsIgnoreCase(c,u)}return m._lower===E._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}t.ExtensionIdentifier=d;function I(f){return w(f)}t.isApplicationScopedExtension=I;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=w;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=h;function v(f,m){if(m){const E=`onResolveRemoteAuthority:${(0,P.getRemoteName)(m)}`;return f.activationEvents?.indexOf(E)!==-1}return!1}t.isResolverExtension=v,t.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,13,10,11,32]),function(B,t,D,C,P,T,L,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeTargetPlatform=t.isAlpineLinux=t.getExtensionDependencies=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.getIdAndVersion=t.ExtensionKey=t.areSameExtensions=void 0;function d(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,D.compareIgnoreCase)(r.id,i.id)===0}t.areSameExtensions=d;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,n,o)}static parse(i){const n=I.exec(i);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?d(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}t.ExtensionKey=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const i=h.exec(r);return i&&i[1]?[m(i[1]),i[2]]:[m(r),void 0]}t.getIdAndVersion=v;function f(r,i){return`${r}.${i}`}t.getExtensionId=f;function m(r){return r.toLocaleLowerCase()}t.adoptToGalleryExtensionId=m;function E(r,i){return m(f(r,i))}t.getGalleryExtensionId=E;function c(r,i){const n=[],o=S=>{for(const y of n)if(y.some(b=>d(i(b),i(S))))return y;return null};for(const S of r){const y=o(S);y?y.push(S):n.push([S])}return n}t.groupByExtension=c;function u(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=u;function g(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}t.getGalleryExtensionTelemetryData=g,t.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function l(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const S=o.shift();if(S&&n.every(y=>!d(y.identifier,{id:S}))){const y=r.filter(b=>d(b.identifier,{id:S}));y.length===1&&(n.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}t.getExtensionDependencies=l;async function s(r,i){if(!T.isLinux)return!1;let n;try{n=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){i.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(S))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}t.isAlpineLinux=s;async function e(r,i){const n=await s(r,i),o=(0,C.getTargetPlatform)(n?"alpine":T.platform,a.arch);return i.debug("ComputeTargetPlatform:",o),o}t.computeTargetPlatform=e}),define(Q[121],Z([0,1,24,11,17,18,39,10,84,22,23,34]),function(B,t,D,C,P,T,L,p,a,d,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLI=void 0;const h=E=>(0,a.localize)(0,null,E),v=(0,a.localize)(1,null,"ms-dotnettools.csharp");function f(E,c){return c?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let m=class{constructor(c,u){this.extensionManagementService=c,this.extensionGalleryService=u}get location(){}async listExtensions(c,u,g,l=console){let s=await this.extensionManagementService.getInstalled(1,g);const e=w.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(u&&u!==""){if(e.indexOf(u.toLowerCase())<0){l.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(i=>i.manifest.categories?i.manifest.categories.map(o=>o.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){l.log("Possible Categories: "),e.forEach(i=>{l.log(i)});return}this.location&&l.log((0,a.localize)(2,null,this.location)),s=s.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let r;for(const i of s)r!==i.identifier.id&&(r=i.identifier.id,l.log(f(i.manifest,c)))}async installExtensions(c,u,g,l,s=console){const e=[],r=[];c.length&&s.log(this.location?(0,a.localize)(3,null,this.location):(0,a.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1,g.profileLocation),n=(b,R)=>{const j=i.find(_=>(0,I.areSameExtensions)(_.identifier,{id:b}));if(j){if(!l&&(!R||R==="prerelease"&&j.preRelease))return s.log((0,a.localize)(5,null,b,j.manifest.version,b)),!1;if(R&&j.manifest.version===R)return s.log((0,a.localize)(6,null,`${b}@${R}`)),!1}return!0},o=(b,R,j)=>{y.push({id:b,version:R!=="prerelease"?R:void 0,installOptions:{...g,isBuiltin:j,installPreReleaseVersion:R==="prerelease"||g.installPreReleaseVersion}})},S=[],y=[];for(const b of c)if(b instanceof p.URI)S.push(b);else{const[R,j]=(0,I.getIdAndVersion)(b);n(R,j)&&o(R,j,!1)}for(const b of u){const[R,j]=(0,I.getIdAndVersion)(b);n(R,j)&&o(R,j,!0)}if(S.length&&await Promise.all(S.map(async b=>{try{const R=await this.installVSIX(b,{...g,isBuiltin:!1},l,s);R&&r.push(R)}catch(R){s.error(R.message||R.stack||R),e.push(b.toString())}})),y.length){const b=await this.getGalleryExtensions(y);await Promise.all(y.map(async R=>{const j=b.get(R.id.toLowerCase());if(j)try{const _=await this.installFromGallery(R,j,i,l,s);_&&r.push(_)}catch(_){s.error(_.message||_.stack||_),e.push(R.id)}else s.error(`${h(R.version?`${R.id}@${R.version}`:R.id)}
${v}`),e.push(R.id)}))}if(e.length)throw new Error((0,a.localize)(7,null,e.join(", ")))}async installVSIX(c,u,g,l){const s=await this.extensionManagementService.getManifest(c);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,g,u.profileLocation,l))try{return await this.extensionManagementService.install(c,u),l.log((0,a.localize)(8,null,(0,T.basename)(c))),s}catch(r){if((0,C.isCancellationError)(r))return l.log((0,a.localize)(9,null,(0,T.basename)(c))),null;throw r}return null}async getGalleryExtensions(c){const u=new Map,g=c.some(s=>s.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(c.map(s=>({...s,preRelease:g})),D.CancellationToken.None);for(const s of l)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:c,version:u,installOptions:g},l,s,e,r){const i=await this.extensionGalleryService.getManifest(l,D.CancellationToken.None);if(i&&!this.validateExtensionKind(i,r))return null;const n=s.find(o=>(0,I.areSameExtensions)(o.identifier,l.identifier));if(n){if(l.version===n.manifest.version)return r.log((0,a.localize)(10,null,u?`${c}@${u}`:c)),null;r.log((0,a.localize)(11,null,c,l.version))}try{g.isBuiltin?r.log(u?(0,a.localize)(12,null,c,u):(0,a.localize)(13,null,c)):r.log(u?(0,a.localize)(14,null,c,u):(0,a.localize)(15,null,c));const o=await this.extensionManagementService.installFromGallery(l,{...g,installGivenVersion:!!u});return r.log((0,a.localize)(16,null,c,o.manifest.version)),i}catch(o){if((0,C.isCancellationError)(o))return r.log((0,a.localize)(17,null,c)),null;throw o}}validateExtensionKind(c,u){return!0}async validateVSIX(c,u,g,l){const s={id:(0,I.getGalleryExtensionId)(c.publisher,c.name)},r=(await this.extensionManagementService.getInstalled(1,g)).find(i=>(0,I.areSameExtensions)(s,i.identifier)&&(0,L.gt)(i.manifest.version,c.version));return r&&!u?(l.log((0,a.localize)(18,null,r.identifier.id,r.manifest.version,c.version)),!1):this.validateExtensionKind(c,l)}async uninstallExtensions(c,u,g,l=console){const s=async r=>{if(r instanceof p.URI){const i=await this.extensionManagementService.getManifest(r);return f(i)}return r},e=[];for(const r of c){const i=await s(r),o=(await this.extensionManagementService.getInstalled(void 0,g)).filter(S=>(0,I.areSameExtensions)(S.identifier,{id:i}));if(!o.length)throw new Error(`${this.notInstalled(i)}
${v}`);if(o.some(S=>S.type===0)){l.log((0,a.localize)(19,null,i));return}if(!u&&o.some(S=>S.isBuiltin)){l.log((0,a.localize)(20,null,i));return}l.log((0,a.localize)(21,null,i));for(const S of o)await this.extensionManagementService.uninstall(S,{profileLocation:g}),e.push(S);this.location?l.log((0,a.localize)(22,null,i,this.location)):l.log((0,a.localize)(23,null,i))}}async locateExtension(c,u=console){const g=await this.extensionManagementService.getInstalled();c.forEach(l=>{g.forEach(s=>{if(s.identifier.id===l&&s.location.scheme===P.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(c){return this.location?(0,a.localize)(24,null,c,this.location):(0,a.localize)(25,null,c)}};m=ge([ee(0,d.IExtensionManagementService),ee(1,d.IExtensionGalleryService)],m),t.ExtensionManagementCLI=m}),define(Q[41],Z([0,1,3,15,2,36,10,23,12,8,9]),function(B,t,D,C,P,T,L,p,a,d,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsProfileScannerService=t.IExtensionsProfileScannerService=void 0,t.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let w=class extends P.Disposable{constructor(v,f){super(),this.fileService=v,this.logService=f,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,f){return this.withProfileExtensions(f,m=>(m=m.filter(E=>v.some(([c])=>!(0,p.areSameExtensions)(E.identifier,c.identifier))),m.push(...v.map(([E,c])=>({identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:c}))),m))}removeExtensionFromProfile(v,f){return this.withProfileExtensions(f,m=>m.filter(E=>!(0,p.areSameExtensions)(E.identifier,v)))}async withProfileExtensions(v,f){return this.getResourceAccessQueue(v).queue(async()=>{let m=[];try{const E=await this.fileService.readFile(v),c=JSON.parse(E.value.toString());for(const u of c){if(!u.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",u);continue}if(!u.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",u);continue}if(!u.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",u);continue}m.push({identifier:u.identifier,location:L.URI.revive(u.location),version:u.version,metadata:u.metadata})}}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}if(f){m=f(m);const E=m.map(c=>({identifier:c.identifier,version:c.version,location:c.location.toJSON(),metadata:c.metadata}));await this.fileService.writeFile(v,C.VSBuffer.fromString(JSON.stringify(E)))}return m})}getResourceAccessQueue(v){let f=this.resourcesAccessQueueMap.get(v);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(v,f)),f}};w=ge([ee(0,a.IFileService),ee(1,I.ILogService)],w),t.ExtensionsProfileScannerService=w}),define(Q[122],Z([0,1,3,11,2,13,18,39,10,30,20,16,22,23,12,9]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;let E=class extends P.Disposable{constructor(u,g,l,s){super(),this.fileService=g,this.extensionGalleryService=l,this.logService=s,this.extensionsDownloadDir=a.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,g){await this.cleanUpPromise;const l=this.getName(u),s=(0,L.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(s)){const e=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(u,e,g);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(e)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,e.path),r}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,g,l){try{await I.Promises.rename(u.fsPath,g.fsPath)}catch(s){if(T.isWindows&&s&&s.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${u} to ${g} with 'EPERM' error. Trying again...`),this.rename(u,g,l);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const g=[],l=[];for(const r of u.children){const i=v.ExtensionKey.parse(r.name);i&&l.push([i,r])}const s=(0,v.groupByExtension)(l,([r])=>r),e=[];for(const r of s)r.sort((i,n)=>p.rcompare(i[0].version,n[0].version)),g.push(...r.slice(1).map(i=>i[1].resource)),e.push(r[0][1]);e.sort((r,i)=>r.mtime-i.mtime),g.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(g.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?v.ExtensionKey.create(u).toString().toLowerCase():(0,d.generateUuid)()}};E=ge([ee(0,w.INativeEnvironmentService),ee(1,f.IFileService),ee(2,h.IExtensionGalleryService),ee(3,m.ILogService)],E),t.ExtensionsDownloader=E}),define(Q[123],Z([0,1,2,14,20,34]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(a,d){super(),this.environmentService=a,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(d.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(a){a.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(a){a.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=L}),define(Q[124],Z([0,1,154,19,3,2,17,14,20,16,22,23,9,62]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeLanguagePackService=void 0;let f=class extends v.LanguagePackBaseService{constructor(u,g,l,s){super(l),this.extensionManagementService=u,this.logService=s,this.cache=this._register(new m(g,s)),this.extensionManagementService.registerParticipant({postInstall:async e=>this.postInstallExtension(e),postUninstall:async e=>this.postUninstallExtension(e)})}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),g=Object.keys(u).map(l=>{const s=u[l];return{...this.createQuickPickItem(l,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),g.sort((l,s)=>l.label.localeCompare(s.label)),g}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const g=await this.cache.getLanguagePacks();Object.keys(g).some(l=>g[l]&&g[l].extensions.some(s=>(0,w.areSameExtensions)(s.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(g);return!(0,C.equals)(Object.keys(u),Object.keys(l))}};f=ge([ee(0,I.IExtensionManagementService),ee(1,d.INativeEnvironmentService),ee(2,I.IExtensionGalleryService),ee(3,h.ILogService)],f),t.NativeLanguagePackService=f;let m=class extends T.Disposable{constructor(u,g){super(),this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(g=>{Object.keys(g).forEach(l=>delete g[l]),this.createLanguagePacksFromExtensions(g,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...g){for(const l of g)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,l);Object.keys(u).forEach(l=>this.updateHash(u[l]))}createLanguagePacksFromExtension(u,g){const l=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const e of s)if(g.location.scheme===L.Schemas.file&&E(e)){let r=u[e.languageId];r||(r={hash:"",extensions:[],translations:{},label:e.localizedLanguageName??e.languageName},u[e.languageId]=r);const i=r.extensions.filter(n=>(0,w.areSameExtensions)(n.extensionIdentifier,l))[0];i?i.version=g.manifest.version:r.extensions.push({extensionIdentifier:l,version:g.manifest.version});for(const n of e.translations)r.translations[n.id]=(0,p.join)(g.location.fsPath,n.path)}}updateHash(u){if(u){const g=(0,D.createHash)("md5");for(const l of u.extensions)g.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);u.hash=g.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return a.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(g=u(l),l)).then(l=>{for(const e of Object.keys(l))l[e]||delete l[e];this.languagePacks=l,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),a.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>g,l=>this.logService.error(l))})}};m=ge([ee(0,d.INativeEnvironmentService),ee(1,h.ILogService)],m);function E(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const u of c.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,8,33]),function(B,t,D,C,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asTextOrError=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,T.createDecorator)("requestService");function p(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}t.isSuccess=p;function a(m){return m.res.statusCode===204}async function d(m){return a(m)?null:(await(0,D.streamToBuffer)(m.stream)).toString()}t.asText=d;async function I(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);return d(m)}t.asTextOrError=I;async function w(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);if(a(m))return null;const c=(await(0,D.streamToBuffer)(m.stream)).toString();try{return JSON.parse(c)}catch(u){throw u.message+=`:
`+c,u}}t.asJson=w;function h(m){f(m)}t.updateProxyConfigurationsScope=h;let v;function f(m){const E=L.Registry.as(P.Extensions.Configuration),c=v;v={id:"http",order:15,title:(0,C.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(4,null),(0,C.localize)(5,null),(0,C.localize)(6,null),(0,C.localize)(7,null)],default:"override",description:(0,C.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[v],remove:c?[c]:[]})}f(2)}),define(Q[125],Z([0,1,24,17,12,47]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(a,d){this.requestService=a,this.fileService=d}async download(a,d,I=D.CancellationToken.None){if(a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote){await this.fileService.copy(a,d);return}const w={type:"GET",url:a.toString(!0)},h=await this.requestService.request(w,I);if(h.res.statusCode===200)await this.fileService.writeFile(d,h.stream);else{const v=await(0,T.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};L=ge([ee(0,T.IRequestService),ee(1,P.IFileService)],L),t.DownloadService=L}),define(Q[126],Z([0,1,127,5]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function P(L,p){return L.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:L.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function T(L,p,a={}){const d=(0,D.parse)(L),I=a.proxyUrl||P(d,p);if(!I)return null;const w=(0,D.parse)(I);if(!/^https?:$/.test(w.protocol||""))return null;const h={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,C.isBoolean)(a.strictSSL)?a.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((v,f)=>{B(["http-proxy-agent"],v,f)}))(h):new(await new Promise((v,f)=>{B(["https-proxy-agent"],v,f)}))(h)}t.getProxyAgent=T}),define(Q[128],Z([0,1,57,14,95,24,31,11,13,30,77,155,3]),function(B,t,D,C,P,T,L,p,a,d,I,w,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const v=1e4;let f;async function m(c,u,g){return u["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):a.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(g)&&!u["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(g)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=h.Promises.withAsyncBody(async(l,s)=>{const e=new T.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),s(new Error((0,P.localize)(0,null)))},v);try{l(await E(c,e.token))}catch(i){!(0,p.isCancellationError)(i)&&!e.token.isCancellationRequested?s(new Error((0,P.localize)(1,null,(0,L.toErrorMessage)(i)))):l({})}finally{clearTimeout(r),e.dispose()}})),f)}t.getResolvedShellEnv=m;async function E(c,u){const g=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",g);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",l);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",r);const i=await(0,I.getSystemShell)(a.OS,r);return c.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(u.isCancellationRequested)return o((0,p.canceled)());const S=(0,C.basename)(i);let y,b;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(S)?(y=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,b=["-Login","-Command"]):(y=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,S==="tcsh"?b=["-ic"]:b=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),y);const j=(0,D.spawn)(i,[...b,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(j.kill(),o((0,p.canceled)()))),j.on("error",H=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(H)),o(H)});const _=[];j.stdout.on("data",H=>_.push(H));const J=[];j.stderr.on("data",H=>J.push(H)),j.on("close",(H,ne)=>{const re=Buffer.concat(_).toString("utf8");c.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(J).toString("utf8");if(se.trim()&&c.trace("getUnixShellEnvironment#stderr",se),H||ne)return o(new Error((0,P.localize)(2,null,H,ne)));const fe=e.exec(re),le=fe?fe[1]:"{}";try{const ie=JSON.parse(le);g?ie.ELECTRON_RUN_AS_NODE=g:delete ie.ELECTRON_RUN_AS_NODE,l?ie.ELECTRON_NO_ATTACH_CONSOLE=l:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ie),n(ie)}catch(ie){c.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[65],Z([0,1,8]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,D.createDecorator)("stateService")}),define(Q[129],Z([0,1,3,15,5,16,12,9]),function(B,t,D,C,P,T,L,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class a{constructor(w,h,v){this.storagePath=w,this.logService=h,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,h){const v=this.storage[w];return(0,P.isUndefinedOrNull)(v)?h:v}setItem(w,h){this.setItems([{key:w,data:h}])}setItems(w){let h=!1;for(const{key:v,data:f}of w)this.storage[v]!==f&&((0,P.isUndefinedOrNull)(f)?(0,P.isUndefined)(this.storage[v])||(this.storage[v]=void 0,h=!0):(this.storage[v]=f,h=!0));h&&this.save()}removeItem(w){(0,P.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,C.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}t.FileStorage=a;let d=class{constructor(w,h,v){this.fileStorage=new a(w.stateResource,h,v)}async init(){await this.fileStorage.init()}getItem(w,h){return this.fileStorage.getItem(w,h)}};d=ge([ee(0,T.IEnvironmentService),ee(1,p.ILogService),ee(2,L.IFileService)],d),t.StateService=d}),define(Q[66],Z([0,1,13,32,10,30]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function L(d){if(D.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function p(d,I,w,h,v,f,m,E,c,u){const g=Object.create(null);g["common.machineId"]=m,g.sessionID=(0,T.generateUuid)()+Date.now(),g.commitHash=v,g.version=f,g["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,D.PlatformToString)(D.platform),g["common.nodePlatform"]=C.platform,g["common.nodeArch"]=h,g["common.product"]=u||"desktop",E&&(g["common.msftInternal"]=E);let l=0;const s=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(g["common.snap"]="true");const e=L(w);e&&(g["common.platformDetail"]=e);try{const r=await d.readFile(P.URI.file(c));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}t.resolveCommonProperties=p;function a(d){const I=C.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return d.some(h=>w===h)}t.verifyMicrosoftInternalDomain=a}),define(Q[35],Z([0,1,8]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,D.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(C=t.TelemetryLevel||(t.TelemetryLevel={}));var P;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(P=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,35]),function(B,t,D,C,P,T,L,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPiiPathsFromEnvironment=t.isInternalTelemetry=t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class a{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,C.staticObservableValue)(0)}publicLog(e,r){return Promise.resolve(void 0)}publicLog2(e,r){return this.publicLog(e,r)}publicLogError(e,r){return Promise.resolve(void 0)}publicLogError2(e,r){return this.publicLogError(e,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=a,t.NullTelemetryService=new a;class d{async publicLog(e,r,i){}async publicLogError(e,r,i){}}t.NullEndpointTelemetryService=d,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(s,e){return e.onDidChangeConfiguration(r=>{r.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(r.source),configurationKeys:c(r.sourceConfig)})})}t.configurationTelemetry=I;function w(s,e){return!(e.disableTelemetry||!s.enableTelemetry||e.extensionTestsLocationURI)}t.supportsTelemetry=w;function h(s){const e=s.getValue(p.TELEMETRY_SETTING_ID),r=s.getValue("telemetry.enableCrashReporter");if(s.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(e??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=h;function v(s){const e={},r={},i={};E(s,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),e[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(e[n]=o)}return{properties:e,measurements:r}}t.validateTelemetryData=v;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(s){if(!s)return"none";for(const e of f)if(s.startsWith(`${e}+`))return e;return"other"}t.cleanRemoteAuthority=m;function E(s,e,r=0,i){if(!!s)for(const n of Object.getOwnPropertyNames(s)){const o=s[n],S=i?i+n:n;Array.isArray(o)?e[S]=(0,D.safeStringify)(o):o instanceof Date?e[S]=o.toISOString():(0,P.isObject)(o)?r<2?E(o,e,r+1,S+"."):e[S]=(0,D.safeStringify)(o):e[S]=o}}function c(s){if(!s)return[];const e=[];return u(e,"",s),e}function u(s,e,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(i=>u(s,e?`${e}.${i}`:i,r[i])):s.push(e)}function g(s,e){const r=s.msftInternalDomains||[],i=e.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(r)||i}t.isInternalTelemetry=g;function l(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}t.getPiiPathsFromEnvironment=l}),define(Q[130],Z([0,1,103,42]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function P(T,L,p,a,d,I,w){const h={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${L.nameShort})`};if((0,C.supportsTelemetry)(L,p)&&(0,C.getTelemetryLevel)(a)===3){const v=await(0,D.getServiceMachineId)(p,d,I),{sessionId:f}=await w.getTelemetryInfo();h["X-Market-User-Id"]=v,h["VSCode-SessionId"]=f}return h}t.resolveMarketplaceHeaders=P}),define(Q[131],Z([0,1,11,26,42]),function(B,t,D,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(a,d,I){const w=await new Promise((E,c)=>{B(["@microsoft/1ds-core-js"],E,c)}),h=await new Promise((E,c)=>{B(["@microsoft/1ds-post-js"],E,c)}),v=new w.AppInsightsCore,f=new h.PostChannel,m={instrumentationKey:a,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(I){m.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:I};m.extensionConfig[f.identifier]=E}return v.initialize(m,[]),v.addTelemetryInitializer(E=>{d&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),v}class p{constructor(d,I,w,h,v){this._isInternalTelemetry=d,this._eventPrefix=I,this._defaultData=w,this._xhrOverride=v,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(d){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){d(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{d(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(d,I){if(!this._aiCoreOrKey)return;I=(0,C.mixin)(I,this._defaultData),I=(0,P.validateTelemetryData)(I);const w=this._eventPrefix+"/"+d;try{this._withAIClient(h=>{h.pluginVersionString=I?.properties.version??"Unknown",h.track({name:w,baseData:{name:w,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(d=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,d(void 0)})})}):Promise.resolve(void 0)}}t.AbstractOneDataSystemAppender=p}),define(Q[132],Z([0,1,2,26,52,13,27,96,21,40,133,28,33,35,42]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let m=class{constructor(u,g,l){this._configurationService=g,this._productService=l,this._experimentProperties={},this.telemetryLevel=new P.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,g){this._experimentProperties[u]=g}_updateTelemetryLevel(){let u=(0,f.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const l=g.usage?3:g.error?2:0;u=Math.min(u,l)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties,g=u.sessionID,l=u["common.machineId"],s=u["common.firstSessionDate"],e=u["common.msftInternal"];return{sessionId:g,machineId:l,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(u,g,l,s){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(e=>{l=(0,C.mixin)(l,e),l=(0,C.mixin)(l,this._experimentProperties),l=(0,C.cloneAndChange)(l,r=>{if(typeof r=="string")return this._cleanupInfo(r,s)}),this._appenders.forEach(r=>r.log(u,l))},e=>{console.error(e)})}publicLog(u,g,l){return this._log(u,3,g,l)}publicLog2(u,g,l){return this.publicLog(u,g,l)}publicLogError(u,g){return this._sendErrorTelemetry?this._log(u,2,g,!0):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}_anonymizeFilePaths(u){let g=u;const l=[];for(const i of this._cleanupPatterns)for(;;){const n=i.exec(u);if(!n)break;l.push([n.index,i.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(g="";;){const i=e.exec(u);if(!i)break;!s.test(i[0])&&l.every(([n,o])=>i.index<n||i.index>=o)&&(g+=u.substring(r,i.index)+"<REDACTED: user-file-path>",r=e.lastIndex)}return r<u.length&&(g+=u.substr(r)),g}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const g=u.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of l)if(s.regex.test(g))return`<REDACTED: ${s.label}>`;return u}_cleanupInfo(u,g){let l=u;g&&(l=this._anonymizeFilePaths(l));for(const s of this._cleanupPatterns)l=l.replace(s,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ge([ee(1,a.IConfigurationService),ee(2,w.IProductService)],m),t.TelemetryService=m;function E(){const c=(0,p.localize)(0,null,I.default.nameLong),u=I.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=T.isWeb?"":(0,p.localize)(3,null),l=(0,p.localize)(4,null),s=(0,p.localize)(5,null),e=(0,p.localize)(6,null),r=(0,p.localize)(7,null),i=`
|       | ${l} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,p.localize)(8,null);return`
${c} ${u} ${g}

&nbsp;

${r}
${i}

&nbsp;

${n}
`}h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,p.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,p.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[134],Z([0,1,156,131]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OneDataSystemAppender=void 0;class P extends C.AbstractOneDataSystemAppender{constructor(L,p,a,d){const I={sendPOST:(w,h)=>{const v={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const f=D.request(w.urlString,v,m=>{m.on("data",function(E){h(m.statusCode??200,m.headers,E.toString())}),m.on("error",function(E){h(0,{})})});f.write(w.data),f.end()}catch{h(0,{})}}};super(L,p,a,d,I)}}t.OneDataSystemAppender=P}),define(Q[135],Z([0,1,14,20]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function P(T,L){const p=Object.create(null),a=(I,w)=>{const h=JSON.parse(I);p[w]=h};if(L){const I=[],w=await C.Promises.readdir(L);for(const v of w)try{(await C.Promises.stat((0,D.join)(L,v))).isDirectory()&&I.push(v)}catch{}const h=[];for(const v of I)(await C.Promises.readdir((0,D.join)(L,v))).filter(m=>m==="telemetry.json").length===1&&h.push(v);for(const v of h){const f=(await C.Promises.readFile((0,D.join)(L,v,"telemetry.json"))).toString();a(f,v)}}let d=(await C.Promises.readFile((0,D.join)(T,"telemetry-core.json"))).toString();return a(d,"vscode-core"),d=(await C.Promises.readFile((0,D.join)(T,"telemetry-extensions.json"))).toString(),a(d,"vscode-extensions"),JSON.stringify(p,null,4)}t.buildTelemetryMessage=P}),define(Q[29],Z([0,1,8]),function(B,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Q[136],Z([0,1,4,2,10,16,23,12,9,29]),function(B,t,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let I=class extends C.Disposable{constructor(h,v,f,m,E){super(),this.extensionsManagementService=h,this.logService=m,this.uriIdentityService=E,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(u=>this.onInstallExtension(u))),this._register(h.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(h.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const c=P.URI.file(f.extensionsPath);this._register(v.watch(c)),this._register(D.Event.filter(v.onDidFilesChange,u=>u.rawChanges.some(g=>this.doesChangeAffects(g,c)))(()=>this.onDidChange()))}doesChangeAffects(h,v){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),v)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,L.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,L.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),v=h.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(E=>(0,L.areSameExtensions)(E,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),f=this.installedExtensions.filter(m=>this.installingExtensions.some(E=>(0,L.areSameExtensions)(E,m))?!1:h.every(E=>!(0,L.areSameExtensions)(E.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=h.map(m=>m.identifier),(v.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:f})}}};I=ge([ee(1,p.IFileService),ee(2,T.INativeEnvironmentService),ee(3,a.ILogService),ee(4,d.IUriIdentityService)],I),t.ExtensionsWatcher=I}),define(Q[137],Z([0,1,29,104,12,18,69,4,2]),function(B,t,D,C,P,T,L,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class d{constructor(h){this.uri=h,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let I=class{constructor(h){this._fileService=h,this._dispooables=new a.DisposableStore,this._limit=2**16;const v=new Map,f=m=>{let E=v.get(m.scheme);return E===void 0&&(E=h.hasProvider(m)&&!this._fileService.hasCapability(m,1024),v.set(m.scheme,E)),E};this._dispooables.add(p.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{v.delete(m.scheme)})),this.extUri=new T.ExtUri(f),this._canonicalUris=new L.SkipList((m,E)=>this.extUri.compare(m,E,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,T.normalizePath)(h));const v=this._canonicalUris.get(h);return v?v.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new d(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let f=0;f<v;f++)this._canonicalUris.set(h[f][0],h[f][1].touch())}};I=ge([ee(0,P.IFileService)],I),t.UriIdentityService=I,(0,C.registerSingleton)(D.IUriIdentityService,I,!0)}),define(Q[138],Z([0,1,98,14,36,18,10,8,17]),function(B,t,D,C,P,T,L,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.hasWorkspaceFileExtension=t.isSavedWorkspace=t.isTemporaryWorkspace=t.isUntitledWorkspace=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_SUFFIX=t.WORKSPACE_EXTENSION=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.isWorkspaceFolder=t.isWorkspace=t.WorkbenchState=t.reviveIdentifier=t.isWorkspaceIdentifier=t.toWorkspaceIdentifier=t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=t.isSingleFolderWorkspaceIdentifier=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=(0,p.createDecorator)("contextService");function d(r){const i=r;return typeof i?.id=="string"&&L.URI.isUri(i.uri)}t.isSingleFolderWorkspaceIdentifier=d,t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(r,i){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,C.basename)(r)}:i?t.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=r;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}t.toWorkspaceIdentifier=I;function w(r){const i=r;return typeof i?.id=="string"&&L.URI.isUri(i.configPath)}t.isWorkspaceIdentifier=w;function h(r){const i=r;if(i?.uri)return{id:i.id,uri:L.URI.revive(i.uri)};const n=r;if(n?.configPath)return{id:n.id,configPath:L.URI.revive(n.configPath)};if(r?.id)return{id:r.id}}t.reviveIdentifier=h;var v;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(v=t.WorkbenchState||(t.WorkbenchState={}));function f(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}t.isWorkspace=f;function m(r){const i=r;return!!(i&&typeof i=="object"&&L.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}t.isWorkspaceFolder=m;class E{constructor(i,n,o,S,y){this._id=i,this._transient=o,this._configuration=S,this._ignorePathCasing=y,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.Workspace=E;class c{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,T.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=c;function u(r){return new c({uri:r,index:0,name:(0,T.basenameOrAuthority)(r)},{uri:r.toString()})}t.toWorkspaceFolder=u,t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_SUFFIX=`.${t.WORKSPACE_EXTENSION}`,t.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json";function g(r,i){return T.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}t.isUntitledWorkspace=g;function l(r){let i;return L.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===a.Schemas.tmp}t.isTemporaryWorkspace=l;function s(r,i){return!g(r,i)&&!l(r)}t.isSavedWorkspace=s;function e(r){return(typeof r=="string"?(0,C.extname)(r):(0,T.extname)(r))===t.WORKSPACE_SUFFIX}t.hasWorkspaceFileExtension=e}),define(Q[25],Z([0,1,53,4,2,18,5,10,97,16,12,8,9,138,36,29,3,30,27]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryUserDataProfilesService=t.UserDataProfilesService=t.toUserDataProfile=t.EXTENSIONS_RESOURCE_NAME=t.reviveProfile=t.IUserDataProfilesService=t.PROFILES_ENABLEMENT_CONFIG=t.isUserDataProfile=void 0;function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&p.URI.isUri(n.location)&&p.URI.isUri(n.globalStorageHome)&&p.URI.isUri(n.settingsResource)&&p.URI.isUri(n.keybindingsResource)&&p.URI.isUri(n.tasksResource)&&p.URI.isUri(n.snippetsHome)&&((0,L.isUndefined)(n.extensionsResource)||p.URI.isUri(n.extensionsResource)))}t.isUserDataProfile=g,t.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",t.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function l(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:p.URI.revive(i.location).with({scheme:n}),globalStorageHome:p.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:p.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:p.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:p.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:p.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:p.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}t.reviveProfile=l,t.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(i,n,o,S){return{id:i,name:n,location:o,isDefault:!1,shortName:S?.shortName,globalStorageHome:(0,T.joinPath)(o,"globalStorage"),settingsResource:(0,T.joinPath)(o,"settings.json"),keybindingsResource:(0,T.joinPath)(o,"keybindings.json"),tasksResource:(0,T.joinPath)(o,"tasks.json"),snippetsHome:(0,T.joinPath)(o,"snippets"),extensionsResource:(0,T.joinPath)(o,t.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}t.toUserDataProfile=s;let e=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,o,S,y){super(),this.environmentService=n,this.fileService=o,this.uriIdentityService=S,this.logService=y,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new C.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new C.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new C.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new C.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(b=>s((0,T.basename)(b.location),b.name,b.location,{shortName:b.shortName,useDefaultFlags:b.useDefaultFlags})):[];let o;const S=new f.ResourceMap,y=s((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,a.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...y,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?y.extensionsResource:void 0}),n.length){const b=this.getStoredProfileAssociations();if(b.workspaces)for(const[R,j]of Object.entries(b.workspaces)){const _=p.URI.parse(R),J=p.URI.parse(j),H=n.find(ne=>this.uriIdentityService.extUri.isEqual(ne.location,J));H&&S.set(_,H)}if(b.emptyWindow){const R=p.URI.parse(b.emptyWindow);o=n.find(j=>this.uriIdentityService.extUri.isEqual(j.location,R))}}this._profilesObject={profiles:n,workspaces:S,emptyWindow:o}}return this._profilesObject}async createTransientProfile(n){const o="Temp",S=new RegExp(`${(0,u.escapeRegExpCharacters)(o)}\\s(\\d+)`);let y=0;for(const R of this.profiles){const j=S.exec(R.name),_=j?parseInt(j[1]):0;y=_>y?_:y}const b=`${o} ${y+1}`;return this.createProfile((0,D.hash)((0,c.generateUuid)()).toString(16),b,{transient:!0},n)}async createNamedProfile(n,o,S){return this.createProfile((0,D.hash)((0,c.generateUuid)()).toString(16),n,o,S)}async createProfile(n,o,S,y){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const b=await this.doCreateProfile(n,o,S);return y&&await this.setProfileForWorkspace(y,b),b}async doCreateProfile(n,o,S){let y=this.profileCreationPromises.get(o);return y||(y=(async()=>{try{const b=this.profiles.find(_=>_.name===o||_.id===n);if(b)return b;const R=s(n,o,(0,T.joinPath)(this.profilesHome,n),S);await this.fileService.createFolder(R.location);const j=[];return this._onWillCreateProfile.fire({profile:R,join(_){j.push(_)}}),await E.Promises.settled(j),this.updateProfiles([R],[],[]),R}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,y)),y}async updateProfile(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);let S=this.profiles.find(y=>y.id===n.id);if(!S)throw new Error(`Profile '${n.name}' does not exist`);return S=s(S.id,o.name??S.name,S.location,{shortName:o.shortName??S.shortName,transient:o.transient??S.isTransient,useDefaultFlags:o.useDefaultFlags??S.useDefaultFlags}),this.updateProfiles([],[],[S]),S}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(y=>y.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const S=[];this._onWillRemoveProfile.fire({profile:o,join(y){S.push(y)}});try{await Promise.allSettled(S)}catch(y){this.logService.error(y)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const y of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(y)?.id&&this.profilesObject.workspaces.delete(y);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(y){this.logService.error(y)}}getOrSetProfileForWorkspace(n,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let S=this.getProfileForWorkspace(n);return S||(S=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,S)),S}async setProfileForWorkspace(n,o){this.setProfileForWorkspaceSync(n,o)}setProfileForWorkspaceSync(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const S=this.profiles.find(y=>y.id===o.id);if(!S)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(n,S)}unsetWorkspace(n,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(S=>!this.uriIdentityService.extUri.isEqual(S.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.getWorkspace(n);return p.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,n.location)))}updateProfiles(n,o,S){const y=[...this.profiles,...n],b=[];this.transientProfilesObject.profiles=[];for(let R of y)R.isDefault||o.some(j=>R.id===j.id)||(R=S.find(j=>R.id===j.id)??R,R.isTransient?this.transientProfilesObject.profiles.push(R):b.push({location:R.location,name:R.name,shortName:R.shortName,useDefaultFlags:R.useDefaultFlags}));this.saveStoredProfiles(b),this._profilesObject=void 0,this.triggerProfilesChanges(n,o,S)}triggerProfilesChanges(n,o,S){this._onDidChangeProfiles.fire({added:n,removed:o,updated:S,all:this.profiles})}updateWorkspaceAssociation(n,o,S){S=o?.isTransient?!0:S,S||this.updateWorkspaceAssociation(n,void 0,!0);const y=this.getWorkspace(n),b=S?this.transientProfilesObject:this.profilesObject;p.URI.isUri(y)?(b.workspaces.delete(y),o&&b.workspaces.set(y,o)):b.emptyWindow=o,S||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[S,y]of this.profilesObject.workspaces.entries())n[S.toString()]=y.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};e.PROFILES_KEY="userDataProfiles",e.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e=ge([ee(0,d.IEnvironmentService),ee(1,I.IFileService),ee(2,m.IUriIdentityService),ee(3,h.ILogService)],e),t.UserDataProfilesService=e;class r extends e{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}t.InMemoryUserDataProfilesService=r}),define(Q[139],Z([0,1,19,3,24,11,4,2,13,10,82,22,23,34,9,28,35,25]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let u=class extends p.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,n,o,S,y){super(),this.galleryService=i,this.telemetryService=n,this.logService=o,this.productService=S,this.userDataProfilesService=y,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(({task:b})=>b.cancel()),this.uninstallingExtensions.forEach(b=>b.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(I.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(i,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,n)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(i),error:o}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(o),l(o)}}async uninstall(i,n={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,n)}async reinstallFromGallery(i){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",i.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const n=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...i.identifier,preRelease:i.preRelease}],{targetPlatform:n,compatible:!0},P.CancellationToken.None);if(!o)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(i,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,n,o){const S=J=>`${h.ExtensionKey.create(J).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!d.URI.isUri(n)){const J=this.installingExtensions.get(S(n));if(J){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:H}=await J.task.waitUntilTaskIsFinished();return H}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const y=[],b=[],R=[],j=this.createInstallExtensionTask(i,n,o);d.URI.isUri(n)||this.installingExtensions.set(S(n),{task:j,waitingTasks:[]}),this._onInstallExtension.fire({identifier:j.identifier,source:n,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",j.identifier.id),y.push({task:j,manifest:i});let _=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",j.identifier.id);else try{const H=await this.getAllDepsAndPackExtensions(j.identifier,i,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:re,manifest:se}of H){_=_||!!se.extensionDependencies?.some(ie=>(0,h.areSameExtensions)({id:ie},j.identifier));const fe=S(re),le=this.installingExtensions.get(fe);if(le){if(this.canWaitForTask(j,le.task)){this.logService.info("Waiting for already requested installing extension",re.identifier.id,j.identifier.id),le.waitingTasks.push(j);const ie=le.task.identifier;b.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,V=>V.some(N=>(0,h.areSameExtensions)(N.identifier,ie)))).then(V=>{if(!V.find(F=>(0,h.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!ne.some(({identifier:ie})=>(0,h.areSameExtensions)(ie,re.identifier))){const ie=this.createInstallExtensionTask(se,re,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(fe,{task:ie,waitingTasks:[j]}),this._onInstallExtension.fire({identifier:ie.identifier,source:re,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,j.identifier.id),y.push({task:ie,manifest:se})}}}catch(H){if(d.URI.isUri(j.source))(0,D.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",j.identifier.id,H.message),(0,D.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",j.identifier.id,H.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",j.identifier.id),H}const J=y.reduce((H,{task:ne,manifest:re})=>(H.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:re}),H),new Map);for(;J.size;){let H;const ne=[...J.values()].filter(({manifest:re})=>!re.extensionDependencies?.some(se=>J.has(se.toLowerCase())));ne.length?H=J.size===1?ne:ne.filter(({task:re})=>!(re===j&&!_)):(this.logService.info("Found extensions with circular dependencies",ne.map(({task:re})=>re.identifier.id)),H=[...J.values()]),await this.joinAllSettled(H.map(async({task:re})=>{const se=new Date().getTime();try{const{local:fe}=await re.run();if(await this.joinAllSettled(this.participants.map(le=>le.postInstall(fe,re.source,o,P.CancellationToken.None))),!d.URI.isUri(re.source)){const le=re.operation===3,ie=le?void 0:(new Date().getTime()-re.source.lastUpdated)/1e3;if(s(this.telemetryService,le?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,durationSinceUpdate:ie}),a.isWeb&&re.operation!==3)try{await this.galleryService.reportStatistic(fe.manifest.publisher,fe.manifest.name,fe.manifest.version,"install")}catch{}}R.push({local:fe,identifier:re.identifier,operation:re.operation,source:re.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:fe.isApplicationScoped})}catch(fe){throw d.URI.isUri(re.source)||s(this.telemetryService,re.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(re.source),duration:new Date().getTime()-se,error:fe}),this.logService.error("Error while installing the extension:",re.identifier.id),fe}finally{J.delete(re.identifier.id.toLowerCase())}}))}return b.length&&await this.joinAllSettled(b),R.forEach(({identifier:H})=>this.logService.info("Extension installed successfully:",H.id)),this._onDidInstallExtensions.fire(R),R.filter(({identifier:H})=>(0,h.areSameExtensions)(H,j.identifier))[0].local}catch(J){if(y.forEach(({task:H})=>H.cancel()),R.length)try{const H=await Promise.allSettled(R.map(({local:ne})=>this.createUninstallExtensionTask(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<H.length;ne++){const re=H[ne],{identifier:se}=R[ne];re.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",se.id):this.logService.warn("Rollback: Error while uninstalling extension",se.id,(0,T.getErrorMessage)(re.reason))}}catch(H){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(H),R.map(({identifier:ne})=>ne.id))}throw this._onDidInstallExtensions.fire(y.map(({task:H})=>({identifier:H.identifier,operation:2,source:H.source,context:o.context,profileLocation:o.profileLocation}))),J}finally{for(const[J,{task:H,waitingTasks:ne}]of this.installingExtensions.entries()){const re=ne.indexOf(j);re!==-1&&ne.splice(re,1),ne.length===0&&(H===j||re!==-1)&&this.installingExtensions.delete(J)}}}canWaitForTask(i,n){for(const[,{task:o,waitingTasks:S}]of this.installingExtensions.entries())if(o===i&&(S.includes(n)||S.some(y=>this.canWaitForTask(y,n)))||o===n&&S[0]&&!this.canWaitForTask(i,S[0]))return!1;return!0}async joinAllSettled(i){const n=[],o=[],S=await Promise.allSettled(i);for(const y of S)y.status==="fulfilled"?n.push(y.value):o.push(y.reason);if(o.length)throw g(o);return n}async getAllDepsAndPackExtensions(i,n,o,S,y){if(!this.galleryService.isEnabled())return[];const b=await this.getInstalled(void 0,y),R=[i],j=[],_=async(J,H)=>{const ne=H.extensionDependencies||[],re=[...ne];if(H.extensionPack){const se=o?b.find(fe=>(0,h.areSameExtensions)(fe.identifier,J)):void 0;for(const fe of H.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(le=>(0,h.areSameExtensions)({id:le},{id:fe}))||re.every(le=>!(0,h.areSameExtensions)({id:le},{id:fe}))&&re.push(fe)}if(re.length){const se=[...R,...j.map(le=>le.gallery.identifier)],fe=re.filter(le=>se.every(ie=>!(0,h.areSameExtensions)(ie,{id:le})));if(fe.length){const le=await this.galleryService.getExtensions(fe.map(ie=>({id:ie,preRelease:S})),P.CancellationToken.None);for(const ie of le){if(se.find(F=>(0,h.areSameExtensions)(F,ie.identifier)))continue;const V=ne.some(F=>(0,h.areSameExtensions)({id:F},ie.identifier));let N;try{N=await this.checkAndGetCompatibleVersion(ie,!1,S)}catch(F){if(F instanceof w.ExtensionManagementError&&F.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}j.push({gallery:N.extension,manifest:N.manifest}),await _(N.extension.identifier,N.manifest)}}}};return await _(i,n),j}async checkAndGetCompatibleVersion(i,n,o){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,h.areSameExtensions)(i.identifier,R)))throw new w.ExtensionManagementError(I.localize(3,null,i.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const R=await this.getTargetPlatform();throw new w.ExtensionManagementError(I.localize(4,null,i.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(R)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.getCompatibleVersion(i,n,o);if(y){if(o&&!n&&i.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(I.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],P.CancellationToken.None))[0]?new w.ExtensionManagementError(I.localize(6,null,i.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(I.localize(7,null,i.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",y.identifier.id);const b=await this.galleryService.getManifest(y,P.CancellationToken.None);if(b===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(b.version!==y.version)throw new w.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:b}}async getCompatibleVersion(i,n,o){const S=await this.getTargetPlatform();let y=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(y=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:S,compatible:!0},P.CancellationToken.None))[0]||null),!y&&await this.galleryService.isExtensionCompatible(i,o,S)&&(y=i),y||(n?y=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:S,compatible:!0},P.CancellationToken.None))[0]||null:y=await this.galleryService.getCompatibleExtension(i,o,S)),y}async uninstallExtension(i,n){const o=_=>`${_.id.toLowerCase()}${n.versionOnly?`-${i.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,S=this.uninstallingExtensions.get(o(i.identifier));if(S)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),S.waitUntilTaskIsFinished();const y=(_,J)=>{const H=this.createUninstallExtensionTask(_,J);return this.uninstallingExtensions.set(o(H.extension.identifier),H),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped}),H},b=(_,J)=>{J?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString(),J.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,J.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(_),error:J}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:J?.code,profileLocation:n.profileLocation,applicationScoped:_.isApplicationScoped})},R=[],j=[];try{R.push(y(i,n));const _=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const J=this.getAllPackExtensionsToUninstall(i,_);for(const H of J)this.uninstallingExtensions.has(o(H.identifier))?this.logService.info("Extensions is already requested to uninstall",H.identifier.id):R.push(y(H,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(R.map(J=>J.extension),_,i),await this.joinAllSettled(R.map(async J=>{try{if(await J.run(),await this.joinAllSettled(this.participants.map(H=>H.postUninstall(J.extension,n,P.CancellationToken.None))),J.extension.identifier.uuid)try{await this.galleryService.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}b(J.extension)}catch(H){const ne=H instanceof w.ExtensionManagementError?H:new w.ExtensionManagementError((0,T.getErrorMessage)(H),w.ExtensionManagementErrorCode.Internal);throw b(J.extension,ne),ne}finally{j.push(J)}}))}catch(_){const J=_ instanceof w.ExtensionManagementError?_:new w.ExtensionManagementError((0,T.getErrorMessage)(_),w.ExtensionManagementErrorCode.Internal);for(const H of R){try{H.cancel()}catch{}j.includes(H)||b(H.extension,J)}throw J}finally{for(const _ of R)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(i,n,o){for(const S of i){const y=this.getDependents(S,n);if(y.length){const b=y.filter(R=>!i.some(j=>(0,h.areSameExtensions)(j.identifier,R.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(S,b,o))}}}getDependentsErrorMessage(i,n,o){return o===i?n.length===1?I.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(9,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(10,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?I.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(12,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(13,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(i,n,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const S=i.manifest.extensionPack?i.manifest.extensionPack:[];if(S.length){const y=n.filter(R=>!R.isBuiltin&&S.some(j=>(0,h.areSameExtensions)({id:j},R.identifier))),b=[];for(const R of y)b.push(...this.getAllPackExtensionsToUninstall(R,n,o));return[...y,...b]}return[]}getDependents(i,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(S=>(0,h.areSameExtensions)({id:S},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(i,n,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(i)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(i,n,o)}createUninstallExtensionTask(i,n){return n.profileLocation&&i.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(i,n)}};u=ge([ee(0,w.IExtensionGalleryService),ee(1,E.ITelemetryService),ee(2,f.ILogService),ee(3,m.IProductService),ee(4,c.IUserDataProfilesService)],u),t.AbstractExtensionManagementService=u;function g(r){const i=Array.isArray(r)?r:[r];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((n,o)=>new Error(`${n.message}${n.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}t.joinErrors=g;function l(r){if(r instanceof w.ExtensionManagementError)return r;const i=new w.ExtensionManagementError(r.message,w.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function s(r,i,{extensionData:n,duration:o,error:S,durationSinceUpdate:y}){const b=S?S instanceof w.ExtensionManagementError?S.code:w.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(i,{...n,success:!S,duration:o,errorcode:b,durationSinceUpdate:y})}t.reportTelemetry=s;class e{constructor(){this.barrier=new C.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(i=>new Promise((n,o)=>{const S=i.onCancellationRequested(()=>{S.dispose(),o(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=e}),define(Q[48],Z([0,1,19,3,26,15,11,50,74,2,17,14,13,18,39,54,5,10,86,16,23,34,45,12,8,9,28,4,44,41,25,29,102]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c,u,g,l,s,e,r,i,n,o,S,y,b,R,j,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtensionsScannerService=t.toExtensionDescription=t.AbstractExtensionsScannerService=t.IExtensionsScannerService=t.Translations=void 0;var J;(function(ie){function V(N,F){if(N===F)return!0;const z=Object.keys(N),$=new Set;for(const Y of Object.keys(F))$.add(Y);if(z.length!==$.size)return!1;for(const Y of z){if(N[Y]!==F[Y])return!1;$.delete(Y)}return $.size===0}ie.equals=V})(J=t.Translations||(t.Translations={})),t.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let H=class extends d.Disposable{constructor(V,N,F,z,$,Y,A,U,k,O,M){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=N,this.extensionsControlLocation=F,this.cacheLocation=z,this.userDataProfilesService=$,this.extensionsProfileScannerService=Y,this.fileService=A,this.logService=U,this.environmentService=k,this.productService=O,this.instantiationService=M,this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,v.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(se,(0,v.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,N,F){const[z,$]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(N)]),Y=F?await this.scanExtensionsUnderDevelopment(V,[...z,...$]):[];return this.dedupExtensions(z,$,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const N=[];N.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),N.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[F,z]=await Promise.all(N);return this.applyScanOptions([...F,...z],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let z=await(V.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return z=await this.applyScanOptions(z,1,V,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(V,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===I.Schemas.file).map(async z=>{const $=await this.createExtensionScannerInput(z,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=N.find(U=>(0,l.areSameExtensions)(U.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",V,!0)}return[]}async scanExistingExtension(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanExtension(z);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions($,N,F,!0)}async scanMetadata(V){const N=(0,v.joinPath)(V,"package.json"),F=(await this.fileService.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,N){const F=(0,v.joinPath)(V,"package.json"),z=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(z);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,$.__metadata={...$.__metadata,...N},await this.fileService.writeFile((0,v.joinPath)(V,"package.json"),T.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(V,N,F,z){return F.includeAllVersions||(V=this.dedupExtensions(N===0?V:void 0,N===1?V:void 0,N==="development"?V:void 0,await this.getTargetPlatform(),z)),F.includeInvalid||(V=V.filter($=>$.isValid)),V.sort(($,Y)=>{const A=w.basename($.location.fsPath),U=w.basename(Y.location.fsPath);return A<U?-1:A>U?1:0})}dedupExtensions(V,N,F,z,$){const Y=(U,k,O)=>{if(U.isValid&&!k.isValid)return!1;if(U.isValid===k.isValid){if($&&f.gt(U.manifest.version,k.manifest.version))return this.logService.debug(`Skipping extension ${k.location.path} with lower version ${k.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(f.eq(U.manifest.version,k.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${k.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===z)return this.logService.debug(`Skipping extension ${k.location.path} from different target platform ${k.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${U.location.path} with ${k.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${k.location.path}.`),!0},A=new Map;return V?.forEach(U=>{const k=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(k);(!O||Y(O,U,!1))&&A.set(k,U)}),N?.forEach(U=>{const k=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(k);if(!O&&V&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!O||Y(O,U,!1))&&A.set(k,U)}),F?.forEach(U=>{const k=s.ExtensionIdentifier.toKey(U.identifier.id),O=A.get(k);(!O||Y(O,U,!0))&&A.set(k,U),A.set(k,U)}),[...A.values()]}async scanDefaultSystemExtensions(V,N){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),$=await(V&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(V,N){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=N?await this.getBuiltInExtensionControl():{},$=[],Y=c.URI.file(w.normalize(w.join(I.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const U of F){const k=z[U.name]||"marketplace";switch(k){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(Y,U.name));break;default:$.push(c.URI.file(k));break}}const A=await Promise.all($.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,D.coalesce)(A)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,N,F,z,$,Y=!0){const A=await this.getTranslations($??h.language),U=await this.getMtime(V),k=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=k?await this.getMtime(k):void 0;return new ne(V,U,k,O,N,F,z,Y,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(V){try{const N=await this.fileService.stat(V);if(typeof N.mtime=="number")return N.mtime}catch{}}};H=ge([ee(4,R.IUserDataProfilesService),ee(5,b.IExtensionsProfileScannerService),ee(6,r.IFileService),ee(7,n.ILogService),ee(8,g.IEnvironmentService),ee(9,o.IProductService),ee(10,i.IInstantiationService)],H),t.AbstractExtensionsScannerService=H;class ne{constructor(V,N,F,z,$,Y,A,U,k,O,M,W,q,K){this.location=V,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=Y,this.excludeObsolete=A,this.validate=U,this.productVersion=k,this.productDate=O,this.productCommit=M,this.devMode=W,this.language=q,this.translations=K}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,N){return(0,v.isEqual)(V.location,N.location)&&V.mtime===N.mtime&&(0,v.isEqual)(V.applicationExtensionslocation,N.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&V.profile===N.profile&&V.type===N.type&&V.excludeObsolete===N.excludeObsolete&&V.validate===N.validate&&V.productVersion===N.productVersion&&V.productDate===N.productDate&&V.productCommit===N.productCommit&&V.devMode===N.devMode&&V.language===N.language&&J.equals(V.translations,N.translations)}}let re=class extends d.Disposable{constructor(V,N,F,z,$){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=N,this.uriIdentityService=F,this.fileService=z,this.logService=$}async scanExtensions(V){const N=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let F={};if(V.excludeObsolete&&V.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(z)}catch{}return(0,E.isEmptyObject)(F)?N:N.filter(z=>!F[l.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(V){const N=await this.fileService.resolve(V.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async z=>{if(!z.isDirectory||V.type===1&&(0,v.basename)(z.resource).indexOf(".")===0)return null;const $=new ne(z.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension($)}));return(0,D.coalesce)(F).sort((z,$)=>z.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(V){let N=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){N=N.filter(z=>!z.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,V);N.push(...F)}return N}async scanExtensionsFromProfileResource(V,N,F){const z=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!z.length)return[];const $=await Promise.all(z.map(async Y=>{if(N(Y)){const A=new ne(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,Y.metadata)}return null}));return(0,D.coalesce)($)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,v.joinPath)(V.location,"package.json"))){const N=await this.scanExtension(V);return N?[N]:[]}else return await this.scanExtensions(V)}catch(N){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,L.getErrorMessage)(N)),[]}}async scanExtension(V,N){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const z=(0,l.getGalleryExtensionId)(F.publisher,F.name),$=N?.id?{id:z,uuid:N.id}:{id:z},Y=N?.isSystem?0:V.type,A=Y===0||!!N?.isBuiltin;F=await this.translateManifest(V.location,F,ne.createNlsConfiguration(V));const U={type:Y,identifier:$,manifest:F,location:V.location,isBuiltin:A,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return V.validate?this.validate(U,V):U}}catch(F){V.type!==0&&this.logService.error(F)}return null}validate(V,N){let F=!0;const z=(0,e.validateExtensionManifest)(N.productVersion,N.productDate,N.location,V.manifest,V.isBuiltin);for(const[$,Y]of z)$===m.default.Error&&(F=!1,this.logService.error(this.formatMessage(N.location,Y)));return V.isValid=F,V.validations=z,V}async scanExtensionManifest(V){const N=(0,v.joinPath)(V,"package.json");let F;try{F=(await this.fileService.readFile(N)).value.toString()}catch($){return(0,r.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(V,(0,u.localize)(0,null,N.path,$.message))),null}let z;try{z=JSON.parse(F)}catch{const Y=[];(0,p.parse)(F,Y);for(const A of Y)this.logService.error(this.formatMessage(V,(0,u.localize)(1,null,N.path,A.offset,A.length,(0,a.getParseErrorMessage)(A.error))));return null}return(0,p.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(V,(0,u.localize)(2,null,N.path))),null):z}async translateManifest(V,N,F){const z=await this.getLocalizedMessages(V,N,F);if(z)try{const $=[],Y=await this.resolveOriginalMessageBundle(z.default,$);if($.length>0)return $.forEach(U=>{this.logService.error(this.formatMessage(V,(0,u.localize)(3,null,z.default?.path,(0,a.getParseErrorMessage)(U.error))))}),N;if((0,p.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(V,(0,u.localize)(4,null,z.default?.path))),N;const A=z.values||Object.create(null);return(0,_.localizeManifest)(N,A,Y)}catch{}return N}async getLocalizedMessages(V,N,F){const z=(0,v.joinPath)(V,"package.nls.json"),$=(k,O)=>{O.forEach(M=>{this.logService.error(this.formatMessage(V,(0,u.localize)(5,null,k?.path,(0,a.getParseErrorMessage)(M.error))))})},Y=k=>{this.logService.error(this.formatMessage(V,(0,u.localize)(6,null,k?.path)))},A=`${N.publisher}.${N.name}`,U=F.translations[A];if(U)try{const k=c.URI.file(U),O=(await this.fileService.readFile(k)).value.toString(),M=[],W=(0,p.parse)(O,M);return M.length>0?($(k,M),{values:void 0,default:z}):(0,p.getNodeType)(W)!=="object"?(Y(k),{values:void 0,default:z}):{values:W.contents?W.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let O;try{O=await this.findMessageBundles(V,F)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const M=(await this.fileService.readFile(O.localized)).value.toString(),W=[],q=(0,p.parse)(M,W);return W.length>0?($(O.localized,W),{values:void 0,default:O.original}):(0,p.getNodeType)(q)!=="object"?(Y(O.localized),{values:void 0,default:O.original}):{values:q,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle(V,N){if(V)try{const F=(await this.fileService.readFile(V)).value.toString();return(0,p.parse)(F,N)}catch{}}findMessageBundles(V,N){return new Promise((F,z)=>{const $=Y=>{const A=(0,v.joinPath)(V,`package.nls.${Y}.json`);this.fileService.exists(A).then(U=>{U&&F({localized:A,original:(0,v.joinPath)(V,"package.nls.json")});const k=Y.lastIndexOf("-");k===-1?F({localized:(0,v.joinPath)(V,"package.nls.json"),original:null}):(Y=Y.substring(0,k),$(Y))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,v.joinPath)(V,"package.nls.json"),original:null});$(N.language)})}formatMessage(V,N){return`[${V.path}]: ${N}`}};re=ge([ee(1,b.IExtensionsProfileScannerService),ee(2,j.IUriIdentityService),ee(3,r.IFileService),ee(4,n.ILogService)],re);let se=class extends re{constructor(V,N,F,z,$,Y){super(N,F,z,$,Y),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new C.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const N=await this.readExtensionCache();if(this.input=V,N&&N.input&&ne.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(z=>(z.location=c.URI.revive(z.location),z));const F=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:F}),F}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),N=JSON.parse(V.value.toString());return{result:N.result,input:(0,y.revive)(N.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(V)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const N=V.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(F,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};se=ge([ee(2,b.IExtensionsProfileScannerService),ee(3,j.IUriIdentityService),ee(4,r.IFileService),ee(5,n.ILogService)],se);function fe(ie,V){const N=(0,l.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:V,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}t.toExtensionDescription=fe;class le extends H{constructor(V,N,F,z,$,Y,A,U,k,O,M){super(V,N,(0,v.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,Y,A,U,k,O,M),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const W=await this.fileService.readFile(c.URI.file(h.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}t.NativeExtensionsScannerService=le}),define(Q[140],Z([0,1,57,3,31,4,2,17,14,20,9,25]),function(B,t,D,C,P,T,L,p,a,d,I,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let h=class extends L.Disposable{constructor(f,m){super(),this.userDataProfilesService=f,this.logService=m,this.processesLimiter=new C.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),E=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${E}`)))),d.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,E=>this.logService.error("Error while removing extension storage path",E))}parseScript(f,m){const E=`vscode:${m}`;if(f.location.scheme===p.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[E]=="string"){const c=f.manifest.scripts[E].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${E} should be a node script`),null):{script:(0,a.join)(f.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}runLifecycleHook(f,m,E,c,u){return new Promise((g,l)=>{const s=this.start(f,m,E,u);let e;const r=i=>{e&&(clearTimeout(e),e=null),i?l(i):g(void 0)};s.on("error",i=>{r((0,P.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,n)=>{r(i?`post-${m} process exited with code ${i}`:void 0)}),c&&(e=setTimeout(()=>{e=null,s.kill(),l("timed out")},5e3))})}start(f,m,E,c){const u={silent:!0,execArgv:void 0},g=(0,D.fork)(f,[`--type=extension-post-${m}`,...E],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const l=T.Event.fromNodeEventEmitter(g.stdout,"data"),s=T.Event.fromNodeEventEmitter(g.stderr,"data");l(i=>this.logService.info(c.identifier.id,c.manifest.version,`post-${m}`,i)),s(i=>this.logService.error(c.identifier.id,c.manifest.version,`post-${m}`,i));const e=T.Event.any(T.Event.map(l,i=>({data:`%c${i}`,format:[""]})),T.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(e,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(c.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),g}getExtensionStoragePath(f){return(0,a.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=ge([ee(0,w.IUserDataProfilesService),ee(1,I.ILogService)],h),t.ExtensionsLifecycle=h}),define(Q[141],Z([0,1,10,16,41,48,12,8,9,28,25]),function(B,t,D,C,P,T,L,p,a,d,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScannerService=void 0;let w=class extends T.NativeExtensionsScannerService{constructor(v,f,m,E,c,u,g){super(D.URI.file(c.builtinExtensionsPath),D.URI.file(c.extensionsPath),c.userHome,D.URI.file(c.userDataPath),v,f,m,E,c,u,g)}};w=ge([ee(0,I.IUserDataProfilesService),ee(1,P.IExtensionsProfileScannerService),ee(2,L.IFileService),ee(3,a.ILogService),ee(4,C.INativeEnvironmentService),ee(5,d.IProductService),ee(6,p.IInstantiationService)],w),t.ExtensionsScannerService=w}),define(Q[142],Z([0,1,3,4,2,112,5,79,8,25]),function(B,t,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.isProfileUsingDefaultStorage=t.AbstractStorageService=t.loadKeyTargets=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.TARGET_KEY=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker",t.TARGET_KEY="__$__targetStorageMarker",t.IStorageService=(0,a.createDecorator)("storageService");var I;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(I=t.WillSaveStateReason||(t.WillSaveStateReason={}));var w;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(w=t.StorageScope||(t.StorageScope={}));var h;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(h=t.StorageTarget||(t.StorageTarget={}));function v(u){const g=u.get(t.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}t.loadKeyTargets=v;class f extends P.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,l){if(l===t.TARGET_KEY){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:l,target:this.getKeyTargets(g)[l]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,l,s){return this.getStorage(l)?.get(g,s)}getBoolean(g,l,s){return this.getStorage(l)?.getBoolean(g,s)}getNumber(g,l,s){return this.getStorage(l)?.getNumber(g,s)}store(g,l,s,e){if((0,L.isUndefinedOrNull)(l)){this.remove(g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,s,e),this.getStorage(s)?.set(g,l)})}remove(g,l){this.withPausedEmitters(()=>{this.updateKeyTarget(g,l,void 0),this.getStorage(l)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,l){const s=[],e=this.getKeyTargets(g);for(const r of Object.keys(e))e[r]===l&&s.push(r);return s}updateKeyTarget(g,l,s){const e=this.getKeyTargets(l);typeof s=="number"?e[g]!==s&&(e[g]=s,this.getStorage(l)?.set(t.TARGET_KEY,JSON.stringify(e))):typeof e[g]=="number"&&(delete e[g],this.getStorage(l)?.set(t.TARGET_KEY,JSON.stringify(e)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const l=this.getStorage(g);return l?v(l):Object.create(null)}isNew(g){return this.getBoolean(t.IS_NEW_KEY,g)===!0}async flush(g=I.NONE){this._onWillSaveState.fire({reason:g});const l=this.getStorage(-1),s=this.getStorage(0),e=this.getStorage(1);switch(g){case I.NONE:await D.Promises.settled([l?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([l?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return c(g,l,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,l){return this.emitWillSaveState(I.NONE),(0,d.isUserDataProfile)(g)?this.switchToProfile(g,l):this.switchToWorkspace(g,l)}canSwitchProfile(g,l){return!(g.id===l.id||m(l)&&m(g))}switchData(g,l,s,e){this.withPausedEmitters(()=>{if(e)for(const[r,i]of g)l.set(r,i);else{const r=new Set;for(const[i,n]of g)r.add(i),l.get(i)!==n&&this.emitDidChangeValue(s,i);for(const[i]of l.items)r.has(i)||this.emitDidChangeValue(s,i)}})}}t.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(u){return u.isDefault||!!u.useDefaultFlags?.uiState}t.isProfileUsingDefaultStorage=m;class E extends f{constructor(){super(),this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(g){return!1}}t.InMemoryStorageService=E;async function c(u,g,l,s,e,r){const i=J=>{try{return JSON.parse(J)}catch{return J}},n=new Map,o=new Map;u.forEach((J,H)=>{n.set(H,J),o.set(H,i(J))});const S=new Map,y=new Map;g.forEach((J,H)=>{S.set(H,J),y.set(H,i(J))});const b=new Map,R=new Map;l.forEach((J,H)=>{b.set(H,J),R.set(H,i(J))}),console.group(s!==e?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const j=[];if(n.forEach((J,H)=>{j.push({key:H,value:J})}),console.table(j),console.groupEnd(),console.log(o),s!==e){console.group(`Storage: Profile (path: ${e}, profile specific)`);const J=[];S.forEach((H,ne)=>{J.push({key:ne,value:H})}),console.table(J),console.groupEnd(),console.log(y)}console.group(`Storage: Workspace (path: ${r})`);const _=[];b.forEach((J,H)=>{_.push({key:H,value:J})}),console.table(_),console.groupEnd(),console.log(R)}t.logStorage=c}),define(Q[143],Z([0,1,19,24,11,13,32,5,10,21,16,22,23,45,12,9,28,47,130,142,35]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c,u,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const s=T.isWeb?"web":(0,w.getTargetPlatform)(T.platform,L.arch);var e;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function r(...k){return String(k.reduce((O,M)=>O|M,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class b{constructor(O=y){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(O,M=this.state.pageSize){return new b({...this.state,pageNumber:O,pageSize:M})}withFilter(O,...M){const W=[...this.state.criteria,...M.length?M.map(q=>({filterType:O,value:q})):[{filterType:O}]];return new b({...this.state,criteria:W})}withSortBy(O){return new b({...this.state,sortBy:O})}withSortOrder(O){return new b({...this.state,sortOrder:O})}withFlags(...O){return new b({...this.state,flags:O.reduce((M,W)=>M|W,0)})}withAssetTypes(...O){return new b({...this.state,assetTypes:O})}withSource(O){return new b({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:K,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:O,pageNumber:M,pageSize:W,sortBy:q,sortOrder:K}],assetTypes:ce,flags:ae}}get searchText(){const O=this.state.criteria.filter(M=>M.filterType===i.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function R(k,O){const M=(k||[]).filter(W=>W.statisticName===O)[0];return M?M.value:0}function j(k){const O="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(W=>W.assetType.indexOf(O)===0).reduce((W,q)=>{const K=H(k,q.assetType);return K&&W.push([q.assetType.substring(O.length),K]),W},[])}function _(k){if(k.properties){const O=k.properties.filter(q=>q.key===n.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=O.filter(q=>M.test(q.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return H(k,n.Repository)}function J(k){return{uri:`${k.fallbackAssetUri}/${n.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${n.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function H(k,O){return k.files.filter(W=>W.assetType===O)[0]?{uri:`${k.assetUri}/${O}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${O}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function ne(k,O){const M=k.properties?k.properties.filter(q=>q.key===O):[],W=M.length>0&&M[0].value;return W?W.split(",").map(q=>(0,h.adoptToGalleryExtensionId)(q)):[]}function re(k){const O=k.properties?k.properties.filter(M=>M.key===o.Engine):[];return O.length>0&&O[0].value||""}function se(k){const O=k.properties?k.properties.filter(M=>M.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function fe(k){const O=k.properties?k.properties.filter(W=>W.key===o.LocalizedLanguages):[],M=O.length>0&&O[0].value||"";return M?M.split(","):[]}function le(k){return k.properties?.find(O=>O.key===o.SponsorLink)?.value}function ie(k){return k.indexOf("preview")!==-1}function V(k){return k.targetPlatform?(0,w.toTargetPlatform)(k.targetPlatform):"undefined"}function N(k){const O=(0,D.distinct)(k.versions.map(V)),M=!!k.tags?.includes(w.WEB_EXTENSION_TAG),W=O.indexOf("web");return M?W===-1&&O.push("web"):W!==-1&&O.splice(W,1),O}function F(k,O){const M=(0,w.getFallbackTargetPlarforms)(O);for(let W=0;W<k.length;W++){const q=k[W];if(q.version===k[W-1]?.version){let K=W;const ae=V(q);if(ae===O)for(;K>0&&k[K-1].version===q.version;)K--;else if(M.includes(ae))for(;K>0&&k[K-1].version===q.version&&V(k[K-1])!==O;)K--;K!==W&&(k.splice(W,1),k.splice(K,0,q))}}return k}t.sortExtensionVersions=F;function z(k,O,M){k.telemetryData={index:O,querySource:M}}function $(k,O,M){const W=k.versions[0],q={manifest:H(O,n.Manifest),readme:H(O,n.Details),changelog:H(O,n.Changelog),license:H(O,n.License),repository:_(O),download:J(O),icon:H(O,n.Icon),coreTranslations:j(O)};return{identifier:{id:(0,h.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:O.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(W),description:k.shortDescription||"",installCount:R(k.statistics,"install"),rating:R(k.statistics,"averagerating"),ratingCount:R(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:M,assets:q,properties:{dependencies:ne(O,o.Dependency),extensionPack:ne(O,o.ExtensionPack),engine:re(O),localizedLanguages:fe(O),targetPlatform:V(O),isPreReleaseVersion:se(O)},hasPreReleaseVersion:se(W),hasReleaseVersion:!0,preview:ie(k.flags)}}let Y=class{constructor(O,M,W,q,K,ae,ce,pe){this.requestService=M,this.logService=W,this.environmentService=q,this.telemetryService=K,this.fileService=ae,this.productService=ce,this.configurationService=pe;const Se=ce.extensionsGallery;this.extensionsGalleryUrl=Se?.serviceUrl,this.extensionsGallerySearchUrl=Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,M,W){const q=C.CancellationToken.isCancellationToken(M)?{}:M,K=C.CancellationToken.isCancellationToken(M)?M:W,ae=[],ce=[],pe=[],Se=[];let te=!0;for(const he of O){he.uuid?ce.push(he.uuid):ae.push(he.id);const ve=!!(he.version||he.preRelease);pe.push({id:he.id,uuid:he.uuid,includePreRelease:ve}),he.version&&Se.push({id:he.id,uuid:he.uuid,version:he.version}),te=te&&!!he.hasPreRelease&&!ve}if(!ce.length&&!ae.length)return[];let oe=new b().withPage(1,O.length);ce.length&&(oe=oe.withFilter(i.ExtensionId,...ce)),ae.length&&(oe=oe.withFilter(i.ExtensionName,...ae)),(q.queryAllVersions||te)&&(oe=oe.withFlags(oe.flags,e.IncludeVersions)),q.source&&(oe=oe.withSource(q.source));const{extensions:de}=await this.queryGalleryExtensions(oe,{targetPlatform:q.targetPlatform??s,includePreRelease:pe,versions:Se,compatible:!!q.compatible},K);return q.source&&de.forEach((he,ve)=>z(he,ve,q.source)),de}async getCompatibleExtension(O,M,W){if((0,w.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(O,M,W))return O;const q=new b().withFlags(e.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,O.identifier.uuid),{extensions:K}=await this.queryGalleryExtensions(q,{targetPlatform:W,compatible:!0,includePreRelease:M},C.CancellationToken.None);return K[0]||null}async isExtensionCompatible(O,M,W){if(!(0,w.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,W)||!M&&O.properties.isPreReleaseVersion)return!1;let q=O.properties.engine;if(!q){const K=await this.getManifest(O,C.CancellationToken.None);if(!K)throw new Error("Manifest was not found");q=K.engines.vscode}return(0,v.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(O,M,W,q,K){if(!(0,w.isTargetPlatformCompatible)(V(O),q,K)||M!=="any"&&se(O)!==(M==="prerelease"))return!1;if(W)try{const ae=await this.getEngine(O);if(!(0,v.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,P.getErrorMessage)(ae)),!1}return!0}async query(O,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let W=O.text||"";const q=O.pageSize??50;let K=new b().withPage(1,q);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(K=K.withFilter(i.Category,de||oe),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(K=K.withFilter(i.Tag,de||oe),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(i.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),K=K.withFilter(i.SearchText,W)),K=K.withSortBy(0)):O.ids?K=K.withFilter(i.ExtensionId,...O.ids):O.names?K=K.withFilter(i.ExtensionName,...O.names):K=K.withSortBy(4),typeof O.sortBy=="number"&&(K=K.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(K=K.withSortOrder(O.sortOrder)),O.source&&(K=K.withSource(O.source));const ae=async(te,oe)=>{const{extensions:de,total:he}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},oe);return de.forEach((ve,ke)=>z(ve,(te.pageNumber-1)*te.pageSize+ke,O.source)),{extensions:de,total:he}},{extensions:ce,total:pe}=await ae(K,M),Se=async(te,oe)=>{if(oe.isCancellationRequested)throw new P.CancellationError;const{extensions:de}=await ae(K.withPage(te+1),oe);return de};return{firstPage:ce,total:pe,pageSize:K.pageSize,getPage:Se}}async queryGalleryExtensions(O,M,W){const q=O.flags;!!(O.flags&e.IncludeLatestVersionOnly)&&!!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(O.flags&e.IncludeLatestVersionOnly)&&!(O.flags&e.IncludeVersions)&&(O=O.withFlags(O.flags,e.IncludeLatestVersionOnly)),M.versions?.length&&(O=O.withFlags(O.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),O=O.withFlags(O.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:K,total:ae}=await this.queryRawGalleryExtensions(O,W);if(!(O.flags&e.IncludeLatestVersionOnly)){const te=[];for(const oe of K){const de=await this.toGalleryExtensionWithCriteria(oe,M);de&&te.push(de)}return{extensions:te,total:ae}}const pe=[],Se=new Map;for(let te=0;te<K.length;te++){const oe=K[te],de={id:(0,h.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),uuid:oe.extensionId},he=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ke=>(0,h.areSameExtensions)(ke,de))?.includePreRelease;if(M.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(N(oe),M.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(oe,M);!ve||ve.properties.isPreReleaseVersion&&(!he||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==M.targetPlatform&&ve.hasPreReleaseVersion?Se.set(oe.extensionId,te):pe.push([te,ve])}if(Se.size){const te=new Date().getTime(),oe=new b().withFlags(q&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,Se.size).withFilter(i.ExtensionId,...Se.keys()),{extensions:de}=await this.queryGalleryExtensions(oe,M,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:Se.size});for(const he of de){const ve=Se.get(he.identifier.uuid);pe.push([ve,he])}}return{extensions:pe.sort((te,oe)=>te[0]-oe[0]).map(([,te])=>te),total:ae}}async toGalleryExtensionWithCriteria(O,M){const W={id:(0,h.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},q=M.versions?.find(pe=>(0,h.areSameExtensions)(pe,W))?.version,K=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(pe=>(0,h.areSameExtensions)(pe,W))?.includePreRelease,ae=N(O),ce=F(O.versions,M.targetPlatform);if(M.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ae,M.targetPlatform))return null;for(let pe=0;pe<ce.length;pe++){const Se=ce[pe];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,K?"any":"release",M.compatible,ae,M.targetPlatform))return $(O,Se,ae);if(q&&Se.version===q)return null}}return q||M.compatible?null:$(O,O.versions[0],ae)}async queryRawGalleryExtensions(O,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,e.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(e.Unpublished));const W=await this.commonHeadersPromise,q=JSON.stringify(O.raw),K={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ae=new Date().getTime();let ce,pe,Se=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&O.criteria.some(oe=>oe.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:K},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:Se};const te=await(0,c.asJson)(ce);if(te){const oe=te.results[0],de=oe.extensions,he=oe.resultMetadata&&oe.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return Se=he&&he.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:Se}}return{galleryExtensions:[],total:Se}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ae,success:!!ce&&(0,c.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:pe?(0,P.isCancellationError)(pe)?"canceled":(0,P.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(O,M,W,q){if(!this.isEnabled())return;const K=T.isWeb?this.api(`/itemName/${O}.${M}/version/${W}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${M}/${W}/stats?statType=${q}`),ae=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:K,headers:pe},C.CancellationToken.None)}catch{}}async download(O,M,W){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const q=(0,h.getGalleryExtensionTelemetryData)(O),K=new Date().getTime(),ae=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:te}),ce=W===2?"install":W===3?"update":"",pe=ce?{uri:`${O.assets.download.uri}${a.URI.parse(O.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${O.assets.download.fallbackUri}${a.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:O.assets.download,Se=await this.getAsset(pe);await this.fileService.writeFile(M,Se.stream),ae(new Date().getTime()-K)}async getReadme(O,M){if(O.assets.readme){const W=await this.getAsset(O.assets.readme,{},M);return await(0,c.asTextOrError)(W)||""}return""}async getManifest(O,M){if(O.assets.manifest){const W=await this.getAsset(O.assets.manifest,{},M),q=await(0,c.asTextOrError)(W);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(O,M){const W=H(O,n.Manifest);if(!W)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},K=await this.getAsset(W,{headers:q});return await(0,c.asJson)(K)}async getCoreTranslation(O,M){const W=O.assets.coreTranslations.filter(q=>q[0]===M.toUpperCase())[0];if(W){const q=await this.getAsset(W[1]),K=await(0,c.asTextOrError)(q);return K?JSON.parse(K):null}return null}async getChangelog(O,M){if(O.assets.changelog){const W=await this.getAsset(O.assets.changelog,{},M);return await(0,c.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(O,M,W){let q=new b().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?q=q.withFilter(i.ExtensionId,O.identifier.uuid):q=q.withFilter(i.ExtensionName,O.identifier.id);const{galleryExtensions:K}=await this.queryRawGalleryExtensions(q,C.CancellationToken.None);if(!K.length)return[];const ae=N(K[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(ae,W))return[];const ce=[];await Promise.all(K[0].versions.map(async te=>{try{await this.isValidVersion(te,M?"any":"release",!0,ae,W)&&ce.push(te)}catch{}}));const pe=[],Se=new Set;for(const te of F(ce,W))Se.has(te.version)||(Se.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:se(te)}));return pe}async getAsset(O,M={},W=C.CancellationToken.None){const q=await this.commonHeadersPromise,K={type:"GET"},ae={...q,...M.headers||{}};M={...M,...K,headers:ae};const ce=O.uri,pe=O.fallbackUri,Se={...M,url:ce};try{const te=await this.requestService.request(Se,W);if(te.res.statusCode===200)return te;const oe=await(0,c.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${oe}`)}catch(te){if((0,P.isCancellationError)(te))throw te;const oe=(0,P.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:oe});const de={...M,url:pe};return this.requestService.request(de,W)}}async getEngine(O){let M=re(O);if(!M){const W=await this.getManifestFromRawExtensionVersion(O,C.CancellationToken.None);if(!W)throw new Error("Manifest was not found");M=W.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.asJson)(O),W=[],q={};if(M){for(const K of M.malicious)W.push({id:K});if(M.migrateToPreRelease)for(const[K,ae]of Object.entries(M.migrateToPreRelease))(!ae.engine||(0,v.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(q[K.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[K,ae]of Object.entries(M.deprecated))ae&&(q[K.toLowerCase()]=(0,p.isBoolean)(ae)?{}:ae)}return{malicious:W,deprecated:q}}};Y=ge([ee(1,c.IRequestService),ee(2,m.ILogService),ee(3,I.IEnvironmentService),ee(4,l.ITelemetryService),ee(5,f.IFileService),ee(6,E.IProductService),ee(7,d.IConfigurationService)],Y);let A=class extends Y{constructor(O,M,W,q,K,ae,ce,pe){super(O,M,W,q,K,ae,ce,pe)}};A=ge([ee(0,g.IStorageService),ee(1,c.IRequestService),ee(2,m.ILogService),ee(3,I.IEnvironmentService),ee(4,l.ITelemetryService),ee(5,f.IFileService),ee(6,E.IProductService),ee(7,d.IConfigurationService)],A),t.ExtensionGalleryService=A;let U=class extends Y{constructor(O,M,W,q,K,ae,ce){super(void 0,O,M,W,q,K,ae,ce)}};U=ge([ee(0,c.IRequestService),ee(1,m.ILogService),ee(2,I.IEnvironmentService),ee(3,l.ITelemetryService),ee(4,f.IFileService),ee(5,E.IProductService),ee(6,d.IConfigurationService)],U),t.ExtensionGalleryServiceWithNoStorageService=U}),define(Q[144],Z([0,1,44,16,12,9,65,29,25]),function(B,t,D,C,P,T,L,p,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=void 0;let d=class We extends a.UserDataProfilesService{constructor(w,h,v,f,m){super(v,f,h,m),this.stateService=w}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(We.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(We.PROFILE_ASSOCIATIONS_KEY,{}))}};d=ge([ee(0,L.IStateService),ee(1,p.IUriIdentityService),ee(2,C.IEnvironmentService),ee(3,P.IFileService),ee(4,T.ILogService)],d),t.UserDataProfilesService=d}),define(Q[145],Z([0,1,37,3,157,2]),function(B,t,D,C,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativePolicyService=void 0;class L extends D.AbstractPolicyService{constructor(a){super(),this.productName=a,this.throttler=new C.Throttler,this.watcher=this._register(new T.MutableDisposable)}async initializePolicies(a){await this.throttler.queue(()=>new Promise((d,I)=>{try{this.watcher.value=(0,P.createWatcher)(this.productName,a,w=>{for(const h in w){const v=w[h];v===void 0?this.policies.delete(h):this.policies.set(h,v)}this._onDidChange.fire(Object.keys(w)),d()})}catch(w){I(w)}}))}}t.NativePolicyService=L}),define(Q[67],Z([0,1,114,3,14,5,20,80,158,159]),function(B,t,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class I extends Error{constructor(e,r){let i=r.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=e,this.cause=r}}t.ExtractError=I;function w(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,i)=>r+i,e&61440)}function h(s){if(s instanceof I)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new I(e,s)}function v(s,e,r,i,n,o){const S=P.dirname(e),y=P.join(i,S);if(!y.startsWith(i))return Promise.reject(new Error(p.localize(0,null,e)));const b=P.join(i,e);let R;return o.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(L.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((j,_)=>{if(!o.isCancellationRequested)try{R=(0,D.createWriteStream)(b,{mode:r}),R.once("close",()=>j()),R.once("error",_),s.once("error",_),s.pipe(R)}catch(J){_(J)}}))}function f(s,e,r,i){let n=(0,C.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((S,y)=>{const b=new C.Sequencer,R=j=>{j.isCancellationRequested||(o++,s.readEntry())};s.once("error",y),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===o?S():y(new I("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},y)),s.readEntry(),s.on("entry",j=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(j.fileName)){R(i);return}const _=j.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(_)){const ne=P.join(e,_);n=(0,C.createCancelablePromise)(re=>L.Promises.mkdir(ne,{recursive:!0}).then(()=>R(re)).then(void 0,y));return}const J=E(s,j),H=w(j);n=(0,C.createCancelablePromise)(ne=>b.queue(()=>J.then(re=>v(re,_,H,e,r,ne).then(()=>R(ne)))).then(null,y))})})}function m(s,e=!1){return new Promise((r,i)=>{(0,a.open)(s,e?{lazyEntries:!0}:void 0,(n,o)=>{n?i(h(n)):r((0,T.assertIsDefined)(o))})})}function E(s,e){return new Promise((r,i)=>{s.openReadStream(e,(n,o)=>{n?i(h(n)):r((0,T.assertIsDefined)(o))})})}function c(s,e){return new Promise((r,i)=>{const n=new d.ZipFile;e.forEach(S=>{S.contents?n.addBuffer(typeof S.contents=="string"?Buffer.from(S.contents,"utf8"):S.contents,S.path):S.localPath&&n.addFile(S.localPath,S.path)}),n.end();const o=(0,D.createWriteStream)(s);n.outputStream.pipe(o),n.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>r(s))})}t.zip=c;function u(s,e,r={},i){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=m(s,!0);return r.overwrite&&(o=o.then(S=>L.Promises.rm(e).then(()=>S))),o.then(S=>f(S,e,{sourcePathRegex:n},i))}t.extract=u;function g(s,e){return m(s).then(r=>new Promise((i,n)=>{r.on("entry",o=>{o.fileName===e&&E(r,o).then(S=>i(S),S=>n(S))}),r.once("close",()=>n(new Error(p.localize(2,null,e))))}))}function l(s,e){return g(s,e).then(r=>new Promise((i,n)=>{const o=[];r.once("error",n),r.on("data",S=>o.push(S)),r.on("end",()=>i(Buffer.concat(o)))}))}t.buffer=l}),define(Q[146],Z([0,1,67,88]),function(B,t,D,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function P(T){return(0,D.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}t.getManifest=P}),define(Q[147],Z([0,1,3,31,11,2,17,14,13,18,39,5,10,30,20,67,87,58,16,139,22,23,41,48,122,140,146,123,136,34,45,12,8,9,28,35,29,25]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c,u,g,l,s,e,r,i,n,o,S,y,b,R,j,_,J,H,ne,re,se){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=t.INativeServerExtensionManagementService=void 0,t.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(l.IExtensionManagementService);let fe=class extends g.AbstractExtensionManagementService{constructor(A,U,k,O,M,W,q,K,ae,ce,pe,Se){super(A,U,k,ce,Se),this.extensionsScannerService=M,this.extensionsProfileScannerService=W,this.downloadService=q,this.fileService=ae,this.installGalleryExtensionsTasks=new Map;const te=this._register(K.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(le,de=>te.postUninstall(de))),this.manifestCache=this._register(new S.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(K.createInstance(i.ExtensionsDownloader));const oe=this._register(new y.ExtensionsWatcher(this,ae,O,k,pe));this._register(oe.onDidChangeExtensionsByAnotherSource(({added:de,removed:he})=>{de.length&&this._onDidInstallExtensions.fire(de.map(ve=>({identifier:ve.identifier,operation:1,local:ve}))),he.forEach(ve=>this._onDidUninstallExtension.fire({identifier:ve}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const U=await this.collectFiles(A),k=await(0,m.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,U);return h.URI.file(k)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:U,cleanup:k}=await this.downloadVsix(A),O=p.resolve(U.fsPath);try{return await(0,o.getManifest)(O)}finally{await k()}}getInstalled(A,U){return this.extensionsScanner.scanExtensions(A??null,U)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,U={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:k,cleanup:O}=await this.downloadVsix(A);try{const M=await(0,o.getManifest)(p.resolve(k.fsPath));if(M.engines&&M.engines.vscode&&!(0,R.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(E.localize(0,null,(0,s.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return await this.installExtension(M,k,U)}finally{await O()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,U){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const k={...U};return U.isPreReleaseVersion&&(k.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,k),this.manifestCache.invalidate(),A}async updateExtensionScope(A,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:U}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===L.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const U=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(A,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(O){this.logService.error(O)}}}}doCreateInstallExtensionTask(A,U,k){let O;if(h.URI.isUri(U))O=new N(A,U,k,this.galleryService,this.extensionsScanner,this.logService);else{const M=s.ExtensionKey.create(U).toString();O=this.installGalleryExtensionsTasks.get(M),O||(this.installGalleryExtensionsTasks.set(M,O=new V(A,U,k,this.extensionsDownloader,this.extensionsScanner,this.logService)),O.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(M)))}return k.profileLocation?new F(O,k.profileLocation,this.extensionsProfileScannerService):O}doCreateUninstallExtensionTask(A,U){return U.profileLocation?new $(A,U.profileLocation,this.extensionsProfileScannerService):new z(A,U,this.extensionsScanner)}async collectFiles(A){const U=async O=>{let M=await f.Promises.readdir(O);M=M.map(K=>p.join(O,K));const W=await Promise.all(M.map(K=>f.Promises.stat(K)));let q=Promise.resolve([]);return W.forEach((K,ae)=>{const ce=M[ae];K.isFile()&&(q=q.then(pe=>[...pe,ce])),K.isDirectory()&&(q=q.then(pe=>U(ce).then(Se=>[...pe,...Se])))}),q};return(await U(A.location.fsPath)).map(O=>({path:`extension/${p.relative(A.location.fsPath,O)}`,localPath:O}))}};fe=ge([ee(0,l.IExtensionGalleryService),ee(1,ne.ITelemetryService),ee(2,J.ILogService),ee(3,u.INativeEnvironmentService),ee(4,r.IExtensionsScannerService),ee(5,e.IExtensionsProfileScannerService),ee(6,c.IDownloadService),ee(7,_.IInstantiationService),ee(8,j.IFileService),ee(9,H.IProductService),ee(10,re.IUriIdentityService),ee(11,se.IUserDataProfilesService)],fe),t.ExtensionManagementService=fe;let le=class extends T.Disposable{constructor(A,U,k,O){super(),this.beforeRemovingExtension=A,this.fileService=U,this.extensionsScannerService=k,this.logService=O,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,U){const k={includeInvalid:!0,profileLocation:U};let O=[];return A===null||A===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},k,!1)):A===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(k)),O=A!==null?O.filter(M=>M.type===A):O,Promise.all(O.map(M=>this.toLocalExtension(M)))}async scanUserExtensions(A){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(U.map(k=>this.toLocalExtension(k)))}async extractUserExtension(A,U,k,O){const M=A.toString(),W=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),q=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M);try{await f.Promises.rm(q)}catch{throw new l.ExtensionManagementError(E.localize(1,null,q,A.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,U,W,O),await this.extensionsScannerService.updateMetadata(h.URI.file(W),k);try{await this.rename(A,W,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(K){try{await f.Promises.rm(W)}catch{}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(K)}. Deleted from extracted location`,W),K}return this.scanLocalExtension(h.URI.file(q),1)}async updateMetadata(A,U){return await this.extensionsScannerService.updateMetadata(A.location,U),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(k=>s.ExtensionKey.create(k));await this.withUninstalledExtensions(k=>{U.forEach(O=>k[O.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(O=>delete O[A.toString()]);const k=(await this.scanUserExtensions(!0)).find(O=>s.ExtensionKey.create(O).equals(A))||null;return k?this.updateMetadata(k,{installedTimestamp:Date.now()}):null}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await f.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let k={};if(U)try{k=JSON.parse(U)}catch{}return A&&(A(k),Object.keys(k).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(k)):await f.Promises.rm(this.uninstalledPath)),k})}async extractAtLocation(A,U,k,O){this.logService.trace(`Started extracting the extension from ${U} to ${k}`);try{await f.Promises.rm(k)}catch(M){throw new l.ExtensionManagementError(this.joinErrors(M).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(U,k,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${k}:`,A.id)}catch(M){try{await f.Promises.rm(k)}catch{}let W=l.ExtensionManagementErrorCode.Extract;throw M instanceof m.ExtractError&&(M.type==="CorruptZip"?W=l.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(W=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(M.message,W)}}async rename(A,U,k,O){try{await f.Promises.rename(U,k)}catch(M){if(a.isWindows&&M&&M.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${U} to ${k} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,k,O);throw new l.ExtensionManagementError(M.message||E.localize(2,null,U,k),M.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,U){const k=await this.extensionsScannerService.scanExistingExtension(A,U,{includeInvalid:!0});if(k)return this.toLocalExtension(k);throw new Error(E.localize(3,null,A.path))}async toLocalExtension(A){const U=await this.fileService.resolve(A.location);let k,O;return U.children&&(k=U.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,O=U.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:k,changelogUrl:O,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const W of U)A[s.ExtensionKey.create(W).toString()]||k.add(W.identifier.id.toLowerCase());const O=(0,s.groupByExtension)(U,W=>W.identifier);await D.Promises.settled(O.map(async W=>{const q=W.sort((K,ae)=>I.rcompare(K.manifest.version,ae.manifest.version))[0];k.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}));const M=U.filter(W=>A[s.ExtensionKey.create(W).toString()]);await D.Promises.settled(M.map(W=>this.removeUninstalledExtension(W)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=[],O=await this.extensionsScannerService.getTargetPlatform(),M=(0,s.groupByExtension)(U,W=>W.identifier);for(const W of M)if(W.length>1&&k.push(...W.sort((q,K)=>{const ae=I.rcompare(q.manifest.version,K.manifest.version);return ae!==0?ae:q.targetPlatform===O?-1:1}).slice(1)),W[0].type===0){const q=A.find(K=>(0,s.areSameExtensions)(K.identifier,W[0].identifier));(!q||I.gte(q.manifest.version,W[0].manifest.version))&&k.push(W[0])}await D.Promises.settled(k.map(W=>this.removeExtension(W,"outdated")))}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((k,O)=>new Error(`${k.message}${k.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}};le=ge([ee(1,j.IFileService),ee(2,r.IExtensionsScannerService),ee(3,J.ILogService)],le);class ie extends g.AbstractExtensionTask{get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(A,U,k,O,M){super(),this.identifier=A,this.source=U,this.options=k,this.extensionsScanner=O,this.logService=M,this._operation=2}async installExtension(A,U){try{const k=await this.unsetUninstalledAndGetLocal(A.key);if(k)return this.extensionsScanner.updateMetadata(k,A.metadata)}catch{throw a.isMacintosh?new l.ExtensionManagementError(E.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(E.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(A,U)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const k=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),k}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:U,metadata:k},O){const M=await this.extensionsScanner.extractUserExtension(U,A,k,O);return this.logService.info("Extracting completed.",U.id),M}}class V extends ie{constructor(A,U,k,O,M,W){super(U.identifier,U,k,M,W),this.manifest=A,this.gallery=U,this.extensionsDownloader=O}async doRun(A){const k=(await this.extensionsScanner.scanExtensions(null,void 0)).find(W=>(0,s.areSameExtensions)(W.identifier,this.gallery.identifier));k&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,b.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(k,O),metadata:O};const M=await this.downloadExtension(this.gallery,this._operation);try{const W=await this.installExtension({zipPath:M,key:s.ExtensionKey.create(this.gallery),metadata:O},A);return k&&!this.options.profileLocation&&(k.targetPlatform!==W.targetPlatform||I.neq(k.manifest.version,W.manifest.version))&&await this.extensionsScanner.setUninstalled(k),{local:W,metadata:O}}catch(W){throw await this.deleteDownloadedVSIX(M),W}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(h.URI.file(A))}catch(U){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,P.getErrorMessage)(U))}}async downloadExtension(A,U){let k;try{this.logService.trace("Started downloading extension:",A.identifier.id),k=(await this.extensionsDownloader.downloadExtension(A,U)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,k)}catch(O){throw new l.ExtensionManagementError((0,g.joinErrors)(O).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(k),k}catch(O){throw await this.deleteDownloadedVSIX(k),new l.ExtensionManagementError((0,g.joinErrors)(O).message,l.ExtensionManagementErrorCode.Invalid)}}}class N extends ie{constructor(A,U,k,O,M,W){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},U,k,M,W),this.manifest=A,this.location=U,this.galleryService=O}async doRun(A){const U=new s.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,void 0)).find(q=>(0,s.areSameExtensions)(this.identifier,q.identifier)),M=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(M.isApplicationScoped=(0,b.isApplicationScopedExtension)(this.manifest),M.isMachineScoped=this.options.isMachineScoped||O?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||O?.isBuiltin,M.installedTimestamp=Date.now(),O)if(this._operation=3,U.equals(new s.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(E.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const q=await this.unsetUninstalledAndGetLocal(U);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:U,metadata:M},A),metadata:M}}async getMetadata(A,U,k){try{let[O]=await this.galleryService.getExtensions([{id:A,version:U}],k);if(O||([O]=await this.galleryService.getExtensions([{id:A}],k)),O)return{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,U,k){this.task=A,this.profileLocation=U,this.extensionsProfileScannerService=k,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class z extends g.AbstractExtensionTask{constructor(A,U,k){super(),this.extension=A,this.options=U,this.extensionsScanner=k}async doRun(A){const U=[],k=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const O=s.ExtensionKey.create(this.extension);U.push(...k.filter(M=>O.equals(s.ExtensionKey.create(M))))}else U.push(...k.filter(O=>(0,s.areSameExtensions)(O.identifier,this.extension.identifier)));if(!U.length)throw new Error(E.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...U),this.options.remove)for(const O of U)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(O)}catch(M){throw new Error(E.localize(9,null,(0,C.toErrorMessage)(M)))}}}class $ extends g.AbstractExtensionTask{constructor(A,U,k){super(),this.extension=A,this.profileLocation=U,this.extensionsProfileScannerService=k}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[148],Z([0,1,127,3,15,11,2,5,21,16,128,9,126,160]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let f=class extends L.Disposable{constructor(E,c,u){super(),this.environmentService=c,this.logService=u,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,c){this.logService.trace("RequestService#request (node) - begin",E.url);const{proxyUrl:u,strictSSL:g}=this;let l;try{l=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const s={...process.env,...l},e=E.agent?E.agent:await(0,h.getProxyAgent)(E.url||"",s,{proxyUrl:u,strictSSL:g});E.agent=e,E.strictSSL=g,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(E,c);return this.logService.trace("RequestService#request (node) - success",E.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",E.url,r),r}}async getNodeRequest(E){return((0,D.parse)(E.url).protocol==="https:"?await new Promise((g,l)=>{B(["https"],g,l)}):await new Promise((g,l)=>{B(["http"],g,l)})).request}_request(E,c){return C.Promises.withAsyncBody(async(u,g)=>{const l=(0,D.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),e={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,p.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(e.auth=E.user+":"+E.password);const r=s(e,i=>{const n=(0,p.isNumber)(E.followRedirects)?E.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...E,url:i.headers.location,followRedirects:n-1},c).then(u,g);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,v.createGunzip)())),u({res:i,stream:(0,P.streamToBufferReadableStream)(o)})}});r.on("error",g),E.timeout&&r.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&r.write(E.data),r.end(),c.onCancellationRequested(()=>{r.abort(),g(new T.CancellationError)})})}async resolveProxy(E){}};f=ge([ee(0,a.IConfigurationService),ee(1,d.INativeEnvironmentService),ee(2,w.ILogService)],f),t.RequestService=f}),define(Q[161],Z([0,1,38,3,15,31,11,2,17,14,13,32,10,20,21,119,58,125,16,101,143,22,121,41,48,147,141,12,111,113,46,109,61,62,124,9,115,116,37,145,133,28,47,148,65,129,66,35,132,42,134,135,29,137,25,144]),function(B,t,D,C,P,T,L,p,a,d,I,w,h,v,f,m,E,c,u,g,l,s,e,r,i,n,o,S,y,b,R,j,_,J,H,ne,re,se,fe,le,ie,V,N,F,z,$,Y,A,U,k,O,M,W,q,K,ae){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class ce extends p.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,oe]=await this.initServices();return te.invokeFunction(async de=>{const he=de.get(ne.ILogService),ve=de.get(S.IFileService),ke=de.get(u.INativeEnvironmentService),Fe=de.get(K.IUserDataProfilesService);he.info("CLI main",this.argv),this.registerErrorHandler(he),await this.doRun(ke,ve,Fe,te),await Promise.all(oe.map(Ue=>{(0,C.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new _.ServiceCollection,oe={_serviceBrand:void 0,...ie.default};te.set(V.IProductService,oe);const de=new g.NativeEnvironmentService(this.argv,oe);te.set(u.INativeEnvironmentService,de),await Promise.all([de.appSettingsHome.fsPath,de.extensionsPath].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0));const he=(0,ne.getLogLevel)(de),ve=[];ve.push(new re.SpdLogLogger("cli",(0,d.join)(de.logsPath,"cli.log"),!0,!1,he)),he===ne.LogLevel.Trace&&ve.push(new ne.ConsoleLogger(he));const ke=this._register(new ne.MultiplexLogService(ve));te.set(ne.ILogService,ke);const Fe=this._register(new y.FileService(ke));te.set(S.IFileService,Fe);const Ue=this._register(new b.DiskFileSystemProvider(ke));Fe.registerProvider(a.Schemas.file,Ue);const xe=new $.StateService(de,ke,Fe);te.set(z.IStateService,xe);const x=new q.UriIdentityService(Fe);te.set(W.IUriIdentityService,x);const G=new ae.UserDataProfilesService(xe,x,de,Fe,ke);te.set(K.IUserDataProfilesService,G);const X=I.isWindows&&oe.win32RegValueName?this._register(new le.NativePolicyService(oe.win32RegValueName)):de.policyFile?this._register(new se.FilePolicyService(de.policyFile,Fe,ke)):new fe.NullPolicyService;te.set(fe.IPolicyService,X);const ue=this._register(new m.ConfigurationService(G.defaultProfile.settingsResource,Fe,X,ke));te.set(f.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),G.setEnablement(oe.quality!=="stable"||ue.getValue(K.PROFILES_ENABLEMENT_CONFIG)),te.set(W.IUriIdentityService,new q.UriIdentityService(Fe)),te.set(N.IRequestService,new R.SyncDescriptor(F.RequestService,void 0,!0)),te.set(E.IDownloadService,new R.SyncDescriptor(c.DownloadService,void 0,!0)),te.set(r.IExtensionsProfileScannerService,new R.SyncDescriptor(r.ExtensionsProfileScannerService,void 0,!0)),te.set(i.IExtensionsScannerService,new R.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),te.set(n.INativeServerExtensionManagementService,new R.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new R.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(J.ILanguagePackService,new R.SyncDescriptor(H.NativeLanguagePackService,void 0,!1));const me=[],De=(0,k.isInternalTelemetry)(oe,ue);if((0,k.supportsTelemetry)(oe,de)){oe.aiConfig&&oe.aiConfig.ariaKey&&me.push(new O.OneDataSystemAppender(De,"monacoworkbench",null,oe.aiConfig.ariaKey));const{installSourcePath:we}=de,Le={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const Ce=await v.Promises.readFile(de.stateResource.fsPath);be=JSON.parse(Ce.toString())[A.machineIdKey]}catch(Ce){Ce.code!=="ENOENT"&&ke.error(Ce)}return(0,Y.resolveCommonProperties)(Fe,(0,D.release)(),(0,D.hostname)(),process.arch,oe.commit,oe.version,be,De,we)})(),piiPaths:(0,k.getPiiPathsFromEnvironment)(de)};te.set(A.ITelemetryService,new R.SyncDescriptor(U.TelemetryService,[Le],!1))}else te.set(A.ITelemetryService,k.NullTelemetryService);return[new j.InstantiationService(te),me]}registerErrorHandler(te){(0,L.setUnexpectedErrorHandler)(oe=>{const de=(0,T.toErrorMessage)(oe,!0);!de||te.error(`[uncaught exception in CLI]: ${de}`)}),process.on("uncaughtException",oe=>(0,L.onUnexpectedError)(oe)),process.on("unhandledRejection",oe=>(0,L.onUnexpectedError)(oe))}async doRun(te,oe,de,he){const ve=te.args.profile?de.profiles.find(ke=>ke.name===te.args.profile)?.extensionsResource:de.defaultProfile.extensionsResource;if(this.argv["install-source"])return this.setInstallSource(te,oe,this.argv["install-source"]);if(this.argv["list-extensions"])return he.createInstance(e.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,ve);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ke={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ve};return he.createInstance(e.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ke,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return he.createInstance(e.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ve);if(this.argv["locate-extension"])return he.createInstance(e.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(oe=>/\.vsix$/i.test(oe)?h.URI.file((0,d.isAbsolute)(oe)?oe:(0,d.join)((0,w.cwd)(),oe)):oe)}async setInstallSource(te,oe,de){await oe.writeFile(h.URI.file(te.installSourcePath),P.VSBuffer.fromString(de.slice(0,30)))}}async function pe(Se){const te=new ce(Se);try{await te.run()}finally{te.dispose()}}t.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9fb452c4852ef098206ec67a2b236ad5fd0ba828/core/vs/code/node/cliProcessMain.js.map
